      SUBROUTINE BCFED
C     ******************************************************************
C     Input BCF Package data
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
      INCLUDE 'mfi2k.inc'
      TYPE(WIN_MESSAGE)   :: MESSAGE
C     ------------------------------------------------------------------
C
C  Check if LPF is already active
      IF(IUNIT(23).GT.0) THEN
         CALL WMessageBox(YesNo,QuestionIcon,CommonYes,
     1   'LPF is already active -- do you want to deactivate LPF?',' ')
         IRESP=WInfoDialog(ExitButtonCommon)
         IF(IRESP.NE.CommonYes) RETURN
C  User confirms, so deactivate
C  Set in-use flag to 0 for any files that were used by BCF.
         DO 40 J=1,MXFNAM
         IF(IFNUSE(J).EQ.IUNIT(23)) IFNUSE(J)=0
40       CONTINUE
C  Set IUNIT=0
         IUNIT(23)=0
C  Set INUIT2 to 0 as well as the in-use flag for a cbc budget file
C  used only by this package.
         IF(IUNIT2(23).GT.0) THEN
            NBD=0
            DO 45 L=1,40
            IF(IUNIT2(L).EQ.IUNIT2(23)) NBD=NBD+1
45          CONTINUE
            IF(NBD.EQ.1) IFNUSE(IUNIT2(23))=0
         END IF
         IUNIT2(23)=0
         CALL FNMRMV
      END IF
C
C  Set IUNIT if not already set
      IF(IUNIT(1).EQ.0) THEN
         CALL FINDUN(11,IU,'BCF6','BC6')
         IUNIT(1)=IU
         IUNIT2(1)=0
C  Force TRPY to 1.0
         CALL VALGET('TRPY',0,0,NAR,V)
         IF(NAR.LE.0) THEN
            CALL ARRMAK('TRPY',0,0,NLAY,1)
C  Always allocate space in X for TRPY because the LAYCON edit screen
C  always accesses the individual TRPY values.
            CALL ARRALO(IARRDA(2,NARRAY),NLAY,1)
            ARRCON(NARRAY)=1.0
         END IF
      END IF
C
C  Display BCF dialog
      CALL WDialogLoad(BCF_DIALOG)
      CALL WDialogShow(-1,50,0,SemiModeless)
C
50    CALL WMessage(ITYPE,MESSAGE)
C
C  Check for push buttons
      IF(ITYPE.EQ.PushButton) THEN
         IF(MESSAGE%VALUE1.EQ.BCF_CHECK_BUT) THEN
C  CHECK BUTTON
            CALL BCFSV(IUNDEF,-1)
C
         ELSE IF(MESSAGE%VALUE1.EQ.BCF_MISC_BUT) THEN
C  MISC BUTTON
            CALL WDialogLoad(BCF_MISC_DIALOG)
C  Initialize values
            CALL VALGET('HDRY',0,0,ITYPE,HDRY)
            IF(ITYPE.NE.0) HDRY=1.E30
            CALL WDialogPutReal(BCF_HDRY,HDRY,'(1PG13.6)')
            CALL IVLGET('IWDFLG',0,0,ITYPE,IWDFLG)
            IF(ITYPE.NE.0) IWDFLG=0
            IF(IWDFLG.EQ.0) THEN
               CALL WDialogPutRadioButton(BCF_WETDRY_OFF)
            ELSE
               CALL WDialogPutRadioButton(BCF_WETDRY_ON)
            END IF
            CALL VALGET('WETFCT',0,0,ITYPE,WETFCT)
            IF(ITYPE.NE.0) WETFCT=.5
            CALL WDialogPutReal(BCF_WETFCT,WETFCT,' ')
            CALL IVLGET('IWETIT',0,0,ITYPE,IWETIT)
            IF(ITYPE.NE.0) IWETIT=1
            CALL WDialogPutInteger(BCF_IWETIT,IWETIT)
            CALL IVLGET('IHDWET',0,0,ITYPE,IHDWET)
            IF(ITYPE.NE.0) IHDWET=0
            IHW=1
            IF(IHDWET.NE.0) IHW=2
            CALL WDialogPutOption(BCF_IHDWET,IHW)
C
C  Make Miscellaneous Dialog visible
            CALL WDialogShow(-1,50,0,MODAL)
C  Get and store values if "OK" was pushed
            IF(WInfoDialog(ExitButton).EQ.IDOK) THEN
               CALL WDialogGetReal(BCF_HDRY,HDRY)
               CALL VALSAV('HDRY',0,0,HDRY)
               CALL WDialogGetRadioButton(BCF_WETDRY_OFF,IWD)
               IWDFLG=IWD-1
               CALL IVLSAV('IWDFLG',0,0,IWDFLG)
               CALL WDialogGetReal(BCF_WETFCT,WETFCT)
               CALL VALSAV('WETFCT',0,0,WETFCT)
               CALL WDialogGetInteger(BCF_IWETIT,IWETIT)
               CALL IVLSAV('IWETIT',0,0,IWETIT)
               CALL WDialogGetMenu(BCF_IHDWET,IHW)
               CALL IVLSAV('IHDWET',0,0,IHW-1)
            END IF
            CALL WDialogUnload(BCF_MISC_DIALOG)
C
         ELSE IF(MESSAGE%VALUE1.EQ.BCF_LAYCON_BUT) THEN
C  LAYCON PUSHBUTTON
            CALL BCFLAYED
C
         ELSE IF(MESSAGE%VALUE1.EQ.BCF_HYDRAULIC_BUT) THEN
C  HYDRAULIC PUSHBUTTON
            CALL BCFARRIN(IUNIT(1))
C
         ELSE IF(MESSAGE%VALUE1.EQ.IDCLOSE) THEN
C  CLOSE PUSHBUTTON -- done with BCF dialog
            CALL BCFSV(IUNDEF,1)
            CALL WDialogUnload(BCF_DIALOG)
            RETURN
         END IF
         CALL WDialogSelect(BCF_DIALOG)
      END IF
      GO TO 50
C
      END
      SUBROUTINE BCFLAYED
C     ******************************************************************
C     Input BCF LAYCON data
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
C
      INCLUDE 'mfi2k.inc'
      COMMON /FLWCOM/LAYCON(200)
      COMMON /FLWAVG/LAYAVG(200)
      DIMENSION ANI(200),IIIDUM(200)
      CHARACTER*4 CLAY(200)
      CHARACTER*60 CTXT(1)
C     ------------------------------------------------------------------
C
C  BCF_LAYCON --  Edit LAYCON, LAYAVG, and TRPY values
C  Load the LAYCON dialog
25    CALL WDialogLoad(BCF_LAYCON_DIALOG)
C
C  Set current values for LAYCON table
      CALL WGridRows(BCF_LAYER_GRID,NLAY)
      DO 30 I=1,NLAY
      IIIDUM(I)=I
30    CONTINUE
      CALL WGridPutInteger(BCF_LAYER_GRID,1,IIIDUM,NLAY)
      DO 32 I=1,NLAY
      IIIDUM(I)=LAYCON(I)+1
32    CONTINUE
      CALL WGridPutOption(BCF_LAYER_GRID,2,IIIDUM,NLAY)
      CALL VALGET('TRPY',0,0,NTRPY,TDUM)
      LOCTRP=IARRDA(2,NTRPY)-1
      DO 34 I=1,NLAY
      IF(IARRDA(1,NTRPY).EQ.-1) THEN
         ANI(I)=X(LOCTRP+I)*ARRCON(NTRPY)
      ELSE
         ANI(I)=ARRCON(NTRPY)
      END IF
34    CONTINUE
      CALL WGridPutReal(BCF_LAYER_GRID,3,ANI,NLAY,'(1PG13.6)')
      DO 36 I=1,NLAY
      IIIDUM(I)=LAYAVG(I)/10 + 1
36    CONTINUE
      CALL WGridPutOption(BCF_LAYER_GRID,4,IIIDUM,NLAY)
C
C  Make LAYCON Dialog visible
      CALL WDialogShow(-1,50,0,Modal)
C
C  Process values if OK was pushed
      IF(WInfoDialog(ExitButton).EQ.IDOK) THEN
         CALL WGridGetMenu(BCF_LAYER_GRID,2,IIIDUM,NLAY)
         DO 42 I=1,NLAY
         LAYCON(I)=IIIDUM(I)-1
42       CONTINUE
         CALL WGridGetReal(BCF_LAYER_GRID,3,ANI,NLAY)
C  NEWCAT is the new LOCAT value for TRPY -- before processing a
C  screen of TRPY values, set NEWCAT to 0 (i.e. assume TRPY a constant)
C  and save the first TRPY value to compare against.  If any TRPY is
C  different, set NEWCAT to -1 (i.e. internal array).
         TRPCON=ANI(1)
         NEWCAT=0
         DO 47 I=1,NLAY
         X(LOCTRP+I)=ANI(I)
         IF(ANI(I).NE.TRPCON) NEWCAT=-1
47       CONTINUE
         IARRDA(1,NTRPY)=NEWCAT
         IF(NEWCAT.EQ.0) THEN
            ARRCON(NTRPY)=TRPCON
         ELSE
            ARRCON(NTRPY)=1.0
         END IF
         CALL WGridGetMenu(BCF_LAYER_GRID,4,IIIDUM,NLAY)
         DO 49 I=1,NLAY
         LAYAVG(I)=(IIIDUM(I)-1)*10
         IF(LAYAVG(I).EQ.30 .AND.
     1        (LAYCON(I).EQ.0 .OR. LAYCON(I).EQ.2)) LAYAVG(I)=20
49       CONTINUE
         IF(NLAY.GT.1) THEN
            DO 50 I=2,NLAY
            IF(LAYCON(I).EQ.1) THEN
C  LAYCON 1 was found below the top layer -- notify user and try again
           CTXT(1)='Unconfined is not allowed below the top layer'
               CALL TXTLOG(CTXT,1)
               LAYCON(I)=0
               GO TO 25
            END IF
50          CONTINUE
         END IF
      END IF
      CALL WDialogUnload(BCF_LAYCON_DIALOG)
C
      RETURN
      END
      SUBROUTINE BCFARRIN(IUPACK)
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
C     ******************************************************************
C     Prompt user for arrays that vary according to layer
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      COMMON /PERCOM/PERLEN(MXPER),NSTP(MXPER),TSMULT(MXPER),
     1               ISSFLG(MXPER)
      COMMON /FLWCOM/LAYCON(200)
      COMMON /FLWAVG/LAYAVG(200)
      TYPE(WIN_MESSAGE)   :: MESSAGE
      CHARACTER*67 FNAME
      CHARACTER*20 FMT
      CHARACTER*4 CLAY(NLAY)
      CHARACTER*10 ANAME(7)
C     ------------------------------------------------------------------
      ISS=1
      DO 77 N=1,NPER
      IF(ISSFLG(N).EQ.0) ISS=0
77    CONTINUE
C
      NC=NCOL
      NR=NROW
      CALL IVLGET('IWDFLG',0,0,ITYPE,IWDFLG)
      IF(ITYPE.NE.0) IWDFLG=0
C
C  Make a list of layer numbers.
      DO 20 K=1,NLAY
      WRITE(CLAY(K),'(I4)') K
20    CONTINUE
C
C  Define array defaults
      CON1=0.
      CON2=1.
      CON3=1.
      FNAME=' '
      IFTYP=1   ! 1=File Name, 2=OPEN/CLOSE
C
C  Load the BCF_array dialog
      CALL WDialogLoad(BCF_ARRAY_DIALOG)
      CALL WMessageEnable(FieldChanged,Enabled)
C
C  Initialize values
      KK=1
      CALL WDialogPutMenu(BCF_ARRAY_LAYER,CLAY,NLAY,KK)
      IAR=1
C
C  Find how many arrays are used for the selected layer, and
C  display them
23    N=0
      IF(ISS.EQ.0) THEN
         N=N+1
         ANAME(N)='SF1'
      END IF
      IF(LAYCON(KK).EQ.0 .OR. LAYCON(KK).EQ.2) THEN
         N=N+1
         ANAME(N)='TRAN'
      END IF
      IF(LAYCON(KK).EQ.1 .OR. LAYCON(KK).EQ.3) THEN
         N=N+1
         ANAME(N)='HY'
      END IF
      IF(KK.NE.NLAY) THEN
         N=N+1
         ANAME(N)='VCONT'
      END IF
      IF(ISS.EQ.0 .AND.(LAYCON(KK).EQ.2 .OR. LAYCON(KK).EQ.3))THEN
         N=N+1
         ANAME(N)='SF2'
      END IF
      IF(IWDFLG.NE.0) THEN
         N=N+1
         ANAME(N)='WETDRY'
      END IF
      IF(IAR.GT.N) IAR=N
      CALL WDialogPutMenu(BCF_ARRAY_ARRAY,ANAME,N,IAR)
C  
C  Find current array -- create if it doesn't already exist
25    CALL VALGET(ANAME(IAR),KK,0,NAR,V)
      IF(NAR.LE.0) THEN
         CALL ARRMAK(ANAME(IAR),KK,0,NC,NR)
         NAR=NARRAY
         FMT='(10F8.0)'
      END IF
C  Define defaults
      IAMETH=1
      CON1=0.
      CON2=1.
      CON3=1.
      FMT='(10F8.0)'
      FNAME=' '
      IFTYP=1   ! 1=File Name, 2=OPEN/CLOSE
      IPRN=0
      LOCAT=IARRDA(1,NAR)
      IF(LOCAT.EQ.0) THEN
         IAMETH=1  ! Constant array
         IF(ARRCON(NAR) .NE. RMISS) CON1=ARRCON(NAR)
         CON2=1.0
         CON3=CON2
      ELSE IF(LOCAT.EQ.-1) THEN
         IAMETH=2   !  package array
         CON2=ARRCON(NAR)
         CON1=CON2
         CON3=CON2
      ELSE IF(LOCAT.GT.0) THEN
         IAMETH=3   ! Separate array
         CON3=ARRCON(NAR)
         CON1=CON3
         CON2=CON3
         FMT=ARRFMT(NAR)
         FNAME=FILNAM(LOCAT)
         IPRN=IARRDA(5,NAR)
         IF(FILTYP(LOCAT)(1:10).EQ.'OPEN/CLOSE') IFTYP=2
      END IF
C
C  Set current values for array
30    IF(IAMETH.EQ.1) THEN
         CALL WDialogPutRadioButton(BCF_ARRAY_CONBUT)
         CALL WDialogFieldState(BCF_ARRAY_CONSTANT,Enabled)
         CALL WDialogFieldState(BCF_ARRAY_MULTIPLIER,Disabled)
         CALL WDialogFieldState(BCF_ARRAY_MULTIPLIER2,Disabled)
         CALL WDialogFieldState(BCF_ARRAY_IPRN,Disabled)
         CALL WDialogFieldState(BCF_ARRAY_FORMAT,Disabled)
         CALL WDialogFieldState(BCF_ARRAY_FILE,Disabled)
         CALL WDialogFieldState(FILE_BROWSE,Disabled)
         CALL WDialogFieldState(BCF_ARRAY_TYPE,Disabled)
         CALL WDialogFieldState(BCF_ARRAY_SPREADSHEET,Disabled)
         CALL WDialogFieldState(BCF_ARRAY_GRID,Disabled)
      ELSE IF(IAMETH.EQ.2) THEN
         CALL WDialogPutRadioButton(BCF_ARRAY_PACKAGE)
         CALL WDialogFieldState(BCF_ARRAY_CONSTANT,Disabled)
         CALL WDialogFieldState(BCF_ARRAY_MULTIPLIER,Enabled)
         CALL WDialogFieldState(BCF_ARRAY_MULTIPLIER2,Disabled)
         CALL WDialogFieldState(BCF_ARRAY_IPRN,Disabled)
         CALL WDialogFieldState(BCF_ARRAY_FORMAT,Disabled)
         CALL WDialogFieldState(BCF_ARRAY_FILE,Disabled)
         CALL WDialogFieldState(FILE_BROWSE,Disabled)
         CALL WDialogFieldState(BCF_ARRAY_TYPE,Disabled)
         CALL WDialogFieldState(BCF_ARRAY_SPREADSHEET,Enabled)
         IF(NC.GT.100 .OR. NR.GT.100) THEN
            CALL WDialogFieldState(BCF_ARRAY_GRID,Disabled)
         ELSE
            CALL WDialogFieldState(BCF_ARRAY_GRID,Enabled)
         END IF
      ELSE
         CALL WDialogPutRadioButton(BCF_ARRAY_SEPARATE)
         CALL WDialogFieldState(BCF_ARRAY_CONSTANT,Disabled)
         CALL WDialogFieldState(BCF_ARRAY_MULTIPLIER,Disabled)
         CALL WDialogFieldState(BCF_ARRAY_MULTIPLIER2,Enabled)
         CALL WDialogFieldState(BCF_ARRAY_IPRN,Enabled)
         CALL WDialogFieldState(BCF_ARRAY_FORMAT,Enabled)
         CALL WDialogFieldState(BCF_ARRAY_FILE,Enabled)
         CALL WDialogFieldState(FILE_BROWSE,Enabled)
         CALL WDialogFieldState(BCF_ARRAY_TYPE,Enabled)
         CALL WDialogFieldState(BCF_ARRAY_SPREADSHEET,Disabled)
         CALL WDialogFieldState(BCF_ARRAY_GRID,Disabled)
      END IF
      CALL WDialogPutInteger(BCF_ARRAY_IPRN,IPRN)
      CALL WDialogPutReal(BCF_ARRAY_CONSTANT,CON1,'(1PG13.6)')
      CALL WDialogPutReal(BCF_ARRAY_MULTIPLIER,CON2,'(1PG13.6)')
      CALL WDialogPutReal(BCF_ARRAY_MULTIPLIER2,CON3,'(1PG13.6)')
      CALL WDialogPutString(BCF_ARRAY_FORMAT,FMT)
      CALL WDialogPutString(BCF_ARRAY_FILE,FNAME)
      CALL WDialogPutOption(BCF_ARRAY_TYPE,IFTYP)
C
C  Make Array Dialog visible
      CALL WDialogShow(-1,50,0,SemiModeless)
50    CALL WMessage(ITYPE,MESSAGE)
C
C  Act upon field changes
      IF(ITYPE.EQ.FieldChanged) THEN
C
C  Check for change of array name
         CALL WDialogGetMenu(BCF_ARRAY_ARRAY,IARNEW)
         IF(IARNEW.NE.IAR) THEN
            CALL UBCFINGET(NAR,IUPACK,IERR)
            CALL WDialogSelect(BCF_ARRAY_DIALOG)
            IF(IERR.NE.0) GO TO 25
            IAR=IARNEW
            GO TO 25
         END IF
C
C  Check for layer change
         CALL WDialogGetMenu(BCF_ARRAY_LAYER,KNEW)
         IF(KNEW.NE.KK) THEN
            CALL UBCFINGET(NAR,IUPACK,IERR)
            CALL WDialogSelect(BCF_ARRAY_DIALOG)
            IF(IERR.NE.0) GO TO 23
            KK=KNEW
            GO TO 23
         END IF
C
C  Check for array Method change
         CALL WDialogGetRadioButton(BCF_ARRAY_CONBUT,IAMNEW)
         IF(IAMNEW.NE.IAMETH) THEN
            IAMETH=IAMNEW
            IF(IAMETH.EQ.2 .AND. IARRDA(2,NAR).EQ.0) THEN
               CALL ARRALO(IARRDA(2,NAR),IARRDA(3,NAR),IARRDA(4,NAR))
               LOC=IARRDA(2,NAR)
               CALL ZIPR(NC*NR,0.,X(LOC))
C               CALL SS2DR(X(LOC),NC,NR,ANAME(IAR),BCF_ARRAY_DIALOG)
               CALL WDialogSelect(BCF_ARRAY_DIALOG)
               CALL WMessageEnable(FieldChanged,Enabled)
            END IF
            GO TO 30
         END IF
C
C  Check for push buttons
      ELSE IF(ITYPE.EQ.PushButton) THEN
C
C  Check for BCF_ARRAY_SPREADSHEET
         IF(MESSAGE%VALUE1.EQ.BCF_ARRAY_SPREADSHEET) THEN
            LOC=IARRDA(2,NAR)
            CALL SS2DR(X(LOC),NC,NR,ANAME(IAR),BCF_ARRAY_DIALOG)
            CALL WDialogSelect(BCF_ARRAY_DIALOG)
            CALL WMessageEnable(FieldChanged,Enabled)
C
C  Check for BCF_ARRAY_GRID
         ELSE IF(MESSAGE%VALUE1.EQ.BCF_ARRAY_GRID) THEN
            IF(NC.LE.100 .AND. NR.LE.100) THEN
            LOC=IARRDA(2,NAR)
            CALL SS2DRG(X(LOC),NC,NR,ANAME(IAR),BCF_ARRAY_DIALOG)
            CALL WDialogSelect(BCF_ARRAY_DIALOG)
            CALL WMessageEnable(FieldChanged,Enabled)
            END IF
C
C  Check for Browse
         ELSE IF(MESSAGE%VALUE1.EQ.FILE_BROWSE) THEN
            CALL BROWSE(FNAME)
            CALL WDialogSelect(BCF_ARRAY_DIALOG)
            GO TO 30
C
C  Check for OK
         ELSE IF(MESSAGE%VALUE1.EQ.BCF_ARRAY_IDOK) THEN
            CALL UBCFINGET(NAR,IUPACK,IERR)
            CALL WDialogSelect(BCF_ARRAY_DIALOG)
            IF(IERR.NE.0) GO TO 50
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL WDialogUnload(BCF_ARRAY_DIALOG)
            RETURN
C
C  Check for CANCEL
         ELSE IF(MESSAGE%VALUE1.EQ.IDCANCEL) THEN
C  Exit without storing values
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL WDialogUnload(BCF_ARRAY_DIALOG)
            RETURN
         END IF
C
C  Ignore all other types of message
      END IF
      GO TO 50
C
      END
      SUBROUTINE UBCFINGET(NAR,IUPACK,IERR)
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
C     ******************************************************************
C     Retrieve and store values for a 2-D array for a stress period
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      CHARACTER*67 FNAME
      CHARACTER*20 FMT
C     ------------------------------------------------------------------
      IERR=0
      CALL WDialogGetRadioButton(BCF_ARRAY_CONBUT,IATNEW)
      IF(IATNEW.EQ.1) THEN
         IARRDA(1,NAR)=0
         CALL WDialogGetReal(BCF_ARRAY_CONSTANT,CON1)
         ARRCON(NAR)=CON1
      ELSE IF(IATNEW.EQ.2) THEN
         IARRDA(1,NAR)=-1
         CALL WDialogGetReal(BCF_ARRAY_MULTIPLIER,CON2)
         ARRCON(NAR)=CON2
      ELSE
         CALL WDialogGetString(BCF_ARRAY_FILE,FNAME)
         CALL USTLFT(FNAME,67)
         IF(IUCASE.NE.0) CALL USTRUC(FNAME,67)
         CALL WDialogGetMenu(BCF_ARRAY_TYPE,IFTYP)
         CALL WDialogGetString(BCF_ARRAY_FORMAT,FMT)
         CALL FMTCHK(FMT,IERR)
         IF(IERR.NE.0) RETURN
         ARRFMT(NAR)=FMT
         IF(FMT.EQ.'(BINARY)') THEN
            CALL FNMSV2(FNAME,IU,0,IUPACK,NAR,IFTYP)
         ELSE
            CALL FNMSV2(FNAME,IU,1,IUPACK,NAR,IFTYP)
         END IF
         IF(IU.LE.0) THEN
            IERR=1
            RETURN
         END IF
         IARRDA(1,NAR)=IU
         CALL WDialogGetReal(BCF_ARRAY_MULTIPLIER2,CON3)
         ARRCON(NAR)=CON3
         CALL WDialogGetInteger(BCF_ARRAY_IPRN,IPRN)
         IARRDA(5,NAR)=IPRN
      END IF
C
      RETURN
      END
