      SUBROUTINE MOCED
C     ******************************************************************
C     Edit MOC data
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
      INCLUDE 'mfi2k.inc'
      TYPE(WIN_MESSAGE)   :: MESSAGE
      COMMON /MOCCOM/IUMOCL,IUMOC,IUCRC,IUCOBS,NSCOL,NSROW,NSLAY,
     1     ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2,
     2     NODISP,NPTPND,ICINFL,MOCMETH,
     3     PNEWL(51),PNEWR(51),PNEWC(51),IZONE(MXCZON),ZONCON(MXCZON),
     4     ICOB(3,MXCOB),ICOBFL(MXCOB)
      COMMON /MOCCCM/HEDMOC(2)
      CHARACTER*78 HEDMOC
      CHARACTER*78 RCHFIL
      CHARACTER*78 LABEL
      CHARACTER*80 LINE(10)
C     ------------------------------------------------------------------
C
C  Set IUNIT and IUMOC if not already set
      IF(IUNIT(15).EQ.0) THEN
C  Define the subgrid
         CALL SUBGRID(ICANCEL)
         IF(ICANCEL.EQ.1) RETURN
C
         CALL FINDUN(25,IU,'GWT','GWT')
         IUNIT(15)=IU
         IUNIT2(15)=0
         CALL FINDUN(50,IU,'MOC','MOC')
         IUMOC=IU
         CALL FINDUN(51,IU,'LSM','LSM')
         FILTYP(IU)='CLST'
         IUMOCL=IU
         IFNUSE(IU)=IUMOC
         IUCRC=0
         NODISP=1
         NPTPND=1
         HEDMOC(1)=' '
         HEDMOC(2)=' '
         MOCMETH=1
      END IF
C
C  Main GWT menu
C
      CALL WDialogLoad(GWT_DIALOG)
      IF(NODISP.EQ.0) THEN
         CALL WDialogPutRadioButton(GWT_DISPERSION_ON)
      ELSE
         CALL WDialogPutRadioButton(GWT_DISPERSION_OFF)
      END IF
      IF(MOCMETH.EQ.1) THEN
         CALL WDialogPutRadioButton(MOCMETH_MOC)
      ELSE IF(MOCMETH.EQ.2) THEN
         CALL WDialogPutRadioButton(MOCMETH_MOCIMP)
      ELSE
         CALL WDialogPutRadioButton(MOCMETH_ELLAM)
      END IF
      CALL WDialogShow(-1,50,0,SemiModeless)
C
5     CALL WMessageEnable(FieldChanged,Enabled)
      IF(MOCMETH.EQ.3) THEN
         CALL WDialogFieldState(GWT_IGENPT_BUT,DISABLED)
      ELSE
         CALL WDialogFieldState(GWT_IGENPT_BUT,ENABLED)
      END IF
      IF(NODISP.EQ.0) THEN
         CALL WDialogFieldState(GWT_ALONG_BUT,ENABLED)
         CALL WDialogFieldState(GWT_ATRANH_BUT,ENABLED)
         CALL WDialogFieldState(GWT_ATRANV_BUT,ENABLED)
      ELSE
         CALL WDialogFieldState(GWT_ALONG_BUT,DISABLED)
         CALL WDialogFieldState(GWT_ATRANH_BUT,DISABLED)
         CALL WDialogFieldState(GWT_ATRANV_BUT,DISABLED)
      END IF
      CALL WMessage(ITYPE,MESSAGE)
C
C  Check for field changes
      IF(ITYPE.EQ.FieldChanged) THEN
         CALL WDialogGetRadioButton(GWT_DISPERSION_ON,IBUT)
         IF((IBUT-1).NE.NODISP) THEN
            NODISP=1-NODISP
         END IF
         CALL WDialogGetRadioButton(MOCMETH_MOC,MOCMETH)
C
C  Check for push buttons
      ELSE IF(ITYPE.EQ.PushButton) THEN
         IF(MESSAGE%VALUE1.EQ.GWT_CHECK_BUT) THEN
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL MOCSV(IUNDEF,-1)
C
         ELSE IF(MESSAGE%VALUE1.EQ.GWT_MISC_BUT) THEN
C  Miscellaneous BUTTON
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL MOCMISC
C
         ELSE IF(MESSAGE%VALUE1.EQ.GWT_CINT_BUT) THEN
C  Initial Concentration BUTTON
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL U3DIN(
     1'Initial Concentration (layer valuess are subgrid numbers)',
     2     'CINT',NSCOL,NSROW,IUMOC,NSLAY)
C
         ELSE IF(MESSAGE%VALUE1.EQ.GWT_CINFL_BUT) THEN
C  Concentration outside the subgrid BUTTON
            CALL WMessageEnable(FieldChanged,Disabled)
            IF(ICINFL.GT.0) THEN
               LINE(1)=
     1   'The next screen requires the following CINFL values:'
               LINE(2)=' '
               IF(ISCOL1.GT.1 .OR. ISCOL2.LT.NCOL .OR.
     1         ISROW1.GT.1 .OR. ISROW2.LT.NROW)
     1    LINE(2)='One value for each subgrid layer'
               LINE(3)=' '
               IF(ISLAY1.GT.1)
     1    LINE(3)='One value for the layer above the subgrid'
               LINE(4)=' '
               IF(ISLAY2.LT.NLAY)
     1    LINE(4)='One value for the layer below the subgrid'
               CALL TXTLOG(LINE,4)
               CALL U2DIN('Conc. outside subgrid',
     1          'CINFL',1,ICINFL,IUMOC,0,0)
            ELSE
               LINE(1)=
     1 'Subgrid includes the full grid, so CINFL array is not required'
               CALL TXTLOG(LINE,1)
            END IF
C
         ELSE IF(MESSAGE%VALUE1.EQ.GWT_ZONCON_BUT) THEN
C  Fixed-head Concentration Zone BUTTON
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL ZONCONED
C
         ELSE IF(MESSAGE%VALUE1.EQ.GWT_IGENPT_BUT) THEN
C  Strong Source BUTTON
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL U3DIN(
     1'Strong Source Flags (layer valuess are subgrid numbers)',
     2     'IGENPT',NSCOL,NSROW,IUMOC,NSLAY)
C
         ELSE IF(MESSAGE%VALUE1.EQ.GWT_ALONG_BUT) THEN
C  ALONG BUTTON
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL U2DIN('Longitudinal Dispersivity (ALONG)',
     1             'ALONG',1,NSLAY,IUMOC,0,0)
C
         ELSE IF(MESSAGE%VALUE1.EQ.GWT_ATRANH_BUT) THEN
C  ATRANH BUTTON
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL U2DIN('Horizontal Trans. Dispersivity (ATRANH)',
     1             'ATRANH',1,NSLAY,IUMOC,0,0)
C
         ELSE IF(MESSAGE%VALUE1.EQ.GWT_ATRANV_BUT) THEN
C  ATRANV BUTTON
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL U2DIN('Vertical Trans. Dispersivity (ATRANV)',
     1             'ATRANV',1,NSLAY,IUMOC,0,0)
C
         ELSE IF(MESSAGE%VALUE1.EQ.GWT_RETARDATION_BUT) THEN
C  Retardation Factor BUTTON
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL U2DIN(
     1   'Retardation Factor (RF) -- 1 value for each subgrid layer',
     1          'RF',1,NSLAY,IUMOC,0,0)
C
         ELSE IF(MESSAGE%VALUE1.EQ.GWT_MOCPOR_BUT) THEN
C  Porosity BUTTON
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL U3DIN(
     1'Porosity (layer values are subgrid numbers)',
     2     'PORMOC',NSCOL,NSROW,IUMOC,NSLAY)
C
         ELSE IF(MESSAGE%VALUE1.EQ.GWT_CRECH_BUT) THEN
C  CRECH BUTTON
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL CRECHED
C
         ELSE IF(MESSAGE%VALUE1.EQ.GWT_OUTPUT_BUT) THEN
C  OUTPUT BUTTON
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL MOCOUTED
C
         ELSE IF(MESSAGE%VALUE1.EQ.GWT_OBS_BUT) THEN
C  OUTPUT BUTTON
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL MOCOBS
C
         ELSE IF(MESSAGE%VALUE1.EQ.IDCLOSE) THEN
C  CLOSE PUSHBUTTON -- done with GWT dialog
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL WDialogUnload(GWT_DIALOG)
            CALL MOCSV(IUNDEF,1)
            RETURN
         END IF
         CALL WDialogSelect(GWT_DIALOG)
      END IF
      GO TO 5
C
      END
      SUBROUTINE FNDMFL(CFNAM,CFTYP,IU)
C     ******************************************************************
C     Find an existing file of a given type in the list of file names
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      CHARACTER*(*) CFNAM,CFTYP
C
      IU=0
      CFNAM=' '
      DO 10 I=1,MXFNAM
      IF(FILTYP(I).EQ.CFTYP) THEN
         IU=I
         CFNAM=FILNAM(I)
      END IF
10    CONTINUE
C
      RETURN
      END
      SUBROUTINE PUTMFL(CFNAM,CFTYP,IUPREV,IUPAK,IERR)
C     ******************************************************************
C     Save an MOC output file in the list of file names
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      CHARACTER*(*) CFNAM,CFTYP
C
      IERR=0
C
C  If there was a previous name, clear it out or keep it.
      IF(IUPREV.GT.0) THEN
         IF(FILTYP(IUPREV).EQ.CFTYP .AND. FILNAM(IUPREV).EQ.CFNAM) THEN
C  Name and type match previous name and type, so just keep these as
C  they are.  It is assumed that no other package will have these file
C  types, so an IFNUSE conflict is not checked for.
            IFNUSE(IUPREV)=IUPAK
            RETURN
         ELSE
C  Clear out old name -- this can be done because there cannot be any other
C  use for this file (unlike DATA files which can be used for multiple
C  purposes)
            FILTYP(IUPREV)=' '
            IFNUSE(IUPREV)=0
            FILNAM(IUPREV)=' '
            CALL RTRNUN(IUPREV)
         END IF
      END IF
C
C  If new name is blank, we're done
      IF(CFNAM.EQ.' ') RETURN
C
C  Put new name into file name list
      CALL FNMSV4(CFNAM,IU,CFTYP,IUPAK)
      IF(IU.LT.0) IERR=1
C
      RETURN
      END
      SUBROUTINE SUBGRID(ICANCEL)
C     ******************************************************************
C     Edit MOC data
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
      INCLUDE 'mfi2k.inc'
      COMMON /MOCCOM/IUMOCL,IUMOC,IUCRC,IUCOBS,NSCOL,NSROW,NSLAY,
     1     ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2,
     2     NODISP,NPTPND,ICINFL,MOCMETH,
     3     PNEWL(51),PNEWR(51),PNEWC(51),IZONE(MXCZON),ZONCON(MXCZON),
     4     ICOB(3,MXCOB),ICOBFL(MXCOB)
      CHARACTER*80 LINE(10)
C     ------------------------------------------------------------------
C
      ICANCEL=0
C  Define the subgrid
      IF(NSCOL.NE.0) THEN
C  Subgrid already defined
         WRITE(LINE(1),1)
1        FORMAT('     Subgrid was defined previously:')
         WRITE(LINE(2),2) ISCOL1,ISCOL2
2        FORMAT('Beginning Column:',I5,'     Ending Column',I5)
         WRITE(LINE(3),3) ISROW1,ISROW2
3        FORMAT('Beginning Column:',I5,'     Ending Row',I5)
         WRITE(LINE(4),4) ISLAY1,ISLAY2
4        FORMAT('Beginning Column:',I5,'     Ending layer',I5)
         LINE(5)=
     1   'To change the subgrid, deactivate GWT, exit from MFI,'//
     2   ' restart MFI, and reactivate GWT'
         CALL TXTLOG(LINE,5)
      ELSE
C  Get new subgrid limits
         ISCOL1=1
         ISCOL2=NCOL
         ISROW1=1
         ISROW2=NROW
         ISLAY1=1
         ISLAY2=NLAY
10       CALL WDialogLoad(GWTSUBGRID_DIALOG)
         CALL WDialogPutInteger(GWTSUBGRID_ISCOL1,ISCOL1)
         CALL WDialogPutInteger(GWTSUBGRID_ISCOL2,ISCOL2)
         CALL WDialogPutInteger(GWTSUBGRID_ISROW1,ISROW1)
         CALL WDialogPutInteger(GWTSUBGRID_ISROW2,ISROW2)
         CALL WDialogPutInteger(GWTSUBGRID_ISLAY1,ISLAY1)
         CALL WDialogPutInteger(GWTSUBGRID_ISLAY2,ISLAY2)
         CALL WDialogShow(-1,50,0,MODAL)
C  Get and store values if "OK" was pushed
         IF(WInfoDialog(ExitButton).EQ.IDOK) THEN
            CALL WDialogGetInteger(GWTSUBGRID_ISCOL1,ISCOL1)
            CALL WDialogGetInteger(GWTSUBGRID_ISCOL2,ISCOL2)
            CALL WDialogGetInteger(GWTSUBGRID_ISROW1,ISROW1)
            CALL WDialogGetInteger(GWTSUBGRID_ISROW2,ISROW2)
            CALL WDialogGetInteger(GWTSUBGRID_ISLAY1,ISLAY1)
            CALL WDialogGetInteger(GWTSUBGRID_ISLAY2,ISLAY2)
         ELSE
            CALL WDialogUnload(GWTSUBGRID_DIALOG)
            ICANCEL=1
            RETURN
         END IF
         CALL WDialogUnload(GWTSUBGRID_DIALOG)
         IF(ISCOL2.GT.NCOL) ISCOL2=NCOL
         IF(ISROW2.GT.NROW) ISROW2=NROW
         IF(ISLAY2.GT.NLAY) ISLAY2=NLAY
         IF(ISCOL1.GT.ISCOL2 .OR. ISROW1.GT.ISROW2 .OR.
     1                      ISLAY1.GT.ISLAY2) THEN
            LINE(1)='Illegal subgrid region'
            CALL TXTLOG(LINE,1)
            GO TO 10
         END IF
      END IF
C
C  Check for uniform grid spacing in subgrid
      CALL VALGET('DELR',0,0,IADELR,DUM)
      IF(IADELR.GT.1) THEN
         IF(IARRDA(1,IADELR).EQ.-1) THEN
            LOC=IARRDA(2,IADELR)
            IF(LOC.GT.0) THEN
               D1=X(LOC+ISCOL1-1)
               IERR=0
               DO 14 J=ISCOL1,ISCOL2
               IF(X(LOC+J-1).NE.D1) IERR=1
14             CONTINUE
               IF(IERR.NE.0) THEN
        LINE(1)='DELR is not constant within the transport subgrid'
                  CALL TXTLOG(LINE,1)
               END IF
            END IF
         END IF
      END IF
      CALL VALGET('DELC',0,0,IADELC,DUM)
      IF(IADELC.GT.1) THEN
         IF(IARRDA(1,IADELC).EQ.-1) THEN
            LOC=IARRDA(2,IADELC)
            IF(LOC.GT.0) THEN
               D1=X(LOC+ISROW1-1)
               IERR=0
               DO 16 I=ISROW1,ISROW2
               IF(X(LOC+I-1).NE.D1) IERR=1
16             CONTINUE
               IF(IERR.NE.0) THEN
        LINE(1)='DELC is not constant within the transport subgrid'
                  CALL TXTLOG(LINE,1)
               END IF
            END IF
         END IF
      END IF
      NSCOL=ISCOL2-ISCOL1+1
      NSROW=ISROW2-ISROW1+1
      NSLAY=ISLAY2-ISLAY1+1
      ICINFL=0
      IF(ISCOL1.GT.1 .OR. ISCOL2.LT.NCOL .OR.
     1         ISROW1.GT.1 .OR. ISROW2.LT.NROW) ICINFL=ICINFL+NSLAY
      IF(ISLAY1.GT.1) ICINFL=ICINFL+1
      IF(ISLAY2.LT.NLAY) ICINFL=ICINFL+1
C
      RETURN
      END
      SUBROUTINE MOCMISC
C     ******************************************************************
C     Edit Miscellaneous MOC data
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
      INCLUDE 'mfi2k.inc'
      COMMON /MOCCOM/IUMOCL,IUMOC,IUCRC,IUCOBS,NSCOL,NSROW,NSLAY,
     1     ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2,
     2     NODISP,NPTPND,ICINFL,MOCMETH,
     3     PNEWL(51),PNEWR(51),PNEWC(51),IZONE(MXCZON),ZONCON(MXCZON),
     4     ICOB(3,MXCOB),ICOBFL(MXCOB)
      COMMON /MOCCCM/HEDMOC(2)
      CHARACTER*78 HEDMOC
      CHARACTER*80 LINE(10)
C     ------------------------------------------------------------------
      NFDIM=0
      IF(NSCOL.GT.1) NFDIM=NFDIM+1
      IF(NSROW.GT.1) NFDIM=NFDIM+1
      IF(NSLAY.GT.1) NFDIM=NFDIM+1
C
10    CALL WDialogLoad(GWTMISC_DIALOG)
C  Shared fields
      CALL WDialogPutString(GWTMISC_HEDMOC1,HEDMOC(1))
      CALL WDialogPutString(GWTMISC_HEDMOC2,HEDMOC(2))
      CALL VALGET('CNOFLO',0,0,ITYPE,CNOFLO)
      IF(ITYPE.NE.0) CNOFLO=999.99
      CALL WDialogPutReal(GWTMISC_CNOFLO,CNOFLO,'(1PG13.6)')
      CALL VALGET('DECAY',0,0,ITYPE,DECAY)
      IF(ITYPE.NE.0) DECAY=0.0
      CALL WDialogPutReal(GWTMISC_DECAY,DECAY,'(1PG13.6)')
      CALL VALGET('DIFFUS',0,0,ITYPE,DIFFUS)
      IF(ITYPE.NE.0) DIFFUS=0.0
      CALL WDialogPutReal(GWTMISC_DIFFUS,DIFFUS,'(1PG13.6)')
      CALL VALGET('CELDIS',0,0,ITYPE,CELDIS)
      IF(ITYPE.NE.0) CELDIS=0.1
      CALL WDialogPutReal(GWTMISC_CELDIS,CELDIS,'(1PG13.6)')
C  MOC&MOCINP fields
      CALL IVLGET('NPMAX',0,0,ITYPE,NPMAX)
      IF(ITYPE.NE.0) NPMAX=0
      CALL WDialogPutInteger(GWTMISC_NPMAX,NPMAX)
      CALL WDialogPutInteger(GWTMISC_NPTPND,NPTPND)
      CALL VALGET('FZERO',0,0,ITYPE,FZERO)
      IF(ITYPE.NE.0) FZERO=0.05
      CALL WDialogPutReal(GWTMISC_FZERO,FZERO,'(1PG13.6)')
      CALL IVLGET('INTRPL',0,0,ITYPE,INTRPL)
      IF(ITYPE.NE.0) INTRPL=1
      IF(INTRPL.EQ.1) THEN
         CALL WDialogPutRadioButton(GWTMISC_INTRPL1)
      ELSE
         CALL WDialogPutRadioButton(GWTMISC_INTRPL2)
      END IF
      IF(MOCMETH.EQ.1 .OR. MOCMETH.EQ.2) THEN
         CALL WDialogFieldState(GWTMISC_NPMAX,ENABLED)
         CALL WDialogFieldState(GWTMISC_NPTPND,ENABLED)
         CALL WDialogFieldState(GWTMISC_FZERO,ENABLED)
         CALL WDialogFieldState(GWTMISC_INTRPL1,ENABLED)
         CALL WDialogFieldState(GWTMISC_INTRPL2,ENABLED)
      ELSE
         CALL WDialogFieldState(GWTMISC_NPMAX,DISABLED)
         CALL WDialogFieldState(GWTMISC_NPTPND,DISABLED)
         CALL WDialogFieldState(GWTMISC_FZERO,DISABLED)
         CALL WDialogFieldState(GWTMISC_INTRPL1,DISABLED)
         CALL WDialogFieldState(GWTMISC_INTRPL2,DISABLED)
      END IF
C  MOCIMP only fields
      CALL VALGET('FDTMTH',0,0,ITYPE,FDTMTH)
      IF(ITYPE.NE.0) FDTMTH=1.
      CALL WDialogPutReal(GWTMISC_FDTMTH,FDTMTH,'(1PG13.6)')
      CALL IVLGET('NCXIT',0,0,ITYPE,NCXIT)
      IF(ITYPE.NE.0) NCXIT=2
      CALL WDialogPutInteger(GWTMISC_NCXIT,NCXIT)
      CALL IVLGET('IDIREC',0,0,ITYPE,IDIREC)
      IF(ITYPE.NE.0) IDIREC=1
      CALL WDialogPutInteger(GWTMISC_IDIREC,IDIREC)
      CALL VALGET('EPSSLV',0,0,ITYPE,EPSSLV)
      IF(ITYPE.NE.0) EPSSLV=1.E-5
      CALL WDialogPutReal(GWTMISC_EPSSLV,EPSSLV,'(1PG13.6)')
      CALL IVLGET('MAXIT',0,0,ITYPE,MAXIT)
      IF(ITYPE.NE.0) MAXIT=100
      CALL WDialogPutInteger(GWTMISC_MAXIT,MAXIT)
      IF(MOCMETH.EQ.2) THEN
         CALL WDialogFieldState(GWTMISC_FDTMTH,ENABLED)
         CALL WDialogFieldState(GWTMISC_NCXIT,ENABLED)
         CALL WDialogFieldState(GWTMISC_IDIREC,ENABLED)
         CALL WDialogFieldState(GWTMISC_EPSSLV,ENABLED)
         CALL WDialogFieldState(GWTMISC_MAXIT,ENABLED)
      ELSE
         CALL WDialogFieldState(GWTMISC_FDTMTH,DISABLED)
         CALL WDialogFieldState(GWTMISC_NCXIT,DISABLED)
         CALL WDialogFieldState(GWTMISC_IDIREC,DISABLED)
         CALL WDialogFieldState(GWTMISC_EPSSLV,DISABLED)
         CALL WDialogFieldState(GWTMISC_MAXIT,DISABLED)
      END IF
C  ELLAM only fields
      CALL IVLGET('NSCEXP',0,0,ITYPE,NSCEXP)
      IF(ITYPE.NE.0) NSCEXP=2
      CALL WDialogPutInteger(GWTMISC_NSCEXP,NSCEXP)
      CALL IVLGET('NSREXP',0,0,ITYPE,NSREXP)
      IF(ITYPE.NE.0) NSREXP=2
      CALL WDialogPutInteger(GWTMISC_NSREXP,NSREXP)
      CALL IVLGET('NSLEXP',0,0,ITYPE,NSLEXP)
      IF(ITYPE.NE.0) NSLEXP=1
      CALL WDialogPutInteger(GWTMISC_NSLEXP,NSLEXP)
      CALL IVLGET('NTEXP',0,0,ITYPE,NTEXP)
      IF(ITYPE.NE.0) NTEXP=2
      CALL WDialogPutInteger(GWTMISC_NTEXP,NTEXP)
      IF(MOCMETH.EQ.3) THEN
         CALL WDialogFieldState(GWTMISC_NSCEXP,ENABLED)
         CALL WDialogFieldState(GWTMISC_NSREXP,ENABLED)
         CALL WDialogFieldState(GWTMISC_NSLEXP,ENABLED)
         CALL WDialogFieldState(GWTMISC_NTEXP,ENABLED)
      ELSE
         CALL WDialogFieldState(GWTMISC_NSCEXP,DISABLED)
         CALL WDialogFieldState(GWTMISC_NSREXP,DISABLED)
         CALL WDialogFieldState(GWTMISC_NSLEXP,DISABLED)
         CALL WDialogFieldState(GWTMISC_NTEXP,DISABLED)
      END IF
C
      CALL WDialogShow(-1,50,0,MODAL)
C  Get and store values if "OK" was pushed
      IF(WInfoDialog(ExitButton).EQ.IDOK) THEN
         CALL WDialogGetString(GWTMISC_HEDMOC1,HEDMOC(1))
         CALL WDialogGetString(GWTMISC_HEDMOC2,HEDMOC(2))
         CALL WDialogGetReal(GWTMISC_CNOFLO,CNOFLO)
         CALL VALSAV('CNOFLO',0,0,CNOFLO)
         CALL WDialogGetReal(GWTMISC_DECAY,DECAY)
         CALL VALSAV('DECAY',0,0,DECAY)
         CALL WDialogGetReal(GWTMISC_DIFFUS,DIFFUS)
         CALL VALSAV('DIFFUS',0,0,DIFFUS)
         CALL WDialogGetReal(GWTMISC_CELDIS,CELDIS)
         CALL VALSAV('CELDIS',0,0,CELDIS)
C
         CALL WDialogGetInteger(GWTMISC_NPMAX,NPMAX)
         CALL IVLSAV('NPMAX',0,0,NPMAX)
         CALL WDialogGetInteger(GWTMISC_NPTPND,NPTPND)
         CALL IVLSAV('NPTPND',0,0,NPTPND)
         CALL WDialogGetReal(GWTMISC_FZERO,FZERO)
         CALL VALSAV('FZERO',0,0,FZERO)
         CALL WDialogGetRadioButton(GWTMISC_INTRPL1,INTRPL)
         CALL IVLSAV('INTRPL',0,0,INTRPL)
C
         CALL WDialogGetReal(GWTMISC_FDTMTH,FDTMTH)
         CALL VALSAV('FDTMTH',0,0,FDTMTH)
         CALL WDialogGetInteger(GWTMISC_NCXIT,NCXIT)
         CALL IVLSAV('NCXIT',0,0,NCXIT)
         CALL WDialogGetInteger(GWTMISC_IDIREC,IDIREC)
         CALL IVLSAV('IDIREC',0,0,IDIREC)
         CALL WDialogGetReal(GWTMISC_EPSSLV,EPSSLV)
         CALL VALSAV('EPSSLV',0,0,EPSSLV)
         CALL WDialogGetInteger(GWTMISC_MAXIT,MAXIT)
         CALL IVLSAV('MAXIT',0,0,MAXIT)
C
         CALL WDialogGetInteger(GWTMISC_NSCEXP,NSCEXP)
         CALL IVLSAV('NSCEXP',0,0,NSCEXP)
         CALL WDialogGetInteger(GWTMISC_NSREXP,NSREXP)
         CALL IVLSAV('NSREXP',0,0,NSREXP)
         CALL WDialogGetInteger(GWTMISC_NSLEXP,NSLEXP)
         CALL IVLSAV('NSLEXP',0,0,NSLEXP)
         CALL WDialogGetInteger(GWTMISC_NTEXP,NTEXP)
         CALL IVLSAV('NTEXP',0,0,NTEXP)
      END IF
      CALL WDialogUnload(GWTMISC_DIALOG)
C
      IF(MOCMETH.NE.3) THEN
      IF(NPTPND.GE.0) THEN
         IF((NPTPND.NE.1 .AND. NPTPND.NE.2**NFDIM .AND.
     1      NPTPND.NE.3**NFDIM .AND. NPTPND.NE.4**NFDIM) .OR.
     2             (NFDIM.EQ.3 .AND. NPTPND.EQ.64)) THEN
            IF(NFDIM.EQ.1) THEN
             LINE(1)='For a 1-dimensional transport problem,'//
     1         ' NPTPND must be 1, 2, 3, or 4'
            ELSE IF(NFDIM.EQ.2) THEN
             LINE(1)='For a 1-dimensional transport problem,'//
     1         ' NPTPND must be 1, 4, 9, or 16'
            ELSE
             LINE(1)='For a 3-dimensional transport problem,'//
     1         ' NPTPND must be 1, 8, or 27'
            END IF
            CALL TXTLOG(LINE,1)
            GO TO 10
         END IF
      ELSE
C  Get particle locations
         CALL WDialogLoad(GWTPNEW_DIALOG)
         N=-NPTPND
         CALL WGridRows(GWTPNEW_PNEW,N)
         N=-NPTPND
         CALL WGridPutReal(GWTPNEW_PNEW,1,PNEWL,N,'(F6.3)')
         N=-NPTPND
         CALL WGridPutReal(GWTPNEW_PNEW,2,PNEWR,N,'(F6.3)')
         N=-NPTPND
         CALL WGridPutReal(GWTPNEW_PNEW,3,PNEWC,N,'(F6.3)')
         CALL WDialogShow(-1,50,0,MODAL)
C  Get and store values if "OK" was pushed
         IF(WInfoDialog(ExitButton).EQ.IDOK) THEN
            CALL WGridGetReal(GWTPNEW_PNEW,1,PNEWL,N)
            CALL WGridGetReal(GWTPNEW_PNEW,2,PNEWR,N)
            CALL WGridGetReal(GWTPNEW_PNEW,3,PNEWC,N)
         END IF
         CALL WDialogUnload(GWTPNEW_DIALOG)
      END IF
      END IF
C
      RETURN
      END
      SUBROUTINE ZONCONED
C     ******************************************************************
C     Input concentration data for constant-head zones
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
C
      INCLUDE 'mfi2k.inc'
      COMMON /MOCCOM/IUMOCL,IUMOC,IUCRC,IUCOBS,NSCOL,NSROW,NSLAY,
     1     ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2,
     2     NODISP,NPTPND,ICINFL,MOCMETH,
     3     PNEWL(51),PNEWR(51),PNEWC(51),IZONE(MXCZON),ZONCON(MXCZON),
     4     ICOB(3,MXCOB),ICOBFL(MXCOB)
C
      TYPE(WIN_MESSAGE)   :: MESSAGE
C     ------------------------------------------------------------------
C
      CALL WDialogLoad(GWT_ZONCON_DIALOG)
C
C  Initialize values
C
C  Set current values for zone table
      N=MXCZON
      CALL WGridRows(GWT_ZONCON_GRID,N)
      CALL WGridPutInteger(GWT_ZONCON_GRID,1,IZONE,N)
      CALL WGridPutReal(GWT_ZONCON_GRID,2,ZONCON,N,'(1PG13.6)')
C
C  Make Dialog visible
      CALL WDialogShow(-1,50,0,Modal)
C
C  Get and store values if "OK" was pushed
      IF(WInfoDialog(ExitButton).EQ.IDOK) THEN
         CALL WGridGetInteger(GWT_ZONCON_GRID,1,IZONE,N)
         CALL WGridgetReal(GWT_ZONCON_GRID,2,ZONCON,N)
      END IF
      CALL WDialogUnload(GWT_ZONCON_DIALOG)
C
      RETURN
C
      END
      SUBROUTINE CRECHED
C     ******************************************************************
C     Edit Recharge Concentration
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      COMMON /MOCCOM/IUMOCL,IUMOC,IUCRC,IUCOBS,NSCOL,NSROW,NSLAY,
     1     ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2,
     2     NODISP,NPTPND,ICINFL,MOCMETH,
     3     PNEWL(51),PNEWR(51),PNEWC(51),IZONE(MXCZON),ZONCON(MXCZON),
     4     ICOB(3,MXCOB),ICOBFL(MXCOB)
      CHARACTER*80 CTXT(4)
      CHARACTER*78 RCHFIL
C     ------------------------------------------------------------------
C
      CALL IVLGET('NRCHOP',0,0,ITYPE,NRCHOP)
      IF(ITYPE.NE.0) NRCHOP=1
      IF(IUNIT(8).GT.0 .AND.
     1    ( (NRCHOP.EQ.1 .AND. ISLAY1.EQ.1) .OR. NRCHOP.NE.1) ) THEN
         IF(IUCRC.EQ.0) THEN
            IF(IUCASE.NE.0) RCHFIL=DSNAME(1:NDSNAM)//'.CRC'
            IF(IUCASE.EQ.0) RCHFIL=DSNAME(1:NDSNAM)//'.crc'
            CALL FNDUN2(RCHFIL,IU,'CRCH',IUMOC)
            IF(IU.LE.0) THEN
               WRITE(IOUT,*) 'Error when naming the CRECH file'
               CALL MFISTP
            ELSE
               IUCRC=IU
            END IF
         END IF
         CALL U2DPERINX('Recharge Concentration for subgrid (CRECH)',
     1      'CRECH',NSCOL,NSROW,IUCRC)
      ELSE
C  Recharge not required
         CTXT(1)='The CRECH array is not required for this simulation'
         CTXT(2)=' '
         CTXT(3)=
     1'This is either because the Recharge Package is inactive'
         CTXT(4)=
     1'or because recharge is not applied to cells in the GWT subgrid'
         CALL TXTLOG(CTXT,4)
      END IF
C
      RETURN
      END
      SUBROUTINE MOCOUTED
C     ******************************************************************
C     Edit GWT output control data
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
      INCLUDE 'mfi2k.inc'
      TYPE(WIN_MESSAGE)   :: MESSAGE
      COMMON /MOCCOM/IUMOCL,IUMOC,IUCRC,IUCOBS,NSCOL,NSROW,NSLAY,
     1     ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2,
     2     NODISP,NPTPND,ICINFL,MOCMETH,
     3     PNEWL(51),PNEWR(51),PNEWC(51),IZONE(MXCZON),ZONCON(MXCZON),
     4     ICOB(3,MXCOB),ICOBFL(MXCOB)
C
      CHARACTER*78 COBSFL,FILTXT,FILBIN,COBSAV
      CHARACTER*60 COBFIL(MXCOB)
C     ------------------------------------------------------------------
310   CALL WDialogLoad(GWT_OUTPUT_DIALOG)
C  Load concentration data
         CALL IVLGET('NPNTCL',0,0,ITYPE,NPNTCL)
         IF(ITYPE.NE.0) NPNTCL=0
         NTRVAL=5
         IF(NPNTCL.EQ.0) IFREQ=1
         IF(NPNTCL.LE.-2) IFREQ=2
         IF(NPNTCL.EQ.-1) IFREQ=3
         IF(NPNTCL.GT.0) THEN
            IFREQ=4
            NTRVAL=NPNTCL
         END IF
         CALL IVLGET('ICONFM',0,0,ITYPE,ICONFM)
         IF(ITYPE.NE.0) ICONFM=0
         CALL FNDMFL(FILTXT,'CNCA',IUCNCA)
         CALL FNDMFL(FILBIN,'CNCB',IUCNCB)
         CALL WDialogPutOption(IFREQ_CONCENTRATION,IFREQ)
         CALL WDialogPutInteger(NTRVAL_CONCENTRATION,NTRVAL)
         CALL WDialogPutInteger(GWT_ICONFM,ICONFM)
         CALL WDialogPutString(FILTXT_CONCENTRATION,FILTXT)
         CALL WDialogPutString(FILBIN_CONCENTRATION,FILBIN)
C  Load velocity data
         CALL IVLGET('NPNTVL',0,0,ITYPE,NPNTVL)
         IF(ITYPE.NE.0) NPNTVL=0
         NTRVAL=5
         IF(NPNTVL.EQ.0) IFREQ=1
         IF(NPNTVL.LE.-1) IFREQ=2
         IF(NPNTVL.GT.0) THEN
            IFREQ=3
            NTRVAL=NPNTVL
         END IF
         CALL IVLGET('IVELFM',0,0,ITYPE,IVELFM)
         IF(ITYPE.NE.0) IVELFM=0
         CALL FNDMFL(FILTXT,'VELA',IUVELA)
         CALL FNDMFL(FILBIN,'VELB',IUVELB)
         CALL WDialogPutOption(IFREQ_VELOCITY,IFREQ)
         CALL WDialogPutInteger(NTRVAL_VELOCITY,NTRVAL)
         CALL WDialogPutInteger(GWT_IVELFM,IVELFM)
         CALL WDialogPutString(FILTXT_VELOCITY,FILTXT)
         CALL WDialogPutString(FILBIN_VELOCITY,FILBIN)
C  Load dispersion data
         CALL IVLGET('NPNTDL',0,0,ITYPE,NPNTDL)
         IF(ITYPE.NE.0) NPNTDL=0
         NTRVAL=5
         IF(NPNTDL.EQ.0) IFREQ=1
         IF(NPNTDL.LE.-2) IFREQ=2
         IF(NPNTDL.EQ.-1) IFREQ=3
         IF(NPNTDL.GT.0) THEN
            IFREQ=4
            NTRVAL=NPNTDL
         END IF
         CALL IVLGET('IDSPFM',0,0,ITYPE,IDSPFM)
         IF(ITYPE.NE.0) IDSPFM=0
         CALL WDialogPutOption(IFREQ_DISPERSION,IFREQ)
         CALL WDialogPutInteger(NTRVAL_DISPERSION,NTRVAL)
         CALL WDialogPutInteger(GWT_IDSPFM,IDSPFM)
C  Load particle data
         CALL IVLGET('NPNTPL',0,0,ITYPE,NPNTPL)
         IF(ITYPE.NE.0) NPNTPL=0
         NTRVAL=5
         IF(NPNTPL.EQ.0) IFREQ=1
         IF(NPNTPL.LE.-2) IFREQ=2
         IF(NPNTPL.EQ.-1) IFREQ=3
         IF(NPNTPL.GT.0) THEN
            IFREQ=4
            NTRVAL=NPNTPL
         END IF
         CALL FNDMFL(FILTXT,'PRTA',IUPRTA)
         CALL FNDMFL(FILBIN,'PRTB',IUPRTB)
         CALL WDialogPutOption(IFREQ_PARTICLES,IFREQ)
         CALL WDialogPutInteger(NTRVAL_PARTICLES,NTRVAL)
         CALL WDialogPutString(FILTXT_PARTICLES,FILTXT)
         CALL WDialogPutString(FILBIN_PARTICLES,FILBIN)
C
      CALL WDialogShow(-1,50,0,MODAL)
C
C  Get and store values if "OK" was pushed
      IF(WInfoDialog(ExitButton).EQ.IDOK) THEN
C  Get concentration data
         CALL WDialogGetMenu(IFREQ_CONCENTRATION,IFREQ)
         CALL WDialogGetInteger(NTRVAL_CONCENTRATION,NTRVAL)
         CALL WDialogGetInteger(GWT_ICONFM,ICONFM)
         CALL WDialogGetString(FILTXT_CONCENTRATION,FILTXT)
         CALL WDialogGetString(FILBIN_CONCENTRATION,FILBIN)
         CALL IVLSAV('ICONFM',0,0,ICONFM)
         CALL USTLFT(FILTXT,78)
         IF(IUCASE.NE.0) CALL USTRUC(FILTXT,78)
         CALL PUTMFL(FILTXT,'CNCA',IUCNCA,IUMOC,IERR)
         IF(IERR.NE.0) GO TO 310
         CALL USTLFT(FILBIN,78)
         IF(IUCASE.NE.0) CALL USTRUC(FILBIN,78)
         CALL PUTMFL(FILBIN,'CNCB',IUCNCB,IUMOC,IERR)
         IF(IERR.NE.0) GO TO 310
         IF(IFREQ.EQ.4) THEN
            NPNTCL=NTRVAL
         ELSE IF(IFREQ.EQ.3) THEN
            NPNTCL=-1
         ELSE IF(IFREQ.EQ.2) THEN
            NPNTCL=-2
         ELSE
            NPNTCL=0
         END IF
         CALL IVLSAV('NPNTCL',0,0,NPNTCL)
C  Get velocity data
         CALL WDialogGetMenu(IFREQ_VELOCITY,IFREQ)
         CALL WDialogGetInteger(NTRVAL_VELOCITY,NTRVAL)
         CALL WDialogGetInteger(GWT_IVELFM,IVELFM)
         CALL WDialogGetString(FILTXT_VELOCITY,FILTXT)
         CALL WDialogGetString(FILBIN_VELOCITY,FILBIN)
         CALL IVLSAV('IVELFM',0,0,IVELFM)
         CALL USTLFT(FILTXT,78)
         IF(IUCASE.NE.0) CALL USTRUC(FILTXT,78)
         CALL PUTMFL(FILTXT,'VELA',IUVELA,IUMOC,IERR)
         IF(IERR.NE.0) GO TO 310
         CALL USTLFT(FILBIN,78)
         IF(IUCASE.NE.0) CALL USTRUC(FILBIN,78)
         CALL PUTMFL(FILBIN,'VELB',IUVELB,IUMOC,IERR)
         IF(IERR.NE.0) GO TO 310
         IF(IFREQ.EQ.3) THEN
            NPNTVL=NTRVAL
         ELSE IF(IFREQ.EQ.2) THEN
            NPNTVL=-1
         ELSE
            NPNTVL=0
         END IF
         CALL IVLSAV('NPNTVL',0,0,NPNTVL)
C  Get dispersion data
         CALL WDialogGetMenu(IFREQ_DISPERSION,IFREQ)
         CALL WDialogGetInteger(NTRVAL_DISPERSION,NTRVAL)
         CALL WDialogGetInteger(GWT_IDSPFM,IDSPFM)
         CALL IVLSAV('IDSPFM',0,0,IDSPFM)
         IF(IFREQ.EQ.4) THEN
            NPNTDL=NTRVAL
         ELSE IF(IFREQ.EQ.3) THEN
            NPNTDL=-1
         ELSE IF(IFREQ.EQ.2) THEN
            NPNTDL=-2
         ELSE
            NPNTDL=0
         END IF
         CALL IVLSAV('NPNTDL',0,0,NPNTDL)
C  Get particles data
         CALL WDialogGetMenu(IFREQ_PARTICLES,IFREQ)
         CALL WDialogGetInteger(NTRVAL_PARTICLES,NTRVAL)
         CALL WDialogGetString(FILTXT_PARTICLES,FILTXT)
         CALL WDialogGetString(FILBIN_PARTICLES,FILBIN)
         CALL USTLFT(FILTXT,78)
         IF(IUCASE.NE.0) CALL USTRUC(FILTXT,78)
         CALL PUTMFL(FILTXT,'PRTA',IUPRTA,IUMOC,IERR)
         IF(IERR.NE.0) GO TO 310
         CALL USTLFT(FILBIN,78)
         IF(IUCASE.NE.0) CALL USTRUC(FILBIN,78)
         CALL PUTMFL(FILBIN,'PRTB',IUPRTB,IUMOC,IERR)
         IF(IERR.NE.0) GO TO 310
         IF(IFREQ.EQ.4) THEN
            NPNTPL=NTRVAL
         ELSE IF(IFREQ.EQ.3) THEN
            NPNTPL=-1
         ELSE IF(IFREQ.EQ.2) THEN
            NPNTPL=-2
         ELSE
            NPNTPL=0
         END IF
         CALL IVLSAV('NPNTPL',0,0,NPNTPL)
      END IF
      CALL WDialogUnload(GWT_OUTPUT_DIALOG)
      RETURN
C
      END
      SUBROUTINE U2DPERINX(LABEL,ARRNAM,NCC,NR,IUPACK)
C     ******************************************************************
C     Prompt user for an array that varies according to stress period
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
      TYPE(WIN_MESSAGE)   :: MESSAGE
      INCLUDE 'mfi2k.inc'
      INCLUDE 'mfi2kpar.inc'
      CHARACTER*(*) LABEL,ARRNAM
      CHARACTER*78 CLINE
      CHARACTER*67 FNAME
      CHARACTER*20 FMT
      CHARACTER*4 CPER(MXPER)
C     ------------------------------------------------------------------
      NC=NCC
      IF(NCC.LT.0) NC=-NCC
C
C  Make a list of stress period numbers.
      DO 20 K=1,NPER
      WRITE(CPER(K),'(I4)') K
20    CONTINUE
C
C  Define array defaults
      CON1=0.
      CON2=1.
      CON3=1.
      FNAME=' '
      IFTYP=1   ! 1=File Name, 2=OPEN/CLOSE
C
C  Load the array stress dialog
      CALL WDialogLoad(ARRAY_STRESS_DIALOG)
      CALL WMessageEnable(FieldChanged,Enabled)
C
C  Initialize values
C  Label the package being edited.
      CLINE='Defining values for '//LABEL
      CALL WDialogPutString(ARRAY_PERIODS_TITLE,CLINE)
      K=1
      CALL WDialogPutMenu(ARRAY_PERIODS_NUMBER,CPER,NPER,K)
C
C  Find current array -- create if it doesn't already exist
25    IREAL=1
      FMT='(10F8.0)'
      IPRN=0
      IAMETH=2
      IF(ARRNAM(1:1).EQ.'I') IREAL=0
      CALL VALGET(ARRNAM,0,K,NAR,V)
      IF(NAR.LE.0) THEN
         CALL ARRMAK(ARRNAM,0,K,NC,NR)
         NAR=NARRAY
         IF(IREAL.EQ.0) IARRDA(5,NAR)=4
      END IF
      FMT='(10F8.0)'
      IF(IREAL.EQ.0) FMT='(20I4)'
      IF(IREAL.EQ.0) IPRN=4
      LOCAT=IARRDA(1,NAR)
      IF(LOCAT.EQ.0) THEN
         IAMETH=2  ! Constant array
         IF(IREAL.EQ.0) THEN
            ITMP=ARRCON(NAR)
            IF(ITMP.NE.IMISS) CON1=ARRCON(NAR)
         ELSE
            IF(ARRCON(NAR) .NE. RMISS) CON1=ARRCON(NAR)
         END IF
         CON2=1.0
         CON3=CON2
      ELSE IF(LOCAT.EQ.-1) THEN
         IAMETH=3   !  package array
         CON2=ARRCON(NAR)
         CON1=CON2
         CON3=CON2
      ELSE IF(LOCAT.GT.0) THEN
         IAMETH=4   ! Separate array
         CON3=ARRCON(NAR)
         CON1=CON3
         CON2=CON3
         FMT=ARRFMT(NAR)
         FNAME=FILNAM(LOCAT)
         IPRN=IARRDA(5,NAR)
         IF(FILTYP(LOCAT)(1:10).EQ.'OPEN/CLOSE') IFTYP=2
      ELSE IF(LOCAT.EQ.-3) THEN
         IAMETH=1  !  Previous array
         IF(K.EQ.1) IAMETH=2
      END IF
C
C  Set current values for array
30    IF(K.EQ.1) THEN
         CALL WDialogFieldState(ARRAY_PERIODS_PREVIOUS,Disabled)
      ELSE
         CALL WDialogFieldState(ARRAY_PERIODS_PREVIOUS,Enabled)
      END IF
      IF(IAMETH.EQ.2) THEN
         CALL WDialogPutRadioButton(ARRAY_PERIODS_RADIO_CONSTANT)
         CALL WDialogFieldState(ARRAY_PERIODS_CONSTANT,Enabled)
         CALL WDialogFieldState(ARRAY_PERIODS_MULTIPLIER,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_MULTIPLIER2,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_IPRN,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_FORMAT,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_FILE,Disabled)
         CALL WDialogFieldState(FILE_BROWSE,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_FILE_TYPE,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_SPREADSHEET,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_GRID,Disabled)
      ELSE IF(IAMETH.EQ.3) THEN
         CALL WDialogPutRadioButton(ARRAY_PERIODS_RADIO_PACKAGE)
         CALL WDialogFieldState(ARRAY_PERIODS_CONSTANT,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_MULTIPLIER,Enabled)
         CALL WDialogFieldState(ARRAY_PERIODS_MULTIPLIER2,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_IPRN,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_FORMAT,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_FILE,Disabled)
         CALL WDialogFieldState(FILE_BROWSE,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_FILE_TYPE,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_SPREADSHEET,Enabled)
         IF(NC.GT.100 .OR. NR.GT.100) THEN
            CALL WDialogFieldState(ARRAY_PERIODS_GRID,Disabled)
         ELSE
            CALL WDialogFieldState(ARRAY_PERIODS_GRID,Enabled)
          END IF
      ELSE IF(IAMETH.EQ.4) THEN
         CALL WDialogPutRadioButton(ARRAY_PERIODS_RADIO_SEPARATE)
         CALL WDialogFieldState(ARRAY_PERIODS_CONSTANT,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_MULTIPLIER,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_MULTIPLIER2,Enabled)
         CALL WDialogFieldState(ARRAY_PERIODS_IPRN,Enabled)
         CALL WDialogFieldState(ARRAY_PERIODS_FORMAT,Enabled)
         CALL WDialogFieldState(ARRAY_PERIODS_FILE,Enabled)
         CALL WDialogFieldState(FILE_BROWSE,Enabled)
         CALL WDialogFieldState(ARRAY_PERIODS_FILE_TYPE,Enabled)
         CALL WDialogFieldState(ARRAY_PERIODS_SPREADSHEET,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_GRID,Disabled)
      ELSE
         CALL WDialogPutRadioButton(ARRAY_PERIODS_PREVIOUS)
         CALL WDialogFieldState(ARRAY_PERIODS_CONSTANT,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_MULTIPLIER,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_MULTIPLIER2,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_IPRN,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_FORMAT,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_FILE,Disabled)
         CALL WDialogFieldState(FILE_BROWSE,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_FILE_TYPE,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_SPREADSHEET,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_GRID,Disabled)
      END IF
      CALL WDialogPutInteger(ARRAY_PERIODS_IPRN,IPRN)
      CALL WDialogPutReal(ARRAY_PERIODS_CONSTANT,CON1,'(1PG13.6)')
      CALL WDialogPutReal(ARRAY_PERIODS_MULTIPLIER,CON2,'(1PG13.6)')
      CALL WDialogPutReal(ARRAY_PERIODS_MULTIPLIER2,CON3,'(1PG13.6)')
      CALL WDialogPutString(ARRAY_PERIODS_FORMAT,FMT)
      CALL WDialogPutString(ARRAY_PERIODS_FILE,FNAME)
      CALL WDialogPutOption(ARRAY_PERIODS_FILE_TYPE,IFTYP)
C
C  Make Array Dialog visible
      CALL WDialogShow(-1,50,0,SemiModeless)
50    CALL WMessage(ITYPE,MESSAGE)
C
C  Act upon field changes
      IF(ITYPE.EQ.FieldChanged) THEN
C
C  Check for period change
         CALL WDialogGetMenu(ARRAY_PERIODS_NUMBER,KNEW)
         IF(KNEW.NE.K) THEN
            CALL U2DPERINGET(NAR,IUPACK,0,' ',IERR)
            CALL WDialogSelect(ARRAY_STRESS_DIALOG)
            IF(IERR.NE.0) GO TO 25
            K=KNEW
            GO TO 25
         END IF
C
C  Check for array Method change
         CALL WDialogGetRadioButton(ARRAY_PERIODS_RADIO_CONSTANT,IAMNEW)
         IF(IAMNEW.NE.IAMETH) THEN
            IAMETH=IAMNEW
            IF(IAMETH.EQ.3 .AND. IARRDA(2,NAR).EQ.0) THEN
               CALL ARRALO(IARRDA(2,NAR),IARRDA(3,NAR),IARRDA(4,NAR))
               LOC=IARRDA(2,NAR)
               IF(IREAL.NE.0) THEN
                  CALL ZIPR(NC*NR,0.,X(LOC))
C                  IF(NCC.GT.0) CALL SS2DR(X(LOC),NC,NR,ARRNAM,
C     1       ARRAY_STRESS_DIALOG)
                  CALL WMessageEnable(FieldChanged,Enabled)
               ELSE
                  CALL ZIPI(NC*NR,1,IX(LOC))
C                  IF(NCC.GT.0) CALL SS2DI(IX(LOC),NC,NR,ARRNAM,
C     1       ARRAY_STRESS_DIALOG)
                  CALL WMessageEnable(FieldChanged,Enabled)
               END IF
            END IF
            GO TO 30
         END IF
C
C  Check for push buttons
      ELSE IF(ITYPE.EQ.PushButton) THEN
C
C  Check for ARRAY_PERIODS_SPREADSHEET
         IF(MESSAGE%VALUE1.EQ.ARRAY_PERIODS_SPREADSHEET) THEN
             IF(NCC.GT.0) THEN
               LOC=IARRDA(2,NAR)
               I=1
               IF(IREAL.NE.0) CALL SS2DR(X(LOC),NC,NR,ARRNAM,
     1       ARRAY_STRESS_DIALOG)
               IF(IREAL.EQ.0) CALL SS2DI(IX(LOC),NC,NR,ARRNAM,
     1       ARRAY_STRESS_DIALOG)
               CALL WMessageEnable(FieldChanged,Enabled)
            END IF
C
C  Check for ARRAY_PERIODS_SPREADSHEET
         ELSE IF(MESSAGE%VALUE1.EQ.ARRAY_PERIODS_GRID) THEN
             IF(NCC.GT.0) THEN
               LOC=IARRDA(2,NAR)
               I=1
               IF(NC.LE.100 .AND.NR.LE.100) THEN
               IF(IREAL.NE.0) CALL SS2DRG(X(LOC),NC,NR,ARRNAM,
     1       ARRAY_STRESS_DIALOG)
               IF(IREAL.EQ.0) CALL SS2DIG(IX(LOC),NC,NR,ARRNAM,
     1       ARRAY_STRESS_DIALOG)
               CALL WMessageEnable(FieldChanged,Enabled)
               END IF
            END IF
C
C  Check for Browse
         ELSE IF(MESSAGE%VALUE1.EQ.FILE_BROWSE) THEN
            CALL BROWSE(FNAME)
            CALL WDialogSelect(ARRAY_STRESS_DIALOG)
            GO TO 30
C
C  Check for OK
         ELSE IF(MESSAGE%VALUE1.EQ.ARRAY_PERIODS_IDOK) THEN
            CALL U2DPERINGET(NAR,IUPACK,0,' ',IERR)
            CALL WDialogSelect(ARRAY_STRESS_DIALOG)
            IF(IERR.NE.0) GO TO 50
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL WDialogUnload(ARRAY_STRESS_DIALOG)
            RETURN
C
C  Check for CANCEL
         ELSE IF(MESSAGE%VALUE1.EQ.IDCANCEL) THEN
C  Exit without storing values
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL WDialogUnload(ARRAY_STRESS_DIALOG)
            RETURN
         END IF
C
C  Ignore all other types of message
      END IF
      GO TO 50
C
      END
      SUBROUTINE MOCOBS
C     ******************************************************************
C     Edit GWT Observation sites
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
      TYPE(WIN_MESSAGE)   :: MESSAGE
      INCLUDE 'mfi2k.inc'
      INCLUDE 'mfi2kpar.inc'
      COMMON /MOCCOM/IUMOCL,IUMOC,IUCRC,IUCOBS,NSCOL,NSROW,NSLAY,
     1     ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2,
     2     NODISP,NPTPND,ICINFL,MOCMETH,
     3     PNEWL(51),PNEWR(51),PNEWC(51),IZONE(MXCZON),ZONCON(MXCZON),
     4     ICOB(3,MXCOB),ICOBFL(MXCOB)
      DIMENSION IDUM(MXCOB)
      CHARACTER*80 CTXT(1)
      CHARACTER*78 COBSFL,COBSAV,COBFIL(MXCOB)
C     ------------------------------------------------------------------
      CALL WDialogLoad(GWT_OBS_DIALOG)
C
C  Display current observation file names
      IF(IUCOBS.EQ.0) THEN
	 IF(IUCASE.NE.0) COBSFL=DSNAME(1:NDSNAM)//'.COB'
	 IF(IUCASE.EQ.0) COBSFL=DSNAME(1:NDSNAM)//'.cob'
      ELSE
	 COBSFL=FILNAM(IUCOBS)
      END IF
      CALL WDialogPutString(GWT_COBSFL,COBSFL)
      CALL IVLGET('IOBSFL',0,0,ITYPE,IOBSFL)
      IF(ITYPE.NE.0) IOBSFL=0
      COBSAV=' '
      IF(IOBSFL.GT.0) COBSAV=FILNAM(IOBSFL)
770   CALL WDialogPutString(GWT_COBSFL,COBSFL)
      CALL WDialogPutString(GWT_COBSAV,COBSAV)
      DO 771 I=1,MXCOB
      IDUM(I)=ICOB(1,I)
771   CONTINUE
      CALL WGridPutInteger(GWT_OBS_GRID,1,IDUM,MXCOB)
      DO 772 I=1,MXCOB
      IDUM(I)=ICOB(2,I)
772   CONTINUE
      CALL WGridPutInteger(GWT_OBS_GRID,2,IDUM,MXCOB)
      DO 773 I=1,MXCOB
      IDUM(I)=ICOB(3,I)
773   CONTINUE
      CALL WGridPutInteger(GWT_OBS_GRID,3,IDUM,MXCOB)
      CALL WGridRows(GWT_OBS_GRID,MXCOB)
      IF(IOBSFL.EQ.0) THEN
C  Convert file unit to file name
         DO 782 I=1,MXCOB
         COBFIL(I)=' '
         IF(ICOBFL(I).NE.0) COBFIL(I)=FILNAM(ICOBFL(I))
782      CONTINUE
         CALL WGridPutString(GWT_OBS_GRID,4,COBFIL,MXCOB)
         CALL WGridState(GWT_OBS_GRID,4,ENABLED)
      ELSE
         CALL WGridState(GWT_OBS_GRID,4,DISABLED)
      END IF
C
      CALL WDialogShow(-1,50,0,MODAL)
C
C  Get and store values if "OK" was pushed
      IF(WInfoDialog(ExitButton).EQ.IDOK) THEN
         CALL WDialogGetString(GWT_COBSFL,COBSFL)
         IF(COBSFL.EQ.' ') THEN
            IUCOBS=0
            GO TO 791
         ELSE
            CALL USTLFT(COBSFL,78)
            IF(IUCASE.NE.0) CALL USTRUC(COBSFL,78)
            CALL FNMSV4(COBSFL,IU,'OBS',IUMOC)
            IF(IU.LT.0) GO TO 770
            IUCOBS=IU
         END IF
         CALL WDialogGetSTRING(GWT_COBSAV,COBSAV)
         IF(COBSAV.EQ.' ') THEN
            IOBSFL=0
         ELSE
            CALL USTLFT(COBSAV,78)
	    IF(IUCASE.NE.0) CALL USTRUC(COBSAV,78)
            CALL FNMSV4(COBSAV,IU,'DATA',IUMOC)
            IF(IU.LT.0) GO TO 770
            IOBSFL=IU
         END IF
         CALL IVLSAV('IOBSFL',0,0,IOBSFL)
C
C  Get observation sites
         N=MXCOB
         CALL WGridGetInteger(GWT_OBS_GRID,1,IDUM,N)
         DO 785 I=1,MXCOB
         ICOB(1,I)=IDUM(I)
785      CONTINUE
         CALL WGridGetInteger(GWT_OBS_GRID,2,IDUM,N)
         DO 786 I=1,MXCOB
         ICOB(2,I)=IDUM(I)
786      CONTINUE
         CALL WGridGetInteger(GWT_OBS_GRID,3,IDUM,N)
         DO 787 I=1,MXCOB
         ICOB(3,I)=IDUM(I)
787      CONTINUE
         IF(IOBSFL.EQ.0) THEN
            CALL WGridGetString(GWT_OBS_GRID,4,COBFIL,N)
C  Convert file names to file units -- substitute prior name for blank names
            DO 790 I=1,MXCOB
            IF(ICOB(1,I).GE.ISLAY1 .AND. ICOB(1,I).LE.ISLAY2 .AND.
     1         ICOB(2,I).GE.ISROW1 .AND. ICOB(2,I).LE.ISROW2 .AND.
     2         ICOB(3,I).GE.ISCOL1 .AND. ICOB(3,I).LE.ISCOL2) THEN
               CALL USTLFT(COBFIL(I),60)
               IF(IUCASE.NE.0) CALL USTRUC(COBFIL(I),60)
               IF(COBFIL(I).EQ.' ') THEN
                  ICOBFL(I)=0
                  CTXT(1)=
     1     'All observation sites must have a non-blank file name'
                  CALL TXTLOG(CTXT,1)
                  CALL WDialogSelect(GWT_OBS_DIALOG)
                  GO TO 770
               END IF
C  Check that old name is of type DATA and user MOC.  If a new name, add to
C  list of names.
               CALL FNMSV4(COBFIL(I),IU,'DATA',IUMOC)
               IF(IU.LT.0) THEN
                  ICOBFL(I)=0
                  GO TO 770
               END IF
               ICOBFL(I)=IU
            ELSE
               ICOB(1,I)=0
               ICOB(2,I)=0
               ICOB(3,I)=0
               ICOBFL(I)=0
            END IF
790         CONTINUE
         END IF
C
      END IF
C
791   CALL WDialogUnload(GWT_OBS_DIALOG)
      RETURN
      END
