      SUBROUTINE LPFED
C     ******************************************************************
C     Input LPF Package data
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
      INCLUDE 'mfi2k.inc'
      INCLUDE 'mfi2kpar.inc'
      TYPE(WIN_MESSAGE)   :: MESSAGE
      COMMON /LPFCOM/LAYTYP(200),LAYAVG(200),CHANI(200),LAYVKA(200),
     1               LAYWET(200),LAYFLG(200,6)
      DIMENSION LAYTMP(200)
      CHARACTER*50 CTXT(2)
C     ------------------------------------------------------------------
C
C  Check if BCF is already active
      IF(IUNIT(1).GT.0) THEN
         CALL WMessageBox(YesNo,QuestionIcon,CommonYes,
     1   'BCF is already active -- do you want to deactivate BCF?',' ')
         IRESP=WInfoDialog(ExitButtonCommon)
         IF(IRESP.NE.CommonYes) RETURN
C  User confirms, so deactivate
C  Set in-use flag to 0 for any files that were used by LPF.
         DO 40 J=1,MXFNAM
         IF(IFNUSE(J).EQ.IUNIT(1)) IFNUSE(J)=0
40       CONTINUE
C  Set IUNIT=0
         IUNIT(1)=0
C  Set INUIT2 to 0 as well as the in-use flag for a cbc budget file
C  used only by this package.
         IF(IUNIT2(1).GT.0) THEN
            NBD=0
            DO 45 L=1,40
            IF(IUNIT2(L).EQ.IUNIT2(1)) NBD=NBD+1
45          CONTINUE
            IF(NBD.EQ.1) IFNUSE(IUNIT2(1))=0
         END IF
         IUNIT2(1)=0
         CALL FNMRMV
      END IF
C
C  Set IUNIT if not already set
      IF(IUNIT(23).EQ.0) THEN
         CALL FINDUN(33,IU,'LPF','LPF')
         IUNIT(23)=IU
         IUNIT2(23)=0
         DO 46 K=1,200
         LAYTYP(K)=0
         LAYAVG(K)=0
         CHANI(K)=1.0
         LAYVKA(K)=0
         LAYWET(K)=0
         LAYFLG(K,1)=0
         LAYFLG(K,2)=0
         LAYFLG(K,3)=0
         LAYFLG(K,4)=0
         LAYFLG(K,5)=0
         LAYFLG(K,6)=0
46       CONTINUE
      END IF
C
C  Display LPF dialog
      CALL WDialogLoad(LPF_DIALOG)
      CALL WDialogShow(-1,50,0,SemiModeless)
C
50    CALL WMessage(ITYPE,MESSAGE)
C
C  Check for push buttons
      IF(ITYPE.EQ.PushButton) THEN
         IF(MESSAGE%VALUE1.EQ.LPF_CHECK_BUT) THEN
C  CHECK BUTTON
            CALL LPFSV(IUNDEF,-1)
C
         ELSE IF(MESSAGE%VALUE1.EQ.LPF_HDRY_BUT) THEN
C  HDRY BUTTON
            CALL WDialogLoad(LPF_HDRY_DIALOG)
C  Initialize values
            CALL VALGET('HDRY',0,0,ITYPE,HDRY)
            IF(ITYPE.NE.0) HDRY=1.E30
            CALL WDialogPutReal(LPF_HDRY,HDRY,'(1PG13.6)')
            CALL VALGET('WETFCT',0,0,ITYPE,WETFCT)
            IF(ITYPE.NE.0) WETFCT=.5
            CALL WDialogPutReal(LPF_WETFCT,WETFCT,' ')
            CALL IVLGET('IWETIT',0,0,ITYPE,IWETIT)
            IF(ITYPE.NE.0) IWETIT=1
            CALL WDialogPutInteger(LPF_IWETIT,IWETIT)
            CALL IVLGET('IHDWET',0,0,ITYPE,IHDWET)
            IF(ITYPE.NE.0) IHDWET=0
            IHW=1
            IF(IHDWET.NE.0) IHW=2
            CALL WDialogPutOption(LPF_IHDWET,IHW)
C
C  Make HDRY Dialog visible
            CALL WDialogShow(-1,50,0,MODAL)
C  Get and store values if "OK" was pushed
            IF(WInfoDialog(ExitButton).EQ.IDOK) THEN
               CALL WDialogGetReal(LPF_HDRY,HDRY)
               CALL VALSAV('HDRY',0,0,HDRY)
               CALL WDialogGetReal(LPF_WETFCT,WETFCT)
               CALL VALSAV('WETFCT',0,0,WETFCT)
               CALL WDialogGetInteger(LPF_IWETIT,IWETIT)
               CALL IVLSAV('IWETIT',0,0,IWETIT)
               CALL WDialogGetMenu(LPF_IHDWET,IHW)
               CALL IVLSAV('IHDWET',0,0,IHW-1)
            END IF
            CALL WDialogUnload(LPF_HDRY_DIALOG)
C
         ELSE IF(MESSAGE%VALUE1.EQ.LPF_LAYDAT_BUT) THEN
C  LAYTYP PUSHBUTTON
            CALL LPFLAYED
C  Make sure all CHANI=0. if NPHANI>0
            NPHANI=0
            IF(IPSUM.GT.0) THEN
               DO 41 I=1,IPSUM
               IF(PARTYP(I).EQ.'HANI') THEN
                  NPHANI=NPHANI+1
               END IF
41             CONTINUE
            END IF
            IF(NPHANI.GT.0) THEN
               IP=0
               DO 42 K=1,NLAY
               IF(CHANI(K).GT.0.0) THEN
                  IF(IP.EQ.0) THEN
             CTXT(1)='Nonzero CHANI values have been set to 0 because'
             CTXT(2)='there are HANI parameters'
                     CALL TXTLOG(CTXT,2)
                  END IF
                  CHANI(K)=0.
                  IP=1
               END IF
42             CONTINUE
            END IF
C
         ELSE IF(MESSAGE%VALUE1.EQ.LPF_HYDRAULIC_BUT) THEN
C  HYDRAULIC PUSHBUTTON
            CALL LPFHYD()
C  Make sure all CHANI=0. if NPHANI>0
            NPHANI=0
            IF(IPSUM.GT.0) THEN
               DO 43 I=1,IPSUM
               IF(PARTYP(I).EQ.'HANI') THEN
                  NPHANI=NPHANI+1
               END IF
43             CONTINUE
            END IF
            IF(NPHANI.GT.0) THEN
               IP=0
               DO 44 K=1,NLAY
               IF(CHANI(K).GT.0.0) THEN
                  IF(IP.EQ.0) THEN
             CTXT(1)='Nonzero CHANI values have been set to 0 because'
             CTXT(2)='there are HANI parameters'
                     CALL TXTLOG(CTXT,2)
                  END IF
                  CHANI(K)=0.
                  IP=1
               END IF
44             CONTINUE
            END IF
C
         ELSE IF(MESSAGE%VALUE1.EQ.LPF_LAYFLG_BUT) THEN
C  LAYFLG PUSHBUTTON
            CALL WDialogLoad(LPF_LAYFLG_DIALOG)
            CALL WGridRows(LAYFLG_GRID,NLAY)
            DO 60 K=1,NLAY
            LAYTMP(K)=K
60          CONTINUE
            CALL WGridPutInteger(LAYFLG_GRID,1,LAYTMP(1),NLAY)
            CALL WGridState(LAYFLG_GRID,1,DialogReadOnly)
            CALL WGridPutInteger(LAYFLG_GRID,2,LAYFLG(1,1),NLAY)
            CALL WGridPutInteger(LAYFLG_GRID,3,LAYFLG(1,2),NLAY)
            CALL WGridPutInteger(LAYFLG_GRID,4,LAYFLG(1,3),NLAY)
            CALL WGridPutInteger(LAYFLG_GRID,5,LAYFLG(1,4),NLAY)
            CALL WGridPutInteger(LAYFLG_GRID,6,LAYFLG(1,5),NLAY)
            CALL WGridPutInteger(LAYFLG_GRID,7,LAYFLG(1,6),NLAY)
C
            CALL WDialogShow(-1,50,0,MODAL)
C  Get and store values if "OK" was pushed
            IF(WInfoDialog(ExitButton).EQ.IDOK) THEN
               CALL WGridGetInteger(LAYFLG_GRID,2,LAYFLG(1,1),NLAY)
               CALL WGridGetInteger(LAYFLG_GRID,3,LAYFLG(1,2),NLAY)
               CALL WGridGetInteger(LAYFLG_GRID,4,LAYFLG(1,3),NLAY)
               CALL WGridGetInteger(LAYFLG_GRID,5,LAYFLG(1,4),NLAY)
               CALL WGridGetInteger(LAYFLG_GRID,6,LAYFLG(1,5),NLAY)
               CALL WGridGetInteger(LAYFLG_GRID,7,LAYFLG(1,6),NLAY)
            END IF
            CALL WDialogUnload(LPF_LAYFLG_DIALOG)
C
         ELSE IF(MESSAGE%VALUE1.EQ.LPF_COMMENT_BUT) THEN
C  Comment button
            CALL COMNTIN(23)
C
         ELSE IF(MESSAGE%VALUE1.EQ.IDCLOSE) THEN
C  CLOSE PUSHBUTTON -- done with LPF dialog
            CALL LPFSV(IUNDEF,1)
            CALL WDialogUnload(LPF_DIALOG)
            RETURN
         END IF
         CALL WDialogSelect(LPF_DIALOG)
      END IF
      GO TO 50
C
      END
      SUBROUTINE LPFLAYED
C     ******************************************************************
C     Input LPF Layer data
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
      INCLUDE 'mfi2kpar.inc'
C
      INCLUDE 'mfi2k.inc'
      COMMON /LPFCOM/LAYTYP(200),LAYAVG(200),CHANI(200),LAYVKA(200),
     1               LAYWET(200),LAYFLG(200,6)
      DIMENSION IIIDUM(200),DUM(200)
      CHARACTER*4 CLAY(200)
      CHARACTER*50 CTXT(1)
C     ------------------------------------------------------------------
C
C  Load the LAYTYP dialog
25    CALL WDialogLoad(LPF_LAYTYP_DIALOG)
C
C  Set current values for table
      NL=NLAY
      CALL WGridRows(LPF_LAYTYP_GRID,NL)
      DO 30 I=1,NLAY
      IIIDUM(I)=I
30    CONTINUE
      NL=NLAY
      CALL WGridPutInteger(LPF_LAYTYP_GRID,1,IIIDUM,NL)
C
      DO 32 I=1,NLAY
      IIIDUM(I)=LAYTYP(I) + 1
32    CONTINUE
      NL=NLAY
      CALL WGridPutOption(LPF_LAYTYP_GRID,2,IIIDUM,NL)
C
      DO 34 I=1,NLAY
      IIIDUM(I)=LAYAVG(I) + 1
34    CONTINUE
      NL=NLAY
      CALL WGridPutOption(LPF_LAYTYP_GRID,3,IIIDUM,NL)
C
      DO 36 I=1,NLAY
      DUM(I)=CHANI(I)
36    CONTINUE
      NL=NLAY
      CALL WGridPutReal(LPF_LAYTYP_GRID,4,DUM,NL)
C
      DO 38 I=1,NLAY
      IIIDUM(I)=LAYVKA(I) + 1
38    CONTINUE
      NL=NLAY
      CALL WGridPutOption(LPF_LAYTYP_GRID,5,IIIDUM,NL)
C
      DO 40 I=1,NLAY
      IIIDUM(I)=LAYWET(I) + 1
40    CONTINUE
      NL=NLAY
      CALL WGridPutOption(LPF_LAYTYP_GRID,6,IIIDUM,NL)
C
C  Make LAYTYP Dialog visible
      CALL WDialogShow(-1,50,0,Modal)
C
C  Process values if OK was pushed
      IF(WInfoDialog(ExitButton).EQ.IDOK) THEN
         NL=NLAY
         CALL WGridGetMenu(LPF_LAYTYP_GRID,2,IIIDUM,NL)
         DO 42 I=1,NLAY
         LAYTYP(I)=IIIDUM(I)-1
42       CONTINUE
C
         NL=NLAY
         CALL WGridGetMenu(LPF_LAYTYP_GRID,3,IIIDUM,NL)
         DO 44 I=1,NLAY
         LAYAVG(I)=IIIDUM(I)-1
44       CONTINUE
C
         NL=NLAY
         CALL WGridGetReal(LPF_LAYTYP_GRID,4,DUM,NL)
         DO 46 I=1,NLAY
         CHANI(I)=DUM(I)
         IF(CHANI(I).LT.0.) CHANI(I)=0.
46       CONTINUE
C
C  Get LAYVKA values
         NL=NLAY
         CALL WGridGetMenu(LPF_LAYTYP_GRID,5,IIIDUM,NL)
         NVK=0
         NVANI=0
         DO 48 I=1,NLAY
         LAYVKA(I)=IIIDUM(I)-1
         IF(LAYVKA(I).EQ.0) NVK=NVK+1
         IF(LAYVKA(I).EQ.1) NVANI=NVANI+1
48       CONTINUE
C  Convert VANI parameters to VK if there are no VANI layers.
C  Convert VK parameters to VANI if there are no VK layers.
C  This sort of thing can happen if someone changes LAYVKA after
C          defining VANI and VK parameters.
         IF(IPSUM.GT.0) THEN
           IF(NVK.EQ.0) THEN
             DO 49 I=1,IPSUM
               IF(PARTYP(I).EQ.'VK') PARTYP(I)='VANI'
49           CONTINUE
           END IF
           IF(NVANI.EQ.0) THEN
             DO 51 I=1,IPSUM
               IF(PARTYP(I).EQ.'VANI') PARTYP(I)='VK'
51           CONTINUE
           END IF
         END IF
C
         NL=NLAY
         CALL WGridGetMenu(LPF_LAYTYP_GRID,6,IIIDUM,NL)
         DO 50 I=1,NLAY
         LAYWET(I)=IIIDUM(I)-1
         IF(LAYWET(I).NE.0 .AND. LAYTYP(I).EQ.0) THEN
            LAYWET(I)=0
       CTXT(1)='LAYWET cannot be "Wetting On" if LAYTYP is "confined"'
            CALL TXTLOG(CTXT,1)
            CALL WDialogSelect(LPF_LAYTYP_DIALOG)
         END IF
50       CONTINUE
      END IF
      CALL WDialogUnload(LPF_LAYTYP_DIALOG)
C
      RETURN
      END
      SUBROUTINE LPFHYD()
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
C     ******************************************************************
C     Prompt user for LPF Hydraulic Data
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      INCLUDE 'mfi2kpar.inc'
      TYPE(WIN_MESSAGE)   :: MESSAGE
      COMMON /DISCOM/LBOTM(200),LAYCBD(200)
      COMMON /PERCOM/PERLEN(MXPER),NSTP(MXPER),TSMULT(MXPER),
     1               ISSFLG(MXPER)
      COMMON /LPFCOM/LAYTYP(200),LAYAVG(200),CHANI(200),LAYVKA(200),
     1               LAYWET(200),LAYFLG(200,6)
      CHARACTER*10 CN(MXPAR),PN,MN(200),ZN(200),CTMP
      DIMENSION IZN(200,10),LAY(200)
      CHARACTER*10 ARRNAM(7),ARRNAM2(7)
      CHARACTER*67 FNAME
      CHARACTER*20 FMT
      CHARACTER*4 CLAY(200)
      CHARACTER*10 ARRPARNAM(200)
      CHARACTER*4 ARRPARTYP(7)
C     ------------------------------------------------------------------
      IUPACK=IUNIT(23)
      ISS=1
      DO 97 N=1,NPER
      IF(ISSFLG(N).EQ.0) ISS=0
97    CONTINUE
C
C  Load the 3D-array dialog
      CALL WDialogLoad(LPF_HYDRAULIC_DIALOG)
      CALL WMessageEnable(FieldChanged,Enabled)
C
C  Initialize values
C  Make a list of layer numbers.
      DO 1 K=1,NLAY
      WRITE(CLAY(K),'(I4)') K
1     CONTINUE
      K=1
      CALL WDialogPutMenu(ARRAY_LAYER,CLAY,NLAY,K)
C
C  Make a list of allowed parameter types
      NPT=1
      ARRPARTYP(NPT)='HK'
      DO 2 I=1,NLAY
      IF(CHANI(I).LE.0.0) THEN
         NPT=NPT+1
         ARRPARTYP(NPT)='HANI'
         GO TO 3
      END IF
2     CONTINUE
3     NVK=0
      DO 4 I=1,NLAY
      IF(LAYVKA(I).EQ.0) THEN
         NVK=NVK+1
         IF(NVK.EQ.1) THEN
            NPT=NPT+1
            ARRPARTYP(NPT)='VK'
         END IF
      END IF
4     CONTINUE
      IF(NVK.NE.NLAY) THEN
         NPT=NPT+1
         ARRPARTYP(NPT)='VANI'
      END IF
      IF(ISS.EQ.0) THEN
         NPT=NPT+1
         ARRPARTYP(NPT)='SS'
         DO 6 I=1,NLAY
         IF(LAYTYP(I).NE.0) THEN
            NPT=NPT+1
            ARRPARTYP(NPT)='SY'
            GO TO 7
         END IF
6        CONTINUE
      END IF
7     DO 8 I=1,NLAY
      IF(LAYCBD(I).NE.0) THEN
         NPT=NPT+1
         ARRPARTYP(NPT)='VKCB'
         GO TO 9
      END IF
8     CONTINUE
9     IPT=1
      CALL WDialogPutMenu(PARAMETER_TYPE,ARRPARTYP,NPT,IPT)
C
C  Count the number of parameters of all types, and show current
C  parameters of the specified type
10    NP=0
      NPHK=0
      NPHANI=0
      NPVKA=0
      NPSS=0
      NPSY=0
      NPVKCB=0
      IF(IPSUM.GT.0) THEN
         DO 11 I=1,IPSUM
         IF(PARTYP(I).EQ.'HK') NPHK=NPHK+1
11       CONTINUE
         DO 12 I=1,IPSUM
         IF(PARTYP(I).EQ.'HANI') NPHANI=NPHANI+1
12       CONTINUE
         DO 13 I=1,IPSUM
         IF(PARTYP(I).EQ.'VK') NPVKA=NPVKA+1
13       CONTINUE
         DO 14 I=1,IPSUM
         IF(PARTYP(I).EQ.'VANI') NPVKA=NPVKA+1
14       CONTINUE
         DO 15 I=1,IPSUM
         IF(PARTYP(I).EQ.'SS') NPSS=NPSS+1
15       CONTINUE
         DO 16 I=1,IPSUM
         IF(PARTYP(I).EQ.'SY') NPSY=NPSY+1
16       CONTINUE
         DO 17 I=1,IPSUM
         IF(PARTYP(I).EQ.'VKCB') NPVKCB=NPVKCB+1
17       CONTINUE
         DO 18 I=1,IPSUM
         IF(PARTYP(I).EQ.ARRPARTYP(IPT)) THEN
            NP=NP+1
            ARRPARNAM(NP)=PARNAM(I)
         END IF
18       CONTINUE
      END IF
      NPDSP=NP
      IF(NP.EQ.0) THEN
         ARRPARNAM(1)='(None)'
         NPDSP=1
      END IF
      IP=1
      CALL WDialogPutString(PARAMETER_LABEL,'Currently Defined '//
     1                 ARRPARTYP(IPT)//' Parameters')
      CALL WDialogPutMenu(PARAMETERS_FOR_TYPE,ARRPARNAM,NPDSP,IP)
C
C  For each required array, show if it is currently defined using
C  parameters.
      NDSP=0
      IF(NPHK.GT.0) THEN
         NDSP=NDSP+1
         ARRNAM2(NDSP)='HK'
      END IF
      IF(NPVKA.GT.0) THEN
         NDSP=NDSP+1
         ARRNAM2(NDSP)='VKA'
      END IF
      IF(NPSS.GT.0) THEN
         NDSP=NDSP+1
         ARRNAM2(NDSP)='SS'
      END IF
      IF(NPSY.GT.0) THEN
         NDSP=NDSP+1
         ARRNAM2(NDSP)='SY'
      END IF
      IF(NPVKCB.GT.0) THEN
         NDSP=NDSP+1
         ARRNAM2(NDSP)='VKCB'
      END IF
      IF(NDSP.EQ.0) THEN
         ARRNAM2(1)='(None)'
         NDSP=1
      END IF
      CALL WDialogPutMenu(ALL_ARRAYS_BY_PARAMETERS,ARRNAM2,NDSP,0)
C
C  Show non-parameter arrays
25    NNPAR=0
      IF(NPHK.EQ.0) THEN
         NNPAR=NNPAR+1
         ARRNAM(NNPAR)='HK'
      END IF
      IF(NPHANI.EQ.0 .AND. CHANI(K).LE.0.0) THEN
         NNPAR=NNPAR+1
         ARRNAM(NNPAR)='HANI'
      END IF
      IF(NPVKA.EQ.0) THEN
         NNPAR=NNPAR+1
         ARRNAM(NNPAR)='VKA'
      END IF
      IF(ISS.EQ.0 .AND. NPSS.EQ.0) THEN
         NNPAR=NNPAR+1
         ARRNAM(NNPAR)='SS'
      END IF
      IF(ISS.EQ.0 .AND. NPSY.EQ.0 .AND. LAYTYP(K).NE.0) THEN
         NNPAR=NNPAR+1
         ARRNAM(NNPAR)='SY'
      END IF
      IF(LAYCBD(K).NE.0 .AND. NPVKCB.EQ.0) THEN
         NNPAR=NNPAR+1
         ARRNAM(NNPAR)='VKCB'
      END IF
      IF(LAYWET(K).NE.0) THEN
         NNPAR=NNPAR+1
         ARRNAM(NNPAR)='WETDRY'
      END IF
      NADSP=NNPAR
      IF(NNPAR.EQ.0) THEN
         ARRNAM(1)='(None)'
         NADSP=1
      END IF
      IANAME=1
      CALL WDialogPutMenu(ARRAY_NAME,ARRNAM,NADSP,IANAME)
C  
C  Find array -- create if it doesn't already exist
C  Define defaults
28    IAMETH=1
      CON1=0.
      CON2=1.
      CON3=1.
      FMT='(10F8.0)'
      FNAME=' '
      IFTYP=1   ! 1=File Name, 2=OPEN/CLOSE
      IPRN=0
      IF(NNPAR.NE.0) THEN
         CALL VALGET(ARRNAM(IANAME),K,0,NAR,V)
         IF(NAR.LE.0) THEN
            CALL ARRMAK(ARRNAM(IANAME),K,0,NCOL,NROW)
            NAR=NARRAY
         END IF
         LOCAT=IARRDA(1,NAR)
         IF(LOCAT.EQ.0) THEN
            IF(ARRCON(NAR) .NE. RMISS) CON1=ARRCON(NAR)
            CON2=1.0
            CON3=CON2
         ELSE IF(LOCAT.EQ.-1) THEN
            IAMETH=2
            CON2=ARRCON(NAR)
            CON1=CON2
            CON3=CON2
         ELSE IF(LOCAT.GT.0) THEN
            IAMETH=3
            CON3=ARRCON(NAR)
            CON1=CON3
            CON2=CON3
            FMT=ARRFMT(NAR)
            FNAME=FILNAM(LOCAT)
            IPRN=IARRDA(5,NAR)
            IF(FILTYP(LOCAT)(1:10).EQ.'OPEN/CLOSE') IFTYP=2
         END IF
      END IF
C
C  Set current values for array
30    IF(NNPAR.GT.0) THEN
         IF(IAMETH.EQ.1) THEN
            CALL WDialogPutRadioButton(ARRAY_TYPE_CONSTANT)
            CALL WDialogFieldState(ARRAY_CONSTANT,Enabled)
            CALL WDialogFieldState(ARRAY_MULTIPLIER,Disabled)
            CALL WDialogFieldState(ARRAY_MULTIPLIER2,Disabled)
            CALL WDialogFieldState(ARRAY_IPRN,Disabled)
            CALL WDialogFieldState(ARRAY_FORMAT,Disabled)
            CALL WDialogFieldState(ARRAY_FILE,Disabled)
            CALL WDialogFieldState(FILE_BROWSE,Disabled)
            CALL WDialogFieldState(ARRAY_FILE_TYPE,Disabled)
            CALL WDialogFieldState(ARRAY_SPREADSHEET,Disabled)
            CALL WDialogFieldState(ARRAY_GRID,Disabled)
         ELSE IF(IAMETH.EQ.2) THEN
            CALL WDialogPutRadioButton(ARRAY_TYPE_PACKAGE)
            CALL WDialogFieldState(ARRAY_CONSTANT,Disabled)
            CALL WDialogFieldState(ARRAY_MULTIPLIER,Enabled)
            CALL WDialogFieldState(ARRAY_MULTIPLIER2,Disabled)
            CALL WDialogFieldState(ARRAY_IPRN,Disabled)
            CALL WDialogFieldState(ARRAY_FORMAT,Disabled)
            CALL WDialogFieldState(ARRAY_FILE,Disabled)
            CALL WDialogFieldState(FILE_BROWSE,Disabled)
            CALL WDialogFieldState(ARRAY_FILE_TYPE,Disabled)
            CALL WDialogFieldState(ARRAY_SPREADSHEET,Enabled)
            IF(NCOL.GT.100 .OR. NROW.GT.100) THEN
               CALL WDialogFieldState(ARRAY_GRID,Disabled)
            ELSE
               CALL WDialogFieldState(ARRAY_GRID,Enabled)
            END IF
         ELSE
            CALL WDialogPutRadioButton(ARRAY_TYPE_SEPARATE)
            CALL WDialogFieldState(ARRAY_CONSTANT,Disabled)
            CALL WDialogFieldState(ARRAY_MULTIPLIER,Disabled)
            CALL WDialogFieldState(ARRAY_MULTIPLIER2,Enabled)
            CALL WDialogFieldState(ARRAY_IPRN,Enabled)
            CALL WDialogFieldState(ARRAY_FORMAT,Enabled)
            CALL WDialogFieldState(ARRAY_FILE,Enabled)
            CALL WDialogFieldState(FILE_BROWSE,Enabled)
            CALL WDialogFieldState(ARRAY_FILE_TYPE,Enabled)
            CALL WDialogFieldState(ARRAY_SPREADSHEET,Disabled)
            CALL WDialogFieldState(ARRAY_GRID,Disabled)
         END IF
      ELSE
         CALL WDialogPutRadioButton(ARRAY_TYPE_CONSTANT)
         CALL WDialogFieldState(ARRAY_CONSTANT,Disabled)
         CALL WDialogFieldState(ARRAY_MULTIPLIER,Disabled)
         CALL WDialogFieldState(ARRAY_MULTIPLIER2,Disabled)
         CALL WDialogFieldState(ARRAY_IPRN,Disabled)
         CALL WDialogFieldState(ARRAY_FORMAT,Disabled)
         CALL WDialogFieldState(ARRAY_FILE,Disabled)
         CALL WDialogFieldState(FILE_BROWSE,Disabled)
         CALL WDialogFieldState(ARRAY_FILE_TYPE,Disabled)
         CALL WDialogFieldState(ARRAY_SPREADSHEET,Disabled)
         CALL WDialogFieldState(ARRAY_GRID,Disabled)
      END IF
      CALL WDialogPutInteger(ARRAY_IPRN,IPRN)
      CALL WDialogPutReal(ARRAY_CONSTANT,CON1,'(1PG13.6)')
      CALL WDialogPutReal(ARRAY_MULTIPLIER,CON2,'(1PG13.6)')
      CALL WDialogPutReal(ARRAY_MULTIPLIER2,CON3,'(1PG13.6)')
      CALL WDialogPutString(ARRAY_FORMAT,FMT)
      CALL WDialogPutString(ARRAY_FILE,FNAME)
      CALL WDialogPutOption(ARRAY_FILE_TYPE,IFTYP)
      IF(NP.GT.0) THEN
         CALL WDialogFieldState(PARAMETER_DELETE_BUT,Enabled)
         CALL WDialogFieldState(PARAMETER_MODIFY_BUT,Enabled)
      ELSE
         CALL WDialogFieldState(PARAMETER_DELETE_BUT,Disabled)
         CALL WDialogFieldState(PARAMETER_MODIFY_BUT,Disabled)
      END IF
C
C  Make Array Dialog visible
      CALL WDialogShow(-1,50,0,SemiModeless)
50    CALL WMessage(ITYPE,MESSAGE)
C
C  Act upon field changes
      IF(ITYPE.EQ.FieldChanged) THEN
C
C  Check for parameter type change
         CALL WDialogGetMenu(PARAMETER_TYPE,IPTNEW)
         IF(IPTNEW.NE.IPT) THEN
            IF(NNPAR.NE.0) CALL U3DINGET(NAR,IUPACK,IERR)
            CALL WDialogSelect(LPF_HYDRAULIC_DIALOG)
            IPT=IPTNEW
            GO TO 10
         END IF
C
C  Check for layer change
         CALL WDialogGetMenu(ARRAY_LAYER,KNEW)
         IF(KNEW.NE.K) THEN
            IF(NNPAR.NE.0) THEN
               CALL U3DINGET(NAR,IUPACK,IERR)
               CALL WDialogSelect(LPF_HYDRAULIC_DIALOG)
               IF(IERR.NE.0) GO TO 25
            END IF
            K=KNEW
            GO TO 25
         END IF
C
C  Check for array name change
         IF(NNPAR.GT.0) THEN
            CALL WDialogGetMenu(ARRAY_NAME,IANNEW)
            IF(IANNEW.NE.IANAME) THEN
               CALL U3DINGET(NAR,IUPACK,IERR)
               CALL WDialogSelect(LPF_HYDRAULIC_DIALOG)
               IANAME=IANNEW
               GO TO 28
            END IF
         END IF
C
C  Check for array method change
         CALL WDialogGetRadioButton(ARRAY_TYPE_CONSTANT,IAMNEW)
         IF(IAMNEW.NE.IAMETH) THEN
            IF(NNPAR.GT.0) THEN
               IAMETH=IAMNEW
               IF(IAMETH.EQ.2 .AND. IARRDA(2,NAR).EQ.0) THEN
                  CALL ARRALO(IARRDA(2,NAR),IARRDA(3,NAR),IARRDA(4,NAR))
                  LOC=IARRDA(2,NAR)
                  CALL ZIPR(NCOL*NROW,0.,X(LOC))
C                  CALL SS2DR(X(LOC),NCOL,NROW,ARRNAM(IANAME),
C     1                        LPF_HYDRAULIC_DIALOG)
                  CALL WMessageEnable(FieldChanged,Enabled)
                  CALL WDialogSelect(LPF_HYDRAULIC_DIALOG)
               END IF
            END IF
            GO TO 30
         END IF
C
C  Check for push buttons
      ELSE IF(ITYPE.EQ.PushButton) THEN
C
C  Check for ARRAY_SPREADSHEET
         IF(MESSAGE%VALUE1.EQ.ARRAY_SPREADSHEET) THEN
            IF(NNPAR.LE.0) GO TO 50
            LOC=IARRDA(2,NAR)
            CALL SS2DR(X(LOC),NCOL,NROW,ARRNAM(IANAME),
     1                 LPF_HYDRAULIC_DIALOG)
            CALL WMessageEnable(FieldChanged,Enabled)
            CALL WDialogSelect(LPF_HYDRAULIC_DIALOG)
C
C  Check for ARRAY_GRID
         ELSE IF(MESSAGE%VALUE1.EQ.ARRAY_GRID) THEN
            IF(NNPAR.LE.0) GO TO 50
            IF(NCOL.GT.100 .OR. NROW.GT.100) GO TO 50
            LOC=IARRDA(2,NAR)
            CALL SS2DRG(X(LOC),NCOL,NROW,ARRNAM(IANAME),
     1                 LPF_HYDRAULIC_DIALOG)
            CALL WMessageEnable(FieldChanged,Enabled)
            CALL WDialogSelect(LPF_HYDRAULIC_DIALOG)
C
C  Check for parameter definition changes
         ELSE IF(MESSAGE%VALUE1.EQ.PARAMETER_ADD_BUT) THEN
            PN=' '
            PV=0.0
            DO 59 I=1,200
            MN(I)='NONE'
            ZN(I)='ALL'
            LAY(I)=0
            DO 59 J=1,10
            IZN(I,J)=0
59          CONTINUE
            NPT=1
60          CALL ARRPARGET(PN,ARRPARTYP(IPT),1,NPT,PV,MN,ZN,LAY,IZN,1,
     1                 IERR,0)
            IF(IERR.GT.0) THEN
               GO TO 60
            ELSE IF(IERR.EQ.0) THEN
               ISF=0
               ISE=0
               LNS=0
               B2S=PV
               BLS=0.
               BUS=0.
               BSS=0.
               CALL ARRPARADD(PN,ARRPARTYP(IPT),PV,MN,ZN,LAY,IZN,IERR,1,
     1             ISF,ISE,LNS,B2S,BLS,BUS,BSS)
               IF(IERR.NE.0) GO TO 60
            END IF
            CALL WMessageEnable(FieldChanged,Enabled)
            CALL WDialogSelect(LPF_HYDRAULIC_DIALOG)
            GO TO 10
C
         ELSE IF(MESSAGE%VALUE1.EQ.PARAMETER_MODIFY_BUT) THEN
C  Check for MODIFY
            IF(NP.GT.0) THEN
C get the current values of the parameter
               CALL WDialogGetMenu(PARAMETERS_FOR_TYPE,ISEL)
               PN=ARRPARNAM(ISEL)
               DO 61 I=1,IPSUM
               IF(PARNAM(I).EQ.PN) IPNUM=I
61             CONTINUE
               PV=B(IPNUM)
               ISF=ISFILE(IPNUM)
               ISE=ISENS(IPNUM)
               LNS=LN(IPNUM)
               B2S=B2(IPNUM)
               BLS=BL(IPNUM)
               BUS=BU(IPNUM)
               BSS=BSCAL(IPNUM)
               DO 62 I=1,200
               MN(I)='NONE'
               ZN(I)='ALL'
               LAY(I)=0
               DO 62 J=1,10
               IZN(I,J)=0
62             CONTINUE
               I=0
               DO 78 II=IPLOC(1,IPNUM),IPLOC(2,IPNUM)
               I=I+1
               MN(I)=CPCLST(1,II)
               ZN(I)=CPCLST(2,II)
               LAY(I)=IPCLST(1,II)
               IF(IPCLST(2,II).GT.2) THEN
                  DO 77 J=3,IPCLST(2,II)
                  IZN(I,J-2)=IPCLST(J,II)
77                CONTINUE
               END IF
78             CONTINUE
C  Get parameter modifications
63             CALL ARRPARGET(PN,ARRPARTYP(IPT),1,IDUM,PV,MN,ZN,LAY,
     1                 IZN,1,IERR,1)
               IF(IERR.EQ.0) THEN
C  Delete the current parameter and add the modified parameter
                  CALL ARRPARDEL(PN)
                  CALL ARRPARADD(PN,ARRPARTYP(IPT),PV,MN,ZN,LAY,IZN,
     1                 IERR,1,ISF,ISE,LNS,B2S,BLS,BUS,BSS)
                  IF(IERR.NE.0) GO TO 63
               END IF
               CALL WMessageEnable(FieldChanged,Enabled)
               CALL WDialogSelect(LPF_HYDRAULIC_DIALOG)
               GO TO 10
            END IF
C
C  Check for DELETE
         ELSE IF(MESSAGE%VALUE1.EQ.PARAMETER_DELETE_BUT) THEN
            IF(NP.GT.0) THEN
               CALL WDialogGetMenu(PARAMETERS_FOR_TYPE,ISEL)
               CALL ARRPARDEL(ARRPARNAM(ISEL))
               GO TO 10
            END IF
C
C  Check for Browse
         ELSE IF(MESSAGE%VALUE1.EQ.FILE_BROWSE) THEN
            CALL BROWSE(FNAME)
            CALL WDialogSelect(LPF_HYDRAULIC_DIALOG)
            GO TO 30
C
C  Check for OK
         ELSE IF(MESSAGE%VALUE1.EQ.LPF_HYD_OK) THEN
            IF(NNPAR.GT.0) THEN
               CALL U3DINGET(NAR,IUPACK,IERR)
               CALL WDialogSelect(LPF_HYDRAULIC_DIALOG)
               IF(IERR.NE.0) GO TO 50
            END IF
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL WDialogUnload(LPF_HYDRAULIC_DIALOG)
            RETURN
C
C  Check for CANCEL
         ELSE IF(MESSAGE%VALUE1.EQ.IDCANCEL) THEN
C  Exit without storing values
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL WDialogUnload(LPF_HYDRAULIC_DIALOG)
            RETURN
         END IF
C
C  Ignore all other types of message
      END IF
      GO TO 50
C
      END
