C  Originally documented in U.S. Geological Survey Open-File Report 94-468:
C  "A Data Input Program (MFI) for the U.S. Geological Survey Modular
C   Finite-Difference Ground-Water Flow Model" by Arlen W. Harbaugh
C
      PROGRAM  MFI2K
      USE WINTERACTER
C  *********************************************************************
C     This program is used to enter data for a MODFLOW simulation
C  *********************************************************************
      INCLUDE 'mfi2k.inc'
      INCLUDE 'mfi2kwnt.inc'
      INCLUDE 'mfi2kpar.inc'
      CHARACTER(LEN=8) VERSION
      TYPE(WIN_STYLE)     :: WINDOW
      TYPE(WIN_MESSAGE)   :: MESSAGE
C
      COMMON /PERCOM/PERLEN(MXPER),NSTP(MXPER),TSMULT(MXPER),
     1               ISSFLG(MXPER)
C
      COMMON /FLWCOM/LAYCON(200)
      COMMON /FLWAVG/LAYAVG(200)
C
C     + + + LOCAL VARIABLES + + +
      CHARACTER*80 CTXT(50),LINE(1)
      LOGICAL EX,EXMP
      CHARACTER*128 PATNAM,DIRNAM
      CHARACTER*4 CUNIT(40)
      CHARACTER*3 CEXTN(40)
      DATA CUNIT/'BCF6','WEL ','DRN ','RIV ','EVT ','    ','GHB ',
     1           'RCH ','SIP ','DE4 ','SOR ','OC  ','PCG ','LMG ',
     2           'GWT ','    ','    ','    ','    ','    ','    ',
     3           '    ','LPF ','DIS ','SEN ','PES ','OBS ','HOB ',
     4           'ADV ','COB ','ZONE','MULT','DROB','RVOB','GBOB',
     5           'STOB','    ','CHOB','    ','MP  '/
      DATA CEXTN/'BC6' ,'WEL' ,'DRN' ,'RIV' ,'EVT' ,'TLK' ,'GHB' ,
     1           'RCH' ,'SIP' ,'DE4' ,'SOR' ,'OC ' ,'PCG' ,'LMG' ,
     2           'GWT' ,'FHB' ,'RES' ,'STR' ,'IBS' ,'CHD' ,'HF6' ,
     3           '   ' ,'LPF' ,'DIS' ,'SEN' ,'PES' ,'OBS' ,'HOB' ,
     4           'ADV' ,'COB' ,'ZON' ,'MLT' ,'ODR' ,'ORV' ,'OGB' ,
     5           'OST' ,'   ' ,'OCH' ,'   ' ,'MP ' /
C
      COMMON /FOBCOM/LAYFOB(MXCFOB),IROWFOB(MXCFOB),ICOLFOB(MXCFOB),
     1               FOBFACT(MXCFOB),FOBSTAT(MXTFOB),FOBS(MXTFOB),
     2               IFOBST(MXTFOB),IFOBRSP(MXTFOB),FOBTOFF(MXTFOB),
     3               IFOBPLT(MXTFOB),NGFOB,NTFOB,NCFOB,NFOB(6,MXGFOB),
     4               FOBCON(2,40)
      COMMON /PESCOM/PRM(200),PRMSP(200),IPRMSF(200),IPRMPS(200)
      COMMON /CPESCOM/PARNEG(200),EQNAM(200),PESEQ(200)
      CHARACTER*10 PARNEG,EQNAM
      CHARACTER*100 PESEQ
C     + + + END SPECIFICATIONS + + +
C
      IRESTART=0
1     VERSION='1.1'
      MODINP=0
      MODOUT=0
      ISTRT=0
      IAPART=0
      ISUM=1
      NVAR=0
      NARRAY=0
      NGFOB=0
      NTFOB=0
      NCFOB=0
      DO 4 I=1,200
      LAYCON(I)=0
      LAYAVG(I)=0
4     CONTINUE
C
C  All packages are off
      INBAS=0
      ILOUT=0
      IGOUT=0
      IHEDUN=0
      IDDNUN=0
      IBOUUN=0
      IBUDUN=0
      DO 5 I=1,40
      IUNIT(I)=0
      IUNIT2(I)=0
5     CONTINUE
C
      DO 6 I=1,MXPERPAR
      PERPARNAM(I)=' '
      PERPARTYP(I)=' '
      IPERPARPER(I)=0
6     CONTINUE
C
C  Define file units for use by MFI for log file and general use
      IOUT=98
      IUMISC=IOUT-1
C
C  Initialize files
      DO 7 I=1,MXFNAM
      IFNUSE(I)=0
      FILTYP(I)=' '
      FILNAM(I)=' '
      IFILSTAT(I)=1
      IFILREW(I)=1
7     CONTINUE
C
      DO 8 I=1,200
      EQNAM(I)=' '
      PESEQ(I)=' '
      PRM(I)=1.0
      PRMSP(I)=0.0
      IPRMSF(I)=1
      IPRMPS(I)=0
      PARNEG(I)=' '
8     CONTINUE
C
C  Initialize names of zones, multipliers, and parameters.
      DO 10 I=1,MXZON
      ZONNAM(I)=' '
10    CONTINUE
      DO 20 I=1,MXMLT
      MLTNAM(I)=' '
      MLTFNM(I)=' '
20    CONTINUE
      DO 30 I=1,MXPAR
      PARNAM(I)=' '
30    CONTINUE
      IPSUM=0
      ICLSUM=0
C
C  Initialize comments
      DO 32 I=1,41
      DO 32 J=1,20
      COMENT(J,I)=' '
32    CONTINUE
C
C  Initialize list of active packages.  Don't do this if restarting with
C  a new data set because ACTLST uses the existing CTXT data to determine
C  how many lines to refresh on the screen.
      IF(IRESTART.EQ.0) THEN
         DO 35 I=1,50
         CTXT(I)=' '
35       CONTINUE
      END IF
C
C  Initialize real and available file units
      CALL MFIUMK
C
C  Initialize Winteracter
      IF(IRESTART.NE.0) GO TO 46
      CALL WInitialise(' ')              ! Initialise Winteracter
      WINDOW%FLAGS  = SysMenuOn + MinButton + MaxButton
      WINDOW%X      = -1                 ! Centre window horizontally
      WINDOW%Y      =  0                 ! Put window at top of screen
      WINDOW%WIDTH  = 600
      WINDOW%HEIGHT = 400
      WINDOW%MENUID = MAIN_MENU          ! Menu identifier
      WINDOW%TITLE  = 'MFI2K '//VERSION  ! Root window title
      CALL WindowOpen(WINDOW)            ! Open root window
C
C  Get the dataset name
      DSNAME=' '
      CALL IOsArgument(1,PATNAM)
      IF(PATNAM.NE.' ') THEN
C  There is a command line argument -- separate it into a directory name
C  and a file name
         NC=IActualLength(PATNAM)
         DO 40 I=NC,1,-1
         IF(PATNAM(I:I).EQ.'\') GO TO 42
         IF(PATNAM(I:I).EQ.':') THEN
            PATNAM=' '
            GO TO 46
         END IF
40       CONTINUE
         I=0
42       IF(I.LT.NC) DSNAME=PATNAM(I+1:NC)
         DIRNAM=' '
         IF(I.GT.1) DIRNAM=PATNAM(1:I-1)
         IF(DIRNAM.NE.' ') THEN
            CALL IOsDirChange(DIRNAM)
         ELSE
            CALL IOsDirName(DIRNAM)
         END IF
      END IF
C
C  Get a dataset name if none was specified
46    IF(DSNAME.EQ.' ') THEN
         CALL WSelectFile('MODFLOW Name File|*.nam|All file types|*.*|',
     1       LoadDialog+DirChange+AppendExt,PATNAM,'MODFLOW Name File')
         CALL IOsDirName(DIRNAM)
         NDIR=IActualLength(DIRNAM)+1
         PATNAM(1:NDIR)=' '
         CALL IJustifyString(PATNAM,'L')
         DSNAME=PATNAM
         IF(WInfoDialog(ExitButtonCommon).EQ.CommonCancel) THEN
            CALL WindowClose()
            STOP
         END IF
      ENDIF
C
C  Cleanup DSNAME -- remove ".NAM" if it exists
      NDSNAM=IActualLength(DSNAME)
      IF(IUCASE.NE.0) CALL USTRUC(DSNAME,28)
      IF(NDSNAM.GT.4) THEN
         IF(DSNAME(NDSNAM-3:NDSNAM).EQ.'.NAM' .OR.
     1               DSNAME(NDSNAM-3:NDSNAM).EQ.'.nam') THEN
            DSNAME(NDSNAM-3:NDSNAM)=' '
            NDSNAM=NDSNAM-4
         END IF
      END IF
C
C  Open log file and print some information about array sizes
      OPEN(UNIT=IOUT,FILE=DSNAME(1:NDSNAM)//'.log')
      WRITE(IOUT,*) ' MFI -- MODFLOW Data Editor'
      WRITE(IOUT,*)
      WRITE(IOUT,*) ' MODOUT:',MODOUT
      WRITE(IOUT,*) ' Length of X array:',LENX
      WRITE(IOUT,*) ' Maximum number of variables:',MXVAR
      WRITE(IOUT,*) ' Maximum number of arrays:',MXARR
      WRITE(IOUT,*) ' Maximum number of file names:',MXFNAM
      WRITE(IOUT,*) ' Maximum number of stress periods:',MXPER
      WRITE(IOUT,*) ' Maximum length of a list of stresses:',MXLIST*10
      WRITE(IOUT,*)
C
C  Check for an existing dataset
      INQUIRE(FILE=DSNAME(1:NDSNAM)//'.nam',EXIST=EX)
C
      IF(EX) THEN
C  There is an old dataset, so process it
         INQUIRE(FILE=DSNAME(1:NDSNAM)//'.mpn',EXIST=EXMP)
         INMP=0
         IF(EXMP) INMP=1
         OPEN(UNIT=IUMISC,FILE=DSNAME(1:NDSNAM)//'.nam',STATUS='OLD')
         LINE(1)=' Reading existing data.  Please wait . . .'
         CALL DSPTXT(LINE(1),1)
         NMISS=0
         CALL MFREAD(IUMISC,CUNIT,IWARN,INMP)
         LINE(1)=' '
         CALL DSPTXT(LINE(1),1)
         IF(INMP.GT.0) THEN
            OPEN(UNIT=IUMISC,FILE=DSNAME(1:NDSNAM)//'.mpn',STATUS='OLD')
            CALL MPNAM(IUMISC)
            CALL MPRP(IWARN)
         END IF
C  Reinitialize MODFLOW's real file units now that all data are read.  Even
C  if MODPATH data have not been read, MODFLOW's units are
C  reinitialized because IUREAL for INBAS and ILOUT may not be set to the
C  values that BASSV will set (5 and 6).  I.e we want to erase the values in
C  the original dataset so that BASSV can set new values later.
         CALL MFIUMK
         IF(ILOUT.EQ.0 .AND. IGOUT.EQ.0) THEN
            CALL FINDUN(2,IU,'LIST','LST')
            ILOUT=IU
         END IF
C
C  Display input error messages if there were any
         IF(IWARN.GT.0) CALL TXTLOG(CTEXT,NMISS)
      ELSE
C  New dataset -- check if that's what the user expects
         CALL WMessageBox(YesNo,QuestionIcon,CommonYes,
     1   DSNAME(1:NDSNAM)//' will be a new dataset'//CHAR(13)//
     2    'Is that what you want?',' ')
         IRESP=WInfoDialog(ExitButtonCommon)
         IF(IRESP.NE.CommonYes) THEN
            CLOSE(UNIT=IOUT,STATUS='DELETE')
            CALL WindowClose()                 ! Remove program window
            STOP
         END IF
         INQUIRE(FILE=DSNAME(1:NDSNAM)//'.ba6',EXIST=EX)
         IF(EX) STOP
         INQUIRE(FILE=DSNAME(1:NDSNAM)//'.dis',EXIST=EX)
         IF(EX) STOP
         INQUIRE(FILE=DSNAME(1:NDSNAM)//'.nam',EXIST=EX)
         IF(EX) STOP
C  Activate DIS.
         CALL FINDUN(3,IU,'DIS','DIS')
         IUNIT(24)=IU
C  Now get size of grid and free or fixed format
         CALL GETGRID(IUNIT(24))
C  Activate BAS Package and List file.
         CALL FINDUN(2,IU,'LIST','LST')
         ILOUT=IU
         CALL FINDUN(4,IU,'BAS6','BA6')
         INBAS=IU
         NPER=1
      END IF
C
C  Add dataset name to window title
      WINDOW%TITLE='MFI2K '//VERSION//'Dataset: '//
     1      DSNAME(1:NDSNAM)//'    Directory: '//DIRNAM
      CALL WindowTitle(WINDOW%TITLE)
C
C  LOOP FOR MAIN MENU
C  Open menu and process responses
98    WRITE(CTXT(1),99) 'NLAY=',NLAY,'    NROW=',NROW,'   NCOL=',NCOL
99    FORMAT(20X,A,I4,A,I4,A,I4)
      CALL ACTLST(CTXT,50,NDSP,CUNIT,40)
      CALL DSPTXT(CTXT,NDSP)
100   CALL WMessage(ITYPE,MESSAGE)
      IF(ITYPE.EQ.MenuSelect) THEN
         IOPT=MESSAGE%VALUE1
         IF(IOPT.EQ.MAIN_DIS) THEN
            CALL DISED(IUNIT(24))
         ELSE IF(IOPT.EQ.MAIN_ZONES) THEN
            CALL ZONEED
         ELSE IF(IOPT.EQ.MAIN_MULTIPLIERS) THEN
            CALL MULTED
         ELSE IF(IOPT.EQ.MAIN_BAS) THEN
            CALL BASED
         ELSE IF(IOPT.EQ.MAIN_BCF) THEN
            CALL BCFED
         ELSE IF(IOPT.EQ.MAIN_LPF) THEN
            CALL LPFED
         ELSE IF(IOPT.EQ.MAIN_STRESS) THEN
            CALL STRESSED
         ELSE IF(IOPT.EQ.MAIN_SOLVER) THEN
            CALL SOLVED
         ELSE IF(IOPT.EQ.MAIN_OUTPUT) THEN
            CALL OCED
         ELSE IF(IOPT.EQ.MAIN_MODPATH) THEN
            CALL MPED
         ELSE IF(IOPT.EQ.MAIN_GWT) THEN
            CALL MOCED
         ELSE IF(IOPT.EQ.MAIN_OBSERVATIONS) THEN
            CALL OBSED
         ELSE IF(IOPT.EQ.MAIN_SENSITIVITY) THEN
            CALL SENED
         ELSE IF(IOPT.EQ.MAIN_PAREST) THEN
            CALL PESED
         ELSE IF(IOPT.EQ.MAIN_CHECK) THEN
            CALL ACTIVE
         ELSE IF(IOPT.EQ.MAIN_DEACTIVATE) THEN
            CALL DEACT
         ELSE IF(IOPT.EQ.MAIN_FILES) THEN
            CALL FILDSP
         ELSE IF(IOPT.EQ.MAIN_GLOLST) THEN
            CALL GLOLST
         ELSE IF(IOPT.EQ.MAIN_FILE_STATUS) THEN
            CALL FILESTATUS
         ELSE IF(IOPT.EQ.MAIN_OPEN) THEN
            CALL WMessageBox(3,2,CommonYes,
     1        'Do you want to save the current data'//
     2        ' before opening another data set?',' ')
            IRESP=WInfoDialog(ExitButtonCommon)
            IF(IRESP.EQ.CommonYes) CALL SAVALL(2,IERR)
            IRESTART=1
            DSNAME=' '
            CLOSE(UNIT=98)
            GO TO 1
         ELSE IF(IOPT.EQ.MAIN_SAVEAS) THEN
            CALL RENAME(CEXTN)
            WINDOW%TITLE='MFI2K '//VERSION//'Dataset Name: '//
     1      DSNAME(1:NDSNAM)//'    Directory: '//DIRNAM
            CALL WindowTitle(WINDOW%TITLE)
C
         ELSE IF(IOPT.EQ.MAIN_ABORT) THEN
            CALL WMessageBox(3,2,CommonYes,
     1    'Do you really want to exit without saving data?',' ')
            IRESP=WInfoDialog(ExitButtonCommon)
            IF(IRESP.NE.CommonYes)  GO TO 100
            CALL WindowClose()                 ! Remove program window
            STOP
C
         ELSE IF(IOPT.EQ.MAIN_SAVE) THEN
            CALL SAVALL(2,IERR)
C
         ELSE IF(IOPT.EQ.MAIN_MODFLOW_RUN) THEN
            CALL SAVALL(2,IERR)
            IF(IERR.NE.0) THEN
C  Incomplete data -- ask user about continuing to run.
               CALL WMessageBox(3,2,CommonYes,
     1    'Some files are incomplete -- run anyway?','Incomplete Data')
               IRESP=WInfoDialog(ExitButtonCommon)
               IF(IRESP.EQ.CommonNo)  GO TO 100
            END IF
            WRITE(IOUT,*)
     1           'CALL SYSTEM(mfi2krun.bat ',DSNAME(1:NDSNAM),')'
            CALL SYSTEM('mfi2krun.bat '//DSNAME(1:NDSNAM))
C
         ELSE IF(IOPT.EQ.MAIN_EXIT) THEN
            CALL SAVALL(2,IERR)
            IF(IERR.NE.0) THEN
C  Incomplete data -- ask user about continuing to edit.
               CALL WMessageBox(3,2,CommonYes,
     1    'Some files are incomplete -- exit anyway?','Incomplete Data')
               IRESP=WInfoDialog(ExitButtonCommon)
               IF(IRESP.EQ.CommonNo)  GO TO 100
            END IF
C  Done saving data -- write some information to the log file for
C  diagnostic purposes and quit.
            DO 145 I=1,NVAR
            WRITE(IOUT,*) VARNAM(I),VARVAL(I),(IVARDA(J,I),J=1,3)
145         CONTINUE
            DO 146 I=1,MXFNAM
            IF(FILTYP(I).NE.' ') WRITE(IOUT,*)
     1        I,IUREAL(I),' ',FILTYP(I),FILNAM(I)(1:40)
146         CONTINUE
            WRITE(IOUT,*) 'ISUM=',ISUM
            CALL WindowClose()                 ! Remove program window
            STOP
         END IF
C
C  End of main menu selection -- the selected option has been processed.
C  Redisplay main menu.
         GO TO 98
C
C  Check for other responses to the main menu besides a menu selection
      ELSE IF(ITYPE.EQ.Expose .OR. ITYPE.EQ.Resize) THEN   ! Need to redraw picture
         GO TO 98
      ELSE IF(ITYPE.EQ.CloseRequest) THEN           ! Exit program (e.g. Alt/F4)
         CALL WMessageBox(3,2,CommonYes,
     1    'Do you really want to exit without saving data?',' ')
         IRESP=WInfoDialog(ExitButtonCommon)
         IF(IRESP.NE.CommonYes)  GO TO 100
         CALL WindowClose()                 ! Remove program window
         STOP
      END IF
      GO TO 100
      END PROGRAM MFI2K
      SUBROUTINE RENAME(CEXT)
C     ******************************************************************
C     Rename the dataset
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
      INCLUDE 'mfi2k.inc'
      COMMON /MPCOM/IGUAUN,IGUAM,GUAMIN(15),GUAMAX(15)
      COMMON /OBSCOM/OUTNAM
      CHARACTER*78 OUTNAM
      CHARACTER*28 NEWNAM
      LOGICAL EX
      CHARACTER*3 CEXTN,CEXT(40)
      CHARACTER*80 CMESS(2)
C
C  Prompt for new name
10    CALL WDialogLoad(RENAME_DIALOG)
C
C  Make DIALOG visible
      CALL WDialogShow(-1,50,0,Modal)
C  Get and store values if "OK" was pushed
      IF(WInfoDialog(ExitButton).NE.IDOK) THEN
         CALL WDialogUnload
         RETURN
      END IF
C
      CALL WDialogGetString(DSNAME_RENAME,NEWNAM)
      CALL IJustifyString(NEWNAM,'L')
      IF(IUCASE.NE.0) CALL USTRUC(NEWNAM,28)
      NNEW=IActualLength(NEWNAM)
      IF(NNEW.LT.1) GO TO 300
C
C  First check if each new file name is unique
C
C  Name file
      INQUIRE(FILE=NEWNAM(1:NNEW)//'.nam',EXIST=EX,ERR=100)
      IF(EX) GO TO 100
C
C  Basic Package
      INQUIRE(FILE=NEWNAM(1:NNEW)//'.ba6',EXIST=EX,ERR=100)
      IF(EX) GO TO 100
C
C  ILOUT and IGOUT
      INQUIRE(FILE=NEWNAM(1:NNEW)//'.lst',EXIST=EX,ERR=100)
      IF(EX) GO TO 100
      INQUIRE(FILE=NEWNAM(1:NNEW)//'.glo',EXIST=EX,ERR=100)
      IF(EX) GO TO 100
C
C  Other Packages -- all files included in IUNIT
      DO 20 I=1,40
      IF(IUNIT(I).LE.0) GO TO 20
      CEXTN=CEXT(I)
      IF(IUCASE.EQ.0) CALL USTRLC(CEXTN,3)
      INQUIRE(FILE=NEWNAM(1:NNEW)//'.'//CEXTN,EXIST=EX,ERR=100)
      IF(EX) GO TO 100
20    CONTINUE
C
C  Head, drawdown, budget, and GUA files
      INQUIRE(FILE=NEWNAM(1:NNEW)//'.hed',EXIST=EX,ERR=100)
      IF(EX) GO TO 100
      INQUIRE(FILE=NEWNAM(1:NNEW)//'.ddn',EXIST=EX,ERR=100)
      IF(EX) GO TO 100
      INQUIRE(FILE=NEWNAM(1:NNEW)//'.bud',EXIST=EX,ERR=100)
      IF(EX) GO TO 100
      INQUIRE(FILE=NEWNAM(1:NNEW)//'.gua',EXIST=EX,ERR=100)
      IF(EX) GO TO 100
C
C  Make sure that none of the existing files start with the new name
      DO 30 I=1,MXFNAM
      IF(NEWNAM(1:NNEW)//'.'.EQ.FILNAM(I)(1:NNEW)//'.') GO TO 200
30    CONTINUE
C
C  Now actually try to open the name file, which should detect if
C  there is anything invalid about the filename.
      OPEN(UNIT=IUMISC,FILE=NEWNAM(1:NNEW)//'.nam',ERR=100)
      CLOSE(UNIT=IUMISC,STATUS='DELETE')
C
C  All file names are unique -- change them in the list of file names
C
C  Basic Package
      IF(INBAS.GT.0) THEN
         IF(IUCASE.NE.0) FILNAM(INBAS)=NEWNAM(1:NNEW)//'.BA6'
         IF(IUCASE.EQ.0) FILNAM(INBAS)=NEWNAM(1:NNEW)//'.ba6'
      END IF
C
C  ILOUT and IGOUT
      IF(ILOUT.GT.0) THEN
         IF(IUCASE.NE.0) FILNAM(ILOUT)=NEWNAM(1:NNEW)//'.LST'
         IF(IUCASE.EQ.0) FILNAM(ILOUT)=NEWNAM(1:NNEW)//'.lst'
      END IF
      IF(IGOUT.GT.0) THEN
         IF(IUCASE.NE.0) FILNAM(IGOUT)=NEWNAM(1:NNEW)//'.GLO'
         IF(IUCASE.EQ.0) FILNAM(IGOUT)=NEWNAM(1:NNEW)//'.glo'
      END IF
C
C  Other Packages -- all files included in IUNIT
      DO 40 I=1,40
      IF(IUNIT(I).LE.0) GO TO 40
      CEXTN=CEXT(I)
      IF(IUCASE.EQ.0) CALL USTRLC(CEXTN,3)
      FILNAM(IUNIT(I))=NEWNAM(1:NNEW)//'.'//CEXTN
      IF(IUNIT2(I).LE.0) GO TO 40
      IF(IUCASE.NE.0) THEN
         IF(FILNAM(IUNIT2(I)).EQ.DSNAME(1:NDSNAM)//'.BUD')
     1       FILNAM(IUNIT2(I))=NEWNAM(1:NNEW)//'.BUD'
      ELSE
         IF(FILNAM(IUNIT2(I)).EQ.DSNAME(1:NDSNAM)//'.bud')
     1       FILNAM(IUNIT2(I))=NEWNAM(1:NNEW)//'.bud'
      END IF
40    CONTINUE
C
C  Head, drawdown, budget, GUA files and SEN files
      CALL IVLGET('ISENPU',0,0,ITYPE,ISENPU)
      IF(ITYPE.NE.0) ISENPU=0
      CALL IVLGET('ISENSU',0,0,ITYPE,ISENSU)
      IF(ITYPE.NE.0) ISENSU=0
      IF(IUCASE.NE.0) THEN
         IF(IHEDUN.GT.0) FILNAM(IHEDUN)=NEWNAM(1:NNEW)//'.HED'
         IF(IDDNUN.GT.0) FILNAM(IDDNUN)=NEWNAM(1:NNEW)//'.DDN'
         IF(IBUDUN.GT.0) FILNAM(IBUDUN)=NEWNAM(1:NNEW)//'.BUD'
         IF(IGUAUN.GT.0) FILNAM(IGUAUN)=NEWNAM(1:NNEW)//'.GUA'
         IF(ISENSU.GT.0) FILNAM(ISENSU)=NEWNAM(1:NNEW)//'.SSV'
         IF(ISENPU.GT.0) THEN
            IF(ISENPU.NE.IGOUT .AND. ISENPU.NE.ILOUT)
     1           FILNAM(ISENPU)=NEWNAM(1:NNEW)//'.SPR'
         END IF
      ELSE
         IF(IHEDUN.GT.0) FILNAM(IHEDUN)=NEWNAM(1:NNEW)//'.hed'
         IF(IDDNUN.GT.0) FILNAM(IDDNUN)=NEWNAM(1:NNEW)//'.ddn'
         IF(IBUDUN.GT.0) FILNAM(IBUDUN)=NEWNAM(1:NNEW)//'.bud'
         IF(IGUAUN.GT.0) FILNAM(IGUAUN)=NEWNAM(1:NNEW)//'.gua'
         IF(ISENSU.GT.0) FILNAM(ISENSU)=NEWNAM(1:NNEW)//'.ssv'
         IF(ISENPU.GT.0) THEN
            IF(ISENPU.NE.IGOUT .AND. ISENPU.NE.ILOUT)
     1           FILNAM(ISENPU)=NEWNAM(1:NNEW)//'.spr'
         END IF
      END IF
C
C  MOC file types
      DO 50 I=1,MXFNAM
      IF(FILTYP(I).EQ.'CLST') THEN
         IF(IUCASE.NE.0) FILNAM(I)=NEWNAM(1:NNEW)//'.LSM'
         IF(IUCASE.EQ.0) FILNAM(I)=NEWNAM(1:NNEW)//'.lsm'
      END IF
      IF(FILTYP(I).EQ.'MOC') THEN
         IF(IUCASE.NE.0) FILNAM(I)=NEWNAM(1:NNEW)//'.MOC'
         IF(IUCASE.EQ.0) FILNAM(I)=NEWNAM(1:NNEW)//'.moc'
      END IF
      IF(FILTYP(I).EQ.'MOCOBS' .AND. IUNIT(15).GT.0 .AND.
     1                            IFNUSE(I).EQ.IUNIT(15)) THEN
         IF(IUCASE.NE.0) FILNAM(I)=NEWNAM(1:NNEW)//'.MOB'
         IF(IUCASE.EQ.0) FILNAM(I)=NEWNAM(1:NNEW)//'.mob'
      END IF
      IF(FILTYP(I).EQ.'CRCH') THEN
         IF(IUCASE.NE.0) FILNAM(I)=NEWNAM(1:NNEW)//'.CRC'
         IF(IUCASE.EQ.0) FILNAM(I)=NEWNAM(1:NNEW)//'.crc'
      END IF
50    CONTINUE
C
C  Save the new name and save the dataset
      DSNAME=NEWNAM
      NDSNAM=NNEW
      OUTNAM=NEWNAM
      CALL SAVALL(2,IERR)
C  Add new name to screen title
      CALL WDialogUnload
      RETURN
C
C  ERRORS -- for any error, give a message and return
100   CMESS(1)='The SaveAs Option failed -- one or more files could'
      CMESS(2)='not be created using the new name.  Try another name.'
      CALL TXTLOG(CMESS,2)
      CALL WDialogUnload
      RETURN
200   CMESS(1)='The SaveAs Option failed -- the old dataset contains'
      CMESS(2)='a file that starts with new name.  Try another name.'
      CALL TXTLOG(CMESS,2)
      CALL WDialogUnload
      RETURN
300   CMESS(1)='The SaveAs option failed -- you must specify a'
      CMESS(2)=' non-blank name.'
      CALL TXTLOG(CMESS,2)
      CALL WDialogUnload
      RETURN
C
      END
      SUBROUTINE SAVALL(IWRFLG,IERR)
C     ******************************************************************
C     SAVE ALL DATA
C     IWRFLG=2 for save data in package files
C     IWRFLG=1 for save in "MFI" backup files
C     IWRFLG=0 for check for undefined data without saving the data --
C          simply set IUNDEF not 0 if data are undefined.
C     IWRFLG=-1 for check for undefined data without saving the data --
C          display undefined data.
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
C     ------------------------------------------------------------------
C
      ISTRT=0
      IAPART=0
      IERR=0
      CALL DISSV(IUNDEF,IWRFLG)
      IF(IUNDEF.GT.0) IERR=1
      CALL ZONESV(IUNDEF,IWRFLG)
      IF(IUNDEF.GT.0) IERR=1
      CALL MULTSV(IUNDEF,IWRFLG)
      IF(IUNDEF.GT.0) IERR=1
      CALL BCFSV(IUNDEF,IWRFLG)
      IF(IUNDEF.GT.0) IERR=1
      CALL LPFSV(IUNDEF,IWRFLG)
      IF(IUNDEF.GT.0) IERR=1
      CALL WELSV(IUNDEF,IWRFLG)
      IF(IUNDEF.GT.0) IERR=1
      CALL DRNSV(IUNDEF,IWRFLG)
      IF(IUNDEF.GT.0) IERR=1
      CALL RIVSV(IUNDEF,IWRFLG)
      IF(IUNDEF.GT.0) IERR=1
      CALL EVTSV(IUNDEF,IWRFLG)
      IF(IUNDEF.GT.0) IERR=1
      CALL GHBSV(IUNDEF,IWRFLG)
      IF(IUNDEF.GT.0) IERR=1
      CALL RCHSV(IUNDEF,IWRFLG)
      IF(IUNDEF.GT.0) IERR=1
      CALL SOLVSV(IUNDEF,IWRFLG)
      IF(IUNDEF.GT.0) IERR=1
      CALL OCSV(IUNDEF,IWRFLG)
      IF(IUNDEF.GT.0) IERR=1
      CALL SENSV(IUNDEF,IWRFLG)
      IF(IUNDEF.GT.0) IERR=1
      CALL PESSV(IUNDEF,IWRFLG)
      IF(IUNDEF.GT.0) IERR=1
      CALL OBSSV(IUNDEF,IWRFLG)
      IF(IUNDEF.GT.0) IERR=1
      CALL HOBSV(IUNDEF,IWRFLG)
      IF(IUNDEF.GT.0) IERR=1
      CALL FOBSV(33,'odr',IUNDEF,IWRFLG)
      IF(IUNDEF.GT.0) IERR=1
      CALL FOBSV(34,'orv',IUNDEF,IWRFLG)
      IF(IUNDEF.GT.0) IERR=1
      CALL FOBSV(35,'ogb',IUNDEF,IWRFLG)
      IF(IUNDEF.GT.0) IERR=1
      CALL FOBSV(38,'och',IUNDEF,IWRFLG)
      IF(IUNDEF.GT.0) IERR=1
      CALL MOCSV(IUNDEF,IWRFLG)
      IF(IUNDEF.GT.0) IERR=1
      CALL BASSV(IUNDEF,IWRFLG)
      IF(IUNDEF.GT.0) IERR=1
      CALL NAMESV(IWRFLG)
C
      IF(IUNIT(40).GT.0) THEN
         CALL MPIUMK
         CALL MPSV(IUNDEF,IWRFLG)
         IF(IUNDEF.GT.0) IERR=1
         CALL MPNMSV(IWRFLG)
         CALL MFIUMK
      END IF
C
      RETURN
      END
      SUBROUTINE NAMESV(IWRFLG)
C     ******************************************************************
C     SAVE NAME FILE
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
C  Common block for MOC
      COMMON /MOCCOM/IUMOCL,IUMOC,IUCRC,IUCOBS,NSCOL,NSROW,NSLAY,
     1     ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2,
     2     NODISP,NPTPND,ICINFL,
     3     PNEWL(51),PNEWR(51),PNEWC(51),IZONE(MXCZON),ZONCON(MXCZON),
     4     ICOB(3,MXCOB),ICOBFL(MXCOB)
      CHARACTER*18 FT
C     ------------------------------------------------------------------
      IF(IWRFLG.LT.1) RETURN
      IF(IWRFLG.EQ.1) OPEN(FILE='MFI.NAM',UNIT=IUMISC)
      IF(IWRFLG.GT.1) OPEN(FILE=DSNAME(1:NDSNAM)//'.nam',UNIT=IUMISC)
C  Write the listing file(s
      IF(IGOUT.NE.0) THEN
         J=LENSTR(80,FILNAM(IGOUT))
         WRITE(IUMISC,25) FILTYP(IGOUT),IUREAL(IGOUT),
     1              FILNAM(IGOUT)(1:J)
      END IF
      IF(ILOUT.NE.0) THEN
         J=LENSTR(80,FILNAM(ILOUT))
         WRITE(IUMISC,25) FILTYP(ILOUT),IUREAL(ILOUT),
     1              FILNAM(ILOUT)(1:J)
      END IF
C
C  Write all other files
      DO 10 I=1,MXFNAM
      IF(IFNUSE(I).NE.0 .AND. IFNUSE(I).NE.IUNIT(40) .AND.
     1      FILTYP(I)(1:10).NE.'OPEN/CLOSE' .AND.
     1      I.NE.ILOUT .AND. I.NE.IGOUT .AND.
     1              IFNUSE(I).NE.IUMOC) THEN
         J=LENSTR(80,FILNAM(I))
         IF(IUREAL(I).EQ.0) CALL REALUN(I)
         FT=FILTYP(I)
         IF(FT.EQ.'DATA') THEN
            IF(IFILREW(I).EQ.2) FT='DATAGLO'
            IF(IFILSTAT(I).EQ.2) THEN
               WRITE(IUMISC,25) FT,IUREAL(I),FILNAM(I)(1:J),' OLD'
            ELSE IF(IFILSTAT(I).EQ.3) THEN
               WRITE(IUMISC,25) FT,IUREAL(I),FILNAM(I)(1:J),' REPLACE'
            ELSE
               WRITE(IUMISC,25) FT,IUREAL(I),FILNAM(I)(1:J)
            END IF
         ELSE IF(FT.EQ.'DATA(BINARY)') THEN
            IF(IFILREW(I).EQ.2) FT='DATAGLO(BINARY)'
            IF(IFILSTAT(I).EQ.2) THEN
               WRITE(IUMISC,25) FT,IUREAL(I),FILNAM(I)(1:J),' OLD'
            ELSE IF(IFILSTAT(I).EQ.3) THEN
               WRITE(IUMISC,25) FT,IUREAL(I),FILNAM(I)(1:J),' REPLACE'
            ELSE
               WRITE(IUMISC,25) FT,IUREAL(I),FILNAM(I)(1:J)
            END IF
         ELSE
            WRITE(IUMISC,25) FILTYP(I),IUREAL(I),FILNAM(I)(1:J)
         END IF
      END IF
10    CONTINUE
      CLOSE(UNIT=IUMISC)
      RETURN
25    FORMAT(A,I5,1X,A,A)
      END
      SUBROUTINE MFREAD(INUNIT,CUNIT,IWARN,INMP)
C     ******************************************************************
C     Read a MODFLOW data set.  This is based on the AL and RP modules
C        from MODFLOW.
C           BY ARLEN W. HARBAUGH
      INCLUDE 'mfi2k.inc'
      COMMON /PERCOM/PERLEN(MXPER),NSTP(MXPER),TSMULT(MXPER),
     1               ISSFLG(MXPER)
      DIMENSION IOFLG(200,5)
      CHARACTER*4 CUNIT(40)
      DIMENSION NTSOUT(7),INONE(7),IEND(7),IALPER(7),IALSTP(7)
      CHARACTER*6 CCPER
C     ------------------------------------------------------------------
C  Clear input error warning flag
      IWARN=0
C  Clear counters and flags for output control data
      DO 10 I=1,7
C  Number of time steps for which output control is specified for
C  hdpr,ddpr,hdsv,ddsv,bdpr,bdsv
      NTSOUT(I)=0
C  Flags for no output for any time step
      INONE(I)=1
C  Flags for output only at end of simulation
      IEND(I)=1
C  Flags for output at end of each stress period
      IALPER(I)=1
C  Flags for output at end of each time step
      IALSTP(I)=1
10    CONTINUE
C  flag that checks if all CBC flags are the same
      IBDSAM=-2
C
C3------DEFINE PROBLEM__ROWS,COLUMNS,LAYERS,STRESS PERIODS,PACKAGES
      CALL SGLOOPEN(INUNIT,CUNIT)
      IF(IUNIT(24).EQ.0) THEN
         WRITE(IOUT,*) ' No DIS file was defined'
         CALL RDABRT
      END IF
C
C  Check if LPF and BCF are both active
      IF(IUNIT(23).GT.0 .AND. IUNIT(1).GT.0) THEN
         WRITE(IOUT,*) ' LPF and BCF6 cannot both be active at once'
         CALL RDABRT
      END IF
C
      CALL GLOBALDF(IUNIT(24))
      CALL GLOBALAL(IUNIT(24))
      CALL SGLOAL(IUNIT(31),IUNIT(32),NML,NZN)
      CALL GLOBALRP(IUNIT(24))
      CALL SGLORP(IUNIT(31),IUNIT(32),NML,NZN)
C
C4------ALLOCATE SPACE IN "X" ARRAY.
      IF(INBAS.EQ.0) THEN
         CALL FINDUN(4,IU,'BAS6','BA6')
         INBAS=IU
      ELSE
         CALL BASDF
         CALL BASAL
         CALL BASRP()
      END IF
      IF(IUNIT(12).GT.0) CALL OCRP(IPEROC,ITSOC)
      IF(IUNIT(1).GT.0) CALL BCF6AL(IBDSAM)
      IF(IUNIT(23).GT.0) CALL LPFAL(IUNIT(23),ITRSS,IBDSAM,NPLPF)
      IF(IUNIT(23).GT.0) CALL LPFRP(IUNIT(23),ITRSS,NPLPF)
      IF(IUNIT(2).GT.0) CALL WEL6AL(IBDSAM,NPWEL)
      IF(IUNIT(2).GT.0) CALL WEL6RQ(NPWEL)
      IF(IUNIT(3).GT.0) CALL DRN6AL(IBDSAM,NPDRN)
      IF(IUNIT(3).GT.0) CALL DRN6RQ(NPDRN)
      IF(IUNIT(4).GT.0) CALL RIV6AL(IBDSAM,NPRIV)
      IF(IUNIT(4).GT.0) CALL RIV6RQ(NPRIV)
      IF(IUNIT(7).GT.0) CALL GHB6AL(IBDSAM,NPGHB)
      IF(IUNIT(7).GT.0) CALL GHB6RQ(NPGHB)
      IF(IUNIT(8).GT.0) CALL RCH6AL(IBDSAM,NPRCH)
      IF(IUNIT(8).GT.0) CALL RCH6RQ(NPRCH)
      IF(IUNIT(5).GT.0) CALL EVT6AL(IBDSAM,NPEVT)
      IF(IUNIT(5).GT.0) CALL EVT6RQ(NPEVT)
      IF(IUNIT(9).GT.0) CALL SIPAL()
      IF(IUNIT(10).GT.0) CALL DE4AL()
      IF(IUNIT(11).GT.0) CALL SORAL()
      IF(IUNIT(13).GT.0) CALL PCGAL()
      IF(IUNIT(14).GT.0) CALL LMGAL()
C
C6------READ AND PREPARE INFORMATION FOR ENTIRE SIMULATION.
      IF(IUNIT(1).GT.0) CALL BCF6RP()
      IF(IUNIT(9).GT.0) CALL SIPRP()
      IF(IUNIT(10).GT.0) CALL DE4RP()
      IF(IUNIT(11).GT.0) CALL SORRP()
      IF(IUNIT(13).GT.0) CALL PCGRP()
      IF(IUNIT(14).GT.0) CALL LMGRP()
      IF(IUNIT(15).GT.0) CALL MOCRD()
C
C7------SIMULATE EACH STRESS PERIOD.
      DO 300 KPER=1,NPER
      KKPER=KPER
C
C7B-----READ AND PREPARE INFORMATION FOR STRESS PERIOD.
      WRITE(IOUT,*)
      WRITE(IOUT,*) ' Stress Period',KKPER
      IF(IUNIT(2).GT.0) CALL WEL6RP(KKPER,NPWEL)
      IF(IUNIT(3).GT.0) CALL DRN6RP(KKPER,NPDRN)
      IF(IUNIT(4).GT.0) CALL RIV6RP(KKPER,NPRIV)
      IF(IUNIT(7).GT.0) CALL GHB6RP(KKPER,NPGHB)
      IF(IUNIT(8).GT.0) CALL RCH6RP(KKPER,NPRCH)
      IF(IUNIT(5).GT.0) CALL EVT6RP(KKPER,NPEVT)
      IF(IUNIT(12).GT.0) THEN
         DO 299 KSTP=1,NSTP(KPER)
         KKSTP=KSTP
         CALL BASOC(KKSTP,KKPER,IPEROC,ITSOC,IOFLG,
     1     NTSOUT,INONE,IEND,IALPER,IALSTP)
  299    CONTINUE
      END IF
  300 CONTINUE
C
C  Read OSP files
      IF(IUNIT(25).GT.0) CALL SENIN()
      IF(IUNIT(26).GT.0) CALL PESIN()
      IF(IUNIT(27).GT.0) CALL OBSIN()
      IF(IUNIT(28).GT.0) CALL HOBIN()
      IF(IUNIT(33).GT.0) CALL FOBIN(33,'DROB')
      IF(IUNIT(34).GT.0) CALL FOBIN(34,'RVOB')
      IF(IUNIT(35).GT.0) CALL FOBIN(35,'GBOB')
      IF(IUNIT(38).GT.0) CALL FOBIN(38,'CHOB')
C
C8------CLOSE ALL FILES
      CALL SBASC()
C
C  Set output control frequency flags and IBUDUN
      IF(IUNIT(12).GT.0) CALL OCFREQ(INONE,IEND,IALPER,IALSTP,IBDSAM)
C
C  Turn off extra solvers
      IF(IUNIT(13).NE.0) THEN
         IF(IUNIT(9).NE.0) THEN
            IFNUSE(IUNIT(9))=0
            IUNIT(9)=0
         END IF
         IF(IUNIT(10).NE.0) THEN
            IFNUSE(IUNIT(10))=0
            IUNIT(10)=0
         END IF
         IF(IUNIT(11).NE.0) THEN
            IFNUSE(IUNIT(11))=0
            IUNIT(11)=0
         END IF
      ELSE IF(IUNIT(9).NE.0) THEN
         IF(IUNIT(10).NE.0) THEN
            IFNUSE(IUNIT(10))=0
            IUNIT(10)=0
         END IF
         IF(IUNIT(11).NE.0) THEN
            IFNUSE(IUNIT(11))=0
            IUNIT(11)=0
         END IF
      ELSE IF(IUNIT(10).NE.0) THEN
         IF(IUNIT(11).NE.0) THEN
            IFNUSE(IUNIT(11))=0
            IUNIT(11)=0
         END IF
      END IF
C
      RETURN
      END
      SUBROUTINE RDABRT
C     ******************************************************************
C     PRINT A MESSAGE AND STOP AFTER THERE IS AN INPUT ERROR
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2k.inc'
C
      CALL WMessageBox(OKOnly,ExclamationIcon,CommonOK,
     1      ' Error while reading input data'//CHAR(13)//
     2      ' Look at the end of file '//DSNAME(1:NDSNAM)//
     3      '.log to find the cause of the error',' ')
      STOP
      END
      BLOCK DATA
C     ******************************************************************
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
C  Numeric common block for MODPATH
      COMMON /MPCOM/IGUAUN,IGUAM,GUAMIN(15),GUAMAX(15)
C  Character common block for MODPATH
      PARAMETER (NSPEC=12)
      COMMON /MPCCOM/MPNAME,MPTYPE,CLEGND(15),CLTITL
      CHARACTER*60 MPNAME(NSPEC)
      CHARACTER*16 MPTYPE(NSPEC)
      CHARACTER*30 CLEGND
      CHARACTER*50 CLTITL
      PARAMETER (IDIM=MXSCRN*17)
C  Common block for Basic Package
      COMMON /PERCOM/PERLEN(MXPER),NSTP(MXPER),TSMULT(MXPER),
     1               ISSFLG(MXPER)
C  Common block for WEL Package
      COMMON /WELCOM/WELAUX(3)
      CHARACTER*16 WELAUX
C  Common block for RIV Package
      COMMON /RIVCOM/RIVAUX(3)
      CHARACTER*16 RIVAUX
C  Common block for STR Package
      COMMON /STRCOM/STRAUX(3)
      CHARACTER*16 STRAUX
C  Common block for DRN Package
      COMMON /DRNCOM/DRNAUX(3)
      CHARACTER*16 DRNAUX
C  Common block for GHB Package
      COMMON /GHBCOM/GHBAUX(3)
      CHARACTER*16 GHBAUX
C  Common block for Output Control
      COMMON /OCCOM/IBDOPT,LBHDSV,LBDDSV,LBBOSV,IBOUSV,
     1     IHEDFM,IDDNFM,IHEDPR,IDDNPR,IHEDSV,IDDNSV,IBUDPR,IBUDSV,
     2     IHDPR(17,MXSCRN),IDDPR(17,MXSCRN),IHDSV(17,MXSCRN),
     3     IDDSV(17,MXSCRN),IBDPR(17,MXSCRN),IBDSV(17,MXSCRN),
     4     IBOSV(17,MXSCRN)
C  Common block for MOC
      COMMON /MOCCOM/IUMOCL,IUMOC,IUCRC,IUCOBS,NSCOL,NSROW,NSLAY,
     1     ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2,
     2     NODISP,NPTPND,ICINFL,
     3     PNEWL(51),PNEWR(51),PNEWC(51),IZONE(MXCZON),ZONCON(MXCZON),
     4     ICOB(3,MXCOB),ICOBFL(MXCOB)
      COMMON /MOCCCM/HEDMOC(2)
      CHARACTER*78 HEDMOC
C
      DATA IUMOC,IUCRC,IUCOBS,NSCOL,NSROW,NSLAY/0,0,0,0,0,0/
      DATA ICOB,ICOBFL/MXCOB*0,MXCOB*0,MXCOB*0,MXCOB*0/
      DATA IZONE,ZONCON/MXCZON*0,MXCZON*0./
      DATA PNEWL,PNEWR,PNEWC/51*0.,51*0.,51*0./
C
      DATA NSTP/MXPER*1/
      DATA PERLEN/MXPER*1./
      DATA TSMULT/MXPER*1./
      DATA ISSFLG/MXPER*1/
C
      DATA IHDPR/IDIM*-999/
      DATA IDDPR/IDIM*-999/
      DATA IHDSV/IDIM*-999/
      DATA IDDSV/IDIM*-999/
      DATA IBDPR/IDIM*-999/
      DATA IBDSV/IDIM*-999/
      DATA IBOSV/IDIM*-999/
      DATA IBDOPT,LBHDSV,LBDDSV,LBBOSV,IBOUSV /1,0,0,0,1/
      DATA IHEDFM,IDDNFM /0,0/
      DATA IHEDPR,IDDNPR,IHEDSV,IDDNSV,IBUDPR,IBUDSV /2,1,1,1,3,1/
C
      DATA WELAUX/' ',' ',' '/
      DATA RIVAUX/' ',' ',' '/
      DATA STRAUX/' ',' ',' '/
      DATA DRNAUX/' ',' ',' '/
      DATA GHBAUX/' ',' ',' '/
C
      DATA MPTYPE/'DCF','ENDPOINT','PATHLINE','TIME-SERIES','TIME',
     1            'LOCATIONS','DRAWDOWN(BINARY)','DRAWDOWN',
     2            'CONTOUR-DATA','CONTOUR-LEVEL','LIST','CBF'/
      DATA CLEGND/15*' '/
      DATA CLTITL/' '/
      DATA IGUAUN,IGUAM,GUAMIN,GUAMAX/0,1,15*0.,15*0./
C
C  IBDOPT -- tells kind of budget files
C                    = 1 old budget files
C                    = 2 compact budget files
C
C  IBUDPR,IBUDSV,IHEDPR,IDDNPR,IHEDSV,IDDNSV -- flags indicating frequency
C  of output of the indicated type (e.g. IHEDPR is printout of head):
C                   1 = none (not allowed for IBUDFL)
C                   2 = end of simulation
C                   3 = end of each stress period
C                   4 = every time step
C                   5 = A list contains the time steps and stress periods
C                       when output is desired.  For head and drawdown,
C                       layer specifications are also in the list.
C
C  IHDPR,IDDPR,IHDSV,IDDSV,IBDPR,IBDSV are lists of stress periods and time
C    steps in which the respective output is desired whenever the frequency
C    flag is 5.  There are 15 locations for layer specifications -- if layers
C    are 0, all layers are implied.
      END
