      SUBROUTINE BCF6AL(IBDSAM)
C
C     ******************************************************************
C     ALLOCATE ARRAY STORAGE FOR BLOCK-CENTERED FLOW PACKAGE
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      COMMON /FLWCOM/LAYCON(200)
      COMMON /FLWAVG/LAYAVG(200)
      CHARACTER*80 LINE
      CHARACTER*12 AVGNAM(4)
      DATA AVGNAM/'HARMONIC    ','ARITHMETIC  ',
     1            'LOGARITHMIC ','*UNCONFINED*'/
C     ------------------------------------------------------------------
      IN=IUNIT(1)
C
C1------IDENTIFY PACKAGE
      WRITE(IOUT,1) IN
    1 FORMAT(1X,/1X,'BCF6 -- BLOCK-CENTERED FLOW PACKAGE,',
     1 ' INPUT READ FROM UNIT',I3)
C
C2------READ 1ST RECORD -- IBCFCB (FLAG FOR
C2------PRINTING OR UNIT# FOR RECORDING CELL-BY-CELL FLOW TERMS), HDRY
C2------(HEAD AT CELLS THAT CONVERT TO DRY), AND WETTING PARAMETERS
      IF(MODINP.EQ.0) THEN
C2A-----FIXED FORMAT
         READ(IUREAL(IN),'(A)') LINE
         READ(LINE,'(I10,F10.0,I10,F10.0,2I10)')
     1           IBCFCB,HDRY,IWDFLG,WETFCT,IWETIT,IHDWET
         IF(LINE(21:80).EQ.' ') THEN
            HDRY=1.E30
            IWDFLG=0
            WETFCT=0.5
            IWETIT=1
            IHDWET=1
         END IF
      ELSE
C2B-----FREE FORMAT -- Attempt to avoid problems when using free format
C2B-----to read data without WETDRY codes.
         READ(IUREAL(IN),'(A)') LINE
         LLOC=1
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IBCFCB,R,IOUT,IN)
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,I,HDRY,-1,IN)
         IF(LINE(80:80).EQ.'E' .OR. LLOC.GE.80) THEN
            HDRY=1.E30
            IWDFLG=0
            WETFCT=0.5
            IWETIT=1
            IHDWET=1
         ELSE
            CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IWDFLG,R,IOUT,IN)
            CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,I,WETFCT,IOUT,IN)
            IF(WETFCT.LE.0.) WETFCT=0.5
            CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IWETIT,R,IOUT,IN)
            IF(IWETIT.LE.0) IWETIT=1
            CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IHDWET,R,IOUT,IN)
         END IF
      END IF
C
C  PRINT VALUES FROM FIRST RECORD
      CALL VALSAV('HDRY',0,0,HDRY)
      CALL IVLSAV('IWDFLG',0,0,IWDFLG)
      CALL VALSAV('WETFCT',0,0,WETFCT)
      CALL IVLSAV('IWETIT',0,0,IWETIT)
      CALL IVLSAV('IHDWET',0,0,IHDWET)
      IF(IBCFCB.LT.0) WRITE(IOUT,8)
    8 FORMAT(1X,'CONSTANT-HEAD CELL-BY-CELL FLOWS WILL BE PRINTED',
     1     ' WHEN ICBCFL IS NOT 0')
      IF(IBCFCB.GT.0) WRITE(IOUT,9) IBCFCB
    9 FORMAT(1X,'CELL-BY-CELL FLOWS WILL BE SAVED ON UNIT',I3)
      IF(IBCFCB.LT.0) IBCFCB=-1
      IUNIT2(1)=IBCFCB
      IF(IBCFCB.GT.0) THEN
         IF(FILTYP(IBCFCB).EQ.'DATA(BINARY)') THEN
            IFNUSE(IBCFCB)=IUNIT(12)
         ELSE IF(FILTYP(IBCFCB).EQ.' ') THEN
            IUNIT2(1)=0
         ELSE
            WRITE(IOUT,*)
     1 'Attempt to save CBC budget in a file that is not DATA(BINARY)'
            CALL RDABRT
         END IF
         IF((IHEDUN.GT.0 .AND. IUNIT2(1).EQ.IHEDUN) .OR.
     1      (IDDNUN.GT.0 .AND. IUNIT2(1).EQ.IDDNUN)) THEN
            WRITE(IOUT,*) 'CBC file is same as HEAD or DRAWDOWN file'
            CALL RDABRT
         END IF
      END IF
      IF(IBDSAM.EQ.-2) THEN
         IF(IBCFCB.NE.0) IBDSAM=IBCFCB
      ELSE
         IF(IBDSAM.NE.IBCFCB) IBDSAM=0
      END IF
      WRITE(IOUT,11) HDRY
   11 FORMAT(1X,'HEAD AT CELLS THAT CONVERT TO DRY=',G13.5)
      IF(IWDFLG.NE.0) GO TO 35
      WRITE(IOUT,12)
   12 FORMAT(1X,'WETTING CAPABILITY IS NOT ACTIVE')
      GO TO 39
C
   35 WRITE(IOUT,36)
   36 FORMAT(1X,'WETTING CAPABILITY IS ACTIVE')
      IF(IWETIT.LE.0) IWETIT=1
      WRITE(IOUT,37)WETFCT,IWETIT
   37 FORMAT(1X,'WETTING FACTOR=',F10.5,
     1     '     WETTING ITERATION INTERVAL=',I4)
      WRITE(IOUT,38)IHDWET
   38 FORMAT(1X,'FLAG THAT SPECIFIES THE EQUATION TO USE FOR HEAD',
     1    ' AT WETTED CELLS=',I4)
C
C3------STOP THE SIMULATION IF THERE ARE MORE THAN 200 LAYERS.
   39 LAYMAX=200
      IF(MODINP.EQ.0) LAYMAX=80
      IF(NLAY.LE.LAYMAX) GO TO 50
      WRITE(IOUT,41) LAYMAX
   41 FORMAT(1X,/1X,
     1 'YOU HAVE SPECIFIED MORE THAN THE ALLOWED NUMBER OF LAYERS'/1X,
     2 'THE MAXIMUM NUMBER OF LAYERS IS',I3)
      CALL RDABRT
C
C4------READ LAYCON & PRINT TITLE FOR LAYCON TABLE.
   50 IF(MODINP.EQ.0) READ(IUREAL(IN),'(40I2)') (LAYCON(I),I=1,NLAY)
      IF(MODINP.NE.0) READ(IUREAL(IN),*) (LAYCON(I),I=1,NLAY)
      WRITE(IOUT,52)
   52 FORMAT(1X,5X,'LAYER  LAYER-TYPE CODE     INTERBLOCK T',
     1      /1X,5X,44('-'))
C
C5------LOOP THROUGH LAYERS CALCULATING LAYAVG, PRINTING THE LAYER-TYPE
C5------CODE, AND COUNTING LAYERS THAT NEED TOP & BOT ARRAYS.
      NBOT=0
      NTOP=0
      DO 100 I=1,NLAY
      IF(LAYCON(I).EQ.30 .OR. LAYCON(I).EQ.32) LAYCON(I)=LAYCON(I)-10
      INAM=LAYCON(I)/10
      LAYAVG(I)=INAM*10
      IF(LAYAVG(I).LT.0 .OR. LAYAVG(I).GT.30) THEN
         WRITE(IOUT,53) LAYAVG(I)
   53    FORMAT(1X,'INVALID INTERBLOCK T CODE:',I4)
         CALL RDABRT
      END IF
      LAYCON(I)=LAYCON(I)-LAYAVG(I)
      L=LAYCON(I)
      INAM=INAM+1
      WRITE(IOUT,55) I,L,LAYAVG(I),AVGNAM(INAM)
   55 FORMAT(1X,I9,I13,I11,' -- ',A)
      IF(LAYCON(I).LT.0 .OR. LAYCON(I).GT.3) THEN
         WRITE(IOUT,56) LAYCON(I)
   56    FORMAT(1X,'INVALID LAYER TYPE:',I4)
         CALL RDABRT
      END IF
C
C5A-----ONLY THE TOP LAYER CAN BE UNCONFINED(LAYCON=1).
      IF(L.NE.1 .OR. I.EQ.1) GO TO 70
      WRITE(IOUT,57)
   57 FORMAT(1X,/1X,'LAYER TYPE 1 IS ONLY ALLOWED IN TOP LAYER')
      CALL RDABRT
C
C5B-----LAYER TYPES 1 AND 3 NEED A BOTTOM. ADD 1 TO KB.
   70 IF(L.EQ.1 .OR. L.EQ.3) NBOT=NBOT+1
C
C5C-----LAYER TYPES 2 AND 3 NEED A TOP. ADD 1 TO KT.
      IF(L.EQ.2 .OR. L.EQ.3) NTOP=NTOP+1
C
  100 CONTINUE
C
C9------RETURN.
      RETURN
      END
      SUBROUTINE BCF6RP()
C
C     ******************************************************************
C     READ AND INITIALIZE DATA FOR BLOCK-CENTERED FLOW PACKAGE
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      COMMON /PERCOM/PERLEN(MXPER),NSTP(MXPER),TSMULT(MXPER),
     1               ISSFLG(MXPER)
      CHARACTER*24 ANAME(11)
C
      COMMON /FLWCOM/LAYCON(200)
C
      DATA ANAME(1) /'    PRIMARY STORAGE COEF'/
      DATA ANAME(2) /'    TRANSMIS. ALONG ROWS'/
      DATA ANAME(3) /'   HYD. COND. ALONG ROWS'/
      DATA ANAME(4) /'VERT HYD COND /THICKNESS'/
      DATA ANAME(5) /'  SECONDARY STORAGE COEF'/
      DATA ANAME(6) /'COLUMN TO ROW ANISOTROPY'/
      DATA ANAME(11)/'        WETDRY PARAMETER'/
C     ------------------------------------------------------------------
      ISS=1
      DO 2 N=1,NPER
      IF(ISSFLG(N).EQ.0) ISS=0
2     CONTINUE
C
C1------READ TRPY
      IN=IUNIT(1)
      CALL IVLGET('IWDFLG',0,0,ITYPE,IWDFLG)
C
      CALL ARRMAK('TRPY',0,0,NLAY,1)
C  Always allocate space in X for TRPY because the LAYCON edit screen
C  always accesses the individual TRPY values.
      CALL ARRAL2(IARRDA(2,NARRAY),NLAY,1)
      CALL U1DREL(ANAME(6),NLAY,IN,NARRAY)
      IF(IARRDA(1,NARRAY).GT.0 .OR. IARRDA(1,NARRAY).LT.-1) THEN
         WRITE(IOUT,*) ' Anisotropy cannot be an external array'
         CALL RDABRT
      END IF
C
C2------READ ALL PARAMETERS FOR EACH LAYER
      KT=0
      KB=0
      DO 200 K=1,NLAY
      KK=K
C
C2A-----FIND ADDRESS OF EACH LAYER IN THREE DIMENSION ARRAYS.
      IF(LAYCON(K).EQ.1 .OR. LAYCON(K).EQ.3) KB=KB+1
      IF(LAYCON(K).EQ.2 .OR. LAYCON(K).EQ.3) KT=KT+1
C
C2B-----READ PRIMARY STORAGE COEFFICIENT INTO ARRAY SF1 IF TRANSIENT
      IF(ISS.EQ.0) THEN
         CALL ARRMAK('SF1',KK,0,NCOL,NROW)
         CALL U2DREL(ANAME(1),NROW,NCOL,KK,IN,NARRAY,IN)
      END IF
C
C2C-----READ TRANSMISSIVITY INTO ARRAY CC IF LAYER TYPE IS 0 OR 2
      IF(LAYCON(K).EQ.0 .OR. LAYCON(K).EQ.2) THEN
         CALL ARRMAK('TRAN',KK,0,NCOL,NROW)
         CALL U2DREL(ANAME(2),NROW,NCOL,KK,IN,NARRAY,IN)
      ELSE
C
C2D-----READ HYDRAULIC CONDUCTIVITY(HY)
C2D-----IF LAYER TYPE IS 1 OR 3
         CALL ARRMAK('HY',KK,0,NCOL,NROW)
         CALL U2DREL(ANAME(3),NROW,NCOL,KK,IN,NARRAY,IN)
      END IF
C
C2E-----READ VERTICAL HYCOND/THICK INTO ARRAY CV IF NOT BOTTOM LAYER
C2E----- READ AS HYCOND/THICKNESS -- CONVERTED TO CONDUCTANCE LATER
      IF(K.NE.NLAY) THEN
         CALL ARRMAK('VCONT',KK,0,NCOL,NROW)
         CALL U2DREL(ANAME(4),NROW,NCOL,KK,IN,NARRAY,IN)
      END IF
C
C2F-----READ SECONDARY STORAGE COEFFICIENT INTO ARRAY SF2 IF TRANSIENT
C2F-----AND LAYER TYPE IS 2 OR 3
      IF(LAYCON(K).EQ.3 .OR. LAYCON(K).EQ.2) THEN
         IF(ISS.EQ.0) THEN
            CALL ARRMAK('SF2',KK,0,NCOL,NROW)
            CALL U2DREL(ANAME(5),NROW,NCOL,KK,IN,NARRAY,IN)
         END IF
      END IF
C
C2H-----READ WETDRY CODES IF LAYER TYPE IS 1 OR 3 AND WETTING
C2H-----CAPABILITY HAS BEEN INVOKED (IWDFLG NOT 0)
      IF( (LAYCON(K).EQ.3.OR.LAYCON(K).EQ.1) .AND. IWDFLG.NE.0 ) THEN
         CALL ARRMAK('WETDRY',KK,0,NCOL,NROW)
         CALL U2DREL(ANAME(7),NROW,NCOL,KK,IN,NARRAY,IN)
      END IF
  200 CONTINUE
C
C4------RETURN
      RETURN
      END
      SUBROUTINE BCFSV(IUNDEF,IWRFLG)
C
C     ******************************************************************
C     SAVE DATA FOR BLOCK-CENTERED FLOW PACKAGE
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      COMMON /PERCOM/PERLEN(MXPER),NSTP(MXPER),TSMULT(MXPER),
     1               ISSFLG(MXPER)
      COMMON /FLWCOM/LAYCON(200)
      COMMON /FLWAVG/LAYAVG(200)
      CHARACTER*80 LINE(1)
C     ------------------------------------------------------------------
      IF(IUNIT(1).EQ.0) THEN
         IUNDEF=-1
         RETURN
      END IF
      ISS=1
      DO 2 N=1,NPER
      IF(ISSFLG(N).EQ.0) ISS=0
2     CONTINUE
      CTEXT(1)='Missing data for the BCF Package:'
      CTEXT(2)='------------------------------------------------------'
      NMISS=2
C
      DO 10 I=1,MXFNAM
      IF(IFNUSE(I).EQ.IUNIT(1)) IFNUSE(I)=0
10    CONTINUE
      IFNUSE(IUNIT(1))=IUNIT(1)
C
      IF(IUREAL(IUNIT(1)).EQ.0) CALL REALUN(IUNIT(1))
      IUNDEF=0
      IFIL=IUMISC
      IF(IWRFLG.LE.0) IFIL=0
      IF(IWRFLG.EQ.1) OPEN(FILE='MFI.BCF',UNIT=IFIL)
      IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUNIT(1)),UNIT=IFIL)
      IBCFCB=IBUDUN
      IF(IBUDUN.EQ.0) IBCFCB=IUNIT2(1)
      CALL IVLGET('IWDFLG',0,0,ITYPE,IWDFLG)
      IF(ITYPE.NE.0) IWDFLG=0
      CALL IVLGET('IWETIT',0,0,ITYPE,IWETIT)
      IF(ITYPE.NE.0) IWETIT=1
      CALL IVLGET('IHDWET',0,0,ITYPE,IHDWET)
      IF(ITYPE.NE.0) IHDWET=0
      CALL VALGET('HDRY',0,0,ITYPE,HDRY)
      IF(ITYPE.NE.0) HDRY=1.E30
      CALL VALGET('WETFCT',0,0,ITYPE,WETFCT)
      IF(ITYPE.NE.0) WETFCT=0.5
      ITMP=IBCFCB
      IF(ITMP.GT.0) THEN
         IF(IUREAL(ITMP).EQ.0) CALL REALUN(ITMP)
         ITMP=IUREAL(ITMP)
      END IF
      IF(IWRFLG.GT.0) THEN
         IF(ABS(HDRY).LE.99999. .AND. ABS(HDRY).GE.100.) THEN
         WRITE(IFIL,'(I10,F10.2,I10,1P,E10.2,2I10,A)')
     1         ITMP,HDRY,IWDFLG,WETFCT,IWETIT,IHDWET,
     2      '  IBCFCB,HDRY,IWDFLG,WETFCT,IWETIT,IHDWET'
         ELSE
         WRITE(IFIL,'(I10,1P,E10.2,I10,E10.2,2I10,A)')
     1         ITMP,HDRY,IWDFLG,WETFCT,IWETIT,IHDWET,
     2      '  IBCFCB,HDRY,IWDFLG,WETFCT,IWETIT,IHDWET'
         END IF
      END IF
C  LAYCON
      IF(IWRFLG.GT.0) THEN
         IF(MODOUT.EQ.0) THEN
            WRITE(IFIL,'(40I2)') (LAYCON(I)+LAYAVG(I),I=1,NLAY)
C  Original model -- use I2 format
         ELSE
C  New model -- Write with I2 format if LAYAVG for all layers is 0.  This
C  will allow original model (I2 format) and new model (list directed format)
C  to both read the file.  Write with I3 format if is not 0; this cannot
C  be read by original model.
            DO 20 K=1,NLAY
            IF(LAYAVG(K).NE.0) GO TO 25
20          CONTINUE
C  All LAYAVG values are 0 -- use I2 format.
            WRITE(IFIL,'(40I2)') (LAYCON(I),I=1,NLAY)
            GO TO 26
C  A LAYAVG value is not 0, use I3 format.
25          WRITE(IFIL,'(20I3)') (LAYCON(I)+LAYAVG(I),I=1,NLAY)
         END IF
      END IF
C
26    CALL U1DRSV('TRPY',IUNDEF,IFIL,IUNIT(1))
C
C2------WRITE ALL PARAMETERS FOR EACH LAYER
      KT=0
      KB=0
      DO 200 K=1,NLAY
      IF(LAYAVG(K).EQ.30) IAPART=1
      KK=K
C
C2A-----FIND ADDRESS OF EACH LAYER IN THREE DIMENSION ARRAYS.
      IF(LAYCON(K).EQ.1 .OR. LAYCON(K).EQ.3) KB=KB+1
      IF(LAYCON(K).EQ.2 .OR. LAYCON(K).EQ.3) KT=KT+1
C
C2B-----PRIMARY STORAGE COEFFICIENT INTO ARRAY SC1 IF TRANSIENT
      IF(ISS.EQ.0) THEN
         CALL U2DRSV('SF1',KK,0,IUNDEF,IFIL,IUNIT(1),'SF1',KK)
         IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
            NMISS=NMISS+1
            IUNDEF=0
            WRITE(CTEXT(NMISS),'(A,I10)') 'SF1       HYDRAULIC ',KK
         END IF
      END IF
C
C2C-----TRANSMISSIVITY INTO ARRAY CC IF LAYER TYPE IS 0 OR 2
      IF(LAYCON(K).EQ.0 .OR. LAYCON(K).EQ.2) THEN
         CALL U2DRSV('TRAN',KK,0,IUNDEF,IFIL,IUNIT(1),'TRAN',KK)
         IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
            NMISS=NMISS+1
            IUNDEF=0
            WRITE(CTEXT(NMISS),'(A,I10)') 'TRAN      HYDRAULIC ',KK
         END IF
      ELSE
C
C2D-----HYDRAULIC CONDUCTIVITY(HY)
C2D-----IF LAYER TYPE IS 1 OR 3
         CALL U2DRSV('HY',KK,0,IUNDEF,IFIL,IUNIT(1),'HY',KK)
         IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
            NMISS=NMISS+1
            IUNDEF=0
            WRITE(CTEXT(NMISS),'(A,I10)') 'HY        HYDRAULIC ',KK
         END IF
C
      END IF
C
C2E-----VERTICAL HYCOND/THICK
      IF(K.NE.NLAY) THEN
         CALL U2DRSV('VCONT',KK,0,IUNDEF,IFIL,IUNIT(1),'VCONT',KK)
         IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
            NMISS=NMISS+1
            IUNDEF=0
            WRITE(CTEXT(NMISS),'(A,I10)') 'VCONT     HYDRAULIC ',KK
         END IF
      END IF
C
C2F-----SECONDARY STORAGE COEFFICIENT (ARRAY SF2) IF TRANSIENT
C2F-----AND LAYER TYPE IS 2 OR 3
      IF(LAYCON(K).EQ.3 .OR. LAYCON(K).EQ.2) THEN
         IF(ISS.EQ.0) THEN
            CALL U2DRSV('SF2',KK,0,IUNDEF,IFIL,IUNIT(1),'SF2',KK)
            IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
               NMISS=NMISS+1
               IUNDEF=0
               WRITE(CTEXT(NMISS),'(A,I10)') 'SF2       HYDRAULIC ',KK
            END IF
         END IF
      END IF
C
C2H-----WETDRY CODES IF LAYER TYPE IS 1 OR 3 AND WETTING
C2H-----CAPABILITY HAS BEEN INVOKED (IWDFLG NOT 0)
      IF( (LAYCON(K).EQ.3.OR.LAYCON(K).EQ.1) .AND. IWDFLG.NE.0 ) THEN
         CALL U2DRSV('WETDRY',KK,0,IUNDEF,IFIL,IUNIT(1),'WETDRY',KK)
         IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
            NMISS=NMISS+1
            IUNDEF=0
            WRITE(CTEXT(NMISS),'(A,I10)') 'WETDRY    HYDRAULIC ',KK
         END IF
      END IF
  200 CONTINUE
C
      IF(IWRFLG.GT.0) CLOSE(UNIT=IFIL)
      IF(IWRFLG.LT.0) THEN
         IF(NMISS.GT.2) THEN
            CALL TXTLOG(CTEXT,NMISS)
            IUNDEF=1
         ELSE
            LINE(1)='All data are defined for the BCF Package'
            CALL TXTLOG(LINE,1)
         END IF
      END IF
C
      CALL FNMRMV
      RETURN
      END
