      SUBROUTINE DRN6AL(IBDSAM,NPDRN)
C
C     ******************************************************************
C     ALLOCATE ARRAY STORAGE FOR Drain PACKAGE
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
C  Common block for DRN Package
      COMMON /DRNCOM/DRNAUX(3)
      CHARACTER*16 DRNAUX
      CHARACTER*200 LINE
C     ------------------------------------------------------------------
      IULOC=3
      IN=IUNIT(IULOC)
C
C1------IDENTIFY PACKAGE.
      WRITE(IOUT,1)IN
    1 FORMAT(1X,/1X,'DRN -- DRAIN PACKAGE,  INPUT READ FROM UNIT',I3)
      NNPDRN=0
C
C2------READ MAXIMUM NUMBER OF DRAINS AND UNIT OR FLAG FOR
C2------CELL-BY-CELL FLOW TERMS.
      CALL URDCOM(IUREAL(IN),LINE,IULOC)
      CALL UPARLSTAL(IUREAL(IN),IOUT,LINE,NPDRN,MXPW)
      IF(MODINP.EQ.0) THEN
         READ(LINE,'(2I10)') MXACTD,IDRNCB
         LLOC=21
      ELSE
         LLOC=1
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,MXACTD,R,IOUT,IN)
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IDRNCB,R,IOUT,IN)
      END IF
      WRITE(IOUT,3) MXACTD
    3 FORMAT(1X,'MAXIMUM OF',I5,' ACTIVE REACHES AT ONE TIME')
      IF(IDRNCB.LT.0) WRITE(IOUT,7)
    7 FORMAT(1X,'CELL-BY-CELL FLOWS WILL BE PRINTED WHEN ICBCFL NOT 0')
      IF(IDRNCB.GT.0) WRITE(IOUT,8) IDRNCB
    8 FORMAT(1X,'CELL-BY-CELL FLOWS WILL BE SAVED ON UNIT',I3)
C
C  Process CBC flag
      IF(IDRNCB.LT.0) IDRNCB=-1
      IUNIT2(IULOC)=IDRNCB
      IF(IDRNCB.GT.0) THEN
         IF(FILTYP(IDRNCB).EQ.'DATA(BINARY)') THEN
            IFNUSE(IDRNCB)=IUNIT(12)
         ELSE IF(FILTYP(IDRNCB).EQ.' ') THEN
            IUNIT2(IULOC)=0
         ELSE
            WRITE(IOUT,*)
     1 'Attempt to save CBC budget in a file that is not DATA(BINARY)'
            CALL RDABRT
         END IF
         IF((IHEDUN.GT.0 .AND. IUNIT2(IULOC).EQ.IHEDUN) .OR.
     1      (IDDNUN.GT.0 .AND. IUNIT2(IULOC).EQ.IDDNUN)) THEN
            WRITE(IOUT,*) 'CBC file is same as HEAD or DRAWDOWN file'
            CALL RDABRT
         END IF
      END IF
      IF(IBDSAM.EQ.-2) THEN
         IF(IDRNCB.NE.0) IBDSAM=IDRNCB
      ELSE
         IF(IBDSAM.NE.IDRNCB) IBDSAM=0
      END IF
C
C3------READ AUXILIARY VARIABLES AND CBC ALLOCATION OPTION.
      IDRNAL=0
      NAUX=0
   10 CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IN)
      IF(LINE(ISTART:ISTOP).EQ.'CBCALLOCATE' .OR.
     1   LINE(ISTART:ISTOP).EQ.'CBC') THEN
         IDRNAL=1
         WRITE(IOUT,11)
   11    FORMAT(1X,'MEMORY IS ALLOCATED FOR CELL-BY-CELL BUDGET TERMS')
         GO TO 10
      ELSE IF(LINE(ISTART:ISTOP).EQ.'AUXILIARY' .OR.
     1        LINE(ISTART:ISTOP).EQ.'AUX') THEN
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IN)
         IF(NAUX.LT.3) THEN
            NAUX=NAUX+1
            DRNAUX(NAUX)=LINE(ISTART:ISTOP)
            WRITE(IOUT,12) DRNAUX(NAUX)
   12       FORMAT(1X,'AUXILIARY DRN VARIABLE: ',A)
         ELSE 
            WRITE(IOUT,*) ' Too many auxiliary variables for MFI2K'
            CALL RDABRT
         END IF
         GO TO 10
      END IF
C
C6------RETURN
      RETURN
      END
      SUBROUTINE DRN6RQ(NPDRN)
C
C     ******************************************************************
C     READ PARAMETERS
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      COMMON /DRNCOM/DRNAUX(3)
      CHARACTER*16 DRNAUX
      CHARACTER*10 ARRNAM
C     ------------------------------------------------------------------
      IW=8
      IULOC=3
      IN=IUNIT(IULOC)
C
C-------READ NAMED PARAMETERS
      WRITE(IOUT,3) NPDRN
    3 FORMAT(1X,//1X,I5,' DRN parameters')
      IF(NPDRN.GT.0) THEN
        DO 5 K=1,NPDRN
C---------READ AND STORE LIST PARAMETER DEFINITION INFORMATION
          CALL UPARLSTRP(IUREAL(IN),'DRN','DRN',NLST,ARRNAM)
C  Make a data list for the parameter
          CALL LSTMAK2(ARRNAM,-3,-3,IW,NLST)
          NAR=NARRAY
C---------READ AND PRINT A LIST OF CELLS
          CALL LSTRD2(NLST,NAR,IX(IARRDA(2,NAR)),IN,
     1 'DRAIN NO. LAYER   ROW   COL  ELEVATION    CONDUCTANCE',
     2      DRNAUX,3)
    5   CONTINUE
      END IF
C
C6------RETURN
      RETURN
      END
      SUBROUTINE DRN6RP(KPER,NPDRN)
C
C     ******************************************************************
C     READ NEW DRAIN LOCATIONS AND STRESS RATES
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      COMMON /DRNCOM/DRNAUX(3)
      CHARACTER*16 DRNAUX
C     ------------------------------------------------------------------
      IW=8
      IULOC=3
      IN=IUNIT(IULOC)
C
C1----READ NUMBER OF DRAINS (OR FLAG SAYING REUSE DRN DATA).
C1----AND NUMBER OF PARAMETERS
      IF(NPDRN.GT.0) THEN
        IF(MODINP.EQ.0) THEN
           READ(IUREAL(IN),'(2I10)') ITMP,NP
        ELSE
           READ(IUREAL(IN),*) ITMP,NP
        END IF
      ELSE
         NP=0
         IF(MODINP.EQ.0) THEN
            READ(IUREAL(IN),'(I10)') ITMP
         ELSE
            READ(IUREAL(IN),*) ITMP
         END IF
      END IF
C
C------Calculate some constants.
C
C1A-----IF ITMP LESS THAN ZERO REUSE NON-PARAMETER DATA. PRINT MESSAGE.
C1A-----IF ITMP=>0, SET NUMBER OF NON-PARAMETER DRAINS EQUAL TO ITMP.
      IF(ITMP.EQ.IMISS) THEN
         WRITE(IOUT,*) 'Non-parameter drainss are undefined'
         GO TO 100
      ELSE IF(ITMP.LT.0) THEN
         WRITE(IOUT,6)
    6    FORMAT(1X,/
     1    1X,'REUSING NON-PARAMETER DRAINS FROM LAST STRESS PERIOD')
      END IF
C
C1B-----IF THERE ARE NEW NON-PARAMETER DRAINS, READ THEM.
       CALL LSTMAK2('DRAI',0,KPER,IW,ITMP)
       NAR=NARRAY
C---------READ AND PRINT A LIST OF CELLS
       CALL LSTRD2(ITMP,NAR,IX(IARRDA(2,NAR)),IN,
     1 'DRAIN NO. LAYER   ROW   COL  ELEVATION    CONDUCTANCE',
     2      DRNAUX,3)
C
C1C-----IF THERE ARE ACTIVE DRN PARAMETERS, READ THEM
100   IPF=0
      CALL PERPARRD(IUREAL(IN),NP,'DRN',KPER,IPF)
C
C6------RETURN
      RETURN
      END
      SUBROUTINE DRNSV(IUNDEF,IWRFLG)
C     ******************************************************************
C     Save Drain data
C     ******************************************************************
      COMMON /DRNCOM/DRNAUX(3)
      CHARACTER*16 DRNAUX
C     ------------------------------------------------------------------
C
      IULOC=3
      CALL LSTSAV3(IULOC,'DRAI',DRNAUX,3,IUNDEF,IWRFLG,
     1          'DRN',' MXACTD IDRNCB','DRN')
      RETURN
      END
