      SUBROUTINE EVT6AL(IBDSAM,NPEVT)
C
C     ******************************************************************
C     ALLOCATE ARRAY STORAGE FOR EVAPOTRANSPIRATION
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      CHARACTER*200 LINE
C     ------------------------------------------------------------------
      IN=IUNIT(5)
C
C1------IDENTIFY PACKAGE.
      WRITE(IOUT,1)IN
    1 FORMAT(1X,/1X,'EVT -- EVAPOTRANSPIRATION PACKAGE,',
     1' INPUT READ FROM UNIT',I3)
C
C2------READ NEVTOP AND IEVTCB.
      CALL URDCOM(IUREAL(IN),LINE,5)
      CALL UPARARRAL(IUREAL(IN),IOUT,LINE,NPEVT)
      IF(MODINP.EQ.0) THEN
         READ(LINE,'(2I10)') NEVTOP,IEVTCB
      ELSE
         LLOC=1
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NEVTOP,R,IOUT,IN)
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IEVTCB,R,IOUT,IN)
      END IF
C
C3------CHECK TO SEE THAT OPTION IS LEGAL.
      IF(NEVTOP.GE.1.AND.NEVTOP.LE.2)GO TO 200
C
C3A-----IF ILLEGAL PRINT A MESSAGE AND ABORT SIMULATION
      WRITE(IOUT,8)
    8 FORMAT(1X,'ILLEGAL OPTION CODE. SIMULATION ABORTING')
      CALL RDABRT
C
C4------IF OPTION IS LEGAL PRINT OPTION CODE.
  200 IF(NEVTOP.EQ.1) WRITE(IOUT,201)
  201 FORMAT(1X,'OPTION 1 -- EVAPOTRANSPIRATION TO TOP LAYER')
      IF(NEVTOP.EQ.2) WRITE(IOUT,202)
  202 FORMAT(1X,'OPTION 2 -- EVAPOTRANSPIRATION TO ONE SPECIFIED NODE',
     1   ' IN EACH VERTICAL COLUMN')
C
C5------IF CELL-BY-CELL FLOWS ARE TO BE SAVED, THEN PRINT UNIT NUMBER.
      IF(IEVTCB.GT.0) WRITE(IOUT,204) IEVTCB
  204 FORMAT(1X,'CELL-BY-CELL FLOWS WILL BE SAVED ON UNIT',I3)
C
      CALL IVLSAV('NEVTOP',0,0,NEVTOP)
      IUNIT2(5)=IEVTCB
      IF(IEVTCB.LE.0) IUNIT2(5)=0
      IF(IEVTCB.GT.0) THEN
         IF(FILTYP(IEVTCB).EQ.'DATA(BINARY)') THEN
            IFNUSE(IEVTCB)=IUNIT(12)
         ELSE IF(FILTYP(IEVTCB).EQ.' ') THEN
            IUNIT2(5)=0
         ELSE
            WRITE(IOUT,*)
     1 'Attempt to save CBC budget in a file that is not DATA(BINARY)'
            CALL RDABRT
         END IF
         IF((IHEDUN.GT.0 .AND. IUNIT2(5).EQ.IHEDUN) .OR.
     1      (IDDNUN.GT.0 .AND. IUNIT2(5).EQ.IDDNUN)) THEN
            WRITE(IOUT,*) 'CBC file is same as HEAD or DRAWDOWN file'
            CALL RDABRT
         END IF
      END IF
      IF(IBDSAM.EQ.-2) THEN
         IF(IEVTCB.NE.0) IBDSAM=IEVTCB
      ELSE
         IF(IBDSAM.NE.IEVTCB) IBDSAM=0
      END IF
C
C9------RETURN
      RETURN
      END
      SUBROUTINE EVT6RQ(NPEVT)
C     ******************************************************************
C     Read parameters
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      CHARACTER*4 PTYP
C     ------------------------------------------------------------------
      IF(NPEVT.LE.0) RETURN
C
      IN=IUNIT(5)
      ITERP=1
      DO 20 K=1,NPEVT
      CALL UPARARRRP(IUREAL(IN),IOUT,N,0,PTYP,ITERP)
      IF(PTYP.NE.'EVT') THEN
         WRITE(IOUT,7)
7        FORMAT(1X,'Parameter type must be EVT')
         CALL RDABRT
      END IF
20    CONTINUE
C
      RETURN
      END
      SUBROUTINE EVT6RP(KPER,NPEVT)
C
C     ******************************************************************
C     READ EVAPOTRANSPIRATION DATA
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      CHARACTER*24 ANAME(4)
C
      DATA ANAME(1) /'          ET LAYER INDEX'/
      DATA ANAME(2) /'              ET SURFACE'/
      DATA ANAME(3) /' EVAPOTRANSPIRATION RATE'/
      DATA ANAME(4) /'        EXTINCTION DEPTH'/
C     ------------------------------------------------------------------
      IN=IUNIT(5)
      CALL IVLGET('NEVTOP',0,0,ITYPE,NEVTOP)
C
C1------READ FLAGS SHOWING WHETHER DATA IS TO BE REUSED.
      IF(NEVTOP.EQ.2) THEN
         IF(MODINP.EQ.0) READ(IUREAL(IN),'(4I10)')
     1                                      INSURF,INEVTR,INEXDP,INIEVT
         IF(MODINP.NE.0) READ(IUREAL(IN),*) INSURF,INEVTR,INEXDP,INIEVT
      ELSE
         IF(MODINP.EQ.0) READ(IUREAL(IN),'(3I10)') INSURF,INEVTR,INEXDP
         IF(MODINP.NE.0) READ(IUREAL(IN),*) INSURF,INEVTR,INEXDP
      END IF
C
C2------TEST INSURF TO SEE WHERE SURFACE ELEVATION IS COMING FROM.
      IF(INSURF.GE.0)GO TO 32
C
C2A-----IF INSURF<0 THEN REUSE SURFACE ELEVATION FROM LAST STRESS PERIOD
      WRITE(IOUT,3)
    3 FORMAT(1X,/1X,'REUSING SURF FROM LAST STRESS PERIOD')
      IF(NPEVT.LE.0) THEN
         CALL VALGET('SURF',0,KPER-1,NAR,DUM)
         IF(NAR.LE.0) THEN
            WRITE(IOUT,*) ' ATTEMPT TO REUSE UNDEFINED SURF DATA'
            CALL RDABRT
         END IF
         CALL ARRMAK('SURF',0,KPER,NCOL,NROW)
         ARRCON(NARRAY)=ARRCON(NAR)
         IARRDA(1,NARRAY)=-3
         IARRDA(5,NARRAY)=IARRDA(5,NAR)
         GO TO 35
      ELSE
C  Reuse parameters from last stress period
         CALL ARRMAK('SURF',0,KPER,NCOL,NROW)
         IARRDA(1,NARRAY)=-3
         GO TO 35
      END IF
C
C2B-----IF INSURF=>0 THEN CALL U2DREL TO READ SURFACE ELEVATION.
32    CALL ARRMAK('SURF',0,KPER,NCOL,NROW)
      CALL U2DREL(ANAME(2),NROW,NCOL,0,IN,NARRAY,IN)
C
C3------TEST INEVTR TO SEE WHERE MAX ET RATE IS COMING FROM.
   35 IF(INEVTR.GE.0) GO TO 37
C
C3A-----IF INEVTR<0 THEN REUSE MAX ET RATE FROM LAST STRESS PERIOD.
      WRITE(IOUT,4)
    4 FORMAT(1X,/1X,'REUSING EVTR FROM LAST STRESS PERIOD')
      CALL VALGET('EVTR',0,KPER-1,NAR,DUM)
      IF(NAR.LE.0) THEN
         WRITE(IOUT,*) ' ATTEMPT TO REUSE UNDEFINED EVTR DATA'
         CALL RDABRT
      END IF
      CALL ARRMAK('EVTR',0,KPER,NCOL,NROW)
      ARRCON(NARRAY)=ARRCON(NAR)
      IARRDA(1,NARRAY)=-3
      IARRDA(5,NARRAY)=IARRDA(5,NAR)
      GO TO 45
C
C3B-----IF INEVTR=>0 THEN CALL U2DREL TO READ MAX ET RATE OR READ PARAMETERS.
   37 IF(NPEVT.LE.0) THEN
         CALL ARRMAK('EVTR',0,KPER,NCOL,NROW)
         CALL U2DREL(ANAME(3),NROW,NCOL,0,IN,NARRAY,IN)
      ELSE
         IEVTPF=-999
         CALL PERPARRD(IUREAL(IN),INEVTR,'EVT',KPER,IEVTPF)
         IF(IEVTPF.GT.-999) CALL IVLSAV('IEVTPF',0,KPER,IEVTPF)
      END IF
C
C4------TEST INEXDP TO SEE WHERE EXTINCTION DEPTH IS COMING FROM.
   45 IF(INEXDP.GE.0) GO TO 47
C
C4A-----IF INEXDP<0 THEN REUSE EXTINCTION DEPTH FROM LAST STRESS PERIOD.
      WRITE(IOUT,5)
    5 FORMAT(1X,/1X,'REUSING EXDP FROM LAST STRESS PERIOD')
      CALL VALGET('EXDP',0,KPER-1,NAR,DUM)
      IF(NAR.LE.0) THEN
         WRITE(IOUT,*) ' ATTEMPT TO REUSE UNDEFINED EXDP DATA'
         CALL RDABRT
      END IF
      CALL ARRMAK('EXDP',0,KPER,NCOL,NROW)
      ARRCON(NARRAY)=ARRCON(NAR)
      IARRDA(1,NARRAY)=-3
      IARRDA(5,NARRAY)=IARRDA(5,NAR)
      GO TO 55
C
C4B-----IF INEXDP=>0 THEN CALL U2DREL TO READ EXTINCTION DEPTH.
   47 CALL ARRMAK('EXDP',0,KPER,NCOL,NROW)
      CALL U2DREL(ANAME(4),NROW,NCOL,0,IN,NARRAY,IN)
C
C9------IF NEVTOP=2 THEN A LAYER INDICATOR ARRAY IS NEEDED.
   55 IF (NEVTOP.NE.2) RETURN
C
C9A-----IF INIEVT<0 THEN REUSE LAYER INDICATOR ARRAY.
      IF(INIEVT.GE.0)GO TO 58
      WRITE(IOUT,2)
    2 FORMAT(1X,/1X,'REUSING IEVT FROM LAST STRESS PERIOD')
      CALL VALGET('IEVT',0,KPER-1,NAR,DUM)
      IF(NAR.LE.0) THEN
         WRITE(IOUT,*) ' ATTEMPT TO REUSE UNDEFINED IEVT DATA'
         CALL RDABRT
      END IF
      CALL ARRMAK('IEVT',0,KPER,NCOL,NROW)
      ARRCON(NARRAY)=ARRCON(NAR)
      IARRDA(1,NARRAY)=-3
      IARRDA(5,NARRAY)=IARRDA(5,NAR)
      RETURN
C
C9B-----IF INIEVT=>0 CALL U2DINT TO READ LAYER IND ARRAY(IEVT)
58    CALL ARRMAK('IEVT',0,KPER,NCOL,NROW)
      CALL U2DINT(ANAME(1),NROW,NCOL,0,IN,NARRAY,IN)
      RETURN
C
      END
      SUBROUTINE EVTSV(IUNDEF,IWRFLG)
C
C     ******************************************************************
C     SAVE DATA FOR EVAPOTRANSPIRATION PACKAGE
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      INCLUDE 'mfi2kpar.inc'
      CHARACTER*10 MN,ZN
      CHARACTER*4 CPF
C     ------------------------------------------------------------------
      IULOC=5
      IF(IUNIT(IULOC).EQ.0) THEN
         IUNDEF=-1
         RETURN
      END IF
C
      IHEAD=0
      NM=0
      DO 5 I=1,MXFNAM
      IF(IFNUSE(I).EQ.IUNIT(IULOC)) IFNUSE(I)=0
5     CONTINUE
      IFNUSE(IUNIT(IULOC))=IUNIT(IULOC)
C
      IF(IUREAL(IUNIT(IULOC)).EQ.0) CALL REALUN(IUNIT(IULOC))
      IUNDEF=0
      IFIL=IUMISC
      IF(IWRFLG.LE.0) IFIL=0
      IF(IWRFLG.EQ.1) OPEN(FILE='MFI.EVT',UNIT=IFIL)
      IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUNIT(IULOC)),UNIT=IFIL)
C
C  Write comments
      IF(IWRFLG.GT.0) THEN
         DO 8 I=1,20
         IF(COMENT(I,IULOC)(1:1).EQ.'#') THEN
            DO 6 N=80,1,-1
            IF(COMENT(I,IULOC)(N:N) .NE. ' ') GO TO 7
6           CONTINUE
7           WRITE(IFIL,'(A)') COMENT(I,IULOC)(1:N)
         END IF
8        CONTINUE
      END IF
C
C  Write the number of parameters if there are any.
      NP=0
      DO 10 I=1,IPSUM
      IF(PARTYP(I).EQ.'EVT') THEN
         NP=NP+1
      END IF
10    CONTINUE
      IF(NP.GT.0. AND. IWRFLG.GT.0) WRITE(IFIL,2) NP
2     FORMAT('PARAMETER',1X,I10)
C
      CALL IVLGET('NEVTOP',0,0,ITYPE,NEVTOP)
      IF(ITYPE.NE.0) NEVTOP=1
      IEVTCB=IBUDUN
      IF(IBUDUN.EQ.0) IEVTCB=IUNIT2(IULOC)
      ITMP=IEVTCB
      IF(ITMP.GT.0) THEN
         IF(IUREAL(ITMP).EQ.0) CALL REALUN(ITMP)
         ITMP=IUREAL(ITMP)
      END IF
      IF(IWRFLG.GT.0) THEN
         WRITE(IFIL,'(2I10,A)') NEVTOP,ITMP,'  NEVTOP IEVTCB'
      END IF
C
C  Write the parameter definitions if there are any.
      IF(NP.GT.0 .AND. IWRFLG.GT.0) THEN
         DO 20 J=1,IPSUM
         IF(PARTYP(J).EQ.'EVT') THEN
            NCLU=IPLOC(2,J)-IPLOC(1,J)+1
            WRITE(IFIL,11) PARNAM(J),PARTYP(J),B(J),NCLU
11          FORMAT(A,1X,A,1P,E14.6,I10)
            DO 15 K=IPLOC(1,J),IPLOC(2,J)
            MN=CPCLST(1,K)
            ZN=CPCLST(2,K)
            IF(ZN.NE.'ALL') THEN
               WRITE(IFIL,12) MN,ZN,(IPCLST(L,K),L=3,IPCLST(2,K))
12             FORMAT(A,1X,A,10(1X,I4))
            ELSE
               WRITE(IFIL,12) MN,ZN
            END IF
15          CONTINUE
         END IF
20       CONTINUE
      END IF
C
C  Write data for each stress period
      DO 100 KPER=1,NPER
      INSURF=0
      CALL VALGET('SURF',0,KPER,NAR,DUM)
      IF(NAR.GT.0) THEN
         IF(IARRDA(1,NAR).EQ.-3) INSURF=-1
      END IF
C
      INEVTR=0
      IF(NP.LE.0) THEN
C  EVTR is an array
         CALL VALGET('EVTR',0,KPER,NAR,DUM)
         IF(NAR.GT.0) THEN
            IF(IARRDA(1,NAR).EQ.-3) INEVTR=-1
         END IF
      ELSE
C  EVTR is defined by parameters
         CALL VALGET('EVTR',0,KPER,NAR,DUM)
         IF(NAR.GT.0) THEN
            IF(IARRDA(1,NAR).EQ.-3) INEVTR=-1
         END IF
         IF(INEVTR.EQ.0) THEN
            DO 50 I=1,MXPERPAR
            IF(PERPARTYP(I).EQ.'EVT' .AND. IPERPARPER(I).EQ.KPER) THEN
               INEVTR=INEVTR+1
            END IF
50          CONTINUE
         END IF
      END IF
C
      INEXDP=0
      CALL VALGET('EXDP',0,KPER,NAR,DUM)
      IF(NAR.GT.0) THEN
         IF(IARRDA(1,NAR).EQ.-3) INEXDP=-1
      END IF
      INIEVT=0
      IF(NEVTOP.EQ.2) THEN
         CALL VALGET('IEVT',0,KPER,NAR,DUM)
         IF(NAR.GT.0) THEN
            IF(IARRDA(1,NAR).EQ.-3) INIEVT=-1
         END IF
      END IF
      IF(IWRFLG.GT.0) WRITE(IFIL,'(4I10,A)')
     1   INSURF,INEVTR,INEXDP,INIEVT,'  INSURF INEVTR INEXDP INIEVT'
      IF(INSURF.GE.0) THEN
         CALL U2DRSV('SURF',0,KPER,IUNDEF,IFIL,IUNIT(IULOC),'SURF',0)
         IF(IUNDEF.NE.0 .AND. IWRFLG.LT.0) THEN
            IUNDEF=0
            NM=NM+1
            IF(IHEAD.EQ.0) CALL STRHED(IHEAD,'EVT')
            IF(NMISS.LT.45) THEN
               NMISS=NMISS+1
               WRITE(CTEXT(NMISS),'(A,I4)') 'SURF            ',KPER
            END IF
         END IF
      END IF
C
C  EVTR array
      IF(NP.LE.0) THEN
         IF(INEVTR.GE.0) THEN
            CALL U2DRSV('EVTR',0,KPER,IUNDEF,IFIL,IUNIT(IULOC),'EVTR',0)
            IF(IUNDEF.NE.0 .AND. IWRFLG.LT.0) THEN
               IUNDEF=0
                NM=NM+1
               IF(IHEAD.EQ.0) CALL STRHED(IHEAD,'EVT')
               IF(NMISS.LT.45) THEN
                  NMISS=NMISS+1
                  WRITE(CTEXT(NMISS),'(A,I4)') 'EVTR            ',KPER
               END IF
            END IF
         END IF
      ELSE
C  EVTR is defined by parameters
         IF(IWRFLG.GT.0 .AND. INEVTR.GT.0) THEN
            CPF=' '
            CALL IVLGET('IEVTPF',0,KPER,N,IEVTPF)
            IF(N.EQ.0) WRITE(CPF,'(I4)') IEVTPF 
            DO 60 I=1,MXPERPAR
            IF(PERPARTYP(I).EQ.'EVT' .AND. IPERPARPER(I).EQ.KPER) THEN
               WRITE(IFIL,'(A,1X,A)') PERPARNAM(I),CPF
               CPF=' '
            END IF
60          CONTINUE
         END IF
      END IF
C
      IF(INEXDP.GE.0) THEN
         CALL U2DRSV('EXDP',0,KPER,IUNDEF,IFIL,IUNIT(IULOC),'EXDP',0)
         IF(IUNDEF.NE.0 .AND. IWRFLG.LT.0) THEN
            IUNDEF=0
            NM=NM+1
            IF(IHEAD.EQ.0) CALL STRHED(IHEAD,'EVT')
            IF(NMISS.LT.45) THEN
               NMISS=NMISS+1
               WRITE(CTEXT(NMISS),'(A,I4)') 'EXDP            ',KPER
            END IF
         END IF
      END IF
      IF(NEVTOP.EQ.2) THEN
         IF(INIEVT.GE.0) THEN
            CALL U2DISV('IEVT',0,KPER,IUNDEF,IFIL,IUNIT(IULOC))
            IF(IUNDEF.NE.0 .AND. IWRFLG.LT.0) THEN
               IUNDEF=0
               NM=NM+1
               IF(IHEAD.EQ.0) CALL STRHED(IHEAD,'EVT')
               IF(NMISS.LT.45) THEN
                  NMISS=NMISS+1
                  WRITE(CTEXT(NMISS),'(A,I4)') 'IEVT            ',KPER
               END IF
            END IF
         END IF
      END IF
100   CONTINUE
C
      IF(IWRFLG.GT.0) CLOSE(UNIT=IFIL)
      IF(NM.EQ.0 .AND. IWRFLG.LT.0 .AND. NMISS.LT.45) THEN
         NMISS=NMISS+1
         CTEXT(NMISS)='ALL DATA ARE DEFINED FOR EVT PACKAGE'
      END IF
      IF(NM.NE.0) IUNDEF=1
      CALL FNMRMV
      RETURN
      END
