      SUBROUTINE GHB6AL(IBDSAM,NPGHB)
C
C     ******************************************************************
C     ALLOCATE ARRAY STORAGE FOR GHB PACKAGE
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
C  Common block for GHB Package
      COMMON /GHBCOM/GHBAUX(3)
      CHARACTER*16 GHBAUX
      CHARACTER*200 LINE
C     ------------------------------------------------------------------
      IULOC=7
      IN=IUNIT(IULOC)
C
C1------IDENTIFY PACKAGE.
      WRITE(IOUT,1)IN
    1 FORMAT(1X,/1X,'GHB -- GHB PACKAGE,  INPUT READ FROM UNIT',I3)
      NNPGHB=0
C
C2------READ MAXIMUM NUMBER OF GHB REACHESS AND UNIT OR FLAG FOR
C2------CELL-BY-CELL FLOW TERMS.
      CALL URDCOM(IUREAL(IN),LINE,IULOC)
      CALL UPARLSTAL(IUREAL(IN),IOUT,LINE,NPGHB,MXPW)
      IF(MODINP.EQ.0) THEN
         READ(LINE,'(2I10)') MXACTG,IGHBCB
         LLOC=21
      ELSE
         LLOC=1
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,MXACTG,R,IOUT,IN)
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IGHBCB,R,IOUT,IN)
      END IF
      WRITE(IOUT,3) MXACTG
    3 FORMAT(1X,'MAXIMUM OF',I5,' ACTIVE REACHESS AT ONE TIME')
      IF(IGHBCB.LT.0) WRITE(IOUT,7)
    7 FORMAT(1X,'CELL-BY-CELL FLOWS WILL BE PRINTED WHEN ICBCFL NOT 0')
      IF(IGHBCB.GT.0) WRITE(IOUT,8) IGHBCB
    8 FORMAT(1X,'CELL-BY-CELL FLOWS WILL BE SAVED ON UNIT',I3)
C
C  Process CBC flag
      IF(IGHBCB.LT.0) IGHBCB=-1
      IUNIT2(IULOC)=IGHBCB
      IF(IGHBCB.GT.0) THEN
         IF(FILTYP(IGHBCB).EQ.'DATA(BINARY)') THEN
            IFNUSE(IGHBCB)=IUNIT(12)
         ELSE IF(FILTYP(IGHBCB).EQ.' ') THEN
            IUNIT2(IULOC)=0
         ELSE
            WRITE(IOUT,*)
     1 'Attempt to save CBC budget in a file that is not DATA(BINARY)'
            CALL RDABRT
         END IF
         IF((IHEDUN.GT.0 .AND. IUNIT2(IULOC).EQ.IHEDUN) .OR.
     1      (IDDNUN.GT.0 .AND. IUNIT2(IULOC).EQ.IDDNUN)) THEN
            WRITE(IOUT,*) 'CBC file is same as HEAD or DRAWDOWN file'
            CALL RDABRT
         END IF
      END IF
      IF(IBDSAM.EQ.-2) THEN
         IF(IGHBCB.NE.0) IBDSAM=IGHBCB
      ELSE
         IF(IBDSAM.NE.IGHBCB) IBDSAM=0
      END IF
C
C3------READ AUXILIARY VARIABLES AND CBC ALLOCATION OPTION.
      IGHBAL=0
      NAUX=0
   10 CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IN)
      IF(LINE(ISTART:ISTOP).EQ.'CBCALLOCATE' .OR.
     1   LINE(ISTART:ISTOP).EQ.'CBC') THEN
         IGHBAL=1
         WRITE(IOUT,11)
   11    FORMAT(1X,'MEMORY IS ALLOCATED FOR CELL-BY-CELL BUDGET TERMS')
         GO TO 10
      ELSE IF(LINE(ISTART:ISTOP).EQ.'AUXILIARY' .OR.
     1        LINE(ISTART:ISTOP).EQ.'AUX') THEN
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IN)
         IF(NAUX.LT.3) THEN
            NAUX=NAUX+1
            GHBAUX(NAUX)=LINE(ISTART:ISTOP)
            WRITE(IOUT,12) GHBAUX(NAUX)
   12       FORMAT(1X,'AUXILIARY GHB VARIABLE: ',A)
         ELSE 
            WRITE(IOUT,*) ' Too many auxiliary variables for MFI2K'
            CALL RDABRT
         END IF
         GO TO 10
      END IF
C
C6------RETURN
      RETURN
      END
      SUBROUTINE GHB6RQ(NPGHB)
C
C     ******************************************************************
C     READ PARAMETERS
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      COMMON /GHBCOM/GHBAUX(3)
      CHARACTER*16 GHBAUX
      CHARACTER*10 ARRNAM
C     ------------------------------------------------------------------
      IW=8
      IULOC=7
      IN=IUNIT(IULOC)
C
C-------READ NAMED PARAMETERS
      WRITE(IOUT,3) NPGHB
    3 FORMAT(1X,//1X,I5,' GHB parameters')
      IF(NPGHB.GT.0) THEN
        DO 5 K=1,NPGHB
C---------READ AND STORE LIST PARAMETER DEFINITION INFORMATION
          CALL UPARLSTRP(IUREAL(IN),'GHB','GHB',NLST,ARRNAM)
C  Make a data list for the parameter
          CALL LSTMAK2(ARRNAM,-3,-3,IW,NLST)
          NAR=NARRAY
C---------READ AND PRINT A LIST OF CELLS
          CALL LSTRD2(NLST,NAR,IX(IARRDA(2,NAR)),IN,
     1 'BOUND NO. LAYER   ROW   COL  BOUND HEAD   CONDUCTANCE',
     2      GHBAUX,3)
    5   CONTINUE
      END IF
C
C6------RETURN
      RETURN
      END
      SUBROUTINE GHB6RP(KPER,NPGHB)
C
C     ******************************************************************
C     READ NEW GHB LOCATIONS AND STRESS RATES
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      COMMON /GHBCOM/GHBAUX(3)
      CHARACTER*16 GHBAUX
C     ------------------------------------------------------------------
      IW=8
      IULOC=7
      IN=IUNIT(IULOC)
C
C1----READ NUMBER OF GHB REACHESS (OR FLAG SAYING REUSE GHB DATA).
C1----AND NUMBER OF PARAMETERS
      IF(NPGHB.GT.0) THEN
        IF(MODINP.EQ.0) THEN
           READ(IUREAL(IN),'(2I10)') ITMP,NP
        ELSE
           READ(IUREAL(IN),*) ITMP,NP
        END IF
      ELSE
         NP=0
         IF(MODINP.EQ.0) THEN
            READ(IUREAL(IN),'(I10)') ITMP
         ELSE
            READ(IUREAL(IN),*) ITMP
         END IF
      END IF
C
C------Calculate some constants.
C
C1A-----IF ITMP LESS THAN ZERO REUSE NON-PARAMETER DATA. PRINT MESSAGE.
C1A-----IF ITMP=>0, SET NUMBER OF NON-PARAMETER GHBS EQUAL TO ITMP.
      IF(ITMP.EQ.IMISS) THEN
         WRITE(IOUT,*) 'Non-parameter GHBs are undefined'
         GO TO 100
      ELSE IF(ITMP.LT.0) THEN
         WRITE(IOUT,6)
    6    FORMAT(1X,/
     1    1X,'REUSING NON-PARAMETER GHBS FROM LAST STRESS PERIOD')
      END IF
C
C1B-----IF THERE ARE NEW NON-PARAMETER GHBS, READ THEM.
       CALL LSTMAK2('BNDS',0,KPER,IW,ITMP)
       NAR=NARRAY
C---------READ AND PRINT A LIST OF CELLS
       CALL LSTRD2(ITMP,NAR,IX(IARRDA(2,NAR)),IN,
     1 'BOUND NO. LAYER   ROW   COL  BOUND HEAD   CONDUCTANCE',
     2      GHBAUX,3)
C
C1C-----IF THERE ARE ACTIVE GHB PARAMETERS, READ THEM
100   IPF=0
      CALL PERPARRD(IUREAL(IN),NP,'GHB',KPER,IPF)
C
C6------RETURN
      RETURN
      END
      SUBROUTINE GHBSV(IUNDEF,IWRFLG)
C     ******************************************************************
C     Save GHB data
C     ******************************************************************
      COMMON /GHBCOM/GHBAUX(3)
      CHARACTER*16 GHBAUX
C     ------------------------------------------------------------------
C
      IULOC=7
      CALL LSTSAV3(IULOC,'BNDS',GHBAUX,3,IUNDEF,IWRFLG,
     1          'GHB',' MXACTB IGHBCB','GHB')
      RETURN
      END
