      SUBROUTINE GLOBALDF(INDIS)
C
C     ******************************************************************
C     GLOBAL DEFINITION
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      INCLUDE 'mfi2kpar.inc'
      CHARACTER*80 LINE
C     ------------------------------------------------------------------
C  Initialize parameter definition variables.
      IPSUM=0
      ICLSUM=0
      IDEFPAR=0
      DO 5 N=1,MXPAR
        PARNAM(N)=' '
        PARTYP(N)=' '
        IPLOC(1,N)=0
        IPLOC(2,N)=0
        IACTIVE(N)=0
    5 CONTINUE
C
C------Check for existence of discretization file
      IF(INDIS.LE.0) THEN
         WRITE(IOUT,*) ' DIS file must be specified for MODFLOW to run'
         CALL RDABRT
      END IF
      WRITE(IOUT,6) INDIS
    6 FORMAT(1X,/1X,'DISCRETIZATION INPUT DATA READ FROM UNIT',I3)
C
C5------READ NUMBER OF LAYERS, ROWS, COLUMNS, STRESS PERIODS, AND
C5------ITMUNI USING FREE OR FIXED FORMAT.
C
C2------READ FIRST RECORD AND WRITE
      CALL URDCOM(IUREAL(INDIS),LINE,24)
      LLOC=1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NLAY,R,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NROW,R,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NCOL,R,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NPER,R,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,ITMUNI,R,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,LENUNI,R,IOUT,IN)
C
C6------PRINT # OF LAYERS, ROWS, COLUMNS AND STRESS PERIODS.
      WRITE(IOUT,7) NLAY,NROW,NCOL
    7 FORMAT(1X,I4,' LAYERS',I10,' ROWS',I10,' COLUMNS')
      WRITE(IOUT,8) NPER
    8 FORMAT(1X,I3,' STRESS PERIOD(S) IN SIMULATION')
      IF(NPER.GT.MXPER) THEN
         WRITE(IOUT,9) MXPER
    9    FORMAT(1X,'THE MAXIMUM NUMBER OF STRESS PERIODS IS:',/
     1      1X,'ABORTING BECAUSE THE MAXIMUM IS EXCEEDED')
         CALL RDABRT
      END IF
C
C7------SELECT AND PRINT A MESSAGE SHOWING TIME UNIT.
      IF(ITMUNI.LT.0 .OR. ITMUNI.GT.5) ITMUNI=0
      IF(ITMUNI.EQ.0) THEN
         WRITE(IOUT,10)
   10    FORMAT(1X,'MODEL TIME UNIT IS UNDEFINED')
      ELSE IF(ITMUNI.EQ.1) THEN
         WRITE(IOUT,11)
   11    FORMAT(1X,'MODEL TIME UNIT IS SECONDS')
      ELSE IF(ITMUNI.EQ.2) THEN
         WRITE(IOUT,21)
   21    FORMAT(1X,'MODEL TIME UNIT IS MINUTES')
      ELSE IF(ITMUNI.EQ.3) THEN
         WRITE(IOUT,31)
   31    FORMAT(1X,'MODEL TIME UNIT IS HOURS')
      ELSE IF(ITMUNI.EQ.4) THEN
         WRITE(IOUT,41)
   41    FORMAT(1X,'MODEL TIME UNIT IS DAYS')
      ELSE
         WRITE(IOUT,51)
   51    FORMAT(1X,'MODEL TIME UNIT IS YEARS')
      END IF
C
C7------SELECT AND PRINT A MESSAGE SHOWING LENGTH UNIT.
      IF(LENUNI.LT.0 .OR. LENUNI.GT.3) LENUNI=0
      IF(LENUNI.EQ.0) THEN
         WRITE(IOUT,61)
   61    FORMAT(1X,'MODEL LENGTH UNIT IS UNDEFINED')
      ELSE IF(LENUNI.EQ.1) THEN
         WRITE(IOUT,71)
   71    FORMAT(1X,'MODEL LENGTH UNIT IS FEET')
      ELSE IF(LENUNI.EQ.2) THEN
         WRITE(IOUT,81)
   81    FORMAT(1X,'MODEL LENGTH UNIT IS METERS')
      ELSE IF(LENUNI.EQ.3) THEN
         WRITE(IOUT,91)
   91    FORMAT(1X,'MODEL LENGTH UNIT IS CENTIMETERS')
      END IF
      CALL IVLSAV('ITMUNI',0,0,ITMUNI)
      CALL IVLSAV('LENUNI',0,0,LENUNI)
C
      RETURN
      END
      SUBROUTINE GLOBALAL(INDIS)
C
C     ******************************************************************
C     ALLOCATE GLOBAL DATA
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      COMMON /DISCOM/LBOTM(200),LAYCBD(200)
C     ------------------------------------------------------------------
C
C------Read confining bed information
      READ(IUREAL(INDIS),*) (LAYCBD(K),K=1,NLAY)
      LAYCBD(NLAY)=0
      WRITE(IOUT,*) ' Confining bed flag for each layer:'
      WRITE(IOUT,'(20I4)') (LAYCBD(K),K=1,NLAY)
C
C------RETURN.
      RETURN
      END
      SUBROUTINE GLOBALRP(IN)
C
C     ******************************************************************
C     READ GLOBAL ARRAYS
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      COMMON /DISCOM/LBOTM(200),LAYCBD(200)
      COMMON /PERCOM/PERLEN(MXPER),NSTP(MXPER),TSMULT(MXPER),
     1               ISSFLG(MXPER)
      CHARACTER*80 LINE
      CHARACTER*24 ANAME(5)
      DATA ANAME(1) /'                    DELR'/
      DATA ANAME(2) /'                    DELC'/
      DATA ANAME(3) /'TOP ELEVATION OF LAYER 1'/
      DATA ANAME(4) /'  MODEL LAYER BOTTOM EL.'/
      DATA ANAME(5) /'BOT. EL. OF QUASI-3D BED'/
C     ------------------------------------------------------------------
C
C------Read the DELR and DELC arrays.
      CALL ARRMAK('DELR',0,0,NCOL,1)
      CALL U1DREL(ANAME(1),NCOL,IN,NARRAY)
      CALL ARRMAK('DELC',0,0,1,NROW)
      CALL U1DREL(ANAME(2),NROW,IN,NARRAY)
C
C------Read the top elevation of layer 1.
      CALL ARRMAK('TOP',1,0,NCOL,NROW)
      CALL U2DREL(ANAME(3),NROW,NCOL,0,IN,NARRAY,IN)
C
C------Read the bottom elevations.
      DO 20 K=1,NLAY
      KK=K
      CALL ARRMAK('BOT',KK,0,NCOL,NROW)
      CALL U2DREL(ANAME(4),NROW,NCOL,KK,IN,NARRAY,IN)
      IF(LAYCBD(K).NE.0) THEN
          CALL ARRMAK('CBDBOT',KK,0,NCOL,NROW)
          CALL U2DREL(ANAME(5),NROW,NCOL,KK,IN,NARRAY,IN)
      END IF
   20 CONTINUE
C
C1------READ AND WRITE LENGTH OF STRESS PERIOD, NUMBER OF TIME STEPS,
C1------TIME STEP MULTIPLIER, AND STEADY-STATE FLAG..
      WRITE(IOUT,61)
   61 FORMAT(1X,//1X,'STRESS PERIOD     LENGTH       TIME STEPS',
     1            '     MULTIPLIER FOR DELT    SS FLAG',/1X,76('-'))
      DO 100 N=1,NPER
      READ(IUREAL(IN),'(A)') LINE
      LLOC=1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,I,PERLEN(N),IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NSTP(N),R,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,I,TSMULT(N),IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,I,R,IOUT,IN)
      IF (LINE(ISTART:ISTOP).EQ.'TR') THEN
         ISSFLG(N)=0
      ELSE IF (LINE(ISTART:ISTOP).EQ.'SS') THEN
         ISSFLG(N)=1
      ELSE
         WRITE(IOUT,62)
   62    FORMAT(' SSFLAG MUST BE EITHER "SS" OR "TR"',
     1      ' -- STOP EXECUTION (GLO1RP)')
         CALL RDABRT
      END IF
      WRITE (IOUT,63) N,PERLEN(N),NSTP(N),TSMULT(N),LINE(ISTART:ISTOP)
   63 FORMAT(1X,I8,1PG21.7,I7,0PF25.3,A11)
C
C1A-----STOP IF NSTP LE 0, PERLEN LE 0., OR TSMULT LE 0.
      IF(NSTP(N).LE.0) THEN
         WRITE(IOUT,64)
   64    FORMAT(1X,/1X,
     1  'THERE MUST BE AT LEAST ONE TIME STEP IN EVERY STRESS PERIOD')
         CALL RDABRT
      END IF
      ZERO=0.
      IF(PERLEN(N).EQ.ZERO .AND. ISSFLG(N).EQ.0) THEN
         WRITE(IOUT,65)
   65    FORMAT(1X,/1X,
     1  'PERLEN MUST NOT BE 0.0 FOR TRANSIENT STRESS PERIODS')
         CALL RDABRT
      END IF
      IF(TSMULT(N).LE.ZERO) THEN
         WRITE(IOUT,66)
   66    FORMAT(1X,/1X,'TSMULT MUST BE GREATER THAN 0.0')
         CALL RDABRT
      END IF
      IF(PERLEN(N).LT.ZERO) THEN
         WRITE(IOUT,67)
   67    FORMAT(1X,/1X,
     1  'PERLEN CANNOT BE LESS THAN 0.0 FOR ANY STRESS PERIOD')
         CALL RDABRT
      END IF
  100 CONTINUE
C
      WRITE(IOUT,'(//)')
C
      RETURN
      END
      SUBROUTINE SGLOAL(INZONE,INMULT,NML,NZN)
C
C     ******************************************************************
C     ALLOCATE SPACE FOR MULTIPLIER AND ZONE ARRAYS
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      INCLUDE 'mfi2kpar.inc'
      CHARACTER*80 LINE
C     ------------------------------------------------------------------
C
C------Read Number of Zone Arrays if Zone Option is active.
      NZN=0
      IF(INZONE.GT.0) THEN
         WRITE(IOUT,1) INZONE
    1    FORMAT(1X,/1X,'ZONE OPTION, INPUT READ FROM UNIT',I3)
         CALL URDCOM(INZONE,LINE,31)
         LLOC=1
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NZN,R,IOUT,IN)
         WRITE(IOUT,2) NZN
    2    FORMAT(1X,I5,' ZONE ARRAYS')
         IF(NZN.LT.0) NZN=0
      END IF
C
C------Read Number of Multiplier Arrays if Multiplier Option is active.
      NML=0
      IF(INMULT.GT.0) THEN
         WRITE(IOUT,11) INMULT
   11    FORMAT(1X,/1X,'MULTIPLIER OPTION, INPUT READ FROM UNIT',I3)
         CALL URDCOM(INMULT,LINE,32)
         LLOC=1
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NML,R,IOUT,IN)
         WRITE(IOUT,12) NML
   12    FORMAT(1X,I3,' MULTIPLIER ARRAYS')
      END IF
C
C  Initialize names of zone and multiplier arrays
      NZONAR=NZN
      IF(NZONAR.LE.0) NZONAR=1
      DO 10 I=1,MXZON
      ZONNAM(I)=' '
10    CONTINUE
      NMLTAR=NML
      IF(NMLTAR.LE.0) NMLTAR=1
      DO 20 I=1,MXMLT
      MLTNAM(I)=' '
      MLTFNM(I)=' '
20    CONTINUE
C
C6------RETURN.
      RETURN
      END
      SUBROUTINE SGLORP(INZONE,INMULT,NML,NZN)
C
C     ******************************************************************
C     Read and prepare multiplier and zone arrays.
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      INCLUDE 'mfi2kpar.inc'
      CHARACTER*81 LINE
      CHARACTER*20 RW
      CHARACTER*1 COP
      CHARACTER*10 CTMP,CTMP1,CTMP2
C     ------------------------------------------------------------------
C
C-----Read the multiplier array names and arrays
      IF(NML.GT.0) THEN
        NA=0
        NF=0
        DO 2000 M=1,NML
C  Read a line describing a multiplier array
          READ (INMULT,'(A)') LINE
C  Get the name of the new array
          LLOC=1
          CALL URWORD(LINE,LLOC,ISTART,ISTOP,0,N,R,IOUT,INMULT)
C  Add new multiplier name into list
          CTMP=LINE(ISTART:ISTOP)
          CTMP1=CTMP
          CALL UPCASE(CTMP1)
          CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,INMULT)
          IF(LINE(ISTART:ISTOP).NE.'FUNCTION') THEN
C  Define array using array reader
             CALL ARRMAK2(CTMP1,-2,-2,NCOL,NROW)
             CALL U2DREL(CTMP1,NROW,NCOL,0,INMULT,NARRAY,INMULT)
             NA=NA+1
             MLTNAM(NA)=CTMP
          ELSE
C  Define array as aritmetic combination of other multiplier arrays
C  Start by initializing the array to 0.
             WRITE(IOUT,10) CTMP
   10        FORMAT(1X,/1X,'Calculated multiplier array: ',A)
C
C  Get the names of the multipliers and the operands
             READ (INMULT,'(A)') LINE
             LLOC=1
             NOP=0
   25        IF(NOP.EQ.0) THEN
C  No operator is specified before the first operand -- define it to be " "
                COP=' '
             ELSE
C  Get the operator that precedes each operand after the first operand.
                CALL URWORD(LINE,LLOC,ISTART,ISTOP,0,N,R,IOUT,INMULT)
                IF(LINE(ISTART:ISTOP).EQ.'+' .OR.
     1             LINE(ISTART:ISTOP).EQ.'-' .OR.
     2             LINE(ISTART:ISTOP).EQ.'*' .OR.
     3             LINE(ISTART:ISTOP).EQ.'/') THEN
                   COP=LINE(ISTART:ISTOP)
                ELSE
                   GO TO 1000
                END IF
             END IF
             NOP=NOP+1
C  Get the operand
             CALL URWORD(LINE,LLOC,ISTART,ISTOP,0,N,R,IOUT,INMULT)
             WRITE(IOUT,37 ) COP,LINE(ISTART:ISTOP)
   37        FORMAT(1X,'                        ',A,' ARRAY ',A)
C  Lookup the operand in the list of existing multipliers
             CTMP2=LINE(ISTART:ISTOP)
             CALL UPCASE(CTMP2)
             DO 50 MM=1,MXMLT
               CTMP1=MLTNAM(MM)
               IF(CTMP1 .NE. ' ') THEN
                  CALL UPCASE(CTMP1)
                  IF(CTMP1.EQ.CTMP2) GO TO 60
               END IF
               CTMP1=MLTFNM(MM)
               IF(CTMP1 .NE. ' ') THEN
                  CALL UPCASE(CTMP1)
                  IF(CTMP1.EQ.CTMP2) GO TO 60
               END IF
   50        CONTINUE
             WRITE(IOUT,51) LINE(ISTART:ISTOP)
   51        FORMAT(1X,
     1        'ARRAY OPERAND HAS NOT BEEN PREVIOUSLY DEFINED:',A)
             CALL RDABRT
C
C  Apply the operator -- no need to do this in MFI
   60        CONTINUE
C
C  Get the next operator
             GO TO 25
C
C  Done defining the array function -- get the print code
1000         IPRN=0
             L=20-ISTOP+ISTART
             IF(L.GT.1) THEN
                RW=' '
                RW(L:20)=LINE(ISTART:ISTOP)
                READ(RW,'(I20)',ERR=1200) IPRN
             END IF
1200         CONTINUE
             NF=NF+1
             MLTFNM(NF)=CTMP
             MLTFCN(NF)=LINE
          END IF
 2000   CONTINUE
      ENDIF
C
C-----Read the zone array names and arrays
      IF(NZN.GT.0) THEN
         DO 3000 NZ=1,NZN
         READ(INZONE,'(A)') ZONNAM(NZ)
         CTMP1=ZONNAM(NZ)
         CALL UPCASE(CTMP1)
         CALL ARRMAK(CTMP1,-1,-1,NCOL,NROW)
         CALL U2DINT(CTMP1,NROW,NCOL,0,INZONE,NARRAY,INZONE)
 3000    CONTINUE
      END IF
C
      RETURN
      END
      SUBROUTINE SGLOOPEN(INUNIT,CUNIT)
C
C     ******************************************************************
C     OPEN FILES.
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      CHARACTER*4 CUNIT(40)
      CHARACTER*80 LINE
      CHARACTER*11 FMTARG
      CHARACTER*18 FT
C     ---------------------------------------------------------------
C
C2------READ A LINE; IGNORE BLANK LINES.
10    READ(INUNIT,'(A)',END=1000) LINE
      IF(LINE.EQ.' ') GO TO 10
      IF(LINE(1:1).EQ.'#') THEN
         WRITE(IOUT,'(A)') LINE
         GO TO 10
      END IF
      IOPN=0
C
C3------DECODE THE FILE TYPE AND UNIT NUMBER.
      LLOC=1
      CALL URWORD(LINE,LLOC,ITYP1,ITYP2,1,N,R,IOUT,INUNIT)
      FT=LINE(ITYP1:ITYP2)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IU,R,IOUT,INUNIT)
      IF(IU.LE.0 .OR. IU.GT.MXFNAM) THEN
         WRITE(IOUT,*) ' File unit out of range:',IU
         CALL RDABRT
      END IF
C
C4------CHECK FOR A VALID FILE TYPE.
      FMTARG='FORMATTED'
      IDATA=0
C
C4A-----CHECK FOR FILE-TYPES "LIST" AND "GLOBAL"
      IF(FT.EQ.'GLOBAL') THEN
         IF(IGOUT.NE.0) THEN
            WRITE(IOUT,*) ' Duplicate definition of GLOBAL file'
            CALL RDABRT
         END IF
         IGOUT=IU
         IFNUSE(IU)=IU
C
      ELSE IF(FT.EQ.'LIST') THEN
         IF(ILOUT.NE.0) THEN
            WRITE(IOUT,*) ' Duplicate definition of LIST file'
            CALL RDABRT
         END IF
         ILOUT=IU
         IFNUSE(IU)=IU
C
C4B-----CHECK FOR "BAS" FILE TYPE.
      ELSE IF(FT.EQ.'BAS6') THEN
         IF(INBAS.NE.0) THEN
            WRITE(IOUT,*) ' Duplicate BAS6 Package file type'
            CALL RDABRT
         END IF
         INBAS=IU
         IOPN=1
         IFNUSE(IU)=IU
C
C4C-----CHECK FOR DATA FILES
      ELSE IF(FT.EQ.'DATA(BINARY)') THEN
         FMTARG='UNFORMATTED'
         IFNUSE(IU)=-1
         IDATA=1
C
      ELSE IF(FT.EQ.'DATA') THEN
         FMTARG='FORMATTED'
         IFNUSE(IU)=-1
         IDATA=1
C
      ELSE IF(FT.EQ.'DATAGLO') THEN
         FT='DATA'
         IFILREW(IU)=2
         FMTARG='FORMATTED'
         IFNUSE(IU)=-1
         IDATA=1
C
      ELSE IF(FT.EQ.'DATAGLO(BINARY)') THEN
         FT='DATA(BINARY)'
         IFILREW(IU)=2
         FMTARG='UNFORMATTED'
         IFNUSE(IU)=-1
         IDATA=1
C
C4D-----CHECK FOR MAJOR OPTIONS.
      ELSE
         DO 20 I=1,40
            IF(FT.EQ.CUNIT(I)) THEN
               IF(IUNIT(I).NE.0) THEN
                  WRITE(IOUT,*) ' Duplicate package file type:',CUNIT(I)
                  CALL RDABRT
               END IF
               IUNIT(I)=IU
               IOPN=1
               IFNUSE(IU)=IU
               GO TO 30
            END IF
20       CONTINUE
         IFNUSE(IU)=-1
30       CONTINUE
      END IF
C
C5------DETERMINE FILE NAME
      IF(IUCASE.EQ.0) THEN
         CALL URWORD(LINE,LLOC,INAM1,INAM2,0,N,R,IOUT,INUNIT)
      ELSE
         CALL URWORD(LINE,LLOC,INAM1,INAM2,1,N,R,IOUT,INUNIT)
      END IF
      WRITE(IOUT,36) LINE(INAM1:INAM2),LINE(ITYP1:ITYP2),IU
36    FORMAT(1X,/1X,'OPENING ',A,/1X,'FILE TYPE:',A,'   UNIT',I4)
      IF(IOPN.NE.0) THEN
         CALL REALUN(IU)
         OPEN(UNIT=IUREAL(IU),FILE=LINE(INAM1:INAM2),
     1      FORM=FMTARG,ACCESS='SEQUENTIAL',STATUS='OLD',ERR=2000)
      END IF
C
C6------PUT FILE NAME INTO TABLE OF FILE NAMES.
      IF(FILTYP(IU).NE.' ') THEN
         WRITE(IOUT,*) ' ATTEMPT TO OPEN A FILE ON A PREVIOUSLY',
     1        ' DEFINED UNIT'
         WRITE(IOUT,*) ' THE CONFLICT IS ON UNIT',IU
         CALL RDABRT
      END IF
      DO 40 I=1,MXFNAM
      IF(FILNAM(I).EQ.LINE(INAM1:INAM2)) THEN
         WRITE(IOUT,*) ' Duplicate file name:'
         WRITE(IOUT,*) FILNAM(I)
         CALL RDABRT
      END IF
40    CONTINUE
      FILTYP(IU)=FT
      FILNAM(IU)=LINE(INAM1:INAM2)
C  Look for 'OLD'and 'REPLACE' in DATA files
      IF(IDATA.EQ.1) THEN
         CALL URWORD(LINE,LLOC,IST1,IST2,1,N,R,IOUT,INUNIT)
         IF(LINE(IST1:IST2).EQ.'OLD') IFILSTAT(IU)=2
         IF(LINE(IST1:IST2).EQ.'REPLACE') IFILSTAT(IU)=3
      END IF
      GO TO 10
C
C7------END OF NAME FILE.
1000  WRITE(IOUT,*) ' MODINP:',MODINP
      CLOSE(UNIT=INUNIT)
      RETURN
C
C  Open error
2000  WRITE(IOUT,*) 'UNABLE TO OPEN FILE ',LINE(INAM1:INAM2)
      CALL RDABRT
C
      END
      SUBROUTINE DISSV(IUNDEF,IWRFLG)
C     ******************************************************************
C     SAVE DATA FOR DIS PACKAGE
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      COMMON /PERCOM/PERLEN(MXPER),NSTP(MXPER),TSMULT(MXPER),
     1               ISSFLG(MXPER)
      COMMON /DISCOM/LBOTM(200),LAYCBD(200)
      CHARACTER*80 LINE,MESS(1)
      CHARACTER*4 CSSFLG
C     ------------------------------------------------------------------
      IULOC=24
      CTEXT(1)='Missing data for the DIS File:'
      CTEXT(2)='------------------------------------------------------'
      NMISS=2
C  DIS option is always active, so don't check for inactive
C
      DO 5 I=1,MXFNAM
      IF(IFNUSE(I).EQ.IUNIT(IULOC)) IFNUSE(I)=0
5     CONTINUE
      IFNUSE(IUNIT(IULOC))=IUNIT(IULOC)
C
      IF(IUREAL(IUNIT(IULOC)).EQ.0) CALL REALUN(IUNIT(IULOC))
      IUNDEF=0
      IFIL=IUMISC
      IF(IWRFLG.LE.0) IFIL=0
      IF(IWRFLG.EQ.1) OPEN(FILE='MFI.DIS',UNIT=IFIL)
      IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUNIT(IULOC)),UNIT=IFIL)
C
C  Write comments
      IF(IWRFLG.GT.0) THEN
         DO 8 I=1,20
         IF(COMENT(I,IULOC)(1:1).EQ.'#') THEN
            DO 6 N=80,1,-1
            IF(COMENT(I,IULOC)(N:N) .NE. ' ') GO TO 7
6           CONTINUE
7           WRITE(IFIL,'(A)') COMENT(I,IULOC)(1:N)
         END IF
8        CONTINUE
      END IF
C
C  Write grid size and LAYCBD
      IF(IWRFLG.GT.0) THEN
         CALL IVLGET('ITMUNI',0,0,ITYPE,ITMUNI)
         IF(ITYPE.NE.0) ITMUNI=0
         CALL IVLGET('LENUNI',0,0,ITYPE,LENUNI)
         IF(ITYPE.NE.0) LENUNI=0
         WRITE(IFIL,'(3I10,3I4,A)') NLAY,NROW,NCOL,NPER,ITMUNI,LENUNI,
     1      '  NLAY,NROW,NCOL,NPER,ITMUNI,LENUNI'
         WRITE(IFIL,'(40I2)') (LAYCBD(I),I=1,NLAY)
      END IF
C
C  Write DELR and DELC
      CALL U1DRSV('DELR',IUNDEF,IFIL,IUNIT(IULOC))
      IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
         NMISS=NMISS+1
         IUNDEF=0
         WRITE(CTEXT(NMISS),'(A)') 'DELR'
      END IF
      CALL U1DRSV('DELC',IUNDEF,IFIL,IUNIT(IULOC))
      IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
         NMISS=NMISS+1
         IUNDEF=0
         WRITE(CTEXT(NMISS),'(A)') 'DELC'
      END IF
C
C  Write BOTM array
      CALL U2DRSV('TOP',1,0,IUNDEF,IFIL,IUNIT(IULOC),'TOP',0)
      IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
         NMISS=NMISS+1
         IUNDEF=0
         WRITE(CTEXT(NMISS),'(A)') 'Top Elevation'
      END IF
      DO 20 K=1,NLAY
      KK=K
      CALL U2DRSV('BOT',KK,0,IUNDEF,IFIL,IUNIT(IULOC),'BOT',KK)
      IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
         NMISS=NMISS+1
         IUNDEF=0
         WRITE(CTEXT(NMISS),'(A,I8)') 'Bottom Elevation',KK
      END IF
      IF(LAYCBD(K).NE.0) THEN
         CALL U2DRSV('CBDBOT',KK,0,IUNDEF,IFIL,IUNIT(IULOC),'CBDBOT',KK)
         IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
            NMISS=NMISS+1
            IUNDEF=0
            WRITE(CTEXT(NMISS),'(A,I8)') 'Cnf. Bed Bot. El.',KK
         END IF
      END IF
20    CONTINUE
C
C  Stress period data
      IF(IWRFLG.GT.0) THEN
         DO 30 N=1,NPER
         IF(ISSFLG(N).NE.0) THEN
            CSSFLG='  SS'
         ELSE
            CSSFLG='  TR'
         END IF
         WRITE(IFIL,'(1P,E15.6,I10,E10.3,A4,A)')
     1      PERLEN(N),NSTP(N),TSMULT(N),CSSFLG,
     2        '  PERLEN,NSTP,TSMULT,Ss/tr'
30       CONTINUE
      END IF
C
      IF(IWRFLG.GT.0) CLOSE(UNIT=IFIL)
C
      IF(IWRFLG.LT.0) THEN
         IF(NMISS.GT.2) THEN
            CALL TXTLOG(CTEXT,NMISS)
            IUNDEF=1
         ELSE
            MESS(1)='All data are defined for the DIS File'
            CALL TXTLOG(MESS,1)
         END IF
      END IF
C
      CALL FNMRMV
      RETURN
      END
      SUBROUTINE ZONESV(IUNDEF,IWRFLG)
C     ******************************************************************
C     Save zone arrays
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      INCLUDE 'mfi2kpar.inc'
      CHARACTER*10 ARRNAM
      CHARACTER*80 MESS(1)
C     ------------------------------------------------------------------
      IULOC=31
      CTEXT(1)='Missing data for the ZONE File:'
      CTEXT(2)='------------------------------------------------------'
      NMISS=2
C
      IF(IUNIT(IULOC).EQ.0) THEN
         IUNDEF=-1
         RETURN
      END IF

      IUNDEF=0
      DO 5 I=1,MXFNAM
      IF(IFNUSE(I).EQ.IUNIT(IULOC)) IFNUSE(I)=0
5     CONTINUE
C
      NZN=0
      DO 10 I=1,MXZON
      IF(ZONNAM(I).NE.' ') THEN
         NZN=NZN+1
      END IF
10    CONTINUE
C
      IFNUSE(IUNIT(IULOC))=IUNIT(IULOC)
      IF(IUREAL(IUNIT(IULOC)).EQ.0) CALL REALUN(IUNIT(IULOC))
      IFIL=IUMISC
      IF(IWRFLG.LE.0) IFIL=0
      IF(IWRFLG.EQ.1) OPEN(FILE='MFI.ZON',UNIT=IFIL)
      IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUNIT(IULOC)),UNIT=IFIL)
C
C  Write comments
      IF(IWRFLG.GT.0) THEN
         DO 8 I=1,20
         IF(COMENT(I,IULOC)(1:1).EQ.'#') THEN
            DO 6 N=80,1,-1
            IF(COMENT(I,IULOC)(N:N) .NE. ' ') GO TO 7
6           CONTINUE
7           WRITE(IFIL,'(A)') COMENT(I,IULOC)(1:N)
         END IF
8        CONTINUE
      END IF
C
      IF(IWRFLG.GT.0) WRITE(IFIL,'(I5)') NZN
C
      IF(NZN.GT.0) THEN
         DO 20 I=1,NZN
         IF(IWRFLG.GT.0) WRITE(IFIL,'(A)') ZONNAM(I)
         ARRNAM=ZONNAM(I)
         CALL UPCASE(ARRNAM)
         CALL U2DISV(ARRNAM,-1,-1,IUNDEF,IFIL,IUNIT(IULOC))
         IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
            NMISS=NMISS+1
            IUNDEF=0
            WRITE(CTEXT(NMISS),'(A)') ZONNAM(I)
         END IF
20       CONTINUE
      END IF
C
      IF(IWRFLG.GT.0) CLOSE(UNIT=IFIL)
C
      IF(IWRFLG.LT.0) THEN
         IF(NMISS.GT.2) THEN
            CALL TXTLOG(CTEXT,NMISS)
            IUNDEF=1
         ELSE
            MESS(1)='All data are defined for the ZONE File'
            CALL TXTLOG(MESS,1)
         END IF
      END IF
C
      CALL FNMRMV
C
      RETURN
      END
      SUBROUTINE MULTSV(IUNDEF,IWRFLG)
C     ******************************************************************
C     Save multiplier arrays
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      INCLUDE 'mfi2kpar.inc'
      CHARACTER*10 ARRNAM
      CHARACTER*80 MESS(1)
C     ------------------------------------------------------------------
      IULOC=32
      CTEXT(1)='Missing data for the MULT File:'
      CTEXT(2)='------------------------------------------------------'
      NMISS=2
C
      IF(IUNIT(IULOC).EQ.0) THEN
         IUNDEF=-1
         RETURN
      END IF
C
      IUNDEF=0
      DO 25 I=1,MXFNAM
      IF(IFNUSE(I).EQ.IUNIT(IULOC)) IFNUSE(I)=0
25    CONTINUE
C
      NA=0
      NF=0
      DO 30 I=1,MXMLT
      IF(MLTNAM(I).NE.' ') NA=NA+1
      IF(MLTFNM(I).NE.' ') NF=NF+1
30    CONTINUE
      NML=NA+NF
C
      IFNUSE(IUNIT(IULOC))=IUNIT(IULOC)
      IF(IUREAL(IUNIT(IULOC)).EQ.0) CALL REALUN(IUNIT(IULOC))
      IFIL=IUMISC
      IF(IWRFLG.LE.0) IFIL=0
      IF(IWRFLG.EQ.1) OPEN(FILE='MFI.MLT',UNIT=IFIL)
      IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUNIT(IULOC)),UNIT=IFIL)
C
C  Write comments
      IF(IWRFLG.GT.0) THEN
         DO 8 I=1,20
         IF(COMENT(I,IULOC)(1:1).EQ.'#') THEN
            DO 6 N=80,1,-1
            IF(COMENT(I,IULOC)(N:N) .NE. ' ') GO TO 7
6           CONTINUE
7           WRITE(IFIL,'(A)') COMENT(I,IULOC)(1:N)
         END IF
8        CONTINUE
      END IF
C
      IF(IWRFLG.GT.0) WRITE(IFIL,'(I5)') NML
      IF(NA.GT.0) THEN
         DO 40 I=1,NA
         ARRNAM=MLTNAM(I)
         CALL UPCASE(ARRNAM)
         IF(IWRFLG.GT.0) WRITE(IFIL,'(A)') MLTNAM(I)
            CALL U2DRSV(ARRNAM,-2,-2,IUNDEF,IFIL,IUNIT(IULOC),
     1                 MLTNAM(I),0)
         IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
            NMISS=NMISS+1
            IUNDEF=0
            WRITE(CTEXT(NMISS),'(A)') MLTNAM(I)
         END IF
40       CONTINUE
      END IF
C
      IF(NF.GT.0) THEN
         IF(IWRFLG.GT.0) THEN
            DO 45 I=1,NF
            ARRNAM=MLTFNM(I)
            CALL UPCASE(ARRNAM)
            WRITE(IFIL,'(A)') MLTFNM(I)//'  FUNCTION'
            WRITE(IFIL,'(A)') MLTFCN(I)
45          CONTINUE
         END IF
      END IF
C
      IF(IWRFLG.GT.0) CLOSE(UNIT=IFIL)
C
      IF(IWRFLG.LT.0) THEN
         IF(NMISS.GT.2) THEN
            CALL TXTLOG(CTEXT,NMISS)
            IUNDEF=1
         ELSE
            MESS(1)='All data are defined for the MULT File'
            CALL TXTLOG(MESS,1)
         END IF
      END IF
C
      CALL FNMRMV
C
      RETURN
      END
