      SUBROUTINE MOCROB
C     ******************************************************************
C     Read observation locations
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      COMMON /MOCCOM/IUMOCL,IUMOC,IUCRC,IUCOBS,NSCOL,NSROW,NSLAY,
     1     ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2,
     2     NODISP,NPTPND,ICINFL,MOCMETH,
     3     PNEWL(51),PNEWR(51),PNEWC(51),IZONE(MXCZON),ZONCON(MXCZON),
     4     ICOB(3,MXCOB),ICOBFL(MXCOB)
C
      READ(IUREAL(IUCOBS),*) NUMOBS,IOBSFL
      WRITE(IOUT,*) ' NUMOBS=',NUMOBS,'   IOBSFL=',IOBSFL
      IF(NUMOBS.GT.MXCOB) THEN
         WRITE(IOUT,*) ' In MFI, NUMOBS cannot exceed MXCOB:',MXCOB
         CALL RDABRT
      END IF
      IF(NUMOBS.GT.0) THEN
         WRITE(IOUT,2)
2        FORMAT(' Concentration Observation Wells',/
     1          ' Layer  Row  Column  I/O Unit')
         DO 10 I=1,NUMOBS
         IF(I.EQ.1 .OR. IOBSFL.LE.0) THEN
            READ(IUREAL(IUCOBS),*) (ICOB(J,I),J=1,3),ICOBFL(I)
            WRITE(IOUT,'(I5,I5,I8,I10)') (ICOB(J,I),J=1,3),ICOBFL(I)
         ELSE
            READ(IUREAL(IUCOBS),*) (ICOB(J,I),J=1,3)
            WRITE(IOUT,'(I5,I5,I8)') (ICOB(J,I),J=1,3)
         END IF
10       CONTINUE
C
         IF(IOBSFL.GT.0) THEN
            IF(ICOBFL(1).LE.0 .OR. FILTYP(ICOBFL(1)).NE.'DATA' .OR.
     1         IFNUSE(ICOBFL(1)).NE.IUMOC) THEN
               WRITE(IOUT,*) ' Invalid output file unit specified for',
     1      ' observation data in the'
               WRITE(IOUT,*) ' list of observation wells:',ICOBFL(1)
               WRITE(IOUT,*) ' Observation data can only be stored in',
     1      ' files specified in the MOC'
               WRITE(IOUT,*) ' name file using type DATA'
               CALL RDABRT
            END IF
            IOBSFL=ICOBFL(1)
            DO 20 I=1,NUMOBS
            ICOBFL(I)=0
20          CONTINUE
         ELSE
            DO 40 I=1,NUMOBS
            IF(ICOBFL(I).LE.0 .OR. FILTYP(ICOBFL(I)).NE.'DATA' .OR.
     1         IFNUSE(ICOBFL(I)).NE.IUMOC) THEN
               WRITE(IOUT,*) ' Invalid output file unit specified for',
     1      ' observation data in the'
               WRITE(IOUT,*) ' list of observation wells:',ICOBFL(I)
               WRITE(IOUT,*) ' Observation data can only be stored in',
     1      ' files specified in the MOC'
               WRITE(IOUT,*) ' name file using type DATA'
               CALL RDABRT
            END IF
40          CONTINUE
            IOBSFL=0
         END IF
      ELSE
         IOBSFL=0
      END IF
      CALL IVLSAV('IOBSFL',0,0,IOBSFL)
C
      CLOSE(UNIT=IUREAL(IUCOBS))
      RETURN
      END
      SUBROUTINE MOCRRC
C     ******************************************************************
C     Read recharge concentrations
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      COMMON /MOCCOM/IUMOCL,IUMOC,IUCRC,IUCOBS,NSCOL,NSROW,NSLAY,
     1     ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2,
     2     NODISP,NPTPND,ICINFL,MOCMETH,
     3     PNEWL(51),PNEWR(51),PNEWC(51),IZONE(MXCZON),ZONCON(MXCZON),
     4     ICOB(3,MXCOB),ICOBFL(MXCOB)
      CHARACTER*24 ANAME
      DATA ANAME/'Recharge Concentration  '/
C     ------------------------------------------------------------------
      IF(IUNIT(8).EQ.0) THEN
         CLOSE(UNIT=IUREAL(IUCRC))
         IFNUSE(IUCRC)=0
         IUCRC=0
         RETURN
      END IF
C
      DO 100 KPER=1,NPER
      READ(IUREAL(IUCRC),*) INCRCH
      CALL ARRMAK('CRECH',0,KPER,NSCOL,NSROW)
      IF(INCRCH.GE.0) THEN
         CALL U2DREL(ANAME,NSROW,NSCOL,0,IUCRC,NARRAY,IUMOC)
      ELSE
         IARRDA(1,NARRAY)=-3
      END IF
100   CONTINUE
C
      CLOSE(UNIT=IUREAL(IUCRC))
      RETURN
      END
      SUBROUTINE MOCRNM
C     ******************************************************************
C     Read MOC name file
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      COMMON /MOCCOM/IUMOCL,IUMOC,IUCRC,IUCOBS,NSCOL,NSROW,NSLAY,
     1     ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2,
     2     NODISP,NPTPND,ICINFL,MOCMETH,
     3     PNEWL(51),PNEWR(51),PNEWC(51),IZONE(MXCZON),ZONCON(MXCZON),
     4     ICOB(3,MXCOB),ICOBFL(MXCOB)
C
      PARAMETER (NMOCFT=10)
      CHARACTER*4 CUNIT(NMOCFT)
      CHARACTER*80 LINE
      DIMENSION KUNIT(NMOCFT)
      DATA CUNIT/'CLST','MOC','CRCH','CNCA','CNCB','PRTA','PRTB','VELA',
     1           'VELB','OBS'/
      DATA KUNIT /10*0/
C     ------------------------------------------------------------------
      MOCMETH=0
      WRITE(IOUT,*) ' Reading MOC name file:'
      INUNIT=IUREAL(IUNIT(15))
      IFIRST=1
C
C2------READ A LINE; IGNORE BLANK LINES.
      CALL URDCOM(INUNIT,LINE,15)
      GO TO 21
20    READ(INUNIT,'(A)',END=1000) LINE
21    IF(LINE.EQ.' ') GO TO 20
C
C3------DECODE THE FILE TYPE AND UNIT NUMBER.
      LLOC=1
      CALL URWORD(LINE,LLOC,ITYP1,ITYP2,1,N,R,IOUT,INUNIT)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IU,R,IOUT,INUNIT)
      IF(IU.LE.0 .OR. IU.GT.MXFNAM) THEN
         WRITE(IOUT,*) ' File unit out of range:',IU
         CALL RDABRT
      END IF
C
C  CLST must come first
      IF(IFIRST.EQ.1) THEN
         IF(LINE(ITYP1:ITYP2).NE.'CLST') THEN
            WRITE(IOUT,*) ' First file in the MOC name file is type:',
     1            LINE(ITYP1:ITYP2)
            WRITE(IOUT,*) ' The first file must be type: CLST'
            CALL RDABRT
         ELSE
            KUNIT(1)=IU
            IFIRST=0
         END IF
C
C  Check for DATA file type -- can be multiple files
      ELSE IF(LINE(ITYP1:ITYP2).EQ.'DATA') THEN
      ELSE IF(LINE(ITYP1:ITYP2).EQ.'DATA(BINARY)') THEN
      ELSE IF(LINE(ITYP1:ITYP2).EQ.'MOC') THEN
         IF(KUNIT(2).NE.0) THEN
            WRITE(IOUT,*) ' Multiple MAIN GWT files'
            CALL RDABRT
         END IF
         KUNIT(2)=IU
         MOCMETH=1
      ELSE IF(LINE(ITYP1:ITYP2).EQ.'MOCIMP') THEN
         IF(KUNIT(2).NE.0) THEN
            WRITE(IOUT,*) ' Multiple MAIN GWT files'
            CALL RDABRT
         END IF
         KUNIT(2)=IU
         LINE(ITYP1:ITYP2)='MOC'
         MOCMETH=2
      ELSE IF(LINE(ITYP1:ITYP2).EQ.'ELLAM') THEN
         IF(KUNIT(2).NE.0) THEN
            WRITE(IOUT,*) ' Multiple MAIN GWT files'
            CALL RDABRT
         END IF
         KUNIT(2)=IU
         LINE(ITYP1:ITYP2)='MOC'
         MOCMETH=3
C
C4------CHECK FOR ALL OTHER VALID MOC FILE TYPES.
      ELSE
         DO 40 I=3,NMOCFT
            IF(LINE(ITYP1:ITYP2).EQ.CUNIT(I)) THEN
               IF(KUNIT(I).NE.0) THEN
                  WRITE(IOUT,*) ' Duplicate MOC file type:',CUNIT(I)
                  CALL RDABRT
               END IF
               KUNIT(I)=IU
               GO TO 50
            END IF
40       CONTINUE
C  If the file type is invalid, we end up here.
         WRITE(IOUT,*) ' Invalid MOC file type:',LINE(ITYP1:ITYP2)
         CALL RDABRT
50       CONTINUE
      END IF
C  The file type is valid -- temporarily set IFNUSE=-999.
      IFNUSE(IU)=-999
C
C5------DETERMINE FILE NAME AND WRITE ITS NAME.
      IF(IUCASE.EQ.0) THEN
         CALL URWORD(LINE,LLOC,INAM1,INAM2,0,N,R,IOUT,INUNIT)
      ELSE
         CALL URWORD(LINE,LLOC,INAM1,INAM2,1,N,R,IOUT,INUNIT)
      END IF
      WRITE(IOUT,56) LINE(INAM1:INAM2),
     1     LINE(ITYP1:ITYP2),IU
56    FORMAT(1X,/1X,'MOC FILE: ',A,/
     1     1X,'FILE TYPE:',A,'   UNIT',I4)
C
C6------PUT FILE NAME INTO TABLE OF FILE NAMES.
      IF(FILTYP(IU).NE.' ') THEN
         WRITE(IOUT,*) ' ATTEMPT TO OPEN A FILE ON A PREVIOUSLY',
     1        ' DEFINED UNIT'
         WRITE(IOUT,*) ' THE CONFLICT IS ON UNIT',IU
         CALL RDABRT
      END IF
      DO 60 I=1,MXFNAM
      IF(FILNAM(I).EQ.LINE(INAM1:INAM2)) THEN
         WRITE(IOUT,*) ' Duplicate file name:'
         WRITE(IOUT,*) FILNAM(I)
         CALL RDABRT
      END IF
60    CONTINUE
      FILTYP(IU)=LINE(ITYP1:ITYP2)
      IF(FILTYP(IU).EQ.'OBS') FILTYP(IU)='MOCOBS'
      FILNAM(IU)=LINE(INAM1:INAM2)
      GO TO 20
C
C7------END OF NAME FILE.
1000  IF(IFIRST.EQ.1) THEN
         WRITE(IOUT,*) ' MOC name file is empty'
         CALL RDABRT
      END IF
      IF(KUNIT(2).EQ.0) THEN
         WRITE(IOUT,*) ' Aborting because there is no MAIN MOC file'
         CALL RDABRT
      END IF
      IUMOCL=KUNIT(1)
      IUMOC=KUNIT(2)
      CALL REALUN(IUMOC)
      OPEN(FILE=FILNAM(IUMOC),UNIT=IUREAL(IUMOC),STATUS='OLD')
      IF(KUNIT(3).NE.0) THEN
         IUCRC=KUNIT(3)
         CALL REALUN(IUCRC)
         OPEN(FILE=FILNAM(IUCRC),UNIT=IUREAL(IUCRC),STATUS='OLD')
      END IF
      IF(KUNIT(10).NE.0) THEN
         IUCOBS=KUNIT(10)
         CALL REALUN(IUCOBS)
         OPEN(FILE=FILNAM(IUCOBS),UNIT=IUREAL(IUCOBS),STATUS='OLD')
      END IF
C
C  Mark Data files as being used by IUMOC -- couldn't be done sooner
C  because IUMOC might not be defined.
      DO 1020 I=1,MXFNAM
         IF(IFNUSE(I).EQ.-999) IFNUSE(I)=IUMOC
1020  CONTINUE
      RETURN
C
      END
      SUBROUTINE MOCRD()
C     ******************************************************************
C     READ AND INITIALIZE DATA FOR MOC
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      COMMON /MOCCOM/IUMOCL,IUMOC,IUCRC,IUCOBS,NSCOL,NSROW,NSLAY,
     1     ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2,
     2     NODISP,NPTPND,ICINFL,MOCMETH,
     3     PNEWL(51),PNEWR(51),PNEWC(51),IZONE(MXCZON),ZONCON(MXCZON),
     4     ICOB(3,MXCOB),ICOBFL(MXCOB)
      COMMON /MOCCCM/HEDMOC(2)
      CHARACTER*78 HEDMOC
      CHARACTER*24 ANAME(8)
      DATA ANAME/'Initial Concentration   ',
     1           'Boundary Inflow Conc.   ',
     2           'Strong Source Flag Array',
     3           'Longitudinal Disp.      ',
     4           'Hor. Transverse Disp.   ',
     5           'Vert. Transverse Disp.  ',
     6           'Retardation Factor      ',
     7           'Porosity                '/
C     ------------------------------------------------------------------
C
C  Read name file -- This defines IUMOC, the unit number for the Main
C  MOC file
      CALL MOCRNM
C
C  Items 1-3
      READ(IUREAL(IUMOC),'(A)') HEDMOC(1)
      READ(IUREAL(IUMOC),'(A)') HEDMOC(2)
      WRITE(IOUT,*) HEDMOC(1)
      WRITE(IOUT,*) HEDMOC(2)
      READ(IUREAL(IUMOC),*) ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2
      WRITE(IOUT,'(A,2I17)') 'Subgrid layer range:',ISLAY1,ISLAY2
      WRITE(IOUT,'(A,2I17)') 'Subgrid row range:',ISROW1,ISROW2
      WRITE(IOUT,'(A,2I17)') 'Subgrid column range:',ISCOL1,ISCOL2
      IF(ISCOL1.LT.1 .OR. ISCOL2.GT.NCOL .OR. ISCOL2.LT.ISCOL1) THEN
         WRITE(IOUT,*) ' Invalid subgrid column range'
         CALL RDABRT
      END IF
      IF(ISROW1.LT.1 .OR. ISROW2.GT.NROW .OR. ISROW2.LT.ISROW1) THEN
         WRITE(IOUT,*) ' Invalid subgrid row range'
         CALL RDABRT
      END IF
      IF(ISLAY1.LT.1 .OR. ISLAY2.GT.NLAY .OR. ISLAY2.LT.ISLAY1) THEN
         WRITE(IOUT,*) ' Invalid subgrid layer range'
         CALL RDABRT
      END IF
      NSCOL=ISCOL2-ISCOL1+1
      NSROW=ISROW2-ISROW1+1
      NSLAY=ISLAY2-ISLAY1+1
      IF(NSCOL.EQ.1 .AND. NSROW.EQ.1 .AND. NSLAY.EQ.1) THEN
         WRITE(IOUT,*) ' Subgrid includes only a single cell'
         CALL RDABRT
      END IF
      NFDIM=0
      IF(NSCOL.GT.1) NFDIM=NFDIM+1
      IF(NSROW.GT.1) NFDIM=NFDIM+1
      IF(NSLAY.GT.1) NFDIM=NFDIM+1
C
C  Check for uniform grid spacing in subgrid
      IF(MOCMETH.NE.3) THEN
      CALL VALGET('DELR',0,0,IADELR,DUM)
      IF(IADELR.GT.1) THEN
         IF(IARRDA(1,IADELR).EQ.-1) THEN
            LOC=IARRDA(2,IADELR)
            IF(LOC.GT.0) THEN
               D1=X(LOC+ISCOL1-1)
               DO 4 J=ISCOL1,ISCOL2
               IF(X(LOC+J-1).NE.D1) THEN
                  WRITE(IOUT,*)
     1             ' DELR is not uniform withing the MOC subgrid'
                  CALL RDABRT
               END IF
4              CONTINUE
            END IF
         END IF
      END IF
      CALL VALGET('DELC',0,0,IADELC,DUM)
      IF(IADELC.GT.1) THEN
         IF(IARRDA(1,IADELC).EQ.-1) THEN
            LOC=IARRDA(2,IADELC)
            IF(LOC.GT.0) THEN
               D1=X(LOC+ISROW1-1)
               DO 6 I=ISROW1,ISROW2
               IF(X(LOC+I-1).NE.D1) THEN
                  WRITE(IOUT,*)
     1             ' DELC is not uniform withing the MOC subgrid'
                  CALL RDABRT
               END IF
6              CONTINUE
            END IF
         END IF
      END IF
      END IF
C
C  Items 4-6
      READ(IUREAL(IUMOC),*) NODISP,DECAY,DIFFUS
      WRITE(IOUT,*) ' NODISP=',NODISP
      IF(NODISP.NE.0) NODISP=1
      WRITE(IOUT,*) ' DECAY=',DECAY,'   DIFFUS=',DIFFUS
      CALL VALSAV('DECAY',0,0,DECAY)
      CALL VALSAV('DIFFUS',0,0,DIFFUS)
C  5A -- 
      IF(MOCMETH.NE.3) THEN
         READ(IUREAL(IUMOC),*) NPMAX,NPTPND
         WRITE(IOUT,*) ' NPTPND=',NPTPND
         CALL IVLSAV('NPMAX',0,0,NPMAX)
C  Particle coordinates
         IF(NPTPND.GE.0) THEN
            IF((NPTPND.NE.1 .AND. NPTPND.NE.2**NFDIM .AND.
     1       NPTPND.NE.3**NFDIM .AND. NPTPND.NE.4**NFDIM) .OR.
     2         (NFDIM.EQ.3 .AND. NPTPND.EQ.64)) THEN
               IF(NFDIM.EQ.1) THEN
                  WRITE(IOUT,*)
     1     ' For 1-D transport, NPTPND must be 1, 2, 3, or 4'
               ELSE IF(NFDIM.EQ.2) THEN
                  WRITE(IOUT,*)
     1     ' For 2-D transport, NPTPND must be 1, 4, 9, or 16'
               ELSE
                  WRITE(IOUT,*)
     1     ' For 3-D transport, NPTPND must be 1, 8, or 27'
               END IF
               CALL RDABRT
            END IF
         ELSE
            IF(NPTPND.LT.-51) THEN
            WRITE(IOUT,*) ' A maximum of 51 particles can be defined'
               CALL RDABRT
            END IF
            DO 10 I=1,-NPTPND
            READ(IUREAL(IUMOC),*) PNEWL(I),PNEWR(I),PNEWC(I)
            WRITE(IOUT,*) ' PNEWL=',PNEWL(I),'   PNEWR=',PNEWR(I),
     1         '   PNEWC=',PNEWC(I)
10          CONTINUE
         END IF
      ELSE
C  5B.
         READ(IUREAL(IUMOC),*) NSCEXP,NSREXP,NSLEXP,NTEXP
         CALL IVLSAV('NPMAX',0,0,NSCEXP)
         CALL IVLSAV('NPMAX',0,0,NSREXP)
         CALL IVLSAV('NPMAX',0,0,NSLEXP)
         CALL IVLSAV('NPMAX',0,0,NTEXP)
      END IF
C
C  Item 7
      IF(MOCMETH.NE.3) THEN
         READ(IUREAL(IUMOC),*) CELDIS,FZERO,INTRPL
      ELSE
         READ(IUREAL(IUMOC),*) CELDIS
         FZERO=.01
         INTERPL=1
      END IF
      IF(INTRPL.NE.2) INTRPL=1
      WRITE(IOUT,*) ' CELDIS=',CELDIS,'   FZERO=',FZERO,
     1           '   INTRPL=',INTRPL
      CALL VALSAV('CELDIS',0,0,CELDIS)
      CALL VALSAV('FZERO',0,0,FZERO)
      CALL IVLSAV('INTRPL',0,0,INTRPL)
C  7.1
      IF(MOCMETH.EQ.2) THEN
         READ(IUREAL(IUMOC),*) FDTMTH,NCXIT,IDIREC,EPSSLV,MAXIT
         CALL VALSAV('FDTMTH',0,0,FDTMTH)
         CALL IVLSAV('NCXIT',0,0,NCXIT)
         CALL IVLSAV('IDIREC',0,0,IDIREC)
         CALL VALSAV('EPSSLV',0,0,EPSSLV)
         CALL IVLSAV('MAXIT',0,0,MAXIT)
      END IF
C Item 8
      IF(MOCMETH.NE.3) THEN
         READ(IUREAL(IUMOC),*) NPNTCL,ICONFM,NPNTVL,IVELFM,NPNTDL,
     
     1           IDSPFM,NPNTPL
      ELSE
         READ(IUREAL(IUMOC),*) NPNTCL,ICONFM,NPNTVL,IVELFM,NPNTDL,
     1           IDSPFM
         NPNTPL=0
      END IF
      WRITE(IOUT,*) ' NPNTCL=',NPNTCL,'   ICONFM=',ICONFM,'   NPNTVL=',
     1              NPNTVL
      WRITE(IOUT,*) ' IVELFM=',IVELFM,'   NPNTDL=',NPNTDL,'   IDSPFM=',
     1              IDSPFM
      WRITE(IOUT,*) ' NPNTPL=',NPNTPL
      CALL IVLSAV('NPNTCL',0,0,NPNTCL)
      CALL IVLSAV('ICONFM',0,0,ICONFM)
      CALL IVLSAV('NPNTVL',0,0,NPNTVL)
      CALL IVLSAV('IVELFM',0,0,IVELFM)
      CALL IVLSAV('NPNTDL',0,0,NPNTDL)
      CALL IVLSAV('IDSPFM',0,0,IDSPFM)
      CALL IVLSAV('NPNTPL',0,0,NPNTPL)
      READ(IUREAL(IUMOC),*) CNOFLO
      CALL VALSAV('CNOFLO',0,0,CNOFLO)
      WRITE(IOUT,*) ' CNOFLO=',CNOFLO
C
C  Initial concentration
      DO 20 K=1,NSLAY
      KK=K
      CALL ARRMAK('CINT',KK,0,NSCOL,NSROW)
      CALL U2DREL(ANAME(1),NSROW,NSCOL,KK,IUMOC,NARRAY,IUMOC)
20    CONTINUE
C
C  CINFL
      ICINFL=0
      IF(ISCOL1.GT.1 .OR. ISCOL2.LT.NCOL .OR.
     1         ISROW1.GT.1 .OR. ISROW2.LT.NROW) ICINFL=ICINFL+NSLAY
      IF(ISLAY1.GT.1) ICINFL=ICINFL+1
      IF(ISLAY2.LT.NLAY) ICINFL=ICINFL+1
      IF(ICINFL.GT.0) THEN
         CALL ARRMAK('CINFL',0,0,ICINFL,1)
         CALL U1DREL(ANAME(2),ICINFL,IUMOC,NARRAY)
      END IF
C
C  Fixed head zones
      READ(IUREAL(IUMOC),*) NZONES
      WRITE(IOUT,*) ' NZONES=',NZONES
      IF(NZONES.LT.0) NZONES=0
      CALL IVLSAV('NZONES',0,0,NZONES)
      IF(NZONES.GT.MXCZON) THEN
         WRITE(IOUT,*) ' Stopping because NZONES>',MXCZON
         CALL RDABRT
      END IF
      IF(NZONES.GT.0) THEN
         WRITE(IOUT,'(A)') '     IZONE      ZONCON'
         DO 30 I=1,NZONES
         READ(IUREAL(IUMOC),*) IZONE(I),ZONCON(I)
         WRITE(IOUT,'(I10,1PE12.3)') IZONE(I),ZONCON(I)
30       CONTINUE
      END IF
C
C  Strong source flag array
      IF(MOCMETH.NE.3) THEN
         DO 40 K=1,NSLAY
         KK=K
         CALL ARRMAK('IGENPT',KK,0,NSCOL,NSROW)
         CALL U2DINT(ANAME(3),NSROW,NSCOL,KK,IUMOC,NARRAY,IUMOC)
40       CONTINUE
      END IF
C
C  Dispersivities
      IF(NODISP.EQ.0) THEN
         CALL ARRMAK('ALONG',0,0,1,NSLAY)
         CALL U1DREL(ANAME(4),NSLAY,IUMOC,NARRAY)
         CALL ARRMAK('ATRANH',0,0,1,NSLAY)
         CALL U1DREL(ANAME(5),NSLAY,IUMOC,NARRAY)
         CALL ARRMAK('ATRANV',0,0,1,NSLAY)
         CALL U1DREL(ANAME(6),NSLAY,IUMOC,NARRAY)
      END IF
C
C  Retardation factor
      CALL ARRMAK('RF',0,0,1,NSLAY)
      CALL U1DREL(ANAME(7),NSLAY,IUMOC,NARRAY)
C
C  Porosity
      DO 60 K=1,NSLAY
      KK=K
      CALL ARRMAK('PORMOC',KK,0,NSCOL,NSROW)
      CALL U2DREL(ANAME(8),NSROW,NSCOL,KK,IUMOC,NARRAY,IUMOC)
60    CONTINUE
C
      CLOSE(IUREAL(IUMOC))
C
C
C  MOC Recharge concentration file
      IF(IUCRC.GT.0) CALL MOCRRC
C
C  MOC Observation locations file
      IF(IUCOBS.GT.0) CALL MOCROB
C
      RETURN
      END
      SUBROUTINE MOCSV(IUNDEF,IWRFLG)
C     ******************************************************************
C     SAVE DATA FOR MOC
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      COMMON /MOCCOM/IUMOCL,IUMOC,IUCRC,IUCOBS,NSCOL,NSROW,NSLAY,
     1     ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2,
     2     NODISP,NPTPND,ICINFL,MOCMETH,
     3     PNEWL(51),PNEWR(51),PNEWC(51),IZONE(MXCZON),ZONCON(MXCZON),
     4     ICOB(3,MXCOB),ICOBFL(MXCOB)
      COMMON /MOCCCM/HEDMOC(2)
      CHARACTER*78 HEDMOC,LINE(1)
C  Common block for WEL Package
      COMMON /WELCOM/WELAUX(3)
      CHARACTER*16 WELAUX
C  Common block for RIV Package
      COMMON /RIVCOM/RIVAUX(3)
      CHARACTER*16 RIVAUX
C  Common block for GHB Package
      COMMON /GHBCOM/GHBAUX(3)
      CHARACTER*16 GHBAUX
C     ------------------------------------------------------------------
      IF(IUNIT(15).EQ.0) THEN
         IUNDEF=-1
         RETURN
      END IF
      CTEXT(1)='Missing data for the GWT Process:'
      CTEXT(2)='------------------------------------------------------'
      NMISS=2
C
      MODSAV=MODOUT
      MODOUT=1
C  Unmark all MOC files except the special output files.
      DO 10 I=1,MXFNAM
      IF(IFNUSE(I).EQ.IUMOC .AND.
     1      FILTYP(I).NE.'CNCA' .AND. FILTYP(I).NE.'CNCB' .AND.
     2      FILTYP(I).NE.'VELA' .AND. FILTYP(I).NE.'VELB' .AND.
     3      FILTYP(I).NE.'PRTA' .AND. FILTYP(I).NE.'PRTB') IFNUSE(I)=0
10    CONTINUE
      IFNUSE(IUMOCL)=IUMOC
      IFNUSE(IUMOC)=IUMOC
C
      IUNDEF=0
      IFIL=IUMISC
      IF(IWRFLG.LE.0) IFIL=0
      IF(IWRFLG.EQ.1) OPEN(FILE='MFI.MOC',UNIT=IFIL)
      IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUMOC),UNIT=IFIL)
C
C  Items 1-5
      IF(IWRFLG.GT.0) THEN
         WRITE(IFIL,'(A)') HEDMOC(1)
         WRITE(IFIL,'(A)') HEDMOC(2)
         WRITE(IFIL,'(6I6,A)') ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,
     1       ISCOL2,'  ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2'
         CALL VALGET('DECAY',0,0,ITYPE,DECAY)
         IF(ITYPE.NE.0) DECAY=0.
         CALL VALGET('DIFFUS',0,0,ITYPE,DIFFUS)
         IF(ITYPE.NE.0) DIFFUS=0.
         WRITE(IFIL,'(I6,1P,2E12.3,A)') NODISP,DECAY,
     1         DIFFUS,'  NODISP,DECAY,DIFFUS'
         IF(MOCMETH.NE.3) THEN
            CALL IVLGET('NPMAX',0,0,ITYPE,NPMAX)
            IF(ITYPE.NE.0) NPMAX=0
            WRITE(IFIL,'(2I6,A)') NPMAX,NPTPND,
     1                      '  NPMAX,NPTPND'
         ELSE
            CALL IVLGET('NSCEXP',0,0,ITYPE,NSCEXP)
            IF(ITYPE.NE.0) NSCEXP=2
            CALL IVLGET('NSREXP',0,0,ITYPE,NSREXP)
            IF(ITYPE.NE.0) NSREXP=2
            CALL IVLGET('NSLEXP',0,0,ITYPE,NSLEXP)
            IF(ITYPE.NE.0) NSLEXP=1
            CALL IVLGET('NTEXP',0,0,ITYPE,NTEXP)
            IF(ITYPE.NE.0) NTEXP=2
            WRITE(IFIL,'(4I10,A)') NSCEXP,NSREXP,NSLEXP,NTEXP,
     1                          '  NSCEXP,NSREXP,NSLEXP,NTEXP'
         END IF
      END IF
C  Particle coordinates
      IF(IWRFLG.GT.0 .AND. NPTPND.LT.0 .AND. MOCMETH.NE.3) THEN
         DO 15 I=1,-NPTPND
         WRITE(IFIL,*) PNEWL(I),PNEWR(I),PNEWC(I)
15       CONTINUE
      END IF
C
C  Items 7-9
      IF(IWRFLG.GT.0) THEN
         CALL VALGET('CELDIS',0,0,ITYPE,CELDIS)
         IF(ITYPE.NE.0) CELDIS=0.1
         CALL VALGET('FZERO',0,0,ITYPE,FZERO)
         IF(ITYPE.NE.0) FZERO=0.05
         CALL IVLGET('INTRPL',0,0,ITYPE,INTRPL)
         IF(ITYPE.NE.0) INTRPL=1
         IF(MOCMETH.NE.3) THEN
            WRITE(IFIL,'(1P,2E12.3,I6,A)') CELDIS,FZERO,INTRPL,
     1                                  '  CELDIS,FZERO,INTRPL'
         ELSE
            WRITE(IFIL,'(1P,E12.3,A)') CELDIS,
     1                                  '  CELDIS'
         END IF
         IF(MOCMETH.EQ.2) THEN
            CALL VALGET('FDTMTH',0,0,ITYPE,FDTMTH)
            IF(ITYPE.NE.0) FDTMTH=1.
            CALL IVLGET('NCXIT',0,0,ITYPE,NCXIT)
            IF(ITYPE.NE.0) NCXIT=2
            CALL IVLGET('IDIREC',0,0,ITYPE,IDIREC)
            IF(ITYPE.NE.0) IDIREC=1
            CALL VALGET('EPSSLV',0,0,ITYPE,EPSSLV)
            IF(ITYPE.NE.0) EPSSLV=1.E-5
            CALL IVLGET('MAXIT',0,0,ITYPE,MAXIT)
            IF(ITYPE.NE.0) MAXIT=100
            WRITE(IFIL,'(1P,E12.3,2I10,E12.3,I10,A)')
     1                FDTMTH,NCXIT,IDIREC,EPSSLV,MAXIT,
     2             '  FDTMTH,NCXIT,IDIREC,EPSSLV,MAXIT'
         END IF
C
         CALL IVLGET('NPNTCL',0,0,ITYPE,NPNTCL)
         IF(ITYPE.NE.0) NPNTCL=0
         CALL IVLGET('ICONFM',0,0,ITYPE,ICONFM)
         IF(ITYPE.NE.0) ICONFM=0
         CALL IVLGET('NPNTVL',0,0,ITYPE,NPNTVL)
         IF(ITYPE.NE.0) NPNTVL=0
         CALL IVLGET('IVELFM',0,0,ITYPE,IVELFM)
         IF(ITYPE.NE.0) IVELFM=0
         CALL IVLGET('NPNTDL',0,0,ITYPE,NPNTDL)
         IF(ITYPE.NE.0) NPNTDL=0
         CALL IVLGET('IDSPFM',0,0,ITYPE,IDSPFM)
         IF(ITYPE.NE.0) IDSPFM=0
         CALL IVLGET('NPNTPL',0,0,ITYPE,NPNTPL)
         IF(ITYPE.NE.0) NPNTPL=0
         IF(MOCMETH.NE.3) THEN
            WRITE(IFIL,'(7I6,A)')
     1     NPNTCL,ICONFM,NPNTVL,IVELFM,NPNTDL,IDSPFM,NPNTPL,
     2  '  NPNTCL,ICONFM,NPNVTL,IVELFM,NPNTDL,IDSPFM,NPNTPL'
         ELSE
            WRITE(IFIL,'(6I6,A)')
     1     NPNTCL,ICONFM,NPNTVL,IVELFM,NPNTDL,IDSPFM,
     2  '  NPNTCL,ICONFM,NPNVTL,IVELFM,NPNTDL,IDSPFM'
         END IF
C
         CALL VALGET('CNOFLO',0,0,ITYPE,CNOFLO)
         IF(ITYPE.NE.0) CNOFLO=999.99
         IF(ABS(CNOFLO).LE.999999. .AND. ABS(CNOFLO).GE.100.) THEN
            WRITE(IFIL,'(F10.2,A)') CNOFLO,'  CNOFLO'
         ELSE
            WRITE(IFIL,'(1P,E10.3,A)') CNOFLO,'  CNOFLO'
         END IF
      END IF
C
C  Initial concentration
      DO 20 K=1,NSLAY
      KK=K
      CALL U2DRSV('CINT',KK,0,IUNDEF,IFIL,IUMOC,'CINT',KK)
      IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
         NMISS=NMISS+1
         IUNDEF=0
         WRITE(CTEXT(NMISS),'(A,I10)') 'Initial conc. (CINT)',KK
      END IF
20    CONTINUE
C
C  CINFL
      IF(ICINFL.GT.0) THEN
         CALL U1DRSV('CINFL',IUNDEF,IFIL,IUMOC)
         IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
            NMISS=NMISS+1
            IUNDEF=0
            WRITE(CTEXT(NMISS),'(A,10X)') 'Grd.bnd.conc.(CINFL)'
         END IF
      END IF
C
C  Fixed head zones
      IF(IWRFLG.GT.0) THEN
         NZONES=0
            DO 29 I=1,MXCZON
            IF(IZONE(I).LT.0) NZONES=NZONES+1
29          CONTINUE
         WRITE(IFIL,'(I6,A)') NZONES,'  NZONES'
         IF(NZONES.GT.0) THEN
            DO 30 I=1,MXCZON
            IF(IZONE(I).LT.0) WRITE(IFIL,'(I6,1P,E12.3)')
     1                       IZONE(I),ZONCON(I)
30          CONTINUE
         END IF
      END IF
C
C  Strong source flag array
      IF(MOCMETH.NE.3) THEN
         DO 40 K=1,NSLAY
         KK=K
         CALL U2DISV('IGENPT',KK,0,IUNDEF,IFIL,IUMOC)
         IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
            NMISS=NMISS+1
            IUNDEF=0
            WRITE(CTEXT(NMISS),'(A,I10)') 'Strong flags(IGENPT)',KK
         END IF
40       CONTINUE
      END IF
C
C  Dispersivities
      IF(NODISP.EQ.0) THEN
         CALL U1DRSV('ALONG',IUNDEF,IFIL,IUMOC)
         IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
            NMISS=NMISS+1
            IUNDEF=0
            WRITE(CTEXT(NMISS),'(A,10X)') 'Long. disp. (ALONG) '
         END IF
         CALL U1DRSV('ATRANH',IUNDEF,IFIL,IUMOC)
         IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
            NMISS=NMISS+1
            IUNDEF=0
            WRITE(CTEXT(NMISS),'(A,10X)') 'H.tran.disp.(ATRANH)'
         END IF
         CALL U1DRSV('ATRANV',IUNDEF,IFIL,IUMOC)
         IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
            NMISS=NMISS+1
            IUNDEF=0
            WRITE(CTEXT(NMISS),'(A,10X)') 'V.tran.disp.(ATRANV)'
         END IF
      END IF
C
C  Retardation factor
      CALL U1DRSV('RF',IUNDEF,IFIL,IUMOC)
      IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
         NMISS=NMISS+1
         IUNDEF=0
         WRITE(CTEXT(NMISS),'(A,10X)') 'Retard. Fact. (RF)  '
      END IF
C
C  Porosity
      DO 60 K=1,NSLAY
      KK=K
      CALL U2DRSV('PORMOC',KK,0,IUNDEF,IFIL,IUMOC,'PORMOC',KK)
      IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
         NMISS=NMISS+1
         IUNDEF=0
         WRITE(CTEXT(NMISS),'(A,I10)') 'Porosity (POR)      ',KK
      END IF
60    CONTINUE
      IF(IWRFLG.GT.0) CLOSE(UNIT=IFIL)
C
C  MOC Recharge concentration file
      CALL MOCWRC(IUNDEF,IWRFLG)
C
C  Check if concentration data for auxiliary point stress packages has been
C  entered.
      IF(IUNIT(2).GT.0) THEN
         IF(WELAUX(1).NE.'CONC' .AND. WELAUX(1).NE.'CONCENTRATION' .AND.
     1      WELAUX(2).NE.'CONC' .AND. WELAUX(2).NE.'CONCENTRATION' .AND.
     2      WELAUX(3).NE.'CONC' .AND. WELAUX(3).NE.'CONCENTRATION') THEN
            IUNDEF=1
            IF(NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
               NMISS=NMISS+1
               IUNDEF=0
               WRITE(CTEXT(NMISS),'(A)')
     1                'Well concentration (WEL Package)'
            END IF
         END IF
      END IF
      IF(IUNIT(4).GT.0) THEN
         IF(RIVAUX(1).NE.'CONC' .AND. RIVAUX(1).NE.'CONCENTRATION' .AND.
     1      RIVAUX(2).NE.'CONC' .AND. RIVAUX(2).NE.'CONCENTRATION' .AND.
     2      RIVAUX(3).NE.'CONC' .AND. RIVAUX(3).NE.'CONCENTRATION') THEN
            IUNDEF=1
            IF(NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
               NMISS=NMISS+1
               IUNDEF=0
               WRITE(CTEXT(NMISS),'(A)')
     1                'River concentration (RIV Package)'
            END IF
         END IF
      END IF
      IF(IUNIT(7).GT.0) THEN
         IF(GHBAUX(1).NE.'CONC' .AND. GHBAUX(1).NE.'CONCENTRATION' .AND.
     1      GHBAUX(2).NE.'CONC' .AND. GHBAUX(2).NE.'CONCENTRATION' .AND.
     2      GHBAUX(3).NE.'CONC' .AND. GHBAUX(3).NE.'CONCENTRATION') THEN
            IUNDEF=1
            IF(NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
               NMISS=NMISS+1
               IUNDEF=0
               WRITE(CTEXT(NMISS),'(A)')
     1                'GHB concentration (GHB Package)'
            END IF
         END IF
      END IF
C
C  Display undefined data
      IF(IWRFLG.LT.0) THEN
         IF(NMISS.GT.2) THEN
            CALL TXTLOG(CTEXT,NMISS)
            IUNDEF=1
         ELSE
            LINE(1)='All data are defined for the GWT Process'
            CALL TXTLOG(LINE,1)
         END IF
      END IF
C
C  MOC Observation locations file
      CALL MOCWOB(IWRFLG)
C
C  MOC Name file
      IF(IWRFLG.GT.1) CALL MOCWNM
C
      CALL FNMRMV
      MODOUT=MODSAV
      RETURN
      END
      SUBROUTINE MOCWNM
C     ******************************************************************
C     Write the MOC name file
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      COMMON /MOCCOM/IUMOCL,IUMOC,IUCRC,IUCOBS,NSCOL,NSROW,NSLAY,
     1     ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2,
     2     NODISP,NPTPND,ICINFL,MOCMETH,
     3     PNEWL(51),PNEWR(51),PNEWC(51),IZONE(MXCZON),ZONCON(MXCZON),
     4     ICOB(3,MXCOB),ICOBFL(MXCOB)
      CHARACTER*18 FTP
C
      IF(IUREAL(IUNIT(15)).EQ.0) CALL REALUN(IUNIT(15))
      OPEN(UNIT=IUMISC,FILE=FILNAM(IUNIT(15)))
      IF(IUREAL(IUMOCL).EQ.0) CALL REALUN(IUMOCL)
C
C  Write comments
      DO 20 I=1,20
      IF(COMENT(I,15)(1:1).EQ.'#') THEN
         DO 14 N=80,1,-1
         IF(COMENT(I,15)(N:N) .NE. ' ') GO TO 18
14       CONTINUE
18       WRITE(IUMISC,'(A)') COMENT(I,15)(1:N)
      END IF
20    CONTINUE
C
      J=LENSTR(80,FILNAM(IUMOCL))
      WRITE(IUMISC,25) FILTYP(IUMOCL),IUREAL(IUMOCL),FILNAM(IUMOCL)(1:J)
25    FORMAT(A,I5,1X,A)
C
      DO 200 I=1,MXFNAM
      IF(IFNUSE(I).EQ.IUMOC .AND. I.NE.IUMOCL .AND.
     1            FILTYP(I)(1:10).NE.'OPEN/CLOSE') THEN
         IF(IUREAL(I).EQ.0) CALL REALUN(I)
         J=LENSTR(80,FILNAM(I))
         FTP=FILTYP(I)
         IF(FTP.EQ.'MOCOBS') FTP='OBS'
         IF(FTP.EQ.'MOC') THEN
            IF(MOCMETH.EQ.1) THEN
               FTP='MOC'
            ELSE IF(MOCMETH.EQ.2) THEN
               FTP='MOCIMP'
            ELSE
               FTP='ELLAM'
            END IF
         END IF
         WRITE(IUMISC,25) FTP,IUREAL(I),FILNAM(I)(1:J)
      END IF
200   CONTINUE
C
      RETURN
      END
      SUBROUTINE MOCWRC(IUNDEF,IWRFLG)
C     ******************************************************************
C     WRITE recharge concentrations
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      COMMON /MOCCOM/IUMOCL,IUMOC,IUCRC,IUCOBS,NSCOL,NSROW,NSLAY,
     1     ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2,
     2     NODISP,NPTPND,ICINFL,MOCMETH,
     3     PNEWL(51),PNEWR(51),PNEWC(51),IZONE(MXCZON),ZONCON(MXCZON),
     4     ICOB(3,MXCOB),ICOBFL(MXCOB)
C     ------------------------------------------------------------------
C  Rechrage concentration is required only if RCH is on.
      IF(IUNIT(8).LE.0) THEN
         IUCRC=0
         RETURN
      END IF
C
C  Recharge concentration is only required if recharge is applied
C  to subgrid
      CALL IVLGET('NRCHOP',0,0,ITYPE,NRCHOP)
      IF(ITYPE.NE.0) NRCHOP=1
      IF(NRCHOP.EQ.1 .AND. ISLAY1.NE.1) THEN
         IUCRC=0
         RETURN
      END IF
C
C  Recharge concentration is required -- check if a file has been defined
      IF(IUCRC.EQ.0) THEN
         IUNDEF=1
         IF(NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
            NMISS=NMISS+1
            IUNDEF=0
            WRITE(CTEXT(NMISS),'(A)') 'Rech. conc. (CRECH)'
         END IF
         RETURN
      END IF
C
      IFNUSE(IUCRC)=IUMOC
      IFIL=IUMISC
      IF(IWRFLG.LE.0) IFIL=0
      IF(IWRFLG.EQ.1) OPEN(FILE='MFI.CRC',UNIT=IFIL)
      IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUCRC),UNIT=IFIL)
C
      DO 100 KPER=1,NPER
      INCRCH=1
      CALL VALGET('CRECH',0,KPER,NAR,DUM)
      IF(NAR.GT.0) THEN
         IF(IARRDA(1,NAR).EQ.-3) INCRCH=-1
      END IF
      IF(IWRFLG.GT.0) WRITE(IFIL,'(I10,A)')
     1           INCRCH,'  INCRCH'
      IF(INCRCH.GT.0) THEN
C  Note that if "old" output were being used, the wrong unit number (IUMOC)
C  would be written on the control record for an internal file.  But because
C  new control records are always written for MOC3D, "INTERNAL" is written,
C  which is OK.
         CALL U2DRSV('CRECH',0,KPER,IUNDEF,IFIL,IUMOC,'CRECH',0)
         IF(IUNDEF.NE.0 .AND. IWRFLG.LT.0) THEN
            IUNDEF=0
            IF(NMISS.LT.45) THEN
               NMISS=NMISS+1
               WRITE(CTEXT(NMISS),'(A,I20)') 'Rech. conc. (CRECH) ',KPER
            END IF
         END IF
      END IF
100   CONTINUE
C
      IF(IFIL.GT.0) CLOSE(UNIT=IFIL)
      RETURN
      END
      SUBROUTINE MOCWOB(IWRFLG)
C     ******************************************************************
C     WRITE observation locations
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      COMMON /MOCCOM/IUMOCL,IUMOC,IUCRC,IUCOBS,NSCOL,NSROW,NSLAY,
     1     ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2,
     2     NODISP,NPTPND,ICINFL,MOCMETH,
     3     PNEWL(51),PNEWR(51),PNEWC(51),IZONE(MXCZON),ZONCON(MXCZON),
     4     ICOB(3,MXCOB),ICOBFL(MXCOB)
C     ------------------------------------------------------------------
C
      NUMOBS=0
      DO 10 I=1,MXCOB
      IF(ICOB(1,I).GT.0 .AND. ICOB(2,I).GT.0 .AND. ICOB(3,I).GT.0) THEN
         NUMOBS=NUMOBS+1
      END IF
10    CONTINUE
C
      IF(NUMOBS.GT.0 .AND. IUCOBS.GT.0) THEN
         IFNUSE(IUCOBS)=IUMOC
         IF(IWRFLG.GT.1) OPEN(UNIT=IUMISC,FILE=FILNAM(IUCOBS))
         CALL IVLGET('IOBSFL',0,0,ITYPE,IOB)
         IF(ITYPE.NE.0) IOB=0
         IOBSFL=IOB
         IF(IOB.GT.0) IOBSFL=1
         IF(IWRFLG.GT.1)
     1      WRITE(IUMISC,'(2I6,A)') NUMOBS,IOBSFL,'  NUMOBS,IOBSFL'
         IF(IOBSFL.GT.0) THEN
            IFIRST=1
            DO 20 I=1,MXCOB
            IF(ICOB(1,I).GT.0 .AND. ICOB(2,I).GT.0 .AND. ICOB(3,I).GT.0)
     1                       THEN
               IF(IFIRST.EQ.1) THEN
                  IFIRST=0
                  IF(IUREAL(IOB).EQ.0) CALL REALUN(IOB)
                  IF(IWRFLG.GT.1) WRITE(IUMISC,'(4I6)')
     1                             (ICOB(J,I),J=1,3),IUREAL(IOB)
                  IFNUSE(IOB)=IUMOC
               ELSE
                  IF(IWRFLG.GT.1) WRITE(IUMISC,'(4I6)')
     1                             (ICOB(J,I),J=1,3),0
               END IF
            END IF
20          CONTINUE
         ELSE
            DO 30 I=1,MXCOB
            IF(ICOB(1,I).GT.0 .AND. ICOB(2,I).GT.0 .AND. ICOB(3,I).GT.0)
     1                       THEN
            IF(IUREAL(ICOBFL(I)).EQ.0) CALL REALUN(ICOBFL(I))
            IF(IWRFLG.GT.1)
     1      WRITE(IUMISC,'(4I6,A)') (ICOB(J,I),J=1,3),IUREAL(ICOBFL(I))
            IFNUSE(ICOBFL(I))=IUMOC
            END IF
30          CONTINUE
         END IF
         IF(IWRFLG.GT.1) CLOSE(UNIT=IUMISC)
      ELSE
         IUCOBS=0
      END IF
C
      RETURN
      END
