      SUBROUTINE LPFAL(IN,ITRSS,IBDSAM,NPLPF)
C
C     ******************************************************************
C     ALLOCATE ARRAY STORAGE FOR LAYER PROPERTY FLOW PACKAGE
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      COMMON /PERCOM/PERLEN(MXPER),NSTP(MXPER),TSMULT(MXPER),
     1               ISSFLG(MXPER)
      CHARACTER*14 LAYPRN(5),AVGNAM(3),TYPNAM(2),VKANAM(2),WETNAM(2),
     1            HANNAM
      COMMON /LPFCOM/LAYTYP(200),LAYAVG(200),CHANI(200),LAYVKA(200),
     1               LAYWET(200),LAYFLG(200,6)
C
      DATA AVGNAM/'      HARMONIC','   LOGARITHMIC','     LOG-ARITH'/
      DATA TYPNAM/'      CONFINED','   CONVERTIBLE'/
      DATA VKANAM/'    VERTICAL K','    ANISOTROPY'/
      DATA WETNAM/'  NON-WETTABLE','      WETTABLE'/
      DATA HANNAM/'      VARIABLE'/
      CHARACTER*80 LINE
C     ------------------------------------------------------------------
      ZERO=0.
C
C1------IDENTIFY PACKAGE
      WRITE(IOUT,1) IN
    1 FORMAT(1X,/1X,'LPF1 -- LAYER  PROPERTY FLOW PACKAGE, VERSION 1',
     1', 10/1/97',' INPUT READ FROM UNIT',I3)
C
C2------READ FIRST RECORD AND WRITE
      CALL URDCOM(IUREAL(IN),LINE,23)
      LLOC=1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,ILPFCB,R,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,I,HDRY,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NPLPF,R,IOUT,IN)
      IF(ILPFCB.LT.0) WRITE(IOUT,8)
    8 FORMAT(1X,'CONSTANT-HEAD CELL-BY-CELL FLOWS WILL BE PRINTED',
     1  ' WHEN ICLPFL IS NOT 0')
      IF(ILPFCB.GT.0) WRITE(IOUT,9) ILPFCB
    9 FORMAT(1X,'CELL-BY-CELL FLOWS WILL BE SAVED ON UNIT',I3)
      IF(ILPFCB.LT.0) ILPFCB=-1
      IUNIT2(23)=ILPFCB
      IF(ILPFCB.GT.0) THEN
         IF(FILTYP(ILPFCB).EQ.'DATA(BINARY)') THEN
            IFNUSE(ILPFCB)=IUNIT(12)
         ELSE IF(FILTYP(ILPFCB).EQ.' ') THEN
            IUNIT2(23)=0
         ELSE
            WRITE(IOUT,*)
     1 'Attempt to save CBC budget in a file that is not DATA(BINARY)'
            CALL RDABRT
         END IF
         IF((IHEDUN.GT.0 .AND. IUNIT2(23).EQ.IHEDUN) .OR.
     1      (IDDNUN.GT.0 .AND. IUNIT2(23).EQ.IDDNUN)) THEN
            WRITE(IOUT,*) 'CBC file is same as HEAD or DRAWDOWN file'
            CALL RDABRT
         END IF
      END IF
      IF(IBDSAM.EQ.-2) THEN
         IF(ILPFCB.NE.0) IBDSAM=ILPFCB
      ELSE
         IF(IBDSAM.NE.ILPFCB) IBDSAM=0
      END IF
C
      CALL VALSAV('HDRY',0,0,HDRY)
      WRITE(IOUT,11) HDRY
   11 FORMAT(1X,'HEAD AT CELLS THAT CONVERT TO DRY=',1PG13.5)
C
      WRITE(IOUT,31) NPLPF
31    FORMAT(1X,I5,' Named Parameters')
C
C  Count number of transient and steady-state stress periods and set ITRSS
      ISS=0
      ITR=0
      DO 20 N=1,NPER
      IF(ISSFLG(N).NE.0) THEN
         ISS=1
      ELSE
         ITR=1
      END IF
   20 CONTINUE
      IF(ISS.EQ.0 .AND. ITR.NE.0) THEN
         ITRSS=1
         WRITE(IOUT,3)
    3    FORMAT(1X,'TRANSIENT SIMULATION')
      ELSE IF(ISS.NE.0 .AND. ITR.EQ.0) THEN
         ITRSS=0
         WRITE(IOUT,4)
    4    FORMAT(1X,'STEADY-STATE SIMULATION')
      ELSE
         ITRSS=-1
         WRITE(IOUT,5)
    5    FORMAT(1X,'COMBINED STEADY-STATE AND TRANSIENT SIMULATION')
      END IF
C
C3------STOP THE SIMULATION IF THERE ARE MORE THAN 200 LAYERS.
   39 IF(NLAY.GT.200) THEN
         WRITE(IOUT,41)
   41    FORMAT(1X,/1X,'YOU HAVE SPECIFIED MORE THAN 200 MODEL LAYERS'/
     1 1X,'SPACE IS RESERVED FOR A MAXIMUM OF 200 LAYERS IN LPF ARRAYS')
         CALL RDABRT
      END IF
C
C4------READ LAYTYP, LAYAVG, CHANI, LAYVKA, LAYWET.
      READ(IUREAL(IN),*) (LAYTYP(K),K=1,NLAY)
      READ(IUREAL(IN),*) (LAYAVG(K),K=1,NLAY)
      READ(IUREAL(IN),*) (CHANI(K),K=1,NLAY)
      READ(IUREAL(IN),*) (LAYVKA(K),K=1,NLAY)   ! change to LAYVK()
      READ(IUREAL(IN),*) (LAYWET(K),K=1,NLAY)
C
C4A-----PRINT A TABLE OF VALUES FOR LAYTYP, LAYAVG, CHANI, LAYVKA, LAYWET.
      WRITE(IOUT,47)
   47 FORMAT(1X,/3X,'LAYER FLAGS:',/1X,
     1 'LAYER       LAYTYP        LAYAVG         CHANI ',
     2 '       LAYVKA        LAYWET',/1X,75('-'))
      DO 50 K=1,NLAY
      WRITE(IOUT,48) K,LAYTYP(K),LAYAVG(K),CHANI(K),LAYVKA(K),LAYWET(K)
   48 FORMAT(1X,I4,2I14,1PE14.3,2I14)
   50 CONTINUE
C
C4B-----BASED ON LAYTYP, LAYAVG, CHANI, LAYWET, COUNT THE NUMBER OF EACH
C4B-----TYPE OF 2-D ARRAY; CHECK VALUES FOR CONSISTENCY; AND SETUP
C4B-----POINTERS IN LAYTYP, CHANI, AND LAYWET FOR CONVENIENT ACCESS
C4B-----TO SC2, HANI, and WETDRY.  PRINT INTERPRETED VALUES OF FLAGS.
      WRITE(IOUT,57)
   57 FORMAT(1X,/3X,'INTERPRETATION OF LAYER FLAGS:',/1X,
     1  '                       INTERBLOCK     HORIZONTAL',
     2  '    DATA IN',/1X,
     3  '        LAYER TYPE   TRANSMISSIVITY   ANISOTROPY',
     4  '   ARRAY VKA   WETTABILITY',/1X,
     5  'LAYER      (LAYTYP)      (LAYAVG)       (CHANI)',
     6  '      (LAYVKA)      (LAYWET)',/1X,75('-'))
      DO 100 K=1,NLAY
      IF(LAYTYP(K).NE.0) LAYTYP(K)=1
      IF(CHANI(K).LE.ZERO) CHANI(K)=ZERO
      IF(LAYVKA(K).NE.0) LAYVKA(K)=1
      IF(LAYWET(K).NE.0) THEN
         IF(LAYTYP(K).EQ.0) THEN
            WRITE(IOUT,*)
     1          ' LAYWET is not 0 and LAYTYP is 0 for layer:',K
            WRITE(IOUT,*) ' LAYWET must be 0 if LAYTYP is 0'
            CALL RDABRT
         ELSE
            LAYWET(K)=1
         END IF
      END IF
      IF(LAYAVG(K).LT.0 .OR. LAYAVG(K).GT.2) THEN
         WRITE(IOUT,74) LAYAVG(K)
   74    FORMAT(1X,I8,
     1    ' IS AN INVALID LAYAVG VALUE -- MUST BE 0, 1, or 2')
         CALL RDABRT
      END IF
      LAYPRN(1)=TYPNAM(1)
      IF(LAYTYP(K).NE.0) LAYPRN(1)=TYPNAM(2)
      LAYPRN(2)=AVGNAM(LAYAVG(K)+1)
      IF(CHANI(K).LE.0) THEN
         LAYPRN(3)=HANNAM
      ELSE
         WRITE(LAYPRN(3),'(1PE14.3)') CHANI(K)
      END IF
      LAYPRN(4)=VKANAM(1)
      IF(LAYVKA(K).NE.0) LAYPRN(4)=VKANAM(2)
      LAYPRN(5)=WETNAM(1)
      IF(LAYWET(K).NE.0) LAYPRN(5)=WETNAM(2)
      WRITE(IOUT,78) K,(LAYPRN(I),I=1,5)
   78 FORMAT(1X,I4,5A)
  100 CONTINUE
C
C8------RETURN.
      RETURN
      END
      SUBROUTINE LPFRP(IN,ITRSS,NPLPF)
C
C     ******************************************************************
C     READ DATA FOR LAYER PROPERTY FLOW PACKAGE
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      INCLUDE 'mfi2kpar.inc'
      CHARACTER*24 ANAME(8)
      CHARACTER*4 PTYP
C
      COMMON /DISCOM/LBOTM(200),LAYCBD(200)
      COMMON /LPFCOM/LAYTYP(200),LAYAVG(200),CHANI(200),LAYVKA(200),
     1               LAYWET(200),LAYFLG(200,6)
C
      DATA ANAME(1) /'   HYD. COND. ALONG ROWS'/
      DATA ANAME(2) /'  HORIZ. ANI. (COL./ROW)'/
      DATA ANAME(3) /'     VERTICAL HYD. COND.'/
      DATA ANAME(4) /' HORIZ. TO VERTICAL ANI.'/
      DATA ANAME(5) /'CNF. BED VER. HYD. COND.'/
      DATA ANAME(6) /'        SPECIFIC STORAGE'/
      DATA ANAME(7) /'          SPECIFIC YIELD'/
      DATA ANAME(8) /'        WETDRY PARAMETER'/
C     ------------------------------------------------------------------
      ZERO=0.
C
      IWDFLG=0
      DO 10 K=1,NLAY
      IF(LAYWET(K).NE.0) IWDFLG=IWDFLG+1
   10 CONTINUE
      IF(IWDFLG.EQ.0) THEN
         WRITE(IOUT,11)
   11    FORMAT(1X,/,1X,'WETTING CAPABILITY IS NOT ACTIVE IN ANY LAYER')
      ELSE
         WRITE(IOUT,12) IWDFLG
   12    FORMAT(1X,/,1X,'WETTING CAPABILITY IS ACTIVE IN',I4,' LAYERS')
         IWDFLG=1
         READ(IUREAL(IN),*) WETFCT,IWETIT,IHDWET
         IF(IWETIT.LE.0) IWETIT=1
         WRITE(IOUT,*) ' WETTING FACTOR=',WETFCT
         WRITE(IOUT,*) ' WETTING ITERATION INTERVAL=',IWETIT
         WRITE(IOUT,*) ' IHDWET=',IHDWET
         CALL VALSAV('WETFCT',0,0,WETFCT)
         CALL IVLSAV('IWETIT',0,0,IWETIT)
         CALL IVLSAV('IHDWET',0,0,IHDWET)
      END IF
C
C-------READ NAMED PARAMETERS
      NPHK=0
      NPVKCB=0
      NPHANI=0
      NPVKA=0
      NPSS=0
      NPSY=0
      ITERP=1
      IF(NPLPF.GT.0) THEN
         DO 20 K=1,NPLPF
         CALL UPARARRRP(IN,IOUT,N,1,PTYP,ITERP)
         IF(PTYP.EQ.'HK') THEN
            NPHK=1                     ! Note that NPHK and the other NP variables in
         ELSE IF(PTYP.EQ.'VKCB') THEN  ! this group are used only as flags, not counts
            NPVKCB=1
         ELSE IF(PTYP.EQ.'HANI') THEN
            NPHANI=1
         ELSE IF(PTYP.EQ.'VK') THEN
            NPVKA=1
         ELSE IF(PTYP.EQ.'VANI') THEN
            NPVKA=1
         ELSE IF(PTYP.EQ.'SS') THEN
            NPSS=1
         ELSE IF(PTYP.EQ.'SY') THEN
            NPSY=1
         ELSE
            WRITE(IOUT,*) ' Invalid parameter type for LPF Package'
            CALL RDABRT
         END IF
C  Make the parameter global
         IACTIVE(N)=-1
   20    CONTINUE
      END IF
C
C  Make sure all CHANI=0. if NPHANI>0
      IF(NPHANI.GT.0) THEN
         DO 50 K=1,NLAY
         IF(CHANI(K).GT.0.0) THEN
            WRITE(IOUT,*)
     1        ' All CHANI must be 0 if there are HANI parameters'
            CALL RDABRT
         END IF
50       CONTINUE
      END IF
C
C2------DEFINE DATA FOR EACH LAYER -- VIA READING OR NAMED PARAMETERS.
      DO 200 K=1,NLAY
      KK=K
C
C2B-----DEFINE HORIZONTAL HYDRAULIC CONDUCTIVITY (HK)
      IF(NPHK.EQ.0) THEN
         CALL ARRMAK('HK',KK,0,NCOL,NROW)
         CALL U2DREL(ANAME(1),NROW,NCOL,KK,IN,NARRAY,IN)
         LAYFLG(K,1)=0
      ELSE
         READ(IUREAL(IN),*) LAYFLG(K,1)
         WRITE(IOUT,101) ANAME(1),K,LAYFLG(K,1)
  101    FORMAT(1X,/1X,A,' FOR LAYER',I4,
     1   ' WILL BE DEFINED BY PARAMETERS',/1X,'(PRINT FLAG=',I4,')')
      END IF
C
C2C-----READ HORIZONTAL ANISOTROPY IF CHANI IS NON-ZERO
      IF(CHANI(K).LE.ZERO) THEN
         IF(NPHANI.EQ.0) THEN
            CALL ARRMAK('CHANI',KK,0,NCOL,NROW)
            CALL U2DREL(ANAME(2),NROW,NCOL,KK,IN,NARRAY,IN)
         ELSE
            READ(IUREAL(IN),*) LAYFLG(K,6)
            WRITE(IOUT,101) ANAME(2),K,LAYFLG(K,6)
         END IF
      END IF
C
C2D-----DEFINE VERTICAL HYDRAULIC CONDUCTIVITY OR HORIZONTAL TO VERTICAL
C2D-----ANISOTROPY (VKA).
      IANAME=3
      IF(LAYVKA(K).NE.0) IANAME=4
      IF(NPVKA.EQ.0) THEN
         CALL ARRMAK('VKA',KK,0,NCOL,NROW)
         CALL U2DREL(ANAME(IANAME),NROW,NCOL,KK,IN,NARRAY,IN)
         LAYFLG(K,2)=0
      ELSE
         READ(IUREAL(IN),*) LAYFLG(K,2)
         WRITE(IOUT,101) ANAME(IANAME),K,LAYFLG(K,2)
      END IF
C
C2E-----DEFINE SPECIFIC STORAGE IN ARRAY SC1 IF TRANSIENT.
      IF(ITRSS.NE.0) THEN
         IF(NPSS.EQ.0) THEN
            CALL ARRMAK('SS',KK,0,NCOL,NROW)
            CALL U2DREL(ANAME(6),NROW,NCOL,KK,IN,NARRAY,IN)
            LAYFLG(K,3)=0
         ELSE
            READ(IUREAL(IN),*) LAYFLG(K,3)
            WRITE(IOUT,101) ANAME(6),K,LAYFLG(K,3)
         END IF
      END IF
C
C2F-----DEFINE SPECIFIC YIELD IN ARRAY SC2 IF TRANSIENT AND LAYER IS
C2F-----IS CONVERTIBLE.
      IF(LAYTYP(K).NE.0) THEN
         IF(ITRSS.NE.0) THEN
            IF(NPSY.EQ.0) THEN
               CALL ARRMAK('SY',KK,0,NCOL,NROW)
               CALL U2DREL(ANAME(7),NROW,NCOL,KK,IN,NARRAY,IN)
               LAYFLG(K,4)=0
            ELSE
               READ(IUREAL(IN),*) LAYFLG(K,4)
               WRITE(IOUT,101) ANAME(7),K,LAYFLG(K,4)
            END IF
         END IF
      END IF
C
C2G-----READ CONFINING BED VERTICAL HYDRAULIC CONDUCTIVITY (VKCB)
      IF(LAYCBD(K).NE.0) THEN
         IF(NPVKCB.EQ.0) THEN
            CALL ARRMAK('VKCB',KK,0,NCOL,NROW)
            CALL U2DREL(ANAME(5),NROW,NCOL,KK,IN,NARRAY,IN)
            LAYFLG(K,5)=0
         ELSE
            READ(IUREAL(IN),*) LAYFLG(K,5)
            WRITE(IOUT,101) ANAME(5),K,LAYFLG(K,5)
         END IF
      END IF
C
C2H-----READ WETDRY CODES IF WETTING CAPABILITY HAS BEEN INVOKED
C2H-----(LAYWET NOT 0).
      IF(LAYWET(K).NE.0) THEN
         CALL ARRMAK('WETDRY',KK,0,NCOL,NROW)
         CALL U2DREL(ANAME(8),NROW,NCOL,KK,IN,NARRAY,IN)
      END IF
  200 CONTINUE
C
C4------RETURN
      RETURN
      END
      SUBROUTINE LPFSV(IUNDEF,IWRFLG)
C
C     ******************************************************************
C     SAVE DATA FOR LPF PACKAGE
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      INCLUDE 'mfi2kpar.inc'
      COMMON /PERCOM/PERLEN(MXPER),NSTP(MXPER),TSMULT(MXPER),
     1               ISSFLG(MXPER)
      COMMON /DISCOM/LBOTM(200),LAYCBD(200)
      COMMON /LPFCOM/LAYTYP(200),LAYAVG(200),CHANI(200),LAYVKA(200),
     1               LAYWET(200),LAYFLG(200,6)
      CHARACTER*80 LINE(1)
      DIMENSION IPNUM(MXPAR)
      CHARACTER*10 MN,ZN
C     ------------------------------------------------------------------
      IF(IUNIT(23).EQ.0) THEN
         IUNDEF=-1
         RETURN
      END IF
      CTEXT(1)='Missing data for the LPF Package:'
      CTEXT(2)='------------------------------------------------------'
      NMISS=2
C
      DO 10 I=1,MXFNAM
      IF(IFNUSE(I).EQ.IUNIT(23)) IFNUSE(I)=0
10    CONTINUE
      IFNUSE(IUNIT(23))=IUNIT(23)
C
      IF(IUREAL(IUNIT(23)).EQ.0) CALL REALUN(IUNIT(23))
      IUNDEF=0
      IFIL=IUMISC
      IF(IWRFLG.LE.0) IFIL=0
      IF(IWRFLG.EQ.1) OPEN(FILE='MFI.LPF',UNIT=IFIL)
      IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUNIT(23)),UNIT=IFIL)
      ILPFCB=IBUDUN
      IF(IBUDUN.EQ.0) ILPFCB=IUNIT2(23)
      ITR=0
      DO 30 K=1,NPER
      IF(ISSFLG(K).EQ.0) ITR=1
30    CONTINUE
C
      CALL VALGET('HDRY',0,0,ITYPE,HDRY)
      IF(ITYPE.NE.0) HDRY=1.E30
      ITMP=ILPFCB
      IF(ITMP.GT.0) THEN
         IF(IUREAL(ITMP).EQ.0) CALL REALUN(ITMP)
         ITMP=IUREAL(ITMP)
      END IF
C
      NPLPF=0
      NPHK=0
      NPHANI=0
      NPVK=0
      NPVANI=0
      NPVKCB=0
      NPSS=0
      NPSY=0
      IF(IPSUM.GT.0) THEN
         DO 40 I=1,IPSUM
         IF(PARTYP(I).EQ.'HK') THEN
            NPLPF=NPLPF+1
            NPHK=1
            IPNUM(NPLPF)=I
         END IF
40       CONTINUE
         DO 42 I=1,IPSUM
         IF(PARTYP(I).EQ.'HANI') THEN
            NPLPF=NPLPF+1
            NPHANI=1
            IPNUM(NPLPF)=I
         END IF
42       CONTINUE
         DO 50 I=1,IPSUM
         IF(PARTYP(I).EQ.'VK') THEN
            NPLPF=NPLPF+1
            NPVK=1
            IPNUM(NPLPF)=I
         END IF
50       CONTINUE
         DO 52 I=1,IPSUM
         IF(PARTYP(I).EQ.'VANI') THEN
            NPLPF=NPLPF+1
            NPVANI=1
            IPNUM(NPLPF)=I
         END IF
52       CONTINUE
         DO 60 I=1,IPSUM
         IF(PARTYP(I).EQ.'VKCB') THEN
            NPLPF=NPLPF+1
            NPVKCB=1
            IPNUM(NPLPF)=I
         END IF
60       CONTINUE
         DO 70 I=1,IPSUM
         IF(PARTYP(I).EQ.'SS') THEN
            NPLPF=NPLPF+1
            NPSS=1
            IPNUM(NPLPF)=I
         END IF
70       CONTINUE
         DO 80 I=1,IPSUM
         IF(PARTYP(I).EQ.'SY') THEN
            NPLPF=NPLPF+1
            NPSY=1
            IPNUM(NPLPF)=I
         END IF
80       CONTINUE
      END IF
C
C  Write comments
      IF(IWRFLG.GT.0) THEN
         DO 88 I=1,20
         IF(COMENT(I,23)(1:1).EQ.'#') THEN
            DO 86 N=80,1,-1
            IF(COMENT(I,23)(N:N) .NE. ' ') GO TO 87
86          CONTINUE
87          WRITE(IFIL,'(A)') COMENT(I,23)(1:N)
         END IF
88       CONTINUE
      END IF
C
      IF(IWRFLG.GT.0) THEN
         IF(ABS(HDRY).LE.99999. .AND. ABS(HDRY).GE.100.) THEN
         WRITE(IFIL,'(I10,F10.2,I10,A)') ITMP,HDRY,NPLPF,
     2      '  ILPFCB,HDRY,NPLPF'
         ELSE
         WRITE(IFIL,'(I10,1P,E10.2,I10,A)') ITMP,HDRY,NPLPF,
     2      '  ILPFCB,HDRY,NPLPF'
         END IF
      END IF
C  LAYTYP, LAYAVG, CHANI, LAYVKA,LAYWET
      IF(IWRFLG.GT.0) THEN
         WRITE(IFIL,'(40I2)') (LAYTYP(I),I=1,NLAY)
         WRITE(IFIL,'(40I2)') (LAYAVG(I),I=1,NLAY)
         WRITE(IFIL,'(1P,8E10.2)') (CHANI(I),I=1,NLAY)
         WRITE(IFIL,'(40I2)') (LAYVKA(I),I=1,NLAY)
         WRITE(IFIL,'(40I2)') (LAYWET(I),I=1,NLAY)
      END IF
C
C  Write WETFCT if wetting is active
      IWET=0
      DO 90 K=1,NLAY
      IF(LAYWET(K).NE.0) IWET=1
90    CONTINUE
      IF(IWET.NE.0 .AND. IWRFLG.GT.0) THEN
         CALL IVLGET('IWETIT',0,0,ITYPE,IWETIT)
         IF(ITYPE.NE.0) IWETIT=1
         CALL IVLGET('IHDWET',0,0,ITYPE,IHDWET)
         IF(ITYPE.NE.0) IHDWET=0
         CALL VALGET('WETFCT',0,0,ITYPE,WETFCT)
         IF(ITYPE.NE.0) WETFCT=0.5
         WRITE(IFIL,'(1P,E10.2,2I10,A)') WETFCT,IWETIT,IHDWET,
     1       '  WETFCT,IWETIT,IHDWET'
      END IF
C
C  Write LPF Parameters
      IF(NPLPF.GT.0 .AND. IWRFLG.GT.0) THEN
         DO 110 I=1,NPLPF
         J=IPNUM(I)
         NCLU=IPLOC(2,J)-IPLOC(1,J)+1
         WRITE(IFIL,101) PARNAM(J),PARTYP(J),B(J),NCLU
101      FORMAT(A,1X,A,1P,E14.6,I10)
         DO 105 K=IPLOC(1,J),IPLOC(2,J)
         MN=CPCLST(1,K)
         ZN=CPCLST(2,K)
         IF(ZN.NE.'ALL') THEN
            WRITE(IFIL,102) IPCLST(1,K),MN,ZN,
     1                (IPCLST(L,K),L=3,IPCLST(2,K))
102         FORMAT(I5,1X,A,1X,A,10(1X,I4))
         ELSE
            WRITE(IFIL,102) IPCLST(1,K),MN,ZN
         END IF
105      CONTINUE
110      CONTINUE
      END IF
C
C2------WRITE ALL ARRAYS FOR EACH LAYER
      DO 200 K=1,NLAY
      KK=K
C
C2B-----HK
      IF(NPHK.EQ.0) THEN
         CALL U2DRSV('HK',KK,0,IUNDEF,IFIL,IUNIT(23),'HK',KK)
         IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
            NMISS=NMISS+1
            IUNDEF=0
            WRITE(CTEXT(NMISS),'(A,I10)') 'HK                  ',KK
         END IF
      ELSE
         IF(IWRFLG.GT.0) WRITE(IFIL,201) LAYFLG(KK,1),'HK',KK
201      FORMAT(I5,17X,A,' layer',I3)
      END IF
C
C  HANI
      IF(CHANI(K).LE.0.) THEN
         IF(NPHANI.EQ.0) THEN
            CALL U2DRSV('HANI',KK,0,IUNDEF,IFIL,IUNIT(23),'HANI',KK)
            IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
               NMISS=NMISS+1
               IUNDEF=0
               WRITE(CTEXT(NMISS),'(A,I10)') 'HANI                ',KK
            END IF
         ELSE
            IF(IWRFLG.GT.0) WRITE(IFIL,201) LAYFLG(KK,6),'HANI',KK
         END IF
      END IF
C
C  VKA
      IF(NPVK.EQ.0 .AND. NPVANI.EQ.0) THEN
         CALL U2DRSV('VKA',KK,0,IUNDEF,IFIL,IUNIT(23),'VKA',KK)
         IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
            NMISS=NMISS+1
            IUNDEF=0
            WRITE(CTEXT(NMISS),'(A,I10)') 'VKA                 ',KK
         END IF
      ELSE
         IF(IWRFLG.GT.0) WRITE(IFIL,201) LAYFLG(KK,2),'VKA',KK
      END IF
C
C Ss
      IF(ITR.NE.0) THEN
         IF(NPSS.EQ.0) THEN
            CALL U2DRSV('SS',KK,0,IUNDEF,IFIL,IUNIT(23),'SS',KK)
            IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
               NMISS=NMISS+1
               IUNDEF=0
               WRITE(CTEXT(NMISS),'(A,I10)') 'SS                  ',KK
            END IF
         ELSE
            IF(IWRFLG.GT.0) WRITE(IFIL,201) LAYFLG(KK,3),'SS',KK
         END IF
      END IF
C
C Sy
      IF(ITR.NE.0 .AND. LAYTYP(K).NE.0) THEN
         IF(NPSY.EQ.0) THEN
            CALL U2DRSV('SY',KK,0,IUNDEF,IFIL,IUNIT(23),'SY',KK)
            IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
               NMISS=NMISS+1
               IUNDEF=0
               WRITE(CTEXT(NMISS),'(A,I10)') 'SY                  ',KK
            END IF
         ELSE
             IF(IWRFLG.GT.0) WRITE(IFIL,201) LAYFLG(KK,4),'SY',KK
         END IF
      END IF
C
C2C-----VKCB if Confining bed
      IF(LAYCBD(K).NE.0) THEN
         IF(NPVKCB.EQ.0) THEN
            CALL U2DRSV('VKCB',KK,0,IUNDEF,IFIL,IUNIT(23),'VKCB',KK)
            IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
               NMISS=NMISS+1
               IUNDEF=0
               WRITE(CTEXT(NMISS),'(A,I10)') 'VKCB                ',KK
            END IF
         ELSE
            IF(IWRFLG.GT.0) WRITE(IFIL,201) LAYFLG(KK,5),'VKCB',KK
         END IF
      END IF
C
C
C2H-----WETDRY CODES IF LAYER IS WETTABLE
      IF(LAYWET(K).NE.0) THEN
         CALL U2DRSV('WETDRY',KK,0,IUNDEF,IFIL,IUNIT(23),'WETDRY',KK)
         IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
            NMISS=NMISS+1
            IUNDEF=0
            WRITE(CTEXT(NMISS),'(A,I10)') 'WETDRY              ',KK
         END IF
      END IF
  200 CONTINUE
C
      IF(IWRFLG.GT.0) CLOSE(UNIT=IFIL)
      IF(IWRFLG.LT.0) THEN
         IF(NMISS.GT.2) THEN
            CALL TXTLOG(CTEXT,NMISS)
            IUNDEF=1
         ELSE
            LINE(1)='All data are defined for the LPF Package'
            CALL TXTLOG(LINE,1)
         END IF
      END IF
C
      CALL FNMRMV
      RETURN
      END
