      SUBROUTINE FOBIN(IULOC,CPACK)
C     ******************************************************************
C     Read Flow Observations
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      COMMON /FOBCOM/LAYFOB(MXCFOB),IROWFOB(MXCFOB),ICOLFOB(MXCFOB),
     1               FOBFACT(MXCFOB),FOBSTAT(MXTFOB),FOBS(MXTFOB),
     2               IFOBST(MXTFOB),IFOBRSP(MXTFOB),FOBTOFF(MXTFOB),
     3               IFOBPLT(MXTFOB),NGFOB,NTFOB,NCFOB,NFOB(6,MXGFOB),
     4               FOBCON(2,40)
      COMMON /CFOBCOM/FOBNAM
      CHARACTER*12 FOBNAM(MXTFOB)      
      CHARACTER*(*) CPACK
      CHARACTER*200 LINE
C     ------------------------------------------------------------------
C
      IN=IUNIT(IULOC)
C
C1------IDENTIFY PROCESS AND PRINT HEADING
      WRITE (IOUT,501) CPACK,IN
  501 FORMAT (/,A,' FLOW OBSERVATIONS, ',
     &        ' INPUT READ FROM UNIT ',I3)
C
C-------READ & PRINT ITEM 1 OF THE FOB INPUT FILE
      CALL URDCOM(IUREAL(IN),LINE,IULOC)
      LLOC = 1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NQ,DUM,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NQC,DUM,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NQT,DUM,IOUT,IN)
      WRITE (IOUT,505) NQ
  505 FORMAT (/,' NUMBER OF CELL GROUPS:',I5)
      IF(NGFOB+NQ .GT. MXGFOB) THEN
         WRITE(IOUT,*)
     1   'EXCEEDS THE NUMBER OF CELL GROUPS MFI SUPPORTS:',MXGFOB
         CALL RDABRT
      END IF
C
C
C     READ ITEM 2:
      READ (IUREAL(IN),*) FOBCON(1,IULOC),FOBCON(2,IULOC),IOWTQ
      IF(IOWTQ.GT.0) THEN
         WRITE(IOUT,*)
     1     'MFI does not support reading the WTQ matrix'
         CALL RDABRT
      END IF
C
C  Read flow observations
      DO 100 I=1,NQ
      NGFOB=NGFOB+1
      NFOB(1,NGFOB)=IULOC
      READ(IUREAL(IN),*) NQOB,NQCL
      NFOB(6,NGFOB)=0
      IF(NQCL.LT.0) THEN
         NQCL=-NQCL
         NFOB(6,NGFOB)=1
      END IF
      IF(NTFOB+NQOB.GT.MXTFOB) THEN
         WRITE(IOUT,*) MXTFOB,
     1   ' is the maximum number of flow-obs. times supported by MFI'
         CALL RDABRT
      END IF
      NFOB(2,NGFOB)=NTFOB+1
      WRITE (IOUT,525) I, CPACK
  525 FORMAT (/,'   GROUP NUMBER: ',I3,'   BOUNDARY TYPE: ',A,//,
     &40X,'OBSERVED',/,
     &20X,'REFER.',16X,'FLOW',/,
     &7X,'OBSERVATION',2X,'STRESS',4X,'TIME',5X,'GAIN (-) OR',14X,
     &'STATISTIC   PLOT',/,
     &2X,'OBS#    NAME',6X,'PERIOD   OFFSET',5X,'LOSS (+)',
     &4X,'STATISTIC     TYPE      SYM.')
      DO 60 J=1,NQOB
      NTFOB=NTFOB+1
      READ(IUREAL(IN),*) FOBNAM(NTFOB),IFOBRSP(NTFOB),FOBTOFF(NTFOB),
     1             FOBS(NTFOB),FOBSTAT(NTFOB),IFOBST(NTFOB),
     2             IFOBPLT(NTFOB)
      IF(IFOBST(NTFOB).LT.0 .OR. IFOBST(NTFOB).GT.2) IFOBST(NTFOB)=0
      WRITE (IOUT,535) J,FOBNAM(NTFOB),IFOBRSP(NTFOB),FOBTOFF(NTFOB),
     1             FOBS(NTFOB),FOBSTAT(NTFOB),IFOBST(NTFOB),
     2             IFOBPLT(NTFOB)
  535 FORMAT (1X,I5,1X,A12,2X,I4,2X,G11.4,1X,G11.4,1X,G11.4,2X,I10,
     &1X,I5)
60    CONTINUE
      NFOB(3,NGFOB)=NTFOB
C
      IF(NCFOB+NQCL.GT.MXCFOB) THEN
         WRITE(IOUT,*) MXCFOB,
     1  ' is the maximum number of flow-obs. locations supported by MFI'
         CALL RDABRT
      END IF
      NFOB(4,NGFOB)=NCFOB+1
      WRITE(IOUT,540)
  540 FORMAT (/,'       LAYER  ROW  COLUMN    FACTOR')
      DO 80 J=1,NQCL
      NCFOB=NCFOB+1
      READ(IUREAL(IN),*) LAYFOB(NCFOB),IROWFOB(NCFOB),ICOLFOB(NCFOB),
     1       FOBFACT(NCFOB)
      WRITE (IOUT,550)   LAYFOB(NCFOB),IROWFOB(NCFOB),ICOLFOB(NCFOB),
     1       FOBFACT(NCFOB)
  550 FORMAT (4X,I5,I7,I8,F10.2)
      IF(LAYFOB(NCFOB).LT.1 .OR. LAYFOB(NCFOB).GT.NLAY) THEN
         WRITE(IOUT,*) ' Invalid FOB layer number'
         CALL RDABRT
      END IF
      IF(IROWFOB(NCFOB).LT.1 .OR. IROWFOB(NCFOB).GT.NROW) THEN
         WRITE(IOUT,*) ' Invalid FOB row number'
         CALL RDABRT
      END IF
      IF(ICOLFOB(NCFOB).LT.1 .OR. ICOLFOB(NCFOB).GT.NCOL) THEN
         WRITE(IOUT,*) ' Invalid FOB column number'
         CALL RDABRT
      END IF
80    CONTINUE
      NFOB(5,NGFOB)=NCFOB
C
100   CONTINUE
C
      RETURN
      END
      SUBROUTINE FOBED(IULOC,CPACK,CFEXT)
C     ******************************************************************
C     Edit Flow Observations
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
      INCLUDE 'mfi2k.inc'
      TYPE(WIN_MESSAGE)   :: MESSAGE
      COMMON /FOBCOM/LAYFOB(MXCFOB),IROWFOB(MXCFOB),ICOLFOB(MXCFOB),
     1               FOBFACT(MXCFOB),FOBSTAT(MXTFOB),FOBS(MXTFOB),
     2               IFOBST(MXTFOB),IFOBRSP(MXTFOB),FOBTOFF(MXTFOB),
     3               IFOBPLT(MXTFOB),NGFOB,NTFOB,NCFOB,NFOB(6,MXGFOB),
     4               FOBCON(2,40)
      COMMON /CFOBCOM/FOBNAM
      CHARACTER*12 FOBNAM(MXTFOB)      
      CHARACTER*(*) CPACK,CFEXT
      CHARACTER*50 LINE(200)
      DIMENSION IMENU(MXGFOB)
      CHARACTER*52 CMENU(MXGFOB)
C     ------------------------------------------------------------------
C
C  Activate OBS if not active already.
      IF(IUNIT(IULOC).EQ.0) THEN
C  Ready to activate FOB for the particular package
         CALL FINDUN(IULOC+10,IU,CPACK,CFEXT)
         IUNIT(IULOC)=IU
         FOBCON(1,IULOC)=1.0
         FOBCON(2,IULOC)=1.0
      END IF
C
C  Load the Flow Observation dialog
      CALL WDialogLoad(FOBS_DIALOG)
      CALL WDialogTitle(CPACK//' Flow Observations')
      CALL WDialogPutReal(FOBS_TOMULT,FOBCON(1,IULOC),' ')
      CALL WDialogPutReal(FOBS_EVF,FOBCON(2,IULOC),' ')
C
C  Make Dialog visible
      CALL WDialogShow(-1,50,0,SemiModeless)
C
C  Fill the menu
20    NGRP=0
      IF(NGFOB.GT.0) THEN
         DO 30 I=1,NGFOB
         IF(NFOB(1,I).EQ.IULOC) THEN
            NGRP=NGRP+1
            IMENU(NGRP)=I
            NQT=NFOB(3,I)-NFOB(2,I)+1
            NQC=NFOB(5,I)-NFOB(4,I)+1
            WRITE(CMENU(NGRP),27) NGRP,NQT,NQC
27          FORMAT('Group',I4,I10,' Observations',I10,' Locations')
         END IF
30       CONTINUE
      END IF
      IF(NGRP.GT.0) THEN
         CALL WDialogPutMenu(FOB_GROUP_MENU,CMENU,NGRP,1)
      ELSE
         CMENU(1)='(None)'
         N=1
         CALL WDialogPutMenu(FOB_GROUP_MENU,CMENU,N,1)
      END IF
C
50    CALL WMessage(ITYPE,MESSAGE)
C
C  Check for push buttons
      IF(ITYPE.EQ.PushButton) THEN
C
C  Check for FOBS_DELETE_BUT
         IF(MESSAGE%VALUE1.EQ.FOBS_DELETE_BUT) THEN
            IF(NGRP.GT.0) THEN
               CALL WDialogGetMenu(FOB_GROUP_MENU,ISEL)
               CALL FOBDEL(IMENU(ISEL))
               CALL WDialogSelect(FOBS_DIALOG)
               GO TO 20
            END IF
C
C  Check for FOBS_ADD_BUT
         ELSE IF(MESSAGE%VALUE1.EQ.FOBS_ADD_BUT) THEN
            CALL FOBGADD(IULOC)
            CALL WDialogSelect(FOBS_DIALOG)
            GO TO 20
C
C  Check for FOBS_EDIT_TIMES_BUT
         ELSE IF(MESSAGE%VALUE1.EQ.FOBS_EDIT_TIMES_BUT) THEN
            IF(NGRP.GT.0) THEN
               CALL WDialogGetMenu(FOB_GROUP_MENU,ISEL)
               CALL FOBTEDIT(IMENU(ISEL))
               CALL WDialogSelect(FOBS_DIALOG)
               GO TO 20
            END IF
C
C  Check for FOBS_EDIT_LOC_BUT
         ELSE IF(MESSAGE%VALUE1.EQ.FOBS_EDIT_LOC_BUT) THEN
            IF(NGRP.GT.0) THEN
               CALL WDialogGetMenu(FOB_GROUP_MENU,ISEL)
               CALL FOBCEDIT(IMENU(ISEL))
               CALL WDialogSelect(FOBS_DIALOG)
               GO TO 20
            END IF
C
C  Check for OK
         ELSE IF(MESSAGE%VALUE1.EQ.FOB_IDOK) THEN
            CALL WDialogGetReal(FOBS_TOMULT,FOBCON(1,IULOC))
            CALL WDialogGetReal(FOBS_EVF,FOBCON(2,IULOC))
            CALL WDialogUnload(FOBS_DIALOG)
            CALL FOBSV(IULOC,CFEXT,IUNDEF,1)
            RETURN
C
C  Check for CANCEL
         ELSE IF(MESSAGE%VALUE1.EQ.IDCANCEL) THEN
            CALL WDialogUnload(FOBS_DIALOG)
            RETURN
         END IF
C
C  Ignore all other types of message
      END IF
      GO TO 50
C
      RETURN
      END
      SUBROUTINE FOBSV(IULOC,CFEXT,IUNDEF,IWRFLG)
C     ******************************************************************
C     Save Flow Observations
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      COMMON /FOBCOM/LAYFOB(MXCFOB),IROWFOB(MXCFOB),ICOLFOB(MXCFOB),
     1               FOBFACT(MXCFOB),FOBSTAT(MXTFOB),FOBS(MXTFOB),
     2               IFOBST(MXTFOB),IFOBRSP(MXTFOB),FOBTOFF(MXTFOB),
     3               IFOBPLT(MXTFOB),NGFOB,NTFOB,NCFOB,NFOB(6,MXGFOB),
     4               FOBCON(2,40)
      COMMON /CFOBCOM/FOBNAM
      CHARACTER*12 FOBNAM(MXTFOB)      
      CHARACTER*(*) CFEXT
      CHARACTER*200 LINE
C     ------------------------------------------------------------------
C
      IF(IUNIT(IULOC).EQ.0) THEN
         IUNDEF=-1
         RETURN
      END IF
      IUNDEF=0
      IF(IWRFLG.LE.0) RETURN
C
      DO 5 I=1,MXFNAM
      IF(IFNUSE(I).EQ.IUNIT(IULOC)) IFNUSE(I)=0
5     CONTINUE
      IFNUSE(IUNIT(IULOC))=IUNIT(IULOC)
C
      IF(IUREAL(IUNIT(IULOC)).EQ.0) CALL REALUN(IUNIT(IULOC))
      IFIL=IUMISC
      IF(IWRFLG.EQ.1) OPEN(FILE='MFI.'//CFEXT,UNIT=IFIL)
      IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUNIT(IULOC)),UNIT=IFIL)
C
C  Write comments
      DO 8 I=1,20
      IF(COMENT(I,IULOC)(1:1).EQ.'#') THEN
         DO 6 N=80,1,-1
         IF(COMENT(I,IULOC)(N:N) .NE. ' ') GO TO 7
6        CONTINUE
7        WRITE(IFIL,'(A)') COMENT(I,IULOC)(1:N)
      END IF
8     CONTINUE
C
C  Count NQ, NQC, and NQT
      NQ=0
      NQC=0
      NQT=0
      DO 10 I=1,NGFOB
      IF(NFOB(1,I).EQ.IULOC) THEN
         NQ=NQ+1
         NQC=NQC+ NFOB(5,I)-NFOB(4,I)+1
         NQT=NQT+ NFOB(3,I)-NFOB(2,I)+1
      END IF
10    CONTINUE
C
C  Item 1
      WRITE(IFIL,'(3I5,A)') NQ,NQC,NQT,'  NQxx,NQCxx,NQTxx'
C
C  Item 2:
      TOMULT=FOBCON(1,IULOC)
      EVF=FOBCON(2,IULOC)
      WRITE(IFIL,'(1P,2E13.5,I5,A)') TOMULT,EVF,0,
     1                      '  TOMULTxx,EVFxx,IOWTQxx'
C
C  Item 3
      DO 100 I=1,NGFOB
      IF(NFOB(1,I).EQ.IULOC) THEN
         NQOB=NFOB(3,I)-NFOB(2,I)+1
         NQCL=NFOB(5,I)-NFOB(4,I)+1
         IF(NFOB(6,I).EQ.1) NQCL=-NQCL
         WRITE(IFIL,'(2I10,A)') NQOB,NQCL,'  NQOBxx,NQCLxx'
C  Item 4
         DO 60 J=NFOB(2,I),NFOB(3,I)
         WRITE(IFIL,'(A,I5,1P,3E14.6,2I5,A)')
     1             FOBNAM(J),IFOBRSP(J),FOBTOFF(J),FOBS(J),
     2             FOBSTAT(J),IFOBST(J),IFOBPLT(J),
     3   '  OBSNAM,IREFSP,TOFFSET,HOBS,STATISTIC,STAT-FLAG,PLOT-SYMBOL'
60       CONTINUE
C  Item 5
         DO 80 J=NFOB(4,I),NFOB(5,I)
         WRITE(IFIL,'(3I10,1P,E13.5,A)') LAYFOB(J),IROWFOB(J),
     1       ICOLFOB(J),FOBFACT(J),'  LAYER,ROW,COLUMN,FACTOR'
80       CONTINUE
C
      END IF
100   CONTINUE
C
      CLOSE(UNIT=IFIL)
      RETURN
      END
      SUBROUTINE FOBDEL(NDEL)
C     ******************************************************************
C     Delete FOB
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      COMMON /FOBCOM/LAYFOB(MXCFOB),IROWFOB(MXCFOB),ICOLFOB(MXCFOB),
     1               FOBFACT(MXCFOB),FOBSTAT(MXTFOB),FOBS(MXTFOB),
     2               IFOBST(MXTFOB),IFOBRSP(MXTFOB),FOBTOFF(MXTFOB),
     3               IFOBPLT(MXTFOB),NGFOB,NTFOB,NCFOB,NFOB(6,MXGFOB),
     4               FOBCON(2,40)
      COMMON /CFOBCOM/FOBNAM
      CHARACTER*12 FOBNAM(MXTFOB)      
C     ------------------------------------------------------------------
      NQT=NFOB(3,NDEL)-NFOB(2,NDEL)+1
      NQC=NFOB(5,NDEL)-NFOB(4,NDEL)+1
C  Move observation times
      IF(NFOB(3,NDEL).NE.NTFOB) THEN
         DO 10 I=NFOB(3,NDEL)+1,NTFOB
         NLOC=I-NQT
         FOBSTAT(NLOC)=FOBSTAT(I)
         FOBS(NLOC)=FOBS(I)
         IFOBST(NLOC)=IFOBST(I)
         IFOBRSP(NLOC)=IFOBRSP(I)
         FOBTOFF(NLOC)=FOBTOFF(I)
         IFOBPLT(NLOC)=IFOBPLT(I)
10       CONTINUE
      END IF
C  Move observation locations
      IF(NFOB(5,NDEL).NE.NCFOB) THEN
         DO 20 I=NFOB(5,NDEL)+1,NCFOB
         NLOC=I-NQC
         LAYFOB(NLOC)=LAYFOB(I)
         IROWFOB(NLOC)=IROWFOB(I)
         ICOLFOB(NLOC)=ICOLFOB(I)
         FOBFACT(NLOC)=FOBFACT(I)
20       CONTINUE
      END IF
C  Move group data
      IF(NDEL.NE.NGFOB) THEN
         DO 30 I=NDEL+1,NGFOB
         NLOC=I-1
         NFOB(1,NLOC)=NFOB(1,I)
         NFOB(2,NLOC)=NFOB(2,I)-NQT
         NFOB(3,NLOC)=NFOB(3,I)-NQT
         NFOB(4,NLOC)=NFOB(4,I)-NQC
         NFOB(5,NLOC)=NFOB(5,I)-NQC
         NFOB(6,NLOC)=NFOB(6,I)
         FOBNAM(NLOC)=FOBNAM(I)
30       CONTINUE
      END IF
C  Update counters
      NGFOB=NGFOB-1
      NTFOB=NTFOB-NQT
      NCFOB=NCFOB-NQC
      RETURN
      END
      SUBROUTINE FOBGADD(IULOC)
C     ******************************************************************
C     Add an FOB group with 0 times and 0 locations
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      COMMON /FOBCOM/LAYFOB(MXCFOB),IROWFOB(MXCFOB),ICOLFOB(MXCFOB),
     1               FOBFACT(MXCFOB),FOBSTAT(MXTFOB),FOBS(MXTFOB),
     2               IFOBST(MXTFOB),IFOBRSP(MXTFOB),FOBTOFF(MXTFOB),
     3               IFOBPLT(MXTFOB),NGFOB,NTFOB,NCFOB,NFOB(6,MXGFOB),
     4               FOBCON(2,40)
      COMMON /CFOBCOM/FOBNAM
      CHARACTER*12 FOBNAM(MXTFOB)      
      CHARACTER(50) CTXT(1)
C     ------------------------------------------------------------------
      IF(NGFOB.GE.MXGFOB) THEN
         CTXT(1)='MFI cannot handle any additional Flow Observations'
         CALL TXTLOG(CTXT,1)
         RETURN
      END IF
C
      NGFOB=NGFOB+1
      NFOB(1,NGFOB)=IULOC
      NFOB(2,NGFOB)=NTFOB+1
      NFOB(3,NGFOB)=NTFOB
      NFOB(4,NGFOB)=NCFOB+1
      NFOB(5,NGFOB)=NCFOB
      NFOB(6,NGFOB)=0
      RETURN
      END
      SUBROUTINE OBSED
C     ******************************************************************
C     Edit OBS PROCESS data
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
C
      INCLUDE 'mfi2k.inc'
C
      COMMON /OBSCOM/OUTNAM
      CHARACTER*78 OUTNAM
      PARAMETER (NSPEC=12)
      COMMON /DISCOM/LBOTM(200),LAYCBD(200)
      COMMON /MPCCOM/MPNAME,MPTYPE,CLEGND(15),CLTITL
      TYPE(WIN_MESSAGE)   :: MESSAGE
C     ------------------------------------------------------------------
      IULOC=27
C
C  Activate OBS if not active already.
      IF(IUNIT(IULOC).EQ.0) THEN
C  Ready to activate OBS
         CALL FINDUN(37,IU,'OBS','OBS')
         IUNIT(IULOC)=IU
C  Initialize OUTNAM
         OUTNAM=DSNAME(1:NDSNAM)
      END IF
C
C  Ready to edit data
      CALL WDialogLoad(OBS_DIALOG)
      CALL WDialogShow(-1,50,0,SemiModeless)
C
50    CALL WMessage(ITYPE,MESSAGE)
C
C  Check for push buttons
      IF(ITYPE.EQ.PushButton) THEN
C  All Observations BUTTON
         IF(MESSAGE%VALUE1.EQ.OBS_MISC) THEN
            CALL WDialogLoad(OBS_MISC)
            CALL WDialogPutString(OBS_OUTNAM,OUTNAM)
            CALL IVLGET('ISCALS',0,0,ITYPE,ISCALS)
            IF(ITYPE.NE.0) ISCALS=-1
            ISEL=ISCALS+2
            CALL WDialogPutOption(OBS_ISCALS,ISEL)
            CALL WDialogShow(-1,50,0,Modal)
C
            IF(WInfoDialog(ExitButton).EQ.IDOK) THEN
               CALL WDialogGetString(OBS_OUTNAM,OUTNAM)
               IF(OUTNAM.EQ.' ') OUTNAM='NONE'
               CALL WDialogGetMenu(OBS_ISCALS,ISEL)
               ISCALS=ISEL-2
               CALL IVLSAV('ISCALS',0,0,ISCALS)
            END IF
            CALL WDialogUnload(OBS_MISC)
C
         ELSE IF(MESSAGE%VALUE1.EQ.OBS_SINGLEHEAD) THEN
C  Head Observations PUSHBUTTON
            CALL HOBEDSINGTIM
C
         ELSE IF(MESSAGE%VALUE1.EQ.OBS_MULTIHEAD) THEN
C  Head Observations PUSHBUTTON
            CALL HOBEDMULTITIM
C
         ELSE IF(MESSAGE%VALUE1.EQ.OBS_GHB) THEN
C  GHB Observations PUSHBUTTON
            CALL FOBED(35,'GBOB','ogb')
C
         ELSE IF(MESSAGE%VALUE1.EQ.OBS_DRN) THEN
C  DRN Observations PUSHBUTTON
            CALL FOBED(33,'DROB','odr')
C
         ELSE IF(MESSAGE%VALUE1.EQ.OBS_RIV) THEN
C  RIV Observations PUSHBUTTON
            CALL FOBED(34,'RVOB','orv')
C
         ELSE IF(MESSAGE%VALUE1.EQ.OBS_CHD) THEN
C  CHD Observations PUSHBUTTON
            CALL FOBED(38,'CHOB','och')
C
         ELSE IF(MESSAGE%VALUE1.EQ.IDCLOSE) THEN
C  CLOSE PUSHBUTTON -- done with BAS dialog
            CALL OBSSV(IUNDEF,1)
            CALL WDialogUnload(OBS_DIALOG)
            RETURN
         END IF
         CALL WDialogSelect(OBS_DIALOG)
      END IF
      GO TO 50
C
      END
C
      SUBROUTINE OBSIN
C     ******************************************************************
C     Read OBS file
C     ******************************************************************
C
C        SPECIFICATIONS:
      INCLUDE 'mfi2k.inc'
      COMMON /OBSCOM/OUTNAM
      CHARACTER*78 OUTNAM
      CHARACTER*78 LINE
C     ------------------------------------------------------------------
      IULOC=27
      IN=IUNIT(IULOC)
C
C1------IDENTIFY PROCESS AND PRINT HEADING
      WRITE (IOUT,501) IN
  501 FORMAT (/,' OBSERVATION PACKAGE,  INPUT READ FROM UNIT ',I3)
C
C-------READ & PRINT ITEM 1 OF THE HOB INPUT FILE
      CALL URDCOM(IUREAL(IN),LINE,IULOC)
      LLOC = 1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,0,IDUM,DUM,IOUT,IN)
      OUTNAM=LINE(ISTART:ISTOP)
      WRITE(IOUT,*) 'OUTNAM: ',LINE(ISTART:ISTOP)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,ISCALS,DUM,IOUT,IN)
      IF(ISCALS.LT.0) ISCALS=-1
      IF(ISCALS.GT.3) ISCALS=-1
      WRITE(IOUT,*) 'ISCALS=',ISCALS
      CALL IVLSAV('ISCALS',0,0,ISCALS)
      RETURN
      END
      SUBROUTINE OBSSV(IUNDEF,IWRFLG)
C     ******************************************************************
C     Save OBS file
C     ******************************************************************
C
C        SPECIFICATIONS:
      INCLUDE 'mfi2k.inc'
      COMMON /OBSCOM/OUTNAM
      CHARACTER*78 OUTNAM
C     ------------------------------------------------------------------
      IULOC=27
      IF(IUNIT(IULOC).EQ.0) THEN
         IUNDEF=-1
         RETURN
      END IF
      IUNDEF=0
      IF(IWRFLG.LE.0) RETURN
C
      DO 5 I=1,MXFNAM
      IF(IFNUSE(I).EQ.IUNIT(IULOC)) IFNUSE(I)=0
5     CONTINUE
      IFNUSE(IUNIT(IULOC))=IUNIT(IULOC)
C
      IF(IUREAL(IUNIT(IULOC)).EQ.0) CALL REALUN(IUNIT(IULOC))
      IFIL=IUMISC
      IF(IWRFLG.EQ.1) OPEN(FILE='MFI.OBS',UNIT=IFIL)
      IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUNIT(IULOC)),UNIT=IFIL)
C
      CALL IVLGET('ISCALS',0,0,ITYPE,ISCALS)
      IF(ITYPE.NE.0) ISCALS=-1
C
C  Write data
      DO 100 J=78,1,-1
      IF(OUTNAM(J:J).NE.' ') GO TO 101
100   CONTINUE
      J=1
101   WRITE(IFIL,105) OUTNAM(1:J),ISCALS
105   FORMAT(A,I10,'  OUTNAM,ISCALS')
      CLOSE(UNIT=IFIL)
C
      RETURN
      END
      SUBROUTINE HOBIN()
C     ******************************************************************
C     Read Head Observations
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      COMMON /SHOBCOM/LAYSHOB(10,MXHOB),IROWSHOB(MXHOB),ICOLSHOB(MXHOB),
     1               SHROFF(MXHOB),SHCOFF(MXHOB),SHOBSTAT(MXHOB),
     2               SHOBS(MXHOB),ISHOBST(MXHOB),ISHREFSP(MXHOB),
     3               SHOBTOFF(MXHOB),ISHOBPLT(MXHOB),SHOBPR(10,MXHOB)
      COMMON /CSHOBCOM/SHOBNAM
      CHARACTER*12 SHOBNAM(MXHOB)
      COMMON /HOBCOM/LAYHOB(10,MXHOB),IROWHOB(MXHOB),ICOLHOB(MXHOB),
     1               ROFF(MXHOB),COFF(MXHOB),HOBSTAT(MXHOB),HOBS(MXHOB),
     2               IHOBST(MXHOB),IREFSP(MXHOB),HOBTOFF(MXHOB),
     3               IHOBPLT(MXHOB),ITT(MXHOB),DDSTAT(MXHOB),
     4               HOBPR(10,MXHOB)
      COMMON /CHOBCOM/HOBNAM
      CHARACTER*12 HOBNAM(MXHOB),HNAM
      CHARACTER*200 LINE
C     ------------------------------------------------------------------
C
      IULOC=28
      IN=IUNIT(IULOC)
      DO 10 I=1,MXHOB
      SHOBNAM(I)=' '
      IROWSHOB(I)=0
      ICOLSHOB(I)=0
      SHROFF(I)=0.
      SHCOFF(I)=0.
      SHOBSTAT(I)=1
      SHOBS(I)=0.
      ISHOBST(I)=1
      ISHREFSP(I)=1
      SHOBTOFF(I)=0.
      ISHOBPLT(I)=1
      HOBNAM(I)=' '
      IROWHOB(I)=0
      ICOLHOB(I)=0
      ROFF(I)=0.
      COFF(I)=0.
      HOBSTAT(I)=1
      HOBS(I)=0.
      IHOBST(I)=1
      IREFSP(I)=1
      HOBTOFF(I)=0.
      IHOBPLT(I)=1
      ITT(I)=0
      DDSTAT(I)=0.
      DO 9 J=1,10
      SHOBPR(J,I)=0.
      LAYSHOB(J,I)=0
      HOBPR(J,I)=0.
      LAYHOB(J,I)=0
9     CONTINUE
10    CONTINUE
C
C1------IDENTIFY PROCESS AND PRINT HEADING
      WRITE (IOUT,501) IN
  501 FORMAT (/,' HOB -- HEAD OBSERVATION PACKAGE, ',
     &        ' INPUT READ FROM UNIT ',I3)
C
C-------READ & PRINT ITEM 1 OF THE HOB INPUT FILE
      CALL URDCOM(IUREAL(IN),LINE,IULOC)
      LLOC = 1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NH,DUM,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,MOBS,DUM,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,MAXM,DUM,IOUT,IN)
      WRITE (IOUT,505) NH
  505 FORMAT (/,
     &   ' NUMBER OF HEAD OBSERVATIONS:',I5)
C
C
C     READ ITEM 2: CONTROLS ON PRINTING/SAVING OF SENSITIVITY ARRAYS
      READ (IUREAL(IN),*) TOMULTH,EVH
      CALL VALSAV('TOMULTH',0,0,TOMULTH)
      CALL VALSAV('EVH',0,0,EVH)
C
C  Read head observations
C  I is the number of observations as counted by MODFLOW
C  NHOB is the number of multi-time entries in the HOB list
C  NSHOB is the number of single-time observations in the SHOB list
      I=0
      NHOB=0
      NSHOB=0
11    I=I+1
C
      READ(IUREAL(IN),*) HNAM,LAYH,IROWH,ICOLH,IRSPH,TOFFH,ROFFH,
     1     COFFH,H,STATH,ISTH,IPLTH
      IF(ISTH.LT.0 .OR. ISTH.GT.2) ISTH=0
      IF(IROWH.LT.1 .OR. IROWH.GT.NROW) THEN
         WRITE(IOUT,*) ' Invalid HOB row number'
         CALL RDABRT
      END IF
      IF(ICOLH.LT.1 .OR. ICOLH.GT.NCOL) THEN
         WRITE(IOUT,*) ' Invalid HOB column number'
         CALL RDABRT
      END IF
C
      IF(IRSPH.GE.0) THEN
C  Single-time
         NSHOB=NSHOB+1
         IF(NSHOB.GT.MXHOB) THEN
            WRITE(IOUT,*) MXHOB,
     1    ' is the maximum number of single-time HOBS supported by MFI'
            CALL RDABRT
         END IF
C
         DO 20 J=1,10
         LAYSHOB(J,NSHOB)=0
         SHOBPR(J,NSHOB)=0.
20       CONTINUE
         SHOBNAM(NSHOB)=HNAM
         LAYSHOB(1,NSHOB)=LAYH
         IROWSHOB(NSHOB)=IROWH
         ICOLSHOB(NSHOB)=ICOLH
         ISHREFSP(NSHOB)=IRSPH
         SHOBTOFF(NSHOB)=TOFFH
         SHROFF(NSHOB)=ROFFH
         SHCOFF(NSHOB)=COFFH
         SHOBS(NSHOB)=H
         SHOBSTAT(NSHOB)=STATH
         ISHOBST(NSHOB)=ISTH+1
         ISHOBPLT(NSHOB)=IPLTH
C
C  Read layers if multi-layer
         IF(LAYSHOB(1,NSHOB).LT.0) THEN
            NL=-LAYSHOB(1,NSHOB)
            IF(NL.GT.10) THEN
               WRITE(IOUT,*)
     1   ' MFI does not allow multi-layer HOBS in more than 10 layers.'
               CALL RDABRT
            END IF
            READ(IUREAL(IN),*) (LAYSHOB(J,NSHOB),SHOBPR(J,NSHOB),J=1,NL)
            DO 22 J=1,NL
            IF(LAYSHOB(J,NSHOB).LT.1 .OR. LAYSHOB(J,NSHOB).GT.NLAY) THEN
               WRITE(IOUT,*) ' Invalid HOB layer number'
               CALL RDABRT
            END IF
22          CONTINUE
         ELSE
            IF(LAYSHOB(1,NSHOB).LT.1 .OR. LAYSHOB(1,NSHOB).GT.NLAY) THEN
              WRITE(IOUT,*) ' Invalid HOB layer number'
               CALL RDABRT
            END IF
         END IF
C
      ELSE
C  Read times if multi-times
         NHOB=NHOB+1
         IF(NHOB.GT.MXHOB) THEN
            WRITE(IOUT,*) MXHOB,
     1      ' is the maximum number of multi-time HOBS supported by MFI'
            CALL RDABRT
         END IF
C
         DO 25 J=1,10
         LAYHOB(J,NHOB)=0
         HOBPR(J,NHOB)=0.
25       CONTINUE
C
         HOBNAM(NHOB)=HNAM
         LAYHOB(1,NHOB)=LAYH
         IROWHOB(NHOB)=IROWH
         ICOLHOB(NHOB)=ICOLH
         IREFSP(NHOB)=IRSPH
         HOBTOFF(NHOB)=TOFFH
         ROFF(NHOB)=ROFFH
         COFF(NHOB)=COFFH
         HOBS(NHOB)=H
         HOBSTAT(NHOB)=STATH
         IHOBST(NHOB)=ISTH+1
         IHOBPLT(NHOB)=IPLTH
C
C  Read layers if multi-layer
         IF(LAYHOB(1,NHOB).LT.0) THEN
            NL=-LAYHOB(1,NHOB)
            IF(NL.GT.10) THEN
               WRITE(IOUT,*)
     1   ' MFI does not allow multi-layer HOBS in more than 10 layers.'
               CALL RDABRT
            END IF
            READ(IUREAL(IN),*) (LAYHOB(J,NHOB),HOBPR(J,NHOB),J=1,NL)
            DO 32 J=1,NL
            IF(LAYHOB(J,NHOB).LT.1 .OR. LAYHOB(J,NHOB).GT.NLAY) THEN
               WRITE(IOUT,*) ' Invalid HOB layer number'
               CALL RDABRT
            END IF
32          CONTINUE
         ELSE
            IF(LAYHOB(1,NHOB).LT.1 .OR. LAYHOB(1,NHOB).GT.NLAY) THEN
              WRITE(IOUT,*) ' Invalid HOB layer number'
               CALL RDABRT
            END IF
         END IF
C
C  Set ITT=1 for multitime header with head as the observation
C  Set ITT=2 for multitime header with drawdown as the observation
C  Set ITT=3 for a multitime item 6 record
         NT=-IREFSP(NHOB)
         READ(IUREAL(IN),*) ITT(NHOB)
         IF(ITT(NHOB).NE.2) ITT(NHOB)=1
         DO 60 J=1,NT
         NHOB=NHOB+1
         IF(J.NE.1) I=I+1
         IF(NHOB.GT.MXHOB) THEN
            WRITE(IOUT,*) MXHOB,
     1      ' is the maximum number of HOBS supported by MFI'
            CALL RDABRT
         END IF
         READ(IUREAL(IN),*) HOBNAM(NHOB),IREFSP(NHOB),HOBTOFF(NHOB),
     1             HOBS(NHOB),HOBSTAT(NHOB),DDSTAT(NHOB),ISTH,
     2             IHOBPLT(NHOB)
         IF(ISTH.LT.0 .OR. ISTH.GT.2) ISTH=0
         IHOBST(NHOB)=ISTH+1
         IROWHOB(NHOB)=0
         ICOLHOB(NHOB)=0
         ITT(NHOB)=3
60       CONTINUE
      END IF
C
      IF(I.LT.NH) GO TO 11
C
      RETURN
      END
      SUBROUTINE HOBSV(IUNDEF,IWRFLG)
C     ******************************************************************
C     Save HOB data
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      COMMON /SHOBCOM/LAYSHOB(10,MXHOB),IROWSHOB(MXHOB),ICOLSHOB(MXHOB),
     1               SHROFF(MXHOB),SHCOFF(MXHOB),SHOBSTAT(MXHOB),
     2               SHOBS(MXHOB),ISHOBST(MXHOB),ISHREFSP(MXHOB),
     3               SHOBTOFF(MXHOB),ISHOBPLT(MXHOB),SHOBPR(10,MXHOB)
      COMMON /CSHOBCOM/SHOBNAM
      CHARACTER*12 SHOBNAM(MXHOB)
      COMMON /HOBCOM/LAYHOB(10,MXHOB),IROWHOB(MXHOB),ICOLHOB(MXHOB),
     1               ROFF(MXHOB),COFF(MXHOB),HOBSTAT(MXHOB),HOBS(MXHOB),
     2               IHOBST(MXHOB),IREFSP(MXHOB),HOBTOFF(MXHOB),
     3               IHOBPLT(MXHOB),ITT(MXHOB),DDSTAT(MXHOB),
     4               HOBPR(10,MXHOB)
      COMMON /CHOBCOM/HOBNAM
      CHARACTER*12 HOBNAM(MXHOB)      
C     ------------------------------------------------------------------
      IULOC=28
      IF(IUNIT(IULOC).EQ.0) THEN
         IUNDEF=-1
         RETURN
      END IF
      IUNDEF=0
      IF(IWRFLG.LE.0) RETURN
C
      DO 5 I=1,MXFNAM
      IF(IFNUSE(I).EQ.IUNIT(IULOC)) IFNUSE(I)=0
5     CONTINUE
      IFNUSE(IUNIT(IULOC))=IUNIT(IULOC)
C
      IF(IUREAL(IUNIT(IULOC)).EQ.0) CALL REALUN(IUNIT(IULOC))
      IFIL=IUMISC
      IF(IWRFLG.EQ.1) OPEN(FILE='MFI.HOB',UNIT=IFIL)
      IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUNIT(IULOC)),UNIT=IFIL)
C
C  Write comments
      DO 8 I=1,20
      IF(COMENT(I,IULOC)(1:1).EQ.'#') THEN
         DO 6 N=80,1,-1
         IF(COMENT(I,IULOC)(N:N) .NE. ' ') GO TO 7
6        CONTINUE
7        WRITE(IFIL,'(A)') COMENT(I,IULOC)(1:N)
      END IF
8     CONTINUE
C
C  Count observations
      NH=0
      MOBS=0
      MAXM=0
C
      DO 10 I=1,MXHOB
C  Single time
      IF(SHOBNAM(I).NE.' ') THEN
         NH=NH+1
         NL=0
         DO 9 J=1,10
         IF(LAYSHOB(J,I).GT.0) NL=NL+1
9        CONTINUE
         IF(NL.GT.MAXM) MAXM=NL
         IF(NL.GT.1) MOBS=MOBS+1
      END IF
C  Multi-Time
      IF(HOBNAM(I).NE.' ') THEN
         IF(ITT(I).NE.3) THEN
            NLM=0
            DO 11 J=1,10
            IF(LAYHOB(J,I).GT.0) NLM=NLM+1
11          CONTINUE
            IF(NLM.GT.MAXM) MAXM=NLM
         END IF
         IF(ITT(I).EQ.3) THEN
            NH=NH+1
            IF(NLM.GT.1) MOBS=MOBS+1
            IREFSP(IHEAD)=IREFSP(IHEAD)-1
         ELSE
            IHEAD=I
            IREFSP(IHEAD)=0
         END IF
      END IF
10    CONTINUE
C
      CALL VALGET('TOMULTH',0,0,ITYPE,TOMULTH)
      IF(ITYPE.NE.0) TOMULTH=1.
      CALL VALGET('EVH',0,0,ITYPE,EVH)
      IF(ITYPE.NE.0) EVH=1.
C
C  Write items 1 and 2
      IF(MOBS.EQ.0) MAXM=0
      WRITE(IFIL,105) NH,MOBS,MAXM
105   FORMAT(3I10,'  NH,MOBS,MAXM')
      WRITE(IFIL,106) TOMULTH,EVH
106   FORMAT(1P,2E13.5,'  TOMULTH,EVH')
C
C  Write Single-Time Observations
      DO 200 I=1,MXHOB
      IF(SHOBNAM(I).NE.' ') THEN
         NL=0
         DO 150 J=1,10
         IF(LAYSHOB(J,I).GT.0) NL=NL+1
150      CONTINUE
C  Item 3
         IF(NL.EQ.1) THEN
            WRITE(IFIL,107) SHOBNAM(I),LAYSHOB(1,I),IROWSHOB(I),
     1            ICOLSHOB(I),ISHREFSP(I),SHOBTOFF(I),SHROFF(I),
     2            SHCOFF(I),SHOBS(I),SHOBSTAT(I),ISHOBST(I)-1,
     3            ISHOBPLT(I)
107         FORMAT(A,4I5,1P,5E14.6,I5,I5)
         ELSE
            WRITE(IFIL,107) SHOBNAM(I),-NL,IROWSHOB(I),
     1            ICOLSHOB(I),ISHREFSP(I),SHOBTOFF(I),SHROFF(I),
     2            SHCOFF(I),SHOBS(I),SHOBSTAT(I),ISHOBST(I)-1,
     3            ISHOBPLT(I)
C  Item 4
            WRITE(IFIL,'(1P,10(I5,E13.5))')
     1          (LAYSHOB(J,I),SHOBPR(J,I),J=1,NL)
         END IF
      END IF
200   CONTINUE
C
C  Write Multi-Time Observations
      DO 300 I=1,MXHOB
      IF(HOBNAM(I).NE.' ') THEN
      IF(ITT(I).LT.3) THEN
         NL=0
         DO 250 J=1,10
         IF(LAYHOB(J,I).GT.0) NL=NL+1
250      CONTINUE
         IF(NL.EQ.1) THEN
            WRITE(IFIL,107) HOBNAM(I),LAYHOB(1,I),IROWHOB(I),ICOLHOB(I),
     1            IREFSP(I),HOBTOFF(I),ROFF(I),COFF(I),HOBS(I),
     2            HOBSTAT(I),IHOBST(I)-1,IHOBPLT(I)
         ELSE
            WRITE(IFIL,107) HOBNAM(I),-NL,IROWHOB(I),ICOLHOB(I),
     1            IREFSP(I),HOBTOFF(I),ROFF(I),COFF(I),HOBS(I),
     2            HOBSTAT(I),IHOBST(I)-1,IHOBPLT(I)
C  Item 4
            WRITE(IFIL,'(1P,10(I5,E13.5))')
     1          (LAYHOB(J,I),HOBPR(J,I),J=1,NL)
         END IF
C  Item 5
         IF(IREFSP(I).LT.0) WRITE(IFIL,'(I5)') ITT(I)
      ELSE
C  Item 6
         WRITE(IFIL,258) HOBNAM(I),IREFSP(I),HOBTOFF(I),HOBS(I),
     2         HOBSTAT(I),DDSTAT(I),IHOBST(I)-1,IHOBPLT(I)
258      FORMAT(A,I5,1P,4E13.5,I5,I5)
      END IF
      END IF
300   CONTINUE
C
      CLOSE(UNIT=IFIL)
C
      RETURN
      END
      SUBROUTINE SENED
C     ******************************************************************
C     Edit SEN PROCESS data
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
      INCLUDE 'mfi2k.inc'
      INCLUDE 'mfi2kpar.inc'
      DIMENSION LOCPS(MXPAR),BS(MXPAR),B2S(MXPAR),ISENSS(MXPAR),
     1               LNS(MXPAR),BLS(MXPAR),BUS(MXPAR),BSCALS(MXPAR)
      CHARACTER*10 PARNAMS(MXPAR)
C
      TYPE(WIN_MESSAGE)   :: MESSAGE
      CHARACTER*65 CTMP(1)
      CHARACTER*78 FN
      CHARACTER*18 FTYP
C     ------------------------------------------------------------------
      IULOC=25
C
C  Activate SEN if not active already.
      IF(IUNIT(IULOC).EQ.0) THEN
C  Ready to activate SEN
         CALL FINDUN(35,IU,'SEN','SEN')
         IUNIT(IULOC)=IU
         ISENALL=0
         IUHEAD=0
         IPRINTS=0
         ISENSU=0
         ISENPU=0
         ISENFM=0
         CALL IVLSAV('ISENAL',0,0,ISENALL)
         CALL IVLSAV('IUHEAD',0,0,IUHEAD)
         CALL IVLSAV('IPRNTS',0,0,IPRINTS)
         CALL IVLSAV('ISENSU',0,0,ISENSU)
         CALL IVLSAV('ISENPU',0,0,ISENPU)
         CALL IVLSAV('ISENFM',0,0,ISENFM)
      END IF
      IUSEN=IUNIT(IULOC)
C
C See if there are no parameters, exit
      IF(IPSUM.LE.0) THEN
         CTMP(1)='No parameters have been defined'
         CALL TXTLOG(CTMP,1)
         RETURN
      END IF
C
C  Ready to edit data
      CALL WDialogLoad(SEN_DIALOG)
      CALL IVLGET('ISENAL',0,0,ITYPE,ISENALL)
      IF(ITYPE.NE.0) ISENALL=0
      IF(ISENALL.EQ.0) THEN
         CALL WDialogPutOption(SEN_ISENALL,1)
      ELSE IF(ISENALL.GT.0) THEN
         CALL WDialogPutOption(SEN_ISENALL,2)
      ELSE
         CALL WDialogPutOption(SEN_ISENALL,3)
      END IF
      CALL IVLGET('IPRNTS',0,0,ITYPE,IPRINTS)
      IF(ITYPE.NE.0) IPRINTS=0
      ISEL=IPRINTS+1
      CALL WDialogPutOption(SEN_IPRINTS,ISEL)
      CALL IVLGET('ISENFM',0,0,ITYPE,ISENFM)
      IF(ITYPE.NE.0) ISENFM=0
      CALL WDialogPutInteger(SEN_ISENFM,ISENFM)
      CALL IVLGET('ISENSU',0,0,ITYPE,ISENSU)
      IF(ITYPE.NE.0) ISENSU=0
      FN=' '
      IF(ISENSU.GT.0) FN=FILNAM(ISENSU)
      CALL WDialogPutString(SEN_SAVEFILE,FN)
      CALL IVLGET('ISENPU',0,0,ITYPE,ISENPU)
      IF(ITYPE.NE.0) ISENPU=0
      FN=' '
      IF(ISENPU.GT.0) FN=FILNAM(ISENPU)
      CALL WDialogPutString(SEN_PRINTFILE,FN)
10    IPSUMS=0
      IF(IPSUM.GT.0) THEN
         DO 20 I=1,IPSUM
         IF(ISFILE(I).NE.0) THEN
            IPSUMS=IPSUMS+1
            LOCPS(IPSUMS)=I
            PARNAMS(IPSUMS)=PARNAM(I)
            ISENSS(IPSUMS)=ISENS(I)
            LNS(IPSUMS)=LN(I)
            BS(IPSUMS)=B(I)
            B2S(IPSUMS)=B2(I)
            BLS(IPSUMS)=BL(I)
            BUS(IPSUMS)=BU(I)
            BSCALS(IPSUMS)=BSCAL(I)
            IF(BSCALS(IPSUMS).EQ.0.0)
     1                 BSCALS(IPSUMS)= ABS(B2S(IPSUMS))/100.
         END IF
20       CONTINUE
      END IF
      IF(IPSUMS.GT.0) THEN
         CALL WGridRows(SEN_DIALOG_GRID,IPSUMS)
         CALL WGridPutString(SEN_DIALOG_GRID,1,PARNAMS,IPSUMS)
         CALL WGridPutCheckBox(SEN_DIALOG_GRID,2,ISENSS,IPSUMS)
         CALL WGridPutCheckBox(SEN_DIALOG_GRID,3,LNS,IPSUMS)
         CALL WGridPutReal(SEN_DIALOG_GRID,4,B2S,IPSUMS)
         CALL WGridPutReal(SEN_DIALOG_GRID,5,BS,IPSUMS)
         CALL WGridPutReal(SEN_DIALOG_GRID,6,BLS,IPSUMS)
         CALL WGridPutReal(SEN_DIALOG_GRID,7,BUS,IPSUMS)
         CALL WGridPutReal(SEN_DIALOG_GRID,8,BSCALS,IPSUMS)
      ELSE
         CALL WGridRows(SEN_DIALOG_GRID,1)
         CALL WDialogClearField(SEN_DIALOG_GRID)
         PARNAMS(1)='(None)'
         CALL WGridPutString(SEN_DIALOG_GRID,1,PARNAMS,1)
      END IF
      CALL WDialogShow(-1,50,0,Modal)
C
      IF(WInfoDialog(ExitButton).EQ.SEN_SELECT_PARAMETERS) THEN
         CALL SENSEL
         CALL WDialogSelect(SEN_DIALOG)
         GO TO 10
      ELSE IF(WInfoDialog(ExitButton).EQ.IDOK) THEN
         CALL WDialogGetMenu(SEN_ISENALL,IS)
         IF(IS.EQ.2) THEN
            ISENALL=1
         ELSE IF(IS.EQ.3) THEN
            ISENALL=-1
         ELSE
            ISENALL=0
         END IF
         CALL IVLSAV('ISENAL',0,0,ISENALL)
         CALL WDialogGetMenu(SEN_IPRINTS,ISEL)
         IPRINTS=ISEL-1
         CALL IVLSAV('IPRNTS',0,0,IPRINTS)
         CALL WDialogGetInteger(SEN_ISENFM,ISENFM)
         CALL IVLSAV('ISENFM',0,0,ISENFM)
C  Process the sensitivity save file name
         CALL WDialogGetString(SEN_SAVEFILE,FN)
         CALL USTLFT(FN,78)
         IF(IUCASE.NE.0) CALL USTRUC(FN,78)
         IF(FN.EQ.' ') THEN
            IF(ISENSU.GT.0) THEN
               IFNUSE(ISENSU)=0
               ISENSU=0
            END IF
         ELSE
            FTYP='DATA'
            IF(CHEDFM.EQ.'(BINARY)') FTYP='DATA(BINARY)'
            CALL FNMSV3(FN,IUTMP,FTYP,IUSEN,-1)
            IF(IUTMP.LE.0) THEN
               CALL WDialogSelect(SEN_DIALOG)
               GO TO 10
            END IF
            IF(IUTMP.EQ.ISENPU) THEN
               CTMP(1)=
     1 'Same file cannot be used for printing and saving sensitivities'
               CALL TXTLOG(CTMP,1)
               CALL WDialogSelect(SEN_DIALOG)
               GO TO 10
            END IF
            IF(IUTMP.EQ.IUSEN) THEN
               CTMP(1)='Sensitivities cannot be saved in the SEN file'
               CALL TXTLOG(CTMP,1)
               CALL WDialogSelect(SEN_DIALOG)
               GO TO 10
            END IF
C  Set the unused flag for the old sensu file unless the file is the
C  same as it was previously.
            IF(IUTMP.NE.ISENSU .AND. ISENSU.GT.0) IFNUSE(ISENSU)=0
            ISENSU=IUTMP
         END IF
         CALL IVLSAV('ISENSU',0,0,ISENSU)
C
C  Process the sensitivity print file name
         CALL WDialogGetString(SEN_PRINTFILE,FN)
         CALL USTLFT(FN,78)
         IF(IUCASE.NE.0) CALL USTRUC(FN,78)
         IF(FN.EQ.' ') THEN
            IF(ISENPU.GT.0) THEN
               IFNUSE(ISENPU)=0
               ISENPU=0
            END IF
         ELSE
            IF(ILOUT.GT.0) THEN
               IF(FILNAM(ILOUT).EQ.FN) THEN
                  IF(ISENPU.GT.0 .AND. ISENPU.NE.ILOUT .AND.
     1               ISENPU.NE.IGOUT) IFNUSE(ISENPU)=0
                  ISENPU=ILOUT
                  GO TO 28
               END IF
            END IF
            IF(IGOUT.GT.0) THEN
               IF(FILNAM(IGOUT).EQ.FN) THEN
                  IF(IGOUT.NE.ISENPU .AND. ISENPU.GT.0 .AND.
     1               ISENPU.NE.ILOUT) IFNUSE(ISENPU)=0
                  ISENPU=IGOUT
                  GO TO 28
               END IF
            END IF

            FTYP='DATA'
            CALL FNMSV3(FN,IUTMP,FTYP,IUSEN,-1)
            IF(IUTMP.LE.0) THEN
               CALL WDialogSelect(SEN_DIALOG)
               GO TO 10
            END IF
            IF(IUTMP.EQ.ISENSU) THEN
               CTMP(1)=
     1 'Same file cannot be used for printing and saving sensitivities'
               CALL TXTLOG(CTMP,1)
               CALL WDialogSelect(SEN_DIALOG)
               GO TO 10
            END IF
            IF(IUTMP.EQ.IUSEN) THEN
               CTMP(1)='Sensitivities cannot be printed to the SEN file'
               CALL TXTLOG(CTMP,1)
               CALL WDialogSelect(SEN_DIALOG)
               GO TO 10
            END IF
C  Set the unused flag for the old senpu file unless the file is the
C  same as it was previously.
            IF(IUTMP.NE.ISENPU .AND. ISENPU.GT.0 .AND.
     1         ISENPU.NE.ILOUT .AND. ISENPU.NE.IGOUT) IFNUSE(ISENPU)=0
            ISENPU=IUTMP
         END IF
28       CALL IVLSAV('ISENPU',0,0,ISENPU)
C
         IF(IPSUMS.GT.0) THEN
            N=IPSUMS
            CALL WGridGetCheckBox(SEN_DIALOG_GRID,2,ISENSS,N)
            CALL WGridGetCheckBox(SEN_DIALOG_GRID,3,LNS,N)
            CALL WGridGetReal(SEN_DIALOG_GRID,4,B2S,N)
            CALL WGridGetReal(SEN_DIALOG_GRID,6,BLS,N)
            CALL WGridGetReal(SEN_DIALOG_GRID,7,BUS,N)
            CALL WGridGetReal(SEN_DIALOG_GRID,8,BSCALS,N)
            DO 30 I=1,IPSUMS
               ISENS(LOCPS(I))=ISENSS(I)
               LN(LOCPS(I))=LNS(I)
               B2(LOCPS(I))=B2S(I)
               BL(LOCPS(I))=BLS(I)
               BU(LOCPS(I))=BUS(I)
               BSCAL(LOCPS(I))=BSCALS(I)
30          CONTINUE
         END IF
         CALL SENSV(IUNDEF,1)
      END IF
C
      CALL WDialogUnload(SEN_DIALOG)
      RETURN
C
      END
      SUBROUTINE SENSEL
C     ******************************************************************
C     Select parameters to be included in SEN file
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
      INCLUDE 'mfi2k.inc'
      INCLUDE 'mfi2kpar.inc'
C
      TYPE(WIN_MESSAGE)   :: MESSAGE
C     ------------------------------------------------------------------
      CALL WDialogLoad(SEN_PARAMETERS_DIALOG)
      CALL WGridRows(SEN_PARAMETERS_GRID,IPSUM)
      CALL WGridPutString(SEN_PARAMETERS_GRID,1,PARNAM,IPSUM)
      CALL WGridPutCheckBox(SEN_PARAMETERS_GRID,2,ISFILE,IPSUM)
      CALL WDialogShow(-1,50,0,Modal)
C
      IF(WInfoDialog(ExitButton).EQ.IDOK) THEN
         N=IPSUM
         CALL WGridGetCheckBox(SEN_PARAMETERS_GRID,2,ISFILE,N)
      END IF
      CALL WDialogUnload(SEN_PARAMETERS_DIALOG)
C
      RETURN
C
      END
      SUBROUTINE SENIN()
C     ******************************************************************
C     Read Sensitivity file
C     ******************************************************************
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      INCLUDE 'mfi2kpar.inc'
      CHARACTER*200 LINE
      CHARACTER*10 PN,PNI
      CHARACTER*18 FTYP
C     ------------------------------------------------------------------
      IULOC=25
      IN=IUNIT(IULOC)
C
C1------IDENTIFY PROCESS AND PRINT HEADING
      WRITE (IOUT,501) IN
  501 FORMAT (/,' SENBAS1 -- SENSITIVITY PROCESS, ',
     &        'VERSION 1.0, 10/15/98',/,' INPUT READ FROM UNIT ',I3)
C
C-------READ & PRINT ITEM 1 OF THE SEN INPUT FILE
      CALL URDCOM(IUREAL(IN),LINE,IULOC)
      LLOC = 1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NPLIST,DUM,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,ISENALL,DUM,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IUHEAD,DUM,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,MXSEN,DUM,IOUT,IN)
      CALL IVLSAV('ISENAL',0,0,ISENALL)
      CALL IVLSAV('IUHEAD',0,0,IUHEAD)
      WRITE (IOUT,505) NPLIST
  505 FORMAT (/,
     &   ' NUMBER OF PARAMETER VALUES TO BE READ FROM SEN FILE:',I5)
C
      WRITE (IOUT,560) ISENALL
  560 FORMAT (' ISENALL............................................:',
     &        I5)
C
      IF (IUHEAD.GT.0) THEN
        WRITE (IOUT,600)
  600   FORMAT(' SENSITIVITIES WILL BE STORED IN SCRATCH FILES')
      ELSE
        WRITE (IOUT,620)
  620   FORMAT(' SENSITIVITIES WILL BE STORED IN MEMORY')
      ENDIF
      WRITE (IOUT,630) MXSEN
  630 FORMAT(' FOR UP TO ',I3,' PARAMETERS')
C
C     READ ITEM 2: CONTROLS ON PRINTING/SAVING OF SENSITIVITY ARRAYS
      READ (IUREAL(IN),*) IPRINTS, ISENSU, ISENPU, ISENFM
      IF(IPRINTS.NE.0 .AND. IPRINTS.NE.1) IPRINTS=0
      CALL IVLSAV('IPRNTS',0,0,IPRINTS)
      CALL IVLSAV('ISENFM',0,0,ISENFM)
C Check ISENSU
      IF(ISENSU.GT.0) THEN
         FTYP='DATA'
         IF(CHEDFM.EQ.'(BINARY)') FTYP='DATA(BINARY)'
         IF(FILTYP(ISENSU).EQ.FTYP) THEN
            IF(IFNUSE(ISENSU).LE.0) THEN
               IFNUSE(ISENSU)=IN
            ELSE
               WRITE(IOUT,*)
     1       'Sensitivity save file already being used outside of SEN'
               CALL RDABRT
            END IF
         ELSE IF(FILTYP(ISENSU).EQ.' ') THEN
            ISENSU=0
         ELSE
            WRITE(IOUT,*)
     1     'Attempt to use the wrong file type for saving sensitivity'
            CALL RDABRT
         END IF
         CALL IVLSAV('ISENSU',0,0,ISENSU)
      END IF
C Check ISENPU
      IF(ISENPU.GT.0) THEN
        IF(ISENPU.NE.ILOUT .AND. ISENPU.NE.IGOUT) THEN
          FTYP='DATA'
          IF(FILTYP(ISENPU).EQ.FTYP) THEN
             IF(IFNUSE(ISENPU).LE.0) THEN
                IFNUSE(ISENPU)=IN
             ELSE
                WRITE(IOUT,*)
     1       'Sensitivity save file already being used outside of SEN'
                CALL RDABRT
             END IF
          ELSE IF(FILTYP(ISENPU).EQ.' ') THEN
             ISENPU=0
          ELSE
             WRITE(IOUT,*)
     1     'Attempt to use the wrong file type for saving sensitivity'
             CALL RDABRT
          END IF
        END IF
        CALL IVLSAV('ISENPU',0,0,ISENPU)
      END IF
C
      IF (ISENSU.GT.0 .OR. ISENPU.GT.0) THEN
        IF (IPRINTS.EQ.0) THEN
          WRITE (IOUT,730)
  730 FORMAT (1X,'OUTPUT CONTROL FILE WILL CONTROL PRINTING/SAVING',
     &' OF SENSITIVITY ARRAYS')
        ELSEIF (IPRINTS.EQ.1) THEN
          WRITE (IOUT,740)
  740 FORMAT (1X,'SENSITIVITY ARRAYS WILL BE PRINTED AND/OR SAVED FOR',
     &' ALL TIME STEPS')
        ENDIF
      ELSE
        WRITE (IOUT,660)
  660 FORMAT (1X,'SENSITIVITY ARRAYS WILL NOT BE PRINTED OR SAVED')
      ENDIF
C
          IF (ISENSU.GT.0) WRITE (IOUT,760) ISENSU
  760 FORMAT(1X,'BINARY SENSITIVITY ARRAYS WILL BE SAVED TO UNIT ',I4)
          IF (ISENPU.GT.0) WRITE (IOUT,770) ISENPU, ISENFM
  770 FORMAT(1X,'SENSITIVITY ARRAYS WILL BE PRINTED TO UNIT ',I4,
     &       ' USING FORMAT CODE ',I3)
  850 FORMAT(/,1X,57('*'),/,
     &       6X,'USE OF THE ',A3,' PACKAGE IS INCOMPATIBLE WITH THE',/,
     &       6X,'SENSITIVITY PROCESS',/,
     &       6X,'-- STOP EXECUTION',/,1X,57('*'))
C
C-----READ ITEM 3:  LIST OF PARAMETER INFORMATION
      IF (NPLIST.GT.0) THEN
        WRITE (IOUT,520)
 520  FORMAT (/,' INFORMATION ON PARAMETERS LISTED IN SEN FILE',/,
     &   43X,'LOWER',9X,'UPPER',/
     &   26X,'VALUE IN SEN   REASONABLE    REASONABLE',/,
     &   '    NAME      ISENS   LN   INPUT FILE      LIMIT  ',
     &   '       LIMIT',/,
     &   ' ----------  -------  --  ------------  ------------',
     &   '  ------------')
        DO 500 N=1,NPLIST
          READ(IUREAL(IN),*) PN,ISENSTMP,LNTMP,BTMP,BLTMP,BUTMP,BSTMP
          WRITE(IOUT,570) PN,ISENSTMP,LNTMP,BTMP,BLTMP,BUTMP,BSTMP
 570      FORMAT(1X,A10,4X,I2,5X,I2,4(2X,G12.5))
          IF(ISENSTMP.NE.0) ISENSTMP=1
C
C---------Find parameter in list of parameters
          CALL UPCASE(PN)
          IF(IPSUM.GT.0) THEN
            DO 100 I=1,IPSUM
            PNI=PARNAM(I)
            CALL UPCASE(PNI)
            IF(PNI.EQ.PN) THEN
               IF(ISFILE(I).EQ.1) THEN
                  WRITE(IOUT,*) 'Duplicate entry in Sensitivity file'
                  CALL RDABRT
               END IF
               GO TO 200
            ENDIF
100         CONTINUE
          ENDIF
C  Undefined parameter
          WRITE(IOUT,*)
     1   'Parameter in sensitivity file was not prevously defined'
          CALL RDABRT
C
200       ISFILE(I)=1
          ISENS(I)=ISENSTMP
          LN(I)=LNTMP
          B2(I)=BTMP
          BL(I)=BLTMP
          BU(I)=BUTMP
          BSCAL(I)=BSTMP
C
500     CONTINUE
      ENDIF
C
      RETURN
      END
      SUBROUTINE SENSV(IUNDEF,IWRFLG)
C     ******************************************************************
C     Save SEN data
C     ******************************************************************
C
      INCLUDE 'mfi2k.inc'
      INCLUDE 'mfi2kpar.inc'
C     ------------------------------------------------------------------
      IULOC=25
      IF(IUNIT(IULOC).EQ.0) THEN
         IUNDEF=-1
         RETURN
      END IF
      IUNDEF=0
      IF(IWRFLG.LE.0) THEN
         CALL FNMRMV
         RETURN
      END IF
C
      IF(IUREAL(IUNIT(IULOC)).EQ.0) CALL REALUN(IUNIT(IULOC))
      CALL IVLGET('ISENSU',0,0,ITYPE,ISENSU)
      IF(ITYPE.NE.0) ISENSU=0
      CALL IVLGET('ISENPU',0,0,ITYPE,ISENPU)
      IF(ITYPE.NE.0) ISENPU=0
      IF(ISENSU.GT.0) THEN
         IF(IUREAL(ISENSU).EQ.0) CALL REALUN(ISENSU)
         IF(CHEDFM.EQ.'(BINARY)') THEN
            FILTYP(ISENSU)='DATA(BINARY)'
         ELSE
            FILTYP(ISENSU)='DATA'
         END IF
      END IF
      IF(ISENPU.GT.0) THEN
         IF(IUREAL(ISENPU).EQ.0) CALL REALUN(ISENPU)
      END IF
      IFIL=IUMISC
      IF(IWRFLG.EQ.1) OPEN(FILE='MFI.SEN',UNIT=IFIL)
      IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUNIT(IULOC)),UNIT=IFIL)
C
C  Write comments
      DO 8 I=1,20
      IF(COMENT(I,IULOC)(1:1).EQ.'#') THEN
         DO 6 N=80,1,-1
         IF(COMENT(I,IULOC)(N:N) .NE. ' ') GO TO 7
6        CONTINUE
7        WRITE(IFIL,'(A)') COMENT(I,IULOC)(1:N)
      END IF
8     CONTINUE
C
      CALL IVLGET('ISENAL',0,0,ITYPE,ISENALL)
      IF(ITYPE.NE.0) ISENALL=0
      CALL IVLGET('IUHEAD',0,0,ITYPE,IUHEAD)
      IF(ITYPE.NE.0) IUHEAD=0
      CALL IVLGET('IPRNTS',0,0,ITYPE,IPRINTS)
      IF(ITYPE.NE.0) IPRINTS=0
      CALL IVLGET('ISENFM',0,0,ITYPE,ISENFM)
      IF(ITYPE.NE.0) ISENFM=0
C
C  Count Number of parameters that will be written into SEN file
      NPLIST=0
      NSENS=0
      IF(IPSUM.GT.0) THEN
         DO 100 I=1,IPSUM
         IF(ISFILE(I).NE.0) THEN
            NPLIST=NPLIST+1
            IF(ISENS(I).GT.0) NSENS=NSENS+1
         END IF
100      CONTINUE
      END IF
      MXSEN=0
      IF(ISENALL.GT.0) MXSEN=NPLIST
      IF(ISENALL.EQ.0) MXSEN=NSENS
C
C  Write data
      WRITE(IFIL,105) NPLIST,ISENALL,IUHEAD,MXSEN
105   FORMAT(4I10,'  NPLIST,ISENALL,IUHEAD,MXSEN')
      ISU=0
      IF(ISENSU.GT.0) ISU=IUREAL(ISENSU)
      IPU=0
      IF(ISENPU.GT.0) IPU=IUREAL(ISENPU)
      WRITE(IFIL,106) IPRINTS,ISU,IPU,ISENFM
106   FORMAT(4I10,'  IPRINTS,ISENSU,ISENPU,ISENFM')
      IF(NPLIST.GT.0) THEN
         DO 200 I=1,IPSUM
         IF(ISFILE(I).NE.0) THEN
            WRITE(IFIL,107) PARNAM(I),ISENS(I),LN(I),B2(I),BL(I),BU(I),
     1                   BSCAL(I)
107         FORMAT(A,1X,2I5,1P,4E13.5,'  PARNAM,ISENS,LN,B,BL,BU,BSCAL')
         END IF
200      CONTINUE
      END IF
      CLOSE(UNIT=IFIL)
C
      CALL FNMRMV
      RETURN
      END
      SUBROUTINE PESED
C     ******************************************************************
C     Edit PES PROCESS data
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
      INCLUDE 'mfi2k.inc'
      INCLUDE 'mfi2kpar.inc'
      COMMON /PESCOM/PRM(200),PRMSP(200),IPRMSF(200),IPRMPS(200)
      COMMON /CPESCOM/PARNEG(200),EQNAM(200),PESEQ(200)
      CHARACTER*10 PARNEG,EQNAM
      CHARACTER*100 PESEQ
C
      TYPE(WIN_MESSAGE)   :: MESSAGE
      CHARACTER*50 CTMP(1)
C     ------------------------------------------------------------------
      IF(IUNIT(25).LE.0) THEN
         CTMP(1)='SEN must be active prior to activating PES'
         CALL TXTLOG(CTMP,1)
         RETURN
      END IF
      IF(IUNIT(27).LE.0) THEN
         CTMP(1)='OBS must be active prior to activating PES'
         CALL TXTLOG(CTMP,1)
         RETURN
      END IF
C
C  Activate PES if not active already.
      IULOC=26
      IF(IUNIT(IULOC).EQ.0) THEN
C  Ready to activate PES
         CALL FINDUN(36,IU,'PES','PES')
         IUNIT(IULOC)=IU
      END IF
C
C See if there are no parameters, exit
      IF(IPSUM.LE.0) THEN
         CTMP(1)='No parameters have been defined'
         CALL TXTLOG(CTMP,1)
         RETURN
      END IF
C
C  Ready to edit data
      CALL WDialogLoad(PES_DIALOG)
C  Item 1
      CALL IVLGET('ITMXP',0,0,ITYPE,ITMXP)
      IF(ITYPE.NE.0) ITMXP=0
      CALL VALGET('DMAX',0,0,ITYPE,DMAX)
      IF(ITYPE.NE.0) DMAX=2.0
      CALL VALGET('TOL',0,0,ITYPE,TOL)
      IF(ITYPE.NE.0) TOL=.01
      CALL VALGET('SOSC',0,0,ITYPE,SOSC)
      IF(ITYPE.NE.0) SOSC=0.0
      CALL WDialogPutInteger(PES_ITMXP,ITMXP)
      CALL WDialogPutReal(PES_DMAX,DMAX,' ')
      CALL WDialogPutReal(PES_TOL,TOL,' ')
      CALL WDialogPutReal(PES_SOSC,SOSC,' ')
C  Item 2
      CALL IVLGET('IBEFLG',0,0,ITYPE,IBEFLG)
      IF(ITYPE.NE.0) IBEFLG=0
      CALL IVLGET('IYCFLG',0,0,ITYPE,IYCFLG)
      IF(ITYPE.NE.0) IYCFLG=0
      CALL IVLGET('IOSTAR',0,0,ITYPE,IOSTAR)
      IF(ITYPE.NE.0) IOSTAR=0
      CALL IVLGET('NOPT',0,0,ITYPE,NOPT)
      IF(ITYPE.NE.0) NOPT=0
      CALL IVLGET('NFIT',0,0,ITYPE,NFIT)
      IF(ITYPE.NE.0) NFIT=1
      CALL VALGET('SOSR',0,0,ITYPE,SOSR)
      IF(ITYPE.NE.0) SOSR=0.0
      CALL VALGET('RMAR',0,0,ITYPE,RMAR)
      IF(ITYPE.NE.0) RMAR=0.001
      CALL VALGET('RMARM',0,0,ITYPE,RMARM)
      IF(ITYPE.NE.0) RMARM=1.5
      CALL IVLGET('IAP',0,0,ITYPE,IAP)
      IF(ITYPE.NE.0) IAP=0
      CALL WDialogPutInteger(PES_IBEFLG,IBEFLG)
      CALL WDialogPutInteger(PES_IYCFLG,IYCFLG)
      CALL WDialogPutInteger(PES_IOSTAR,IOSTAR)
      CALL WDialogPutInteger(PES_NOPT,NOPT)
      CALL WDialogPutInteger(PES_NFIT,NFIT)
      CALL WDialogPutReal(PES_SOSR,SOSR,' ')
      CALL WDialogPutReal(PES_RMAR,RMAR,' ')
      CALL WDialogPutReal(PES_RMARM,RMARM,' ')
      CALL WDialogPutInteger(PES_IAP,IAP)
C  Item 3
      CALL IVLGET('IPRC',0,0,ITYPE,IPRC)
      IF(ITYPE.NE.0) IPRC=2
      CALL IVLGET('IPRINT',0,0,ITYPE,IPRINT)
      IF(ITYPE.NE.0) IPRINT=0
      CALL IVLGET('LPRINT',0,0,ITYPE,LPRINT)
      IF(ITYPE.NE.0) LPRINT=0
      CALL WDialogPutInteger(PES_IPRC,IPRC)
      CALL WDialogPutInteger(PES_IPRINT,IPRINT)
      CALL WDialogPutInteger(PES_LPRINT,LPRINT)
C  Item 4
      CALL VALGET('CSA',0,0,ITYPE,CSA)
      IF(ITYPE.NE.0) CSA=.08
      CALL VALGET('FCONV',0,0,ITYPE,FCONV)
      IF(ITYPE.NE.0) FCONV=0.0
      CALL IVLGET('LASTX',0,0,ITYPE,LASTX)
      IF(ITYPE.NE.0) LASTX=0
      CALL WDialogPutReal(PES_CSA,CSA,' ')
      CALL WDialogPutReal(PES_FCONV,FCONV,' ')
      CALL WDialogPutInteger(PES_LASTX,LASTX)
C
C  Item 6
      CALL WGridPutString(PES_PARNEG,1,PARNEG,200)
C
C  Item 9
      DO 10 N=1,200
      IF(EQNAM(N).EQ.' ' .OR. PESEQ(N).EQ.' ') THEN
         EQNAM(N)=' '
         PRM(N)=0.0
         PESEQ(N)=' '
         PRMSP(N)=1.
         IPRMSF(N)=1
         IPRMPS(N)=0
      END IF
10    CONTINUE
      CALL WGridPutString(PES_PESEQ,1,EQNAM,200)
      CALL WGridPutReal(PES_PESEQ,2,PRM,200,'(1PE13.6)')
      CALL WGridPutString(PES_PESEQ,3,PESEQ,200)
      CALL WGridPutReal(PES_PESEQ,4,PRMSP,200,'(1PE13.6)')
      CALL WGridPutOption(PES_PESEQ,5,IPRMSF,200)
      CALL WGridPutInteger(PES_PESEQ,6,IPRMPS,200)
C
      CALL WDialogShow(-1,50,0,Modal)
      IF(WInfoDialog(ExitButton).EQ.IDOK) THEN
C  Get modified values
C  Item 1
         CALL WDialogGetInteger(PES_ITMXP,ITMXP)
         CALL WDialogGetReal(PES_DMAX,DMAX)
         CALL WDialogGetReal(PES_TOL,TOL)
         CALL WDialogGetReal(PES_SOSC,SOSC)
         CALL IVLSAV('ITMXP',0,0,ITMXP)
         CALL VALSAV('DMAX',0,0,DMAX)
         CALL VALSAV('TOL',0,0,TOL)
         CALL VALSAV('SOSC',0,0,SOSC)
C  Item 2
         CALL WDialogGetInteger(PES_IBEFLG,IBEFLG)
         CALL WDialogGetInteger(PES_IYCFLG,IYCFLG)
         CALL WDialogGetInteger(PES_IOSTAR,IOSTAR)
         CALL WDialogGetInteger(PES_NOPT,NOPT)
         CALL WDialogGetInteger(PES_NFIT,NFIT)
         CALL WDialogGetReal(PES_SOSR,SOSR)
         CALL WDialogGetReal(PES_RMAR,RMAR)
         CALL WDialogGetReal(PES_RMARM,RMARM)
         CALL WDialogGetInteger(PES_IAP,IAP)
         CALL IVLSAV('IBEFLG',0,0,IBEFLG)
         CALL IVLSAV('IYCFLG',0,0,IYCFLG)
         CALL IVLSAV('IOSTAR',0,0,IOSTAR)
         CALL IVLSAV('NOPT',0,0,NOPT)
         CALL IVLSAV('NFIT',0,0,NFIT)
         CALL VALSAV('SOSR',0,0,SOSR)
         CALL VALSAV('RMAR',0,0,RMAR)
         CALL VALSAV('RMARM',0,0,RMARM)
         CALL IVLSAV('IAP',0,0,IAP)
C  Item 3
         CALL WDialogGetInteger(PES_IPRC,IPRC)
         CALL WDialogGetInteger(PES_IPRINT,IPRINT)
         CALL WDialogGetInteger(PES_LPRINT,LPRINT)
         CALL IVLSAV('IPRC',0,0,IPRC)
         CALL IVLSAV('IPRINT',0,0,IPRINT)
         CALL IVLSAV('LPRINT',0,0,LPRINT)
C  Item 4
         CALL WDialogGetReal(PES_CSA,CSA)
         CALL WDialogGetReal(PES_FCONV,FCONV)
         CALL WDialogGetInteger(PES_LASTX,LASTX)
         CALL VALSAV('CSA',0,0,CSA)
         CALL VALSAV('FCONV',0,0,FCONV)
         CALL IVLSAV('LASTX',0,0,LASTX)
C
C  Item 6
      N=200
      CALL WGridGetString(PES_PARNEG,1,PARNEG,N)
C
C  Item 9
      N=200
      CALL WGridGetString(PES_PESEQ,1,EQNAM,N)
      CALL WGridGetReal(PES_PESEQ,2,PRM,N)
      CALL WGridGetString(PES_PESEQ,3,PESEQ,N)
      CALL WGridGetReal(PES_PESEQ,4,PRMSP,N)
      CALL WGridGetMenu(PES_PESEQ,5,IPRMSF,N)
      CALL WGridGetInteger(PES_PESEQ,6,IPRMPS,N)
C
         CALL PESSV(IUNDEF,1)
      END IF

      CALL WDialogUnload(PES_DIALOG)
      RETURN
C
      END
      SUBROUTINE PESIN()
C     ******************************************************************
C     Read PES file
C     ******************************************************************
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      INCLUDE 'mfi2kpar.inc'
      COMMON /PESCOM/PRM(200),PRMSP(200),IPRMSF(200),IPRMPS(200)
      COMMON /CPESCOM/PARNEG(200),EQNAM(200),PESEQ(200)
      CHARACTER*10 PARNEG,EQNAM
      CHARACTER*100 PESEQ
      CHARACTER*200 LINE
      CHARACTER*10 CTMP1,CTMP2
C     ------------------------------------------------------------------
      IULOC=26
      IN=IUNIT(IULOC)
C
C1------IDENTIFY PROCESS AND PRINT HEADING
      WRITE (IOUT,501) IN
  501 FORMAT (/,' PESBAS1 -- PARAMETER ESTIMATION PROCESS, ',
     &        'VERSION 1.0, 10/15/98',/,' INPUT READ FROM UNIT ',I3)
C
C-------READ & PRINT ITEM 1 OF THE PES INPUT FILE
      CALL URDCOM(IUREAL(IN),LINE,IULOC)
      LLOC = 1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,ITMXP,DUM,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,IDUM,DMAX,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,IDUM,TOL,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,IDUM,SOSC,IOUT,IN)
      CALL IVLSAV('ITMXP',0,0,ITMXP)
      CALL VALSAV('DMAX',0,0,DMAX)
      CALL VALSAV('TOL',0,0,TOL)
      CALL VALSAV('SOSC',0,0,SOSC)
      WRITE(IOUT,510) ITMXP,DMAX,TOL,SOSC
  510 FORMAT (/,
     &' MAXIMUM NUMBER OF PARAMETER-ESTIMATION ITERATIONS (MAX-ITER)  ='
     &,1X,I5,/,
     &' MAXIMUM PARAMETER CORRECTION (MAX-CHANGE) ------------------- ='
     &,1X,G11.5,/,
     &' CLOSURE CRITERION (TOL) ------------------------------------- ='
     &,1X,G11.5,/,
     &' SUM OF SQUARES CLOSURE CRITERION (SOSC) --------------------- ='
     &,1X,G11.5)
C
C     READ AND PRINT ITEM 2 OF THE PES INPUT FILE
      READ(IUREAL(IN),'(A)') LINE
      LLOC = 1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IBEFLG,DUM,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IYCFLG,DUM,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IOSTAR,DUM,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NOPT,DUM,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NFIT,DUM,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,IDUM,SOSR,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,IDUM,RMAR,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,IDUM,RMARM,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IAP,DUM,IOUT,IN)
      IF(IAP.NE.1) IAP=0
      CALL IVLSAV('IBEFLG',0,0,IBEFLG)
      CALL IVLSAV('IYCFLG',0,0,IYCFLG)
      CALL IVLSAV('IOSTAR',0,0,IOSTAR)
      CALL IVLSAV('NOPT',0,0,NOPT)
      CALL IVLSAV('NFIT',0,0,NFIT)
      CALL VALSAV('SOSR',0,0,SOSR)
      CALL VALSAV('RMAR',0,0,RMAR)
      CALL VALSAV('RMARM',0,0,RMARM)
      CALL IVLSAV('IAP',0,0,IAP)
      WRITE(IOUT,520) IBEFLG,IYCFLG,IOSTAR,NOPT,NFIT,SOSR,RMAR,RMARM,IAP
  520 FORMAT (/,
     &' FLAG TO GENERATE INPUT NEEDED BY BEALE-2000 (IBEFLG) -------- ='
     &,1X,I5,/,
     &' FLAG TO GENERATE INPUT NEEDED BY YCINT-2000 (IYCFLG) -------- ='
     &,1X,I5,/,
     &' OMIT PRINTING TO SCREEN (IF = 1) (IOSTAR) ------------------- ='
     &,1X,I5,/,
     &' ADJUST GAUSS-NEWTON MATRIX WITH NEWTON UPDATES (IF = 1)(NOPT) ='
     &,1X,I5,/,
     &' NUMBER OF FLETCHER-REEVES ITERATIONS (NFIT) ----------------- ='
     &,1X,I5,/,
     &' CRITERION FOR ADDING MATRIX R (SOSR) ------------------------ ='
     &,1X,G11.5,/,
     &' MARQUARDT PARAMETER (RMAR) ---------------------------------- ='
     &,1X,G11.5,/,
     &' MARQUARDT MULTIPLIER (RMARM) -------------------------------- ='
     &,1X,G11.5,/,
     &' APPLY MAX-CHANGE IN REGRESSION SPACE (IF = 1) (IAP) --------- ='
     &,1X,I5)
C
      IF (IBEFLG.LT.0 .OR. IBEFLG.GT.2) THEN
        WRITE (IOUT,521)
  521 FORMAT (/,1X,'ERROR: IBEFLG MUST BE 0, 1, OR 2 -- STOP',
     &' EXECUTION (PESBAS1AL)')
        CALL RDABRT
      ENDIF
C
      IF (IYCFLG.LT.-1 .OR. IYCFLG.GT.2) THEN
        WRITE (IOUT,522)
  522 FORMAT (/,1X,'ERROR: IYCFLG MUST BE -1, 0, 1, OR 2 -- STOP',
     &' EXECUTION (PESBAS1AL)')
        CALL RDABRT
      ENDIF
C
C
C     READ AND PRINT ITEM 3 OF THE PES INPUT FILE
      READ(IUREAL(IN),'(A)') LINE
      LLOC = 1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IPRC,DUM,IOUT,IU)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IPRINT,DUM,IOUT,IU)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,LPRINT,DUM,IOUT,IU)
      CALL IVLSAV('IPRC',0,0,IPRC)
      CALL IVLSAV('IPRINT',0,0,IPRINT)
      CALL IVLSAV('LPRINT',0,0,LPRINT)
      WRITE (IOUT,525) IPRC, IPRINT, LPRINT
  525 FORMAT (/,
     &' FORMAT CODE FOR COVARIANCE AND CORRELATION MATRICES (IPRCOV)  ='
     &,1X,I5,/,
     &' PRINT PARAMETER-ESTIMATION STATISTICS',/,
     &'     EACH ITERATION (IF > 0)  (IPRINT) ----------------------- ='
     &,1X,I5,/,
     &' PRINT EIGENVALUES AND EIGENVECTORS OF',/,
     &'     COVARIANCE MATRIX (IF > 0)  (LPRINT) -------------------- ='
     &,1X,I5)
C
C     READ AND PRINT ITEM 4 OF THE PES INPUT FILE
      READ(IUREAL(IN),'(A)') LINE
      LLOC = 1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,IDUM,CSA,IOUT,IU)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,IDUM,FCONV,IOUT,IU)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,LASTX,DUM,IOUT,IU)
      CALL VALSAV('CSA',0,0,CSA)
      CALL VALSAV('FCONV',0,0,FCONV)
      CALL IVLSAV('LASTX',0,0,LASTX)
      WRITE (IOUT,530) CSA, FCONV, LASTX
  530 FORMAT (/,
     &' SEARCH DIRECTION ADJUSTMENT PARAMETER (CSA) ----------------- ='
     &,1X,G11.5,/,
     &' MODIFY CONVERGENCE CRITERIA (IF > 0) (FCONV) ---------------- ='
     &,1X,G11.5,/,
     &' CALCULATE SENSITIVITIES USING FINAL',/,
     &'     PARAMETER ESTIMATES (IF > 0) (LASTX) -------------------- ='
     &,1X,I5)
C
C     READ AND PRINT ITEM 5 OF THE PES INPUT FILE
      READ(IUREAL(IN),'(A)') LINE
      LLOC = 1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NPNG,DUM,IOUT,IU)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IFPR,DUM,IOUT,IU)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,MPR,DUM,IOUT,IU)
      CALL IVLSAV('MPR',0,0,MPR)
      WRITE(IOUT,535) NPNG,IFPR,MPR
  535 FORMAT (/,
     &' NUMBER OF USUALLY POS. PARAMETERS THAT MAY BE NEG (NPNG) ---- ='
     &,1X,I5,/,
     &' NUMBER OF PARAMETERS WITH CORRELATED PRIOR INFORMATION (IFPR) ='
     &,1X,I5,/,
     &' NUMBER OF PRIOR-INFORMATION EQUATIONS (MPR) ----------------- ='
     &,1X,I5)
      IF(NPNG.GT.200) THEN
         WRITE(IOUT,*) ' NPNG MUST BE 200 OR LESS IN MFI'
         CALL RDABRT
      END IF
C
C-------READ ITEM 6
      IF (NPNG.GT.0) THEN
        READ(IUREAL(IN),*) (PARNEG(I),I=1,NPNG)
        DO 8 I = 1,NPNG
          CTMP1=PARNEG(I)
          CALL UPCASE(CTMP1)
          DO 4 IP = 1,IPSUM
            CTMP2=PARNAM(IP)
            CALL UPCASE(CTMP2)
            IF(CTMP1.EQ.CTMP2) GOTO 6
  4       CONTINUE
          WRITE (IOUT,640) PARNEG(I)
  640 FORMAT (/,' ERROR: PARAMETER NAME "',A,'" NOT DEFINED',/,
     &          ' -- STOP EXECUTION (PESBAS1RP)')
          CALL RDABRT
  6       CONTINUE
  8     CONTINUE
        WRITE (IOUT,541)
  541   FORMAT (/,
     &' PARAMETERS FOR WHICH PARTYP = HK, VK, VANI, VKCB, SS, SY,',
     &' OR EVT,',/,' BUT FOR WHICH PARAMETERS CAN BE NEGATIVE:')
        WRITE (IOUT,542) (PARNEG(I),I=1,NPNG)
  542   FORMAT(3X,A)
      ENDIF
C
      IF(MPR.GT.200) THEN
         WRITE(IOUT,*) 'MPR must be 200 or less in MFI'
         CALL RDABRT
      END IF
      IF(IFPR.GT.0) THEN
         WRITE(IOUT,*) 'IFPR must be 0 in MFI'
         CALL RDABRT
      END IF
C
      IF(MPR.GT.0) THEN
         DO 700 I=1,MPR
         READ(IUREAL(IN),'(A)') LINE
         WRITE(IOUT,*) LINE
         LLOC=1
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,0,IDUM,RDUM,IOUT,IN)
         EQNAM(I)=LINE(ISTART:ISTOP)
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,IDUM,PRM(I),IOUT,IN)
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,0,IDUM,RDUM,IOUT,IN)
         IF(LINE(ISTART:ISTOP).NE.'=') THEN
            WRITE(IOUT,*)
     1      '"=" not found in required location in prior equation'
            CALL RDABRT
         END IF
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,IDUM,RDUM,IOUT,IN)
         IEQBEG=ISTART
690      CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,IDUM,RDUM,IOUT,IN)
         IF(LINE(ISTART:ISTOP).EQ.' ') THEN
            WRITE(IOUT,*)
     1      '"STAT" not found in required location in prior equation'
            CALL RDABRT
         END IF
         IF(LINE(ISTART:ISTOP).NE.'STAT') GO TO 690
         PESEQ(I)=LINE(IEQBEG:ISTOP-5)
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,IDUM,PRMSP(I),IOUT,IN)
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IPRMSF(I),RDUM,IOUT,IN)
         IF(IPRMSF(I).LT.0 .OR. (IPRMSF(I).GT.12) .OR.
     1       (IPRMSF(I).GT.2.AND.IPRMSF(I).LT.10) ) THEN
            WRITE(IOUT,*)
     1      'Illegal STAT-FLAG'
            CALL RDABRT
         END IF
         IF(IPRMSF(I).GT.2) IPRMSF(I)=IPRMSF(I)-7
         IPRMSF(I)=IPRMSF(I)+1
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IPRMPS(I),RDUM,IOUT,IN)
700      CONTINUE
      END IF
C
      RETURN
      END
      SUBROUTINE PESSV(IUNDEF,IWRFLG)
C
      INCLUDE 'mfi2k.inc'
      INCLUDE 'mfi2kpar.inc'
      COMMON /PESCOM/PRM(200),PRMSP(200),IPRMSF(200),IPRMPS(200)
      COMMON /CPESCOM/PARNEG(200),EQNAM(200),PESEQ(200)
      CHARACTER*10 PARNEG,EQNAM
      CHARACTER*100 PESEQ
C     ------------------------------------------------------------------
      IULOC=26
      IF(IUNIT(IULOC).EQ.0) THEN
         IUNDEF=-1
         RETURN
      END IF
      IUNDEF=0
      IF(IWRFLG.LE.0) RETURN
C
      DO 5 I=1,MXFNAM
      IF(IFNUSE(I).EQ.IUNIT(IULOC)) IFNUSE(I)=0
5     CONTINUE
      IFNUSE(IUNIT(IULOC))=IUNIT(IULOC)
C
      IF(IUREAL(IUNIT(IULOC)).EQ.0) CALL REALUN(IUNIT(IULOC))
      IFIL=IUMISC
      IF(IWRFLG.EQ.1) OPEN(FILE='MFI.PES',UNIT=IFIL)
      IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUNIT(IULOC)),UNIT=IFIL)
C
C  Write comments
      DO 8 I=1,20
      IF(COMENT(I,IULOC)(1:1).EQ.'#') THEN
         DO 6 N=80,1,-1
         IF(COMENT(I,IULOC)(N:N) .NE. ' ') GO TO 7
6        CONTINUE
7        WRITE(IFIL,'(A)') COMENT(I,IULOC)(1:N)
      END IF
8     CONTINUE
C
C  Write data
C  Item 1
      CALL IVLGET('ITMXP',0,0,ITYPE,ITMXP)
      IF(ITYPE.NE.0) ITMXP=0
      CALL VALGET('DMAX',0,0,ITYPE,DMAX)
      IF(ITYPE.NE.0) DMAX=2.0
      CALL VALGET('TOL',0,0,ITYPE,TOL)
      IF(ITYPE.NE.0) TOL=.01
      CALL VALGET('SOSC',0,0,ITYPE,SOSC)
      IF(ITYPE.NE.0) SOSC=0.0
      WRITE(IFIL,101) ITMXP,DMAX,TOL,SOSC
101   FORMAT(I10,1P,3E13.5,'  MAX-ITER,MAX-CHANGE,TOL,SOSC')
C  Item 2
      CALL IVLGET('IBEFLG',0,0,ITYPE,IBEFLG)
      IF(ITYPE.NE.0) IBEFLG=0
      CALL IVLGET('IYCFLG',0,0,ITYPE,IYCFLG)
      IF(ITYPE.NE.0) IYCFLG=0
      CALL IVLGET('IOSTAR',0,0,ITYPE,IOSTAR)
      IF(ITYPE.NE.0) IOSTAR=0
      CALL IVLGET('NOPT',0,0,ITYPE,NOPT)
      IF(ITYPE.NE.0) NOPT=0
      CALL IVLGET('NFIT',0,0,ITYPE,NFIT)
      IF(ITYPE.NE.0) NFIT=1
      CALL VALGET('SOSR',0,0,ITYPE,SOSR)
      IF(ITYPE.NE.0) SOSR=0.0
      CALL VALGET('RMAR',0,0,ITYPE,RMAR)
      IF(ITYPE.NE.0) RMAR=0.001
      CALL VALGET('RMARM',0,0,ITYPE,RMARM)
      IF(ITYPE.NE.0) RMARM=1.5
      CALL IVLGET('IAP',0,0,ITYPE,IAP)
      IF(ITYPE.NE.0) IAP=0
      WRITE(IFIL,102) IBEFLG,IYCFLG,IOSTAR,NOPT,NFIT,SOSR,RMAR,RMARM,IAP
102   FORMAT(5I10,1P,3E13.5,I5,
     1      '  IBEFLG,IYCFLG,IOSTAR,NOPT,NFIT,SOSR,RMAR,RMARM,IAP')
C  Item 3
      CALL IVLGET('IPRC',0,0,ITYPE,IPRC)
      IF(ITYPE.NE.0) IPRC=2
      CALL IVLGET('IPRINT',0,0,ITYPE,IPRINT)
      IF(ITYPE.NE.0) IPRINT=0
      CALL IVLGET('LPRINT',0,0,ITYPE,LPRINT)
      IF(ITYPE.NE.0) LPRINT=0
      WRITE(IFIL,103) IPRC,IPRINT,LPRINT
103   FORMAT(3I10,'  IPRC,IPRINT,LPRINT')
C  Item 4
      CALL VALGET('CSA',0,0,ITYPE,CSA)
      IF(ITYPE.NE.0) CSA=.08
      CALL VALGET('FCONV',0,0,ITYPE,FCONV)
      IF(ITYPE.NE.0) FCONV=0.0
      CALL IVLGET('LASTX',0,0,ITYPE,LASTX)
      IF(ITYPE.NE.0) LASTX=0
      WRITE(IFIL,104) CSA,FCONV,LASTX
104   FORMAT(1P,2E13.5,I10,'  CSA,FCONV,LASTX')
C  Item 5
      CALL IVLGET('IFPR',0,0,ITYPE,IFPR)
      IF(ITYPE.NE.0) IFPR=0
      NPNG=0
      MPR=0
      DO 50 I=1,200
      IF(PARNEG(I).NE.' ') NPNG=NPNG+1
      IF(PESEQ(I).NE.' ' .AND. EQNAM(I).NE.' ') MPR=MPR+1
50    CONTINUE
      WRITE(IFIL,105) NPNG,IFPR,MPR
105   FORMAT(3I10,'  NPNG,IFPR,MPR')
C
C  Item 6
      IF(NPNG.GT.0) THEN
         DO 200 I=1,200
         IF(PARNEG(I).NE. ' ') WRITE(IFIL,*) PARNEG(I)
200      CONTINUE
      END IF
C
C  Item 9
      IF(MPR.GT.0) THEN
         DO 300 I=1,200
         IF(PESEQ(I).NE.' ' .AND. EQNAM(I).NE.' ')  THEN
            IPS=IPRMSF(I)-1
            IF(IPS.GT.2) IPS=IPS+7
            DO 250 J=100,1,-1
            IF(PESEQ(I)(J:J).NE.' ') GO TO 260
250         CONTINUE
260         WRITE(IFIL,106)
     1      EQNAM(I),PRM(I),PESEQ(I)(1:J),PRMSP(I),IPS,IPRMPS(I)
106         FORMAT(A,1X,1P,E13.6,' = ',A,' STAT ',E13.6,2I10)
         END IF
300      CONTINUE
      END IF
C
      RETURN
      END
      SUBROUTINE FOBTEDIT(NED)
C     ******************************************************************
C     Edit FOB Times
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
      INCLUDE 'mfi2k.inc'
      COMMON /FOBCOM/LAYFOB(MXCFOB),IROWFOB(MXCFOB),ICOLFOB(MXCFOB),
     1               FOBFACT(MXCFOB),FOBSTAT(MXTFOB),FOBS(MXTFOB),
     2               IFOBST(MXTFOB),IFOBRSP(MXTFOB),FOBTOFF(MXTFOB),
     3               IFOBPLT(MXTFOB),NGFOB,NTFOB,NCFOB,NFOB(6,MXGFOB),
     4               FOBCON(2,40)
      COMMON /CFOBCOM/FOBNAM
      CHARACTER*12 FOBNAM(MXTFOB)      
      DIMENSION STAT(MXTFOB),F(MXTFOB),IST(MXTFOB),IRSP(MXTFOB),
     1          TOFF(MXTFOB),IPLT(MXTFOB)
      CHARACTER*12 NAM(MXTFOB)
C     ------------------------------------------------------------------
      CALL WDialogLoad(FOB_TIME_DIALOG)
C
C  Clear the buffer
      NQT=NFOB(3,NED)-NFOB(2,NED)+1
      NBUF=MXTFOB-(NTFOB-NQT)
      DO 5 I=1,NBUF
      NAM(I)=' '
      STAT(I)=0.
      F(I)=0.
      IST(I)=1
      IRSP(I)=1
      TOFF(I)=0.
      IPLT(I)=0
5     CONTINUE
C
C  If there existing values, move them to the buffer
      IF(NQT.GT.0) THEN
         N=0
         DO 10 I=NFOB(2,NED),NFOB(3,NED)
         N=N+1
         NAM(N)=FOBNAM(I)
         STAT(N)=FOBSTAT(I)
         F(N)=FOBS(I)
         IST(N)=IFOBST(I)+1
         IRSP(N)=IFOBRSP(I)
         TOFF(N)=FOBTOFF(I)
         IPLT(N)=IFOBPLT(I)
10       CONTINUE
      END IF
      CALL WGridPutString(FOB_TIME_GRID,1,NAM,NBUF)
      CALL WGridPutinteger(FOB_TIME_GRID,2,IRSP,NBUF)
      CALL WGridPutReal(FOB_TIME_GRID,3,TOFF,NBUF,'(1PG13.6)')
      CALL WGridPutReal(FOB_TIME_GRID,4,F,NBUF,' ')
      CALL WGridPutReal(FOB_TIME_GRID,5,STAT,NBUF,' ')
      CALL WGridPutOption(FOB_TIME_GRID,6,IST,NBUF)
      CALL WGridPutInteger(FOB_TIME_GRID,7,IPLT,NBUF)
C
C  Make Dialog visible
      CALL WDialogShow(-1,50,0,MODAL)
C  Get and store values if "OK" was pushed
      IF(WInfoDialog(ExitButton).EQ.IDOK) THEN
         CALL WGridGetString(FOB_TIME_GRID,1,NAM,NBUF)
         CALL WGridGetinteger(FOB_TIME_GRID,2,IRSP,NBUF)
         CALL WGridGetReal(FOB_TIME_GRID,3,TOFF,NBUF)
         CALL WGridGetReal(FOB_TIME_GRID,4,F,NBUF)
         CALL WGridGetReal(FOB_TIME_GRID,5,STAT,NBUF)
         CALL WGridGetMenu(FOB_TIME_GRID,6,IST,NBUF)
         CALL WGridGetInteger(FOB_TIME_GRID,7,IPLT,NBUF)
         NQTNEW=0
         DO 100 I=1,NBUF
         IF(NAM(I).NE.' ') NQTNEW=NQTNEW+1
100      CONTINUE
         NADD=NQTNEW-NQT
C  Expand or contract list of times if needed
         IF(NADD.NE.0 .AND. NED.NE.NGFOB) THEN
            IF(NADD.LT.0) THEN
               I1=NFOB(2,NED+1)
               I2=NTFOB
               I3=1
            ELSE
               I2=NFOB(2,NED+1)
               I1=NTFOB
               I3=-1
            END IF
            DO 140 I=I1,I2,I3
            N=I+NADD
            FOBNAM(N)=FOBNAM(I)
            FOBSTAT(N)=FOBSTAT(I)
            FOBS(N)=FOBS(I)
            IFOBST(N)=IFOBST(I)
            IFOBRSP(N)=IFOBRSP(I)
            FOBTOFF(N)=FOBTOFF(I)
            IFOBPLT(N)=IFOBPLT(I)
140         CONTINUE
C
            DO 150 I=NED+1,NGFOB
            NFOB(2,I)=NFOB(2,I)+NADD
            NFOB(3,I)=NFOB(3,I)+NADD
150         CONTINUE
         END IF
         NFOB(3,NED)=NFOB(3,NED)+NADD
C  Move the buffer into the list of times
         I=NFOB(2,NED)-1
         DO 200 N=1,NBUF
         IF(NAM(N).NE.' ') THEN
            I=I+1
            FOBNAM(I)=NAM(N)
            FOBSTAT(I)=STAT(N)
            FOBS(I)=F(N)
            IFOBST(I)=IST(N)-1
            IFOBRSP(I)=IRSP(N)
            FOBTOFF(I)=TOFF(N)
            IFOBPLT(I)=IPLT(N)
         END IF
200      CONTINUE
         NTFOB=NTFOB+NADD
      END IF
      CALL WDialogUnload(FOB_TIME_DIALOG)
C
C
      RETURN
      END
      SUBROUTINE FOBCEDIT(NED)
C     ******************************************************************
C     Edit FOB Cell Locations
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
      INCLUDE 'mfi2k.inc'
      COMMON /FOBCOM/LAYFOB(MXCFOB),IROWFOB(MXCFOB),ICOLFOB(MXCFOB),
     1               FOBFACT(MXCFOB),FOBSTAT(MXTFOB),FOBS(MXTFOB),
     2               IFOBST(MXTFOB),IFOBRSP(MXTFOB),FOBTOFF(MXTFOB),
     3               IFOBPLT(MXTFOB),NGFOB,NTFOB,NCFOB,NFOB(6,MXGFOB),
     4               FOBCON(2,40)
      COMMON /CFOBCOM/FOBNAM
      CHARACTER*12 FOBNAM(MXTFOB)      
      DIMENSION IL(MXCFOB),IR(MXCFOB),IC(MXCFOB),FACT(MXCFOB)
      CHARACTER*60 CTXT(2)
C     ------------------------------------------------------------------
      CALL WDialogLoad(FOB_CELL_DIALOG)
C
C  Clear the buffer
      NQC=NFOB(5,NED)-NFOB(4,NED)+1
      NBUF=MXCFOB-(NCFOB-NQC)
      DO 5 I=1,NBUF
      IL(I)=0
      IR(I)=0
      IC(I)=0
      FACT(I)=0
5     CONTINUE
C
C  If there existing values, move them to the buffer
      IF(NQC.GT.0) THEN
         N=0
         DO 10 I=NFOB(4,NED),NFOB(5,NED)
         N=N+1
         IL(N)=LAYFOB(I)
         IR(N)=IROWFOB(I)
         IC(N)=ICOLFOB(I)
         FACT(N)=FOBFACT(I)
10       CONTINUE
      END IF
      CALL WDialogPutCheckBox(FOB_CELLS_NQCLSIGN,NFOB(6,NED))
      CALL WGridPutInteger(FOB_CELLS_GRID,1,IL,NBUF)
      CALL WGridPutInteger(FOB_CELLS_GRID,2,IR,NBUF)
      CALL WGridPutInteger(FOB_CELLS_GRID,3,IC,NBUF)
      CALL WGridPutReal(FOB_CELLS_GRID,4,FACT,NBUF,' ')
C
C  Make Dialog visible
      CALL WDialogShow(-1,50,0,MODAL)
C  Get and store values if "OK" was pushed
      IF(WInfoDialog(ExitButton).EQ.IDOK) THEN
         CALL WDialogGetCheckBox(FOB_CELLS_NQCLSIGN,NFOB(6,NED))
         CALL WGridGetInteger(FOB_CELLS_GRID,1,IL,NBUF)
         CALL WGridGetInteger(FOB_CELLS_GRID,2,IR,NBUF)
         CALL WGridGetInteger(FOB_CELLS_GRID,3,IC,NBUF)
         CALL WGridGetReal(FOB_CELLS_GRID,4,FACT,NBUF)
         NQCNEW=0
         DO 100 I=1,NBUF
         IF(IL(I).GT.0) THEN
            IF(IL(I).GT.NLAY .OR. IR(I).GT.NROW .OR. IC(I).GT.NCOL .OR.
     1                            IR(I).LT.1   .OR. IC(I).LT.1) THEN
      CTXT(1)='Obs. outside of grid has been eliminated (Lay,row,col):'
               WRITE(CTXT(2),'(3I5)') IL(I),IR(I),IC(I)
               CALL TXTLOG(CTXT,2)
               IL(I)=0
               CALL WDialogSelect(FOB_CELL_DIALOG)
            ELSE
               NQCNEW=NQCNEW+1
            END IF
         END IF
100      CONTINUE
         NADD=NQCNEW-NQC
C  Expand or contract list of times if needed
         IF(NADD.NE.0 .AND. NED.NE.NGFOB) THEN
            IF(NADD.LT.0) THEN
               I1=NFOB(4,NED+1)
               I2=NCFOB
               I3=1
            ELSE
               I2=NFOB(4,NED+1)
               I1=NCFOB
               I3=-1
            END IF
            DO 140 I=I1,I2,I3
            N=I+NADD
            LAYFOB(N)=LAYFOB(I)
            IROWFOB(N)=IROWFOB(I)
            ICOLFOB(N)=ICOLFOB(I)
            FOBFACT(N)=FOBFACT(I)
140         CONTINUE
C
            DO 150 I=NED+1,NGFOB
            NFOB(4,I)=NFOB(4,I)+NADD
            NFOB(5,I)=NFOB(5,I)+NADD
150         CONTINUE
         END IF
         NFOB(5,NED)=NFOB(5,NED)+NADD
C  Move the buffer into the list of locations
         I=NFOB(4,NED)-1
         DO 200 N=1,NBUF
         IF(IL(N).GT.0) THEN
            I=I+1
            LAYFOB(I)=IL(N)
            IROWFOB(I)=IR(N)
            ICOLFOB(I)=IC(N)
            FOBFACT(I)=FACT(N)
         END IF
200      CONTINUE
         NCFOB=NCFOB+NADD
      END IF
      CALL WDialogUnload(FOB_CELL_DIALOG)
C
C
      RETURN
      END
      SUBROUTINE NOBLANK(NAM)
      CHARACTER*(*) NAM
      CHARACTER*80 CDUM
C
      NC=LEN(NAM)
      CDUM=NAM
      IF(NC.GT.80) NC=80
C
      NAM=' '
      NNB=0
      DO 20 I=1,NC
      IF(CDUM(I:I).NE.' ') THEN
         NNB=NNB+1
         NAM(NNB:NNB)=CDUM(I:I)
      END IF
20    CONTINUE
C
      RETURN
      END
      SUBROUTINE HOBEDSINGTIM
C     ******************************************************************
C     Edit single-time head observations
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
      INCLUDE 'mfi2k.inc'
      TYPE(WIN_MESSAGE)   :: MESSAGE
      COMMON /SHOBCOM/LAYSHOB(10,MXHOB),IROWSHOB(MXHOB),ICOLSHOB(MXHOB),
     1               SHROFF(MXHOB),SHCOFF(MXHOB),SHOBSTAT(MXHOB),
     2               SHOBS(MXHOB),ISHOBST(MXHOB),ISHREFSP(MXHOB),
     3               SHOBTOFF(MXHOB),ISHOBPLT(MXHOB),SHOBPR(10,MXHOB)
      COMMON /CSHOBCOM/SHOBNAM
      CHARACTER*12 SHOBNAM(MXHOB)
      COMMON /HOBCOM/LAYHOB(10,MXHOB),IROWHOB(MXHOB),ICOLHOB(MXHOB),
     1               ROFF(MXHOB),COFF(MXHOB),HOBSTAT(MXHOB),HOBS(MXHOB),
     2               IHOBST(MXHOB),IREFSP(MXHOB),HOBTOFF(MXHOB),
     3               IHOBPLT(MXHOB),ITT(MXHOB),DDSTAT(MXHOB),
     4               HOBPR(10,MXHOB)
      COMMON /CHOBCOM/HOBNAM
      CHARACTER*12 HOBNAM(MXHOB),HNAM
      CHARACTER*70 CTXT(1)
      DIMENSION LAY(MXHOB)
C     ------------------------------------------------------------------
      IULOC=28
C
C  Activate HOB if not active already.
      IF(IUNIT(IULOC).EQ.0) THEN
C  Ready to activate HOB
         CALL FINDUN(38,IU,'HOB','HOB')
         IUNIT(IULOC)=IU
         DO 10 I=1,MXHOB
         SHOBNAM(I)=' '
         IROWSHOB(I)=0
         ICOLSHOB(I)=0
         SHROFF(I)=0.
         SHCOFF(I)=0.
         SHOBSTAT(I)=1
         SHOBS(I)=0.
         ISHOBST(I)=1
         ISHREFSP(I)=1
         SHOBTOFF(I)=0.
         ISHOBPLT(I)=1
         HOBNAM(I)=' '
         IROWHOB(I)=0
         ICOLHOB(I)=0
         ROFF(I)=0.
         COFF(I)=0.
         HOBSTAT(I)=1
         HOBS(I)=0.
         IHOBST(I)=1
         IREFSP(I)=1
         HOBTOFF(I)=0.
         IHOBPLT(I)=1
         ITT(I)=0
         DDSTAT(I)=0.
         DO 9 J=1,10
         SHOBPR(J,I)=0.
         LAYSHOB(J,I)=0
         HOBPR(J,I)=0.
         LAYHOB(J,I)=0
9        CONTINUE
10       CONTINUE
      END IF
C
15    CALL WDialogLoad(HOBS_SINGLE_DIALOG)
      CALL VALGET('TOMULTH',0,0,ITYPE,TOMULTH)
      IF(ITYPE.NE.0) TOMULTH=1.
      CALL WDialogPutReal(HOBS_TOMULTH,TOMULTH,' ')
      CALL VALGET('EVH',0,0,ITYPE,EVH)
      IF(ITYPE.NE.0) EVH=1.
      CALL WDialogPutReal(HOBS_EVH,EVH,' ')
      CALL WGridPutString(HOBS_SINGLE,1,SHOBNAM,MXHOB)
      CALL WGridPutInteger(HOBS_SINGLE,3,IROWSHOB,MXHOB)
      CALL WGridPutInteger(HOBS_SINGLE,4,ICOLSHOB,MXHOB)
      CALL WGridPutInteger(HOBS_SINGLE,5,ISHREFSP,MXHOB)
      CALL WGridPutReal(HOBS_SINGLE,6,SHOBTOFF,MXHOB,'(1PG13.6)')
      CALL WGridPutReal(HOBS_SINGLE,7,SHOBS,MXHOB,' ')
      CALL WGridPutReal(HOBS_SINGLE,8,SHOBSTAT,MXHOB,' ')
      CALL WGridPutOption(HOBS_SINGLE,9,ISHOBST,MXHOB)
      CALL WGridPutReal(HOBS_SINGLE,10,SHROFF,MXHOB,' ')
      CALL WGridPutReal(HOBS_SINGLE,11,SHCOFF,MXHOB,' ')
      CALL WGridPutInteger(HOBS_SINGLE,12,ISHOBPLT,MXHOB)
      DO 20 I=1,MXHOB
      LAY(I)=LAYSHOB(1,I)
      IF(LAYSHOB(2,I).NE.0) THEN
         CALL WGridStateCell(HOBS_SINGLE,2,I,DialogReadOnly)
      ELSE
         CALL WGridStateCell(HOBS_SINGLE,2,I,Enabled)
      END IF
20    CONTINUE
      CALL WGridPutInteger(HOBS_SINGLE,2,LAY,MXHOB)
C
C  Make Dialog visible
      CALL WDialogShow(-1,50,0,SemiModeless)
50    CALL WMessage(ITYPE,MESSAGE)
C
C  Check for push buttons
      IF(ITYPE.EQ.PushButton) THEN
C
C  Check for HOB_COMMENT
         IF(MESSAGE%VALUE1.EQ.HOB_COMMENT) THEN
            CALL COMNTIN(IULOC)
            CALL WDialogSelect(HOBS_SINGLE_DIALOG)
C
C  Check for edit layers
         ELSE IF(MESSAGE%VALUE1.EQ.SHOBS_MULTILAYER) THEN
            CALL GETSNGL(IERR)
            IF(IERR.NE.0) GO TO 15
            CALL HOBEDML
            CALL WDialogSelect(HOBS_SINGLE_DIALOG)
            GO TO 15
C
C  Check for OK
         ELSE IF(MESSAGE%VALUE1.EQ.IDOK) THEN
            CALL GETSNGL(IERR)
            IF(IERR.NE.0) GO TO 15
            CALL WDialogUnload(HOBS_SINGLE_DIALOG)
            CALL HOBSV(IUNDEF,1)
            RETURN
C
C  Check for CANCEL
         ELSE IF(MESSAGE%VALUE1.EQ.IDCANCEL) THEN
            CALL WDialogUnload(HOBS_SINGLE_DIALOG)
            RETURN
         END IF
C
      END IF
      GO TO 50
C
C
      END
      SUBROUTINE GETSNGL(IERR)
C     ******************************************************************
C     Retrieve single-time head observations
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
      INCLUDE 'mfi2k.inc'
      TYPE(WIN_MESSAGE)   :: MESSAGE
      COMMON /SHOBCOM/LAYSHOB(10,MXHOB),IROWSHOB(MXHOB),ICOLSHOB(MXHOB),
     1               SHROFF(MXHOB),SHCOFF(MXHOB),SHOBSTAT(MXHOB),
     2               SHOBS(MXHOB),ISHOBST(MXHOB),ISHREFSP(MXHOB),
     3               SHOBTOFF(MXHOB),ISHOBPLT(MXHOB),SHOBPR(10,MXHOB)
      COMMON /CSHOBCOM/SHOBNAM
      CHARACTER*12 SHOBNAM(MXHOB)
      COMMON /HOBCOM/LAYHOB(10,MXHOB),IROWHOB(MXHOB),ICOLHOB(MXHOB),
     1               ROFF(MXHOB),COFF(MXHOB),HOBSTAT(MXHOB),HOBS(MXHOB),
     2               IHOBST(MXHOB),IREFSP(MXHOB),HOBTOFF(MXHOB),
     3               IHOBPLT(MXHOB),ITT(MXHOB),DDSTAT(MXHOB),
     4               HOBPR(10,MXHOB)
      COMMON /CHOBCOM/HOBNAM
      CHARACTER*12 HOBNAM(MXHOB),HNAM
      CHARACTER*70 CTXT(1)
      DIMENSION LAY(MXHOB)
C     ------------------------------------------------------------------
      IERR=0
            CALL WDialogGetReal(HOBS_TOMULTH,TOMULTH)
            CALL VALSAV('TOMULTH',0,0,TOMULTH)
            CALL WDialogGetReal(HOBS_EVH,EVH)
            CALL VALSAV('EVH',0,0,EVH)
            NN=MXHOB
            CALL WGridGetString(HOBS_SINGLE,1,SHOBNAM,NN)
            CALL WGridGetInteger(HOBS_SINGLE,2,LAY,NN)
            CALL WgridGetInteger(HOBS_SINGLE,3,IROWSHOB,NN)
            CALL WGridGetInteger(HOBS_SINGLE,4,ICOLSHOB,NN)
            CALL WGridGetInteger(HOBS_SINGLE,5,ISHREFSP,NN)
            CALL WGridGetReal(HOBS_SINGLE,6,SHOBTOFF,NN)
            CALL WGridGetReal(HOBS_SINGLE,7,SHOBS,NN)
            CALL WGridGetReal(HOBS_SINGLE,8,SHOBSTAT,NN)
            CALL WGridGetMenu(HOBS_SINGLE,9,ISHOBST,NN)
            CALL WGridGetReal(HOBS_SINGLE,10,SHROFF,NN)
            CALL WGridGetReal(HOBS_SINGLE,11,SHCOFF,NN)
            CALL WGridGetInteger(HOBS_SINGLE,12,ISHOBPLT,NN)
            DO 40 N=1,MXHOB
            IF(SHOBNAM(N).NE.' ') THEN
               CALL NOBLANK(SHOBNAM(N))
               LAYSHOB(1,N)=LAY(N)
               IF(LAYSHOB(1,N).LT.1 .OR. LAYSHOB(1,N).GT.NLAY) THEN
                  CTXT(1)='Invalid HOB layer number'
                  CALL TXTLOG(CTXT,1)
                  IERR=1
                  RETURN
               END IF
               IF(IROWSHOB(N).LT.1 .OR. IROWSHOB(N).GT.NROW) THEN
                  CTXT(1)='Invalid HOB row number'
                  CALL TXTLOG(CTXT,1)
                  IERR=1
                  RETURN
               END IF
               IF(ICOLSHOB(N).LT.1 .OR. ICOLSHOB(N).GT.NCOL) THEN
                  CTXT(1)='Invalid HOB column number'
                  CALL TXTLOG(CTXT,1)
                  IERR=1
                  RETURN
               END IF
            ELSE
               IROWSHOB(N)=0
               ICOLSHOB(N)=0
               SHROFF(N)=0.
               SHCOFF(N)=0.
               SHOBSTAT(N)=1
               SHOBS(N)=0.
               ISHOBST(N)=1
               ISHREFSP(N)=1
               SHOBTOFF(N)=0.
               ISHOBPLT(N)=1
               DO 9 J=1,10
               SHOBPR(J,N)=0.
               LAYSHOB(J,N)=0
9              CONTINUE
            END IF
40          CONTINUE
C
         RETURN
      END
      SUBROUTINE HOBEDML
C  Edit multi-layer values for a single-time hobs
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
      INCLUDE 'mfi2k.inc'
      COMMON /SHOBCOM/LAYSHOB(10,MXHOB),IROWSHOB(MXHOB),ICOLSHOB(MXHOB),
     1               SHROFF(MXHOB),SHCOFF(MXHOB),SHOBSTAT(MXHOB),
     2               SHOBS(MXHOB),ISHOBST(MXHOB),ISHREFSP(MXHOB),
     3               SHOBTOFF(MXHOB),ISHOBPLT(MXHOB),SHOBPR(10,MXHOB)
      COMMON /CSHOBCOM/SHOBNAM
      CHARACTER*12 SHOBNAM(MXHOB)
      CHARACTER*40 CTXT(1)
C     ------------------------------------------------------------------
      CALL WDialogLoad(HOBS_SINGLENAME)
      CALL WDialogputMenu(HOBS_SINGLE,SHOBNAM,MXHOB,1)
      CALL WDialogShow(-1,50,0,Modal)
      IF(WInfoDialog(ExitButton).NE.IDOK) THEN
          RETURN
      END IF
      CALL WDialogGetMenu(HOBS_SINGLE,ISEL)
      CALL WDialogUnload(HOBS_SINGLENAME)
C
10          CALL WDialogLoad(HOBS_MULTILAYER)
            CALL WGridPutInteger(LAYER_GRID,1,LAYSHOB(1,ISEL),10)
            CALL WGridPutReal(LAYER_GRID,2,SHOBPR(1,ISEL),10,' ')
            CALL WDialogShow(-1,50,0,Modal)
            IF(WInfoDialog(ExitButton).EQ.IDOK) THEN
               NN=10
               CALL WGridGetInteger(LAYER_GRID,1,LAYSHOB(1,ISEL),NN)
               CALL WGridGetReal(LAYER_GRID,2,SHOBPR(1,ISEL),NN)
               IF(LAYSHOB(1,ISEL).LT.1 .OR.
     1                        LAYSHOB(1,ISEL).GT.NLAY) THEN
                  CTXT(1)='Invalid HOB layer number'
                  CALL TXTLOG(CTXT,1)
                  GO TO 10
               END IF
               DO 50 I=2,10
               IF(LAYSHOB(I,ISEL).GT.NLAY) THEN
                  CTXT(1)='Invalid HOB layer number'
                  CALL TXTLOG(CTXT,1)
                  GO TO 10
               END IF
50             CONTINUE
            END IF
            CALL WDialogUnload(HOBS_MULTILAYER)
            RETURN
      END
      SUBROUTINE HOBEDMULTITIM
C     ******************************************************************
C     Edit Multi-Time Head Observations
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
      INCLUDE 'mfi2k.inc'
      TYPE(WIN_MESSAGE)   :: MESSAGE
      COMMON /SHOBCOM/LAYSHOB(10,MXHOB),IROWSHOB(MXHOB),ICOLSHOB(MXHOB),
     1               SHROFF(MXHOB),SHCOFF(MXHOB),SHOBSTAT(MXHOB),
     2               SHOBS(MXHOB),ISHOBST(MXHOB),ISHREFSP(MXHOB),
     3               SHOBTOFF(MXHOB),ISHOBPLT(MXHOB),SHOBPR(10,MXHOB)
      COMMON /CSHOBCOM/SHOBNAM
      CHARACTER*12 SHOBNAM(MXHOB)
      COMMON /HOBCOM/LAYHOB(10,MXHOB),IROWHOB(MXHOB),ICOLHOB(MXHOB),
     1               ROFF(MXHOB),COFF(MXHOB),HOBSTAT(MXHOB),HOBS(MXHOB),
     2               IHOBST(MXHOB),IREFSP(MXHOB),HOBTOFF(MXHOB),
     3               IHOBPLT(MXHOB),ITT(MXHOB),DDSTAT(MXHOB),
     4               HOBPR(10,MXHOB)
      COMMON /CHOBCOM/HOBNAM
      CHARACTER*12 HOBNAM(MXHOB)
      DIMENSION IHDLOC(MXHOB+1)
      CHARACTER*70 CTXT(2)
      CHARACTER*92 LSTHOB(MXHOB)
      CHARACTER*46 CTIME
      CHARACTER*22 CLOC
      CHARACTER*12 CLAY
      DIMENSION ISP(200),TOFF(200),H(200),STAT(200),DDST(200),IST(200),
     1          IPLT(200),LAY(10),PROP(10)
      CHARACTER*12 NAM(200),HDNAM
C     ------------------------------------------------------------------
      IULOC=28
C
C  Activate HOB if not active already.
      IF(IUNIT(IULOC).EQ.0) THEN
C  Ready to activate HOB
         CALL FINDUN(38,IU,'HOB','HOB')
         IUNIT(IULOC)=IU
         DO 10 I=1,MXHOB
         SHOBNAM(I)=' '
         IROWSHOB(I)=0
         ICOLSHOB(I)=0
         SHROFF(I)=0.
         SHCOFF(I)=0.
         SHOBSTAT(I)=1
         SHOBS(I)=0.
         ISHOBST(I)=1
         ISHREFSP(I)=1
         SHOBTOFF(I)=0.
         ISHOBPLT(I)=1
         HOBNAM(I)=' '
         IROWHOB(I)=0
         ICOLHOB(I)=0
         ROFF(I)=0.
         COFF(I)=0.
         HOBSTAT(I)=1
         HOBS(I)=0.
         IHOBST(I)=1
         IREFSP(I)=1
         HOBTOFF(I)=0.
         IHOBPLT(I)=1
         ITT(I)=0
         DDSTAT(I)=0.
         DO 9 J=1,10
         SHOBPR(J,I)=0.
         LAYSHOB(J,I)=0
         HOBPR(J,I)=0.
         LAYHOB(J,I)=0
9        CONTINUE
10       CONTINUE
      END IF
C
C  Load the Multi-time Head Observation dialog
      CALL WDialogLoad(HOBS_MULTITIME_DIALOG)
      IPSEL=1
C
2     NHEAD=0
      DO 100 I=1,MXHOB
      IF(HOBNAM(I).NE.' ') THEN
         IF(ITT(I).NE.3) THEN
            NHEAD=NHEAD+1
            IHDLOC(NHEAD)=I
            NT=0
            DO 6 J=1,10
               IF(LAYHOB(J,I).GT.0) NT=NT+1
6           CONTINUE
            CLAY='  Multilayer'
            IF(NT.EQ.1) WRITE(CLAY,'(A,I5)') '  Layer',LAYHOB(1,I)
            WRITE(CLOC,'(A,I5,A,I5)') '  Row',IROWHOB(I),
     1            '  Col.',ICOLHOB(I)
            LSTHOB(NHEAD)=HOBNAM(I)//'   '//CLAY//CLOC
         END IF
      ELSE
         IHDLOC(NHEAD+1)=I
         GO TO 101
      END IF
100   CONTINUE
C
101   CALL WDialogFieldState(HOB_NEW_MULTITIME,Enabled)
      IF(NHEAD.GT.0) THEN
         CALL WDialogFieldState(HEAD_OBS,Enabled)
         CALL WDialogPutMenu(HEAD_OBS,LSTHOB,NHEAD,IPSEL)
         CALL WDialogFieldState(HOB_EDIT_MULTITIME,Enabled)
      ELSE
         LSTHOB(1)='(None)'
         CALL WDialogFieldState(HEAD_OBS,Disabled)
         CALL WDialogPutMenu(HEAD_OBS,LSTHOB,1,1)
         CALL WDialogFieldState(HOB_EDIT_MULTITIME,Disabled)
      END IF
      CALL VALGET('TOMULTH',0,0,ITYPE,TOMULTH)
      IF(ITYPE.NE.0) TOMULTH=1.
      CALL WDialogPutReal(HOBS_TOMULTH,TOMULTH,' ')
      CALL VALGET('EVH',0,0,ITYPE,EVH)
      IF(ITYPE.NE.0) EVH=1.
      CALL WDialogPutReal(HOBS_EVH,EVH,' ')
C
C  Make Dialog visible
      CALL WDialogShow(-1,50,0,SemiModeless)
50    CALL WMessage(ITYPE,MESSAGE)
C
C  Check for push buttons
      IF(ITYPE.EQ.PushButton) THEN
C
C  Check for HOB_COMMENT
         IF(MESSAGE%VALUE1.EQ.HOB_COMMENT) THEN
            CALL COMNTIN(IULOC)
            CALL WDialogSelect(HOBS_MULTITIME_DIALOG)
C
C  Check for HOB_EDIT_MULTITIME
         ELSE IF(MESSAGE%VALUE1.EQ.HOB_EDIT_MULTITIME) THEN
            IF(NHEAD.LE.0) GO TO 2
            CALL WDialogGetMenu(HEAD_OBS,IPSEL)
C  Move existing data into buffer
C  Clear out buffer
            DO 60 I=1,200
            NAM(I)=' '
            ISP(I)=1
            TOFF(I)=0.
            H(I)=0.
            STAT(I)=1.
            DDST(I)=1.
            IST(I)=1
            IPLT(I)=1
60          CONTINUE
            I1=IHDLOC(IPSEL)+1
            I2=IHDLOC(IPSEL+1)-1
            IF(I2-I1.GT.199) THEN
               CTXT(1)='Too many observations at this location'
            CTXT(2)='MFI can only edit 200 observations at one location'
               CALL TXTLOG(CTXT,2)
               GO TO 2
            END IF
            IF(I2.GE.I1) THEN
               N=0
               DO 61 I=I1,I2
               N=N+1
               NAM(N)=HOBNAM(I)
               ISP(N)=IREFSP(I)
               TOFF(N)=HOBTOFF(I)
               H(N)=HOBS(I)
               STAT(N)=HOBSTAT(I)
               DDST(N)=DDSTAT(I)
               IST(N)=IHOBST(I)
               IPLT(N)=IHOBPLT(I)
61             CONTINUE
            END IF
            I=I1-1
            HDNAM=HOBNAM(I)
            IHDROW=IROWHOB(I)
            IHDCOL=ICOLHOB(I)
            HDROFF=ROFF(I)
            HDCOFF=COFF(I)
            IT=ITT(I)
            DO 62 J=1,10
            LAY(J)=LAYHOB(J,I)
            PROP(J)=HOBPR(J,I)
62          CONTINUE
            CALL MTHOBED(NAM,ISP,TOFF,H,STAT,DDST,IST,IPLT,200,
     1           HDNAM,IHDROW,IHDCOL,LAY,PROP,HDROFF,HDCOFF,IT,IOK)
            IF(IOK.EQ.1) THEN
               CALL MTDELETE(NHEAD,IHDLOC,IPSEL)
               CALL MTCOUNT(NAM,200,HDNAM,IHEAD,NTIME)
               IF(NTIME.GT.1) THEN
                  IF((IHEAD+NTIME+IHDLOC(NHEAD+1)-1).GT.MXHOB) THEN
                     CTXT(1)='Too many observations for MFI'
                     CALL TXTLOG(CTXT,1)
                     CALL WDialogSelect(HOBS_MULTITIME_DIALOG)
                     GO TO 2
                  END IF
                  NEWLOC=IHDLOC(IPSEL)
                  CALL MTMOVE(NHEAD,IHDLOC,IPSEL,NTIME)
                  CALL MTINSERT(NAM,ISP,TOFF,H,STAT,DDST,IST,IPLT,200,
     1            HDNAM,IHDROW,IHDCOL,LAY,PROP,HDROFF,HDCOFF,IT,NEWLOC)
               END IF
            END IF
            CALL WDialogSelect(HOBS_MULTITIME_DIALOG)
            GO TO 2
C
C  Check for HOB_NEW_MULTITIME
         ELSE IF(MESSAGE%VALUE1.EQ.HOB_NEW_MULTITIME) THEN
            CALL WDialogGetMenu(HEAD_OBS,IPSEL)
C  Clear out buffer
            DO 70 I=1,200
            NAM(I)=' '
            ISP(I)=1
            TOFF(I)=0.
            H(I)=0.
            STAT(I)=1.
            DDST(I)=1.
            IST(I)=1
            IPLT(I)=1
70          CONTINUE
            HDNAM=' '
            IHDROW=1
            IHDCOL=1
            HDROFF=0.
            HDCOFF=0.
            IT=1
            DO 75 I=1,10
            LAY(I)=0
            PROP(I)=0.
75          CONTINUE
            CALL MTHOBED(NAM,ISP,TOFF,H,STAT,DDST,IST,IPLT,200,
     1           HDNAM,IHDROW,IHDCOL,LAY,PROP,HDROFF,HDCOFF,IT,IOK)
            IF(IOK.EQ.1) THEN
               CALL MTCOUNT(NAM,200,HDNAM,IHEAD,NTIME)
               IF(NTIME.GT.1) THEN
                  IF((IHEAD+NTIME+IHDLOC(NHEAD+1)-1).GT.MXHOB) THEN
                     CTXT(1)='Too many observations for MFI'
                     CALL TXTLOG(CTXT,1)
                     CALL WDialogSelect(HOBS_MULTITIME_DIALOG)
                     GO TO 2
                  END IF
                  NEWLOC=IHDLOC(IPSEL)
                  CALL MTMOVE(NHEAD,IHDLOC,IPSEL,NTIME)
                  CALL MTINSERT(NAM,ISP,TOFF,H,STAT,DDST,IST,IPLT,200,
     1            HDNAM,IHDROW,IHDCOL,LAY,PROP,HDROFF,HDCOFF,IT,NEWLOC)
               END IF
            END IF
            CALL WDialogSelect(HOBS_MULTITIME_DIALOG)
            GO TO 2
C
C  Check for OK
         ELSE IF(MESSAGE%VALUE1.EQ.HOB_IDOK) THEN
            CALL WDialogGetReal(HOBS_TOMULTH,TOMULTH)
            CALL VALSAV('TOMULTH',0,0,TOMULTH)
            CALL WDialogGetReal(HOBS_EVH,EVH)
            CALL VALSAV('EVH',0,0,EVH)
            CALL WDialogUnload(HOBS_MULTITIME_DIALOG)
            CALL HOBSV(IUNDEF,1)
            RETURN
C
C  Check for Cancel
         ELSE IF(MESSAGE%VALUE1.EQ.HOB_IDCANCEL) THEN
            CALL WDialogUnload(HOBS_MULTITIME_DIALOG)
            RETURN
         END IF
C
C  Ignore all other types of message
      END IF
      GO TO 50
C
      END
      SUBROUTINE MTHOBED(NAM,ISP,TOFF,H,STAT,DDST,IST,IPLT,
     1           NBF,HDNAM,IHDROW,IHDCOL,LAY,PROP,HDROFF,HDCOFF,IT,IOK)
C     ******************************************************************
C     Edit a multi-time HOBS header and the associated observations
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
      INCLUDE 'mfi2k.inc'
      TYPE(WIN_MESSAGE)   :: MESSAGE
      DIMENSION ISP(NBF),TOFF(NBF),H(NBF),STAT(NBF),DDST(NBF),IST(NBF),
     1          IPLT(NBF),LAY(10),PROP(10)
      CHARACTER*12 NAM(NBF),HDNAM
      CHARACTER*50 CTXT(1)
C     ------------------------------------------------------------------
      IOK=0
10    CALL WDialogLoad(HOBS_HEADER_DIALOG)
C
      CALL WDialogPutString(HOBS_HOBNAM,HDNAM)
      CALL WDialogPutInteger(HOBS_IROWHOB,IHDROW)
      CALL WDialogPutInteger(HOBS_ICOLHOB,IHDCOL)
      CALL WDialogPutReal(HOBS_ROFF,HDROFF,' ')
      CALL WDialogPutReal(HOBS_COFF,HDCOFF,' ')
      CALL WGridPutInteger(HOBS_LAYER,1,LAY,10)
      CALL WGridPutReal(HOBS_LAYER,2,PROP,10,' ')
      IF(IT.EQ.1) THEN
         CALL WDialogPutRadioButton(HOBS_ITTHEAD)
      ELSE
         CALL WDialogPutRadioButton(HOBS_ITTDRAW)
      END IF
C
      CALL WGridPutString(HOB_TIME_GRID,1,NAM,NBF)
      CALL WGridPutInteger(HOB_TIME_GRID,2,ISP,NBF)
      CALL WGridPutReal(HOB_TIME_GRID,3,TOFF,NBF,'(1PG13.6)')
      CALL WGridPutReal(HOB_TIME_GRID,4,H,NBF,' ')
      CALL WGridPutReal(HOB_TIME_GRID,5,STAT,NBF,' ')
      CALL WGridPutReal(HOB_TIME_GRID,6,DDST,NBF,' ')
      CALL WGridPutOption(HOB_TIME_GRID,7,IST,NBF)
      CALL WGridPutInteger(HOB_TIME_GRID,8,IPLT,NBF)
C
C  Make Dialog visible
      CALL WDialogShow(-1,50,0,Modal)
C
      IF(WInfoDialog(ExitButton).EQ.IDOK) THEN
         NN=NBF
         CALL WGridGetString(HOB_TIME_GRID,1,NAM,NN)
         DO 40 I=1,NBF
         CALL NOBLANK(NAM(I))
40       CONTINUE
         CALL WGridGetInteger(HOB_TIME_GRID,2,ISP,NN)
         CALL WGridGetReal(HOB_TIME_GRID,3,TOFF,NN)
         CALL WGridGetReal(HOB_TIME_GRID,4,H,NN)
         CALL WGridGetReal(HOB_TIME_GRID,5,STAT,NN)
         CALL WGridGetReal(HOB_TIME_GRID,6,DDST,NN)
         CALL WGridGetMenu(HOB_TIME_GRID,7,IST,NN)
         CALL WGridGetInteger(HOB_TIME_GRID,8,IPLT,NN)
C
         CALL WDialogGetString(HOBS_HOBNAM,HDNAM)
         CALL NOBLANK(HDNAM)
         NN=10
         CALL WGridGetInteger(HOBS_LAYER,1,LAY,NN)
         CALL WGridGetReal(HOBS_LAYER,2,PROP,NN)
         CALL WDialogGetInteger(HOBS_IROWHOB,IHDROW)
         CALL WDialogGetInteger(HOBS_ICOLHOB,IHDCOL)
         CALL WDialogGetReal(HOBS_ROFF,HDROFF)
         CALL WDialogGetReal(HOBS_COFF,HDCOFF)
         CALL WDialogGetRadioButton(HOBS_ITTHEAD,ISET)
         IF(ISET.EQ.1) IT=1
         IF(ISET.NE.1) IT=2
         IF(HDNAM.EQ.' ') THEN
            CALL WMessageBox(YesNo,QuestionIcon,CommonYes,
     1   'Blank header name -- this will cause all observations at'//
     2   ' this location to be deleted.  Is this what you want?',' ')
            IRESP=WInfoDialog(ExitButtonCommon)
            IF(IRESP.EQ.CommonYes) THEN
               CALL WDialogUnload(HOBS_HEADER_DIALOG)
               IOK=1
               RETURN
            END IF
            GO TO 10
         END IF
         IF(LAY(1).LT.1 .OR. LAY(1).GT.NLAY) THEN
            CTXT(1)='Invalid HOB layer number'
            CALL TXTLOG(CTXT,1)
            GO TO 10
         END IF
         DO 50 I=2,10
         IF(LAY(I).GT.NLAY) THEN
            CTXT(1)='Invalid HOB layer number'
            CALL TXTLOG(CTXT,1)
            GO TO 10
         END IF
50       CONTINUE
         IF(IHDROW.LT.1 .OR. IHDROW.GT.NROW) THEN
            CTXT(1)='Invalid HOB row number'
            CALL TXTLOG(CTXT,1)
            GO TO 10
         END IF
         IF(IHDCOL.LT.1 .OR. IHDCOL.GT.NCOL) THEN
            CTXT(1)='Invalid HOB column number'
            CALL TXTLOG(CTXT,1)
            GO TO 10
         END IF
         IOK=1
C
      END IF
C
      CALL WDialogUnload(HOBS_HEADER_DIALOG)
C
      RETURN
      END
      SUBROUTINE MTCOUNT(NAM,NNAM,HDNAM,IHEAD,NTIME)
C     Count multi-time records
C     ******************************************************************
      CHARACTER*12 NAM(NNAM),HDNAM
C     ------------------------------------------------------------------
      NTIME=0
      IF(HDNAM.EQ.' ') THEN
         IHEAD=0
         RETURN
      END IF
C
      IHEAD=1
      DO 10 I=1,NNAM
      IF(NAM(I).NE.' ') NTIME=NTIME+1
10    CONTINUE
C
      RETURN
      END
      SUBROUTINE MTMOVE(NHEAD,IHDLOC,IPSEL,NTIME)
C     Move multi-time values to make a hole for new values
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      COMMON /HOBCOM/LAYHOB(10,MXHOB),IROWHOB(MXHOB),ICOLHOB(MXHOB),
     1               ROFF(MXHOB),COFF(MXHOB),HOBSTAT(MXHOB),HOBS(MXHOB),
     2               IHOBST(MXHOB),IREFSP(MXHOB),HOBTOFF(MXHOB),
     3               IHOBPLT(MXHOB),ITT(MXHOB),DDSTAT(MXHOB),
     4               HOBPR(10,MXHOB)
      COMMON /CHOBCOM/HOBNAM
      CHARACTER*12 HOBNAM(MXHOB)
      DIMENSION IHDLOC(MXHOB+1)
C     ------------------------------------------------------------------
      IF(IPSEL.GT.NHEAD) THEN
         NHEAD=NHEAD+1
         IHDLOC(NHEAD+1)=IHDLOC(NHEAD)+1+NTIME
         RETURN
      END IF
C
      NMOVE=NTIME+1
      IEOLD=IHDLOC(NHEAD+1)-1
      IBOLD=IHDLOC(IPSEL)
C
      DO 100 I=IEOLD,IBOLD,-1
      INEW=I+NMOVE
      HOBNAM(INEW)=HOBNAM(I)
      DO 90 J=1,10
      LAYHOB(J,INEW)=LAYHOB(J,I)
      HOBPR(J,INEW)=HOBPR(J,I)
90    CONTINUE
      IROWHOB(INEW)=IROWHOB(I)
      ICOLHOB(INEW)=ICOLHOB(I)
      ROFF(I)=ROFF(I)
      COFF(INEW)=COFF(I)
      HOBSTAT(INEW)=HOBSTAT(I)
      HOBS(INEW)=HOBS(I)
      IHOBST(INEW)=IHOBST(I)
      IREFSP(INEW)=IREFSP(I)
      HOBTOFF(INEW)=HOBTOFF(I)
      IHOBPLT(INEW)=IHOBPLT(I)
      ITT(INEW)=ITT(I)
      DDSTAT(INEW)=DDSTAT(I)
100   CONTINUE
C
      DO 200 I=NHEAD+1,IPSEL,-1
      IHDLOC(I+1)=IHDLOC(I)+NMOVE
200   CONTINUE
      NHEAD=NHEAD+1
C
      RETURN
      END
      SUBROUTINE MTINSERT(NAM,ISP,TOFF,H,STAT,DDST,IST,IPLT,NBF,
     1           HDNAM,IHDROW,IHDCOL,LAY,PROP,HDROFF,HDCOFF,IT,NEWLOC)
C     Move multi-time data from buffer into main list
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      DIMENSION ISP(NBF),TOFF(NBF),H(NBF),STAT(NBF),DDST(NBF),IST(NBF),
     1          IPLT(NBF),LAY(10),PROP(10)
      CHARACTER*12 NAM(NBF),HDNAM
      COMMON /HOBCOM/LAYHOB(10,MXHOB),IROWHOB(MXHOB),ICOLHOB(MXHOB),
     1               ROFF(MXHOB),COFF(MXHOB),HOBSTAT(MXHOB),HOBS(MXHOB),
     2               IHOBST(MXHOB),IREFSP(MXHOB),HOBTOFF(MXHOB),
     3               IHOBPLT(MXHOB),ITT(MXHOB),DDSTAT(MXHOB),
     4               HOBPR(10,MXHOB)
      COMMON /CHOBCOM/HOBNAM
      CHARACTER*12 HOBNAM(MXHOB)
C     ------------------------------------------------------------------
      ILOC=NEWLOC
C  Move multi-time header
         HOBNAM(ILOC)=HDNAM
         IROWHOB(ILOC)=IHDROW
         ICOLHOB(ILOC)=IHDCOL
         ROFF(ILOC)=HDROFF
         COFF(ILOC)=HDCOFF
         ITT(ILOC)=IT
         DO 90 J=1,10
         LAYHOB(J,ILOC)=LAY(J)
         HOBPR(J,ILOC)=PROP(J)
90       CONTINUE
C
C  Move each time
      DO 100 I=1,NBF
      IF(NAM(I).NE.' ') THEN
         ILOC=ILOC+1
         HOBNAM(ILOC)=NAM(I)
         HOBSTAT(ILOC)=STAT(I)
         HOBS(ILOC)=H(I)
         IHOBST(ILOC)=IST(I)
         IREFSP(ILOC)=ISP(I)
         HOBTOFF(ILOC)=TOFF(I)
         IHOBPLT(ILOC)=IPLT(I)
         DDSTAT(ILOC)=DDST(I)
         ITT(ILOC)=3
      END IF
100   CONTINUE
C
      RETURN
      END
      SUBROUTINE MTDELETE(NHEAD,IHDLOC,IPSEL)
C  Delete multi-time observations for one header
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      COMMON /HOBCOM/LAYHOB(10,MXHOB),IROWHOB(MXHOB),ICOLHOB(MXHOB),
     1               ROFF(MXHOB),COFF(MXHOB),HOBSTAT(MXHOB),HOBS(MXHOB),
     2               IHOBST(MXHOB),IREFSP(MXHOB),HOBTOFF(MXHOB),
     3               IHOBPLT(MXHOB),ITT(MXHOB),DDSTAT(MXHOB),
     4               HOBPR(10,MXHOB)
      COMMON /CHOBCOM/HOBNAM
      CHARACTER*12 HOBNAM(MXHOB)
      DIMENSION IHDLOC(MXHOB+1)
C     ------------------------------------------------------------------
      IF(IPSEL.GT.NHEAD) RETURN
C
      NMOVE=IHDLOC(IPSEL+1)-IHDLOC(IPSEL)
      ISTART=IHDLOC(IPSEL+1)
      ISTOP=IHDLOC(NHEAD+1)-1
C
C  Move the list of observations
      IF(ISTOP.GE.ISTART) THEN
         DO 100 I=ISTART,ISTOP
         INEW=I-NMOVE
         HOBNAM(INEW)=HOBNAM(I)
         DO 90 J=1,10
         LAYHOB(J,INEW)=LAYHOB(J,I)
         HOBPR(J,INEW)=HOBPR(J,I)
90       CONTINUE
         IROWHOB(INEW)=IROWHOB(I)
         ICOLHOB(INEW)=ICOLHOB(I)
         ROFF(I)=ROFF(I)
         COFF(INEW)=COFF(I)
         HOBSTAT(INEW)=HOBSTAT(I)
         HOBS(INEW)=HOBS(I)
         IHOBST(INEW)=IHOBST(I)
         IREFSP(INEW)=IREFSP(I)
         HOBTOFF(INEW)=HOBTOFF(I)
         IHOBPLT(INEW)=IHOBPLT(I)
         ITT(INEW)=ITT(I)
         DDSTAT(INEW)=DDSTAT(I)
100      CONTINUE
      END IF
C
C  Delete entries at the end of the list
      ISTART=IHDLOC(NHEAD+1)-NMOVE
      ISTOP=IHDLOC(NHEAD+1)-1
      DO 200 I=ISTART,ISTOP
      HOBNAM(I)=' '
200   CONTINUE
C
C  Fixup IHDLOC
      DO 300 I=IPSEL,NHEAD
      IHDLOC(I)=IHDLOC(I+1)-NMOVE
300   CONTINUE
      NHEAD=NHEAD-1
C
      RETURN
      END
