      SUBROUTINE RCH6AL(IBDSAM,NPRCH)
C
C     ******************************************************************
C     ALLOCATE ARRAY STORAGE FOR RECHARGE
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      CHARACTER*200 LINE
C     ------------------------------------------------------------------
      IN=IUNIT(8)
C
C1------IDENTIFY PACKAGE.
      WRITE(IOUT,1)IN
    1 FORMAT(1X,/1X,'RCH -- RECHARGE PACKAGE,',
     1' INPUT READ FROM UNIT',I3)
C
C2------READ NRCHOP AND IRCHCB.
      CALL URDCOM(IUREAL(IN),LINE,8)
      CALL UPARARRAL(IUREAL(IN),IOUT,LINE,NPRCH)
      IF(MODINP.EQ.0) THEN
         READ(LINE,'(2I10)') NRCHOP,IRCHCB
      ELSE
         LLOC=1
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NRCHOP,R,IOUT,IN)
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IRCHCB,R,IOUT,IN)
      END IF
C
C3------CHECK TO SEE THAT OPTION IS LEGAL.
      IF(NRCHOP.GE.1.AND.NRCHOP.LE.3)GO TO 200
C
C3A-----IF ILLEGAL PRINT A MESSAGE AND ABORT SIMULATION
      WRITE(IOUT,8)
    8 FORMAT(1X,'ILLEGAL OPTION CODE. SIMULATION ABORTING')
      CALL RDABRT
C
C4------IF OPTION IS LEGAL PRINT OPTION CODE.
  200 IF(NRCHOP.EQ.1) WRITE(IOUT,201)
  201 FORMAT(1X,'OPTION 1 -- RECHARGE TO TOP LAYER')
      IF(NRCHOP.EQ.2) WRITE(IOUT,202)
  202 FORMAT(1X,'OPTION 2 -- RECHARGE TO ONE SPECIFIED NODE IN EACH',
     1        ' VERTICAL COLUMN')
      IF(NRCHOP.EQ.3) WRITE(IOUT,203)
  203 FORMAT(1X,'OPTION 3 -- RECHARGE TO HIGHEST ACTIVE NODE IN EACH',
     1        ' VERTICAL COLUMN')
C
C5------IF CELL-BY-CELL FLOWS ARE TO BE SAVED, THEN PRINT UNIT NUMBER.
      IF(IRCHCB.GT.0) WRITE(IOUT,204) IRCHCB
  204 FORMAT(1X,'CELL-BY-CELL FLOWS WILL BE SAVED ON UNIT',I3)
C
      CALL IVLSAV('NRCHOP',0,0,NRCHOP)
      IUNIT2(8)=IRCHCB
      IF(IRCHCB.LE.0) IUNIT2(8)=0
      IF(IRCHCB.GT.0) THEN
         IF(FILTYP(IRCHCB).EQ.'DATA(BINARY)') THEN
            IFNUSE(IRCHCB)=IUNIT(12)
         ELSE IF(FILTYP(IRCHCB).EQ.' ') THEN
            IUNIT2(8)=0
         ELSE
            WRITE(IOUT,*)
     1 'Attempt to save CBC budget in a file that is not DATA(BINARY)'
            CALL RDABRT
         END IF
         IF((IHEDUN.GT.0 .AND. IUNIT2(8).EQ.IHEDUN) .OR.
     1      (IDDNUN.GT.0 .AND. IUNIT2(8).EQ.IDDNUN)) THEN
            WRITE(IOUT,*) 'CBC file is same as HEAD or DRAWDOWN file'
            CALL RDABRT
         END IF
      END IF
      IF(IBDSAM.EQ.-2) THEN
         IF(IRCHCB.NE.0) IBDSAM=IRCHCB
      ELSE
         IF(IBDSAM.NE.IRCHCB) IBDSAM=0
      END IF
C
C9------RETURN
      RETURN
      END
      SUBROUTINE RCH6RQ(NPRCH)
C     ******************************************************************
C     Read parameters
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      CHARACTER*4 PTYP
C     ------------------------------------------------------------------
      IF(NPRCH.LE.0) RETURN
C
      IN=IUNIT(8)
      ITERP=1
      DO 20 K=1,NPRCH
      CALL UPARARRRP(IUREAL(IN),IOUT,N,0,PTYP,ITERP)
      IF(PTYP.NE.'RCH') THEN
         WRITE(IOUT,7)
7        FORMAT(1X,'Parameter type must be RCH')
         CALL RDABRT
      END IF
20    CONTINUE
C
      RETURN
      END
      SUBROUTINE RCH6RP(KPER,NPRCH)
C     ******************************************************************
C     READ RECHARGE RATES
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      CHARACTER*24 ANAME(2)
C
      DATA ANAME(1) /'    RECHARGE LAYER INDEX'/
      DATA ANAME(2) /'                RECHARGE'/
C     ------------------------------------------------------------------
      IN=IUNIT(8)
      CALL IVLGET('NRCHOP',0,0,ITYPE,NRCHOP)
C
C1------READ FLAGS SHOWING WHETHER DATA IS TO BE REUSED.
      IF(NRCHOP.EQ.2) THEN
         IF(MODINP.EQ.0) READ(IUREAL(IN),'(2I10)') INRECH,INIRCH
         IF(MODINP.NE.0) READ(IUREAL(IN),*) INRECH,INIRCH
      ELSE
         IF(MODINP.EQ.0) READ(IUREAL(IN),'(I10)') INRECH
         IF(MODINP.NE.0) READ(IUREAL(IN),*) INRECH
      END IF
C
C2------TEST INRECH TO SEE WHERE RECH IS COMING FROM.
      IF(INRECH.GE.0)GO TO 32
C
C2A-----IF INRECH<0 THEN REUSE RECHARGE ARRAY FROM LAST STRESS PERIOD
      WRITE(IOUT,3)
    3 FORMAT(1X,/1X,'REUSING RECH FROM LAST STRESS PERIOD')
      IF(NPRCH.LE.0) THEN
         CALL VALGET('RECH',0,KPER-1,NAR,DUM)
         IF(NAR.LE.0) THEN
            WRITE(IOUT,*) ' ATTEMPT TO REUSE UNDEFINED RECHARGE DATA'
            CALL RDABRT
         END IF
         CALL ARRMAK('RECH',0,KPER,NCOL,NROW)
         ARRCON(NARRAY)=ARRCON(NAR)
         IARRDA(1,NARRAY)=-3
         IARRDA(5,NARRAY)=IARRDA(5,NAR)
         GO TO 55
      ELSE
C  Reuse parameters from last stress period
         CALL ARRMAK('RECH',0,KPER,NCOL,NROW)
         IARRDA(1,NARRAY)=-3
         GO TO 55
      END IF
C
C3------IF INRECH=>0 THEN CALL U2DREL TO READ RECHARGE RATE OR READ PARAMETERS.
32    IF(NPRCH.LE.0) THEN
         CALL ARRMAK('RECH',0,KPER,NCOL,NROW)
         CALL U2DREL(ANAME(2),NROW,NCOL,0,IN,NARRAY,IN)
      ELSE
         IRCHPF=-999
         CALL PERPARRD(IUREAL(IN),INRECH,'RCH',KPER,IRCHPF)
         IF(IRCHPF.GT.-999) CALL IVLSAV('IRCHPF',0,KPER,IRCHPF)
      END IF
C
C5------IF NRCHOP=2 THEN A LAYER INDICATOR ARRAY IS NEEDED.
  55  IF (NRCHOP.NE.2) RETURN
C
C6------IF INIRCH<0 THEN REUSE LAYER INDICATOR ARRAY.
      IF(INIRCH.GE.0)GO TO 58
      WRITE(IOUT,2)
    2 FORMAT(1X,/1X,'REUSING IRCH FROM LAST STRESS PERIOD')
      CALL VALGET('IRCH',0,KPER-1,NAR,DUM)
      IF(NAR.LE.0) THEN
         WRITE(IOUT,*) ' ATTEMPT TO REUSE UNDEFINED IRCH DATA'
         CALL RDABRT
      END IF
      CALL ARRMAK('IRCH',0,KPER,NCOL,NROW)
      ARRCON(NARRAY)=ARRCON(NAR)
      IARRDA(1,NARRAY)=-3
      IARRDA(5,NARRAY)=IARRDA(5,NAR)
      RETURN
C
C7------IF INIRCH=>0 CALL U2DINT TO READ LAYER IND ARRAY(IRCH)
58    CALL ARRMAK('IRCH',0,KPER,NCOL,NROW)
      CALL U2DINT(ANAME(1),NROW,NCOL,0,IN,NARRAY,IN)
      RETURN
C
      END
      SUBROUTINE RCHSV(IUNDEF,IWRFLG)
C
C     ******************************************************************
C     SAVE DATA FOR RECHARGE PACKAGE
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      INCLUDE 'mfi2kpar.inc'
      CHARACTER*10 MN,ZN
      CHARACTER*4 CPF
C     ------------------------------------------------------------------
      IULOC=8
      IF(IUNIT(IULOC).EQ.0) THEN
         IUNDEF=-1
         RETURN
      END IF
C
      IHEAD=0
      NM=0
      DO 5 I=1,MXFNAM
      IF(IFNUSE(I).EQ.IUNIT(IULOC)) IFNUSE(I)=0
5     CONTINUE
      IFNUSE(IUNIT(IULOC))=IUNIT(IULOC)
C
      IF(IUREAL(IUNIT(IULOC)).EQ.0) CALL REALUN(IUNIT(IULOC))
      IUNDEF=0
      IFIL=IUMISC
      IF(IWRFLG.LE.0) IFIL=0
      IF(IWRFLG.EQ.1) OPEN(FILE='MFI.RCH',UNIT=IFIL)
      IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUNIT(IULOC)),UNIT=IFIL)
C
C  Write comments
      IF(IWRFLG.GT.0) THEN
         DO 8 I=1,20
         IF(COMENT(I,IULOC)(1:1).EQ.'#') THEN
            DO 6 N=80,1,-1
            IF(COMENT(I,IULOC)(N:N) .NE. ' ') GO TO 7
6           CONTINUE
7           WRITE(IFIL,'(A)') COMENT(I,IULOC)(1:N)
         END IF
8        CONTINUE
      END IF
C
C  Write the number of parameters if there are any.
      NP=0
      DO 10 I=1,IPSUM
      IF(PARTYP(I).EQ.'RCH') THEN
         NP=NP+1
      END IF
10    CONTINUE
      IF(NP.GT.0. AND. IWRFLG.GT.0) WRITE(IFIL,2) NP
2     FORMAT('PARAMETER',1X,I10)
C
      CALL IVLGET('NRCHOP',0,0,ITYPE,NRCHOP)
      IF(ITYPE.NE.0) NRCHOP=1
      IRCHCB=IBUDUN
      IF(IBUDUN.EQ.0) IRCHCB=IUNIT2(IULOC)
      ITMP=IRCHCB
      IF(ITMP.GT.0) THEN
         IF(IUREAL(ITMP).EQ.0) CALL REALUN(ITMP)
         ITMP=IUREAL(ITMP)
      END IF
      IF(IWRFLG.GT.0) THEN
         WRITE(IFIL,'(2I10,A)') NRCHOP,ITMP,'  NRCHOP IRCHCB'
      END IF
C
C  Write the parameter definitions if there are any.
      IF(NP.GT.0 .AND. IWRFLG.GT.0) THEN
         DO 20 J=1,IPSUM
         IF(PARTYP(J).EQ.'RCH') THEN
            NCLU=IPLOC(2,J)-IPLOC(1,J)+1
            WRITE(IFIL,11) PARNAM(J),PARTYP(J),B(J),NCLU
11          FORMAT(A,1X,A,1P,E14.6,I10)
            DO 15 K=IPLOC(1,J),IPLOC(2,J)
            MN=CPCLST(1,K)
            ZN=CPCLST(2,K)
            IF(ZN.NE.'ALL') THEN
               WRITE(IFIL,12) MN,ZN,(IPCLST(L,K),L=3,IPCLST(2,K))
12             FORMAT(A,1X,A,10(1X,I4))
            ELSE
               WRITE(IFIL,12) MN,ZN
            END IF
15          CONTINUE
         END IF
20       CONTINUE
      END IF
C
C  Write data for each stress period
      DO 100 KPER=1,NPER
      INRECH=0
      INIRCH=0
C
      IF(NP.LE.0) THEN
C  RECH is an array
         CALL VALGET('RECH',0,KPER,NAR,DUM)
         IF(NAR.GT.0) THEN
            IF(IARRDA(1,NAR).EQ.-3) INRECH=-1
         END IF
      ELSE
C  RECH is defined by parameters
         CALL VALGET('RECH',0,KPER,NAR,DUM)
         IF(NAR.GT.0) THEN
            IF(IARRDA(1,NAR).EQ.-3) INRECH=-1
         END IF
         IF(INRECH.EQ.0) THEN
            DO 50 I=1,MXPERPAR
            IF(PERPARTYP(I).EQ.'RCH' .AND. IPERPARPER(I).EQ.KPER) THEN
               INRECH=INRECH+1
            END IF
50          CONTINUE
         END IF
      END IF
      IF(NRCHOP.EQ.2) THEN
         CALL VALGET('IRCH',0,KPER,NAR,DUM)
         IF(NAR.GT.0) THEN
            IF(IARRDA(1,NAR).EQ.-3) INIRCH=-1
         END IF
      END IF
      IF(IWRFLG.GT.0) WRITE(IFIL,'(2I10,A)')
     1           INRECH,INIRCH,'  INRECH INIRCH'
C
C  RECH array
      IF(NP.LE.0) THEN
         IF(INRECH.GE.0) THEN
            CALL U2DRSV('RECH',0,KPER,IUNDEF,IFIL,IUNIT(IULOC),'RECH',0)
            IF(IUNDEF.NE.0 .AND. IWRFLG.LT.0) THEN
               IUNDEF=0
               NM=NM+1
               IF(IHEAD.EQ.0) CALL STRHED(IHEAD,'RCH')
               IF(NMISS.LT.45) THEN
                  NMISS=NMISS+1
                  WRITE(CTEXT(NMISS),'(A,I4)') 'RECH            ',KPER
               END IF
            END IF
         END IF
      ELSE
         IF(IWRFLG.GT.0 .AND. INRECH.GT.0) THEN
            CPF=' '
            CALL IVLGET('IRCHPF',0,KPER,N,IRCHPF)
            IF(N.EQ.0) WRITE(CPF,'(I4)') IRCHPF 
            DO 60 I=1,MXPERPAR
            IF(PERPARTYP(I).EQ.'RCH' .AND. IPERPARPER(I).EQ.KPER) THEN
               WRITE(IFIL,'(A,1X,A)') PERPARNAM(I),CPF
               CPF=' '
            END IF
60          CONTINUE
         END IF
      END IF
C
C  IRCH array
      IF(NRCHOP.EQ.2) THEN
         IF(INIRCH.GE.0) THEN
            CALL U2DISV('IRCH',0,KPER,IUNDEF,IFIL,IUNIT(IULOC))
            IF(IUNDEF.NE.0 .AND. IWRFLG.LT.0) THEN
               IUNDEF=0
               NM=NM+1
               IF(IHEAD.EQ.0) CALL STRHED(IHEAD,'RCH')
               IF(NMISS.LT.45) THEN
                  NMISS=NMISS+1
                  WRITE(CTEXT(NMISS),'(A,I4)') 'IRCH            ',KPER
               END IF
            END IF
         END IF
      END IF
100   CONTINUE
C
      IF(IWRFLG.GT.0) CLOSE(UNIT=IFIL)
      IF(NM.EQ.0 .AND. IWRFLG.LT.0 .AND. NMISS.LT.45) THEN
         NMISS=NMISS+1
         CTEXT(NMISS)='ALL DATA ARE DEFINED FOR RCH PACKAGE'
      END IF
      IF(NM.NE.0) IUNDEF=1
      CALL FNMRMV
      RETURN
      END
