      SUBROUTINE RIV6AL(IBDSAM,NPRIV)
C
C     ******************************************************************
C     ALLOCATE ARRAY STORAGE FOR River PACKAGE
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
C  Common block for RIV Package
      COMMON /RIVCOM/RIVAUX(3)
      CHARACTER*16 RIVAUX
      CHARACTER*200 LINE
C     ------------------------------------------------------------------
      IULOC=4
      IN=IUNIT(IULOC)
C
C1------IDENTIFY PACKAGE.
      WRITE(IOUT,1)IN
    1 FORMAT(1X,/1X,'RIV -- RIVER PACKAGE,  INPUT READ FROM UNIT',I3)
      NNPRIV=0
C
C2------READ MAXIMUM NUMBER OF RIVER REACHESS AND UNIT OR FLAG FOR
C2------CELL-BY-CELL FLOW TERMS.
      CALL URDCOM(IUREAL(IN),LINE,IULOC)
      CALL UPARLSTAL(IUREAL(IN),IOUT,LINE,NPRIV,MXPW)
      IF(MODINP.EQ.0) THEN
         READ(LINE,'(2I10)') MXACTR,IRIVCB
         LLOC=21
      ELSE
         LLOC=1
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,MXACTR,R,IOUT,IN)
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IRIVCB,R,IOUT,IN)
      END IF
      WRITE(IOUT,3) MXACTR
    3 FORMAT(1X,'MAXIMUM OF',I5,' ACTIVE REACHESS AT ONE TIME')
      IF(IRIVCB.LT.0) WRITE(IOUT,7)
    7 FORMAT(1X,'CELL-BY-CELL FLOWS WILL BE PRINTED WHEN ICBCFL NOT 0')
      IF(IRIVCB.GT.0) WRITE(IOUT,8) IRIVCB
    8 FORMAT(1X,'CELL-BY-CELL FLOWS WILL BE SAVED ON UNIT',I3)
C
C  Process CBC flag
      IF(IRIVCB.LT.0) IRIVCB=-1
      IUNIT2(IULOC)=IRIVCB
      IF(IRIVCB.GT.0) THEN
         IF(FILTYP(IRIVCB).EQ.'DATA(BINARY)') THEN
            IFNUSE(IRIVCB)=IUNIT(12)
         ELSE IF(FILTYP(IRIVCB).EQ.' ') THEN
            IUNIT2(IULOC)=0
         ELSE
            WRITE(IOUT,*)
     1 'Attempt to save CBC budget in a file that is not DATA(BINARY)'
            CALL RDABRT
         END IF
         IF((IHEDUN.GT.0 .AND. IUNIT2(IULOC).EQ.IHEDUN) .OR.
     1      (IDDNUN.GT.0 .AND. IUNIT2(IULOC).EQ.IDDNUN)) THEN
            WRITE(IOUT,*) 'CBC file is same as HEAD or DRAWDOWN file'
            CALL RDABRT
         END IF
      END IF
      IF(IBDSAM.EQ.-2) THEN
         IF(IRIVCB.NE.0) IBDSAM=IRIVCB
      ELSE
         IF(IBDSAM.NE.IRIVCB) IBDSAM=0
      END IF
C
C3------READ AUXILIARY VARIABLES AND CBC ALLOCATION OPTION.
      IRIVAL=0
      NAUX=0
   10 CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IN)
      IF(LINE(ISTART:ISTOP).EQ.'CBCALLOCATE' .OR.
     1   LINE(ISTART:ISTOP).EQ.'CBC') THEN
         IRIVAL=1
         WRITE(IOUT,11)
   11    FORMAT(1X,'MEMORY IS ALLOCATED FOR CELL-BY-CELL BUDGET TERMS')
         GO TO 10
      ELSE IF(LINE(ISTART:ISTOP).EQ.'AUXILIARY' .OR.
     1        LINE(ISTART:ISTOP).EQ.'AUX') THEN
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IN)
         IF(NAUX.LT.3) THEN
            NAUX=NAUX+1
            RIVAUX(NAUX)=LINE(ISTART:ISTOP)
            WRITE(IOUT,12) RIVAUX(NAUX)
   12       FORMAT(1X,'AUXILIARY RIV VARIABLE: ',A)
         ELSE 
            WRITE(IOUT,*) ' Too many auxiliary variables for MFI2K'
            CALL RDABRT
         END IF
         GO TO 10
      END IF
C
C6------RETURN
      RETURN
      END
      SUBROUTINE RIV6RQ(NPRIV)
C
C     ******************************************************************
C     READ PARAMETERS
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      COMMON /RIVCOM/RIVAUX(3)
      CHARACTER*16 RIVAUX
      CHARACTER*10 ARRNAM
C     ------------------------------------------------------------------
      IW=9
      IULOC=4
      IN=IUNIT(IULOC)
C
C-------READ NAMED PARAMETERS
      WRITE(IOUT,3) NPRIV
    3 FORMAT(1X,//1X,I5,' RIV parameters')
      IF(NPRIV.GT.0) THEN
        DO 5 K=1,NPRIV
C---------READ AND STORE LIST PARAMETER DEFINITION INFORMATION
          CALL UPARLSTRP(IUREAL(IN),'RIV','RIV',NLST,ARRNAM)
C  Make a data list for the parameter
          CALL LSTMAK2(ARRNAM,-3,-3,IW,NLST)
          NAR=NARRAY
C---------READ AND PRINT A LIST OF CELLS
          CALL LSTRD2(NLST,NAR,IX(IARRDA(2,NAR)),IN,
     1'REACH NO. LAYER   ROW   COL     STAGE   CONDUCTANCE  BOT. ELEV.',
     2      RIVAUX,3)
    5   CONTINUE
      END IF
C
C6------RETURN
      RETURN
      END
      SUBROUTINE RIV6RP(KPER,NPRIV)
C
C     ******************************************************************
C     READ NEW RIVER LOCATIONS AND STRESS RATES
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      COMMON /RIVCOM/RIVAUX(3)
      CHARACTER*16 RIVAUX
C     ------------------------------------------------------------------
      IW=9
      IULOC=4
      IN=IUNIT(IULOC)
C
C1----READ NUMBER OF RIVER REACHESS (OR FLAG SAYING REUSE RIV DATA).
C1----AND NUMBER OF PARAMETERS
      IF(NPRIV.GT.0) THEN
        IF(MODINP.EQ.0) THEN
           READ(IUREAL(IN),'(2I10)') ITMP,NP
        ELSE
           READ(IUREAL(IN),*) ITMP,NP
        END IF
      ELSE
         NP=0
         IF(MODINP.EQ.0) THEN
            READ(IUREAL(IN),'(I10)') ITMP
         ELSE
            READ(IUREAL(IN),*) ITMP
         END IF
      END IF
C
C------Calculate some constants.
C
C1A-----IF ITMP LESS THAN ZERO REUSE NON-PARAMETER DATA. PRINT MESSAGE.
C1A-----IF ITMP=>0, SET NUMBER OF NON-PARAMETER RIVERSS EQUAL TO ITMP.
      IF(ITMP.EQ.IMISS) THEN
         WRITE(IOUT,*) 'Non-parameter rivers are undefined'
         GO TO 100
      ELSE IF(ITMP.LT.0) THEN
         WRITE(IOUT,6)
    6    FORMAT(1X,/
     1    1X,'REUSING NON-PARAMETER RIVERSS FROM LAST STRESS PERIOD')
      END IF
C
C1B-----IF THERE ARE NEW NON-PARAMETER RIVERSS, READ THEM.
       CALL LSTMAK2('RIVR',0,KPER,IW,ITMP)
       NAR=NARRAY
C---------READ AND PRINT A LIST OF CELLS
       CALL LSTRD2(ITMP,NAR,IX(IARRDA(2,NAR)),IN,
     1'REACH NO. LAYER   ROW   COL     STAGE   CONDUCTANCE  BOT. ELEV.',
     2      RIVAUX,3)
C
C1C-----IF THERE ARE ACTIVE RIV PARAMETERS, READ THEM
100   IPF=0
      CALL PERPARRD(IUREAL(IN),NP,'RIV',KPER,IPF)
C
C6------RETURN
      RETURN
      END
      SUBROUTINE RIVSV(IUNDEF,IWRFLG)
C     ******************************************************************
C     Save River data
C     ******************************************************************
      COMMON /RIVCOM/RIVAUX(3)
      CHARACTER*16 RIVAUX
C     ------------------------------------------------------------------
C
      IULOC=4
      CALL LSTSAV3(IULOC,'RIVR',RIVAUX,3,IUNDEF,IWRFLG,
     1          'RIV',' MXACTR IRIVCB','RIV')
      RETURN
      END
