      SUBROUTINE LMGAL()
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      CHARACTER*200 LINE
C     ------------------------------------------------------------------
      IN=IUNIT(14)
      IFREFM=1
C
C1------PRINT A MESSAGE IDENTIFYING AMG PACKAGE
      WRITE(IOUT,500)
  500 FORMAT(1X,/1X,'LMG -- ALGEBRAIC MULTI-GRID SOLUTION PACKAGE',
     &     ', VERSION 1.0, 02/21/2001')
      
C
C2-------READ AND PRINT COMMENTS, STOR1, STOR2, STOR3, ICG
      CALL URDCOM(IN,LINE,14)
      IF(IFREFM.EQ.0) THEN
        READ (LINE,505) STOR1, STOR2, STOR3, ICG
  505   FORMAT (3F10.0,I10)
      ELSE
        READ (LINE,*)  STOR1, STOR2, STOR3, ICG
      END IF
      WRITE(IOUT,510) STOR1, STOR2, STOR3
  510 FORMAT (1X,'STORAGE FACTOR FOR (A) AND (JA)= ',F6.3,/,
     &        1X,'STORAGE FACTOR FOR (IA), (U), AND (F)= ',F6.3,/,
     &        1X,'STORAGE FACTOR FOR (IG)= ',F6.3)
C
C2A-----IF CG CORRECTION NOT SET TO 0 OR 1, SET TO ZERO (NO CG)
      IF(ICG .NE. 0 .AND. ICG .NE. 1) ICG = 0
      CALL VALSAV('STOR1',0,0,STOR1)
      CALL VALSAV('STOR2',0,0,STOR2)
      CALL VALSAV('STOR3',0,0,STOR3)
      CALL IVLSAV('ICG',0,0,ICG)
C
      RETURN
      END
C
C***********************************************************************
      SUBROUTINE LMGRP()
C
C     ******************************************************************
C     READ DATA FOR AMG
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
C     ------------------------------------------------------------------
      IFREFM=1
      CALL IVLGET('ICG',0,0,ITYPE,ICG)
      IN=IUNIT(14)
      IADAMP = 0
      DUP=0.
      DLOW=0.
C
C2------READ MXITER,MXCYC,BCLOSE, DAMP, AND IOUTAMG
      IF(IFREFM.EQ.0) THEN
         READ (IN,500) MXITER,MXCYC,BCLOSE,DAMP,IOUTAMG
  500    FORMAT (2I10,2F10.0,I10)
      ELSE
         READ (IN,*)  MXITER,MXCYC,BCLOSE,DAMP,IOUTAMG
      END IF
C2------CHECK VALUE OF DAMP AND SEE IF ADAPTIVE DAMPING IS SELECTED.
C2------USE 1.E-6 AS A TOLERANCE WHEN CHECKING IF DAMP = -1 OR -2
C2------SET DAMP TO 1.0 FOR ALL OTHER VALUES, UNLESS THIS IS GREATER 
C2------THAN DUP, IN WHICH CASE SET DAMP TO DUP.
      IF(DAMP .LE. 0.)THEN
        IF(ABS(DAMP + 1.0) .LT. 1.E-6)THEN
          IADAMP = -1
        ELSEIF(ABS(DAMP + 2.0) .LT. 1.E-6)THEN
          DAMP=1.0
          IADAMP = -2
          READ(IN,*) DUP,DLOW
           IF(DUP .LT. 1.0)DAMP=DUP
        ELSE
          DAMP=1.0
        ENDIF
      ENDIF
C
C3------PRINT COMMENTS REGARDING SOLVER OPTIONS
      WRITE (IOUT,505)
  505   FORMAT (1X,///,36X,'SOLUTION BY THE ALGEBRAIC MULTIGRID METHOD',
     &        /,36X,42('-'))
      WRITE (IOUT,510) MXITER
  510 FORMAT (1X,20X,'MAXIMUM NUMBER OF CALLS TO AMG ROUTINE =',I9)
      WRITE (IOUT,515) MXCYC
  515 FORMAT (1X,25X,'MAXIMUM NUMBER OF CYCLES PER CALL =',I9)
      WRITE (IOUT,520) BCLOSE
  520 FORMAT (1X,10X,'SCALED L2 NORM OF RESIDUAL CRITERION FOR',
     &               ' CLOSURE =',E15.5)
      IF(ICG .EQ. 1)THEN
        WRITE(IOUT,521) ICG
      ELSE
        WRITE(IOUT,522) ICG
      ENDIF
  521 FORMAT (1X,30X,'CG-CORRECTION IS ACTIVE: ICG =',I9)        
  522 FORMAT (1X,26X,'CG-CORRECTION IS NOT ACTIVE: ICG =',I9)        
C3
      IF(IADAMP .EQ. -1)THEN
        WRITE(IOUT,525) IADAMP
      ELSEIF(IADAMP .EQ. -2)THEN
        WRITE(IOUT, 526) IADAMP
        WRITE(IOUT, 527) DUP
        WRITE(IOUT, 528) DLOW
      ELSE
        WRITE(IOUT,529) DAMP
      ENDIF
  525 FORMAT (1X,20X,'ADAPTIVE DAMPING USING COOLEY''S METHOD =', I9)
  526 FORMAT (1X,10X,'ADAPTIVE DAMPING USING RESIDUAL REDUCTION', 
     &               ' METHOD =',I9)
  527 FORMAT (1X,37X,'MAXIMUM VALUE OF DAMP =',E15.5)
  528 FORMAT (1X,37X,'MINIMUM VALUE OF DAMP =',E15.5)
  529 FORMAT (1X,41X,'DAMPING PARAMETER =',E15.5)
      IF(IOUTAMG .EQ. 0) WRITE(IOUT,530) IOUTAMG     
  530 FORMAT (1X,24X,'PRINTING FROM SOLVER IS SUPPRESSED =', I9)
      IF(IOUTAMG .EQ. 1) WRITE(IOUT,531) IOUTAMG     
  531 FORMAT (1X,28X,'PRINTING FROM SOLVER INCLUDES:',/,
     &          25X,'RESIDUALS BEFORE AND AFTER CYCLING =', I9)
      IF(IOUTAMG .EQ. 2) WRITE(IOUT,532) IOUTAMG     
  532 FORMAT (1X,28X,'PRINTING FROM SOLVER INCLUDES:',/,
     &           2X,'RESIDUALS BEFORE AND AFTER CYCLING, CP-TIMES,',
     &              ' AND STORAGE =',I9)
      IF(IOUTAMG .EQ. 3) WRITE(IOUT,533) IOUTAMG     
  533 FORMAT (1X,28X,'PRINTING FROM SOLVER INCLUDES:',/,
     &              'MESSAGES, RESIDUALS AFTER EACH CYCLE, CP-TIMES,',
     &              ' AND STORAGE =',I9)
C
      CALL VALSAV('BCLOSE',0,0,BCLOSE)
      CALL VALSAV('DAMP_LMG',0,0,DAMP)
      CALL VALSAV('DUP',0,0,DUP)
      CALL VALSAV('DLOW',0,0,DLOW)
      CALL IVLSAV('MXILMG',0,0,MXITER)
      CALL IVLSAV('MXCYC',0,0,MXCYC)
      CALL IVLSAV('IOUTAMG',0,0,IOUTAMG)
C
      RETURN
      END
      SUBROUTINE PCGAL
C     ******************************************************************
C     ALLOCATE STORAGE IN THE X ARRAY FOR PCG ARRAYS
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      CHARACTER*80 LINE
C     ------------------------------------------------------------------
      IN=IUNIT(13)
C
C-------PRINT A MESSAGE IDENTIFYING PCG PACKAGE
      WRITE(IOUT,1) IN
    1 FORMAT(1H0,'PCG -- CONJUGATE GRADIENT SOLUTION PACKAGE,',
     1' INPUT READ FROM UNIT',I3)
C
C-------READ AND PRINT MXITER,ITER1 AND NPCOND
      CALL URDCOM(IUREAL(IN),LINE,13)
      IF(MODINP.EQ.0) THEN
         READ(LINE,2) MXITER,ITER1,NPCOND
    2    FORMAT(3I10)
      ELSE
         LLOC=1
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,MXITER,R,IOUT,IN)
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,ITER1,R,IOUT,IN)
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NPCOND,R,IOUT,IN)
      END IF
      WRITE(IOUT,3) MXITER,ITER1,NPCOND
    3 FORMAT(' MAXIMUM OF',I4,' CALLS OF SOLUTION ROUTINE'/
     1       ,' MAXIMUM OF',I4,' INTERNAL ITERATIONS PER '
     2       ,'CALL TO SOLUTION ROUTINE'/
     3       ,' MATRIX PRECONDITIONING TYPE :',I5)
      CALL IVLSAV('MXIPCG',0,0,MXITER)
      CALL IVLSAV('ITER1',0,0,ITER1)
C
C-------RETURN
      RETURN
      END
      SUBROUTINE PCGRP
C
C     ******************************************************************
C     READ DATA FOR PCG
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
C     ------------------------------------------------------------------
      IN=IUNIT(13)
C
C-------READ HCLOSE,RCLOSE,RELAX,NBPOL,IPRPCG,MUTPCG
      IF(MODINP.EQ.0) THEN
         READ(IUREAL(IN),1) HCLOSE,RCLOSE,RELAX,NBPOL,IPRPCG,MUTPCG,DAMP
    1    FORMAT(3F10.0,3I10,F10.0)
      ELSE
         READ(IUREAL(IN),*) HCLOSE,RCLOSE,RELAX,NBPOL,IPRPCG,MUTPCG,DAMP
      END IF
      CALL IVLGET('MXIPCG',0,0,ITYPE,MXITER)
      CALL IVLGET('ITER1',0,0,ITYPE,ITER1)
      NPCOND=1
C
C-------PRINT MXITER,ITER1,NPCOND,HCLOSE,RCLOSE,RELAX,NBPOL,IPRPCG,
C-------MUTPCG,DAMP
      WRITE(IOUT,100)
  100 FORMAT(1H0,///57X,'SOLUTION BY THE CONJUGATE-GRADIENT METHOD'
     1/57X,43('-'))
      WRITE(IOUT,115) MXITER
  115 FORMAT(1H0,38X,'MAXIMUM NUMBER OF CALLS TO PCG ROUTINE =',I9)
      WRITE(IOUT,120) ITER1
  120 FORMAT(1H ,42X,'MAXIMUM ITERATIONS PER CALL TO PCG =',I9)
      WRITE(IOUT,122) NPCOND
  122 FORMAT(1H ,49X,'MATRIX PRECONDITIONING TYPE =',I9)
      IF(NPCOND.EQ.2) WRITE(IOUT,123)
  123 FORMAT(1H ,58X,'THE MATRIX WILL BE SCALED')
      WRITE(IOUT,124) RELAX,NBPOL
  124 FORMAT(1H ,26X,'RELAXATION FACTOR (ONLY USED WITH',
     1' PRECOND. TYPE 1) =',E15.5,/,
     2 1H ,19X,'PARAMETER OF POLYMOMIAL PRECOND.'
     3 ,' = 2 (2) OR IS CALCULATED :',I9)
      WRITE(IOUT,125) HCLOSE
  125 FORMAT(1H ,43X,'HEAD CHANGE CRITERION FOR CLOSURE =',E15.5)
      WRITE(IOUT,127) RCLOSE
  127 FORMAT(1H ,39X,'RESIDUAL CHANGE CRITERION FOR CLOSURE =',E15.5)
      IF(IPRPCG.LE.0)IPRPCG=999
      WRITE(IOUT,130) IPRPCG,MUTPCG
  130 FORMAT(1H ,30X,'PCG HEAD AND RESIDUAL CHANGE PRINTOUT INTERVAL ='
     1,I9,/,1H ,30X,'ALL PRINTING FROM THE SOLVER IS SUPPRESSED (1) ='
     2,I9)
      IF(DAMP.LE.0.) DAMP=1.0
      WRITE(IOUT,135) DAMP
  135 FORMAT(1H ,61X,'DAMPING PARAMETER =',E15.5,/)
      CALL VALSAV('HCLPCG',0,0,HCLOSE)
      CALL VALSAV('RCLOSE',0,0,RCLOSE)
      CALL VALSAV('RELAX',0,0,RELAX)
      CALL IVLSAV('IPRPCG',0,0,IPRPCG)
      CALL IVLSAV('MUTPCG',0,0,MUTPCG)
      CALL VALSAV('DAMP',0,0,DAMP)
C
      RETURN
      END
      SUBROUTINE SIPAL
C     ******************************************************************
C     ALLOCATE STORAGE IN THE X ARRAY FOR SIP ARRAYS
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      CHARACTER*80 LINE
C     ------------------------------------------------------------------
      IN=IUNIT(9)
C
C1------PRINT A MESSAGE IDENTIFYING SIP PACKAGE
      WRITE(IOUT,1)IN
    1 FORMAT(1X,
     1   /1X,'SIP -- STRONGLY IMPLICIT PROCEDURE SOLUTION PACKAGE',
     2   /20X,' INPUT READ FROM UNIT',I3)
C
C2------READ AND PRINT MXITER AND NPARM
      CALL URDCOM(IUREAL(IN),LINE,9)
      IF(MODINP.EQ.0) THEN
         READ(LINE,'(2I10)') MXITER,NPARM
      ELSE
         LLOC=1
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,MXITER,R,IOUT,IN)
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NPARM,R,IOUT,IN)
      END IF
      WRITE(IOUT,3) MXITER,NPARM
    3 FORMAT(1X,'MAXIMUM OF',I4,' ITERATIONS ALLOWED FOR CLOSURE'/
     1       1X,I2,' ITERATION PARAMETERS')
      CALL IVLSAV('MXISIP',0,0,MXITER)
      CALL IVLSAV('NPARM',0,0,NPARM)
C
C5------RETURN
      RETURN
      END
      SUBROUTINE SIPRP
C
C     ******************************************************************
C     READ DATA FOR SIP
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
C     ------------------------------------------------------------------
      IN=IUNIT(9)
      CALL IVLGET('MXISIP',0,0,ITYPE,MXITER)
C
C1------READ ACCL,HCLOSE,WSEED,IPCALC,IPRSIP
      IF(MODINP.EQ.0) READ(IUREAL(IN),'(2F10.0,I10,F10.0,I10)')
     1                                   ACCL,HCLOSE,IPCALC,WSEED,IPRSIP
      IF(MODINP.NE.0) READ(IUREAL(IN),*) ACCL,HCLOSE,IPCALC,WSEED,IPRSIP
      ZERO=0.
      IF(ACCL.EQ.ZERO) ACCL=1.
C
C2------PRINT DATA VALUES JUST READ
      WRITE(IOUT,100)
  100 FORMAT(1X,///10X,'SOLUTION BY THE STRONGLY IMPLICIT PROCEDURE'
     1/10X,43('-'))
      WRITE(IOUT,115) MXITER
  115 FORMAT(1X,'MAXIMUM ITERATIONS ALLOWED FOR CLOSURE =',I9)
      WRITE(IOUT,120) ACCL
  120 FORMAT(1X,16X,'ACCELERATION PARAMETER =',G15.5)
      WRITE(IOUT,125) HCLOSE
  125 FORMAT(1X,5X,'HEAD CHANGE CRITERION FOR CLOSURE =',E15.5)
      IF(IPRSIP.LE.0)IPRSIP=999
      WRITE(IOUT,130) IPRSIP
  130 FORMAT(1X,5X,'SIP HEAD CHANGE PRINTOUT INTERVAL =',I9)
      CALL VALSAV('HCLSIP',0,0,HCLOSE)
      CALL VALSAV('ACLSIP',0,0,ACCL)
      IF(IPCALC.NE.0) WSEED=0.0
      CALL VALSAV('WSEED',0,0,WSEED)
      CALL IVLSAV('IPRSIP',0,0,IPRSIP)
C
C4------RETURN
 1000 RETURN
      END
      SUBROUTINE SORAL
C
C     ******************************************************************
C     ALLOCATE STORAGE FOR SOR ARRAYS
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      CHARACTER*80 LINE
C     ------------------------------------------------------------------
      IN=IUNIT(11)
C
C1------PRINT A MESSAGE IDENTIFYING SOR PACKAGE
      WRITE(IOUT,1)IN
    1 FORMAT(1X,
     1  /1X,'SOR -- SLICE-SUCCESSIVE OVERRELAXATION SOLUTION PACKAGE',
     2  /20X,' INPUT READ FROM UNIT',I3)
C
C2------READ AND PRINT MXITER (MAXIMUM # OF ITERATIONS)
      CALL URDCOM(IUREAL(IN),LINE,11)
      IF(MODINP.EQ.0) THEN
         READ(LINE,'(I10)') MXITER
      ELSE
         LLOC=1
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,MXITER,R,IOUT,IN)
      END IF
      WRITE(IOUT,3) MXITER
    3 FORMAT(1X,I5,' ITERATIONS ALLOWED FOR SOR CLOSURE')
      CALL IVLSAV('MXISOR',0,0,MXITER)
C
C5------RETURN
      RETURN
      END
      SUBROUTINE SORRP
C
C     ******************************************************************
C     READ PARAMETERS FOR SOR
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
C     ------------------------------------------------------------------
      IN=IUNIT(11)
      CALL IVLGET('MXISOR',0,0,ITYPE,MXITER)
C
C1------READ THE ACCELERATION PARAMETER/RELAXATION FACTOR (ACCL) THE
C1------CLOSURE CRITERION (HCLOSE) AND THE NUMBER OF TIME STEPS
C1------BETWEEN PRINTOUTS OF MAXIMUM HEAD CHANGES (IPRSOR).
      IF(MODINP.EQ.0) READ(IUREAL(IN),'(2F10.0,I10)') ACCL,HCLOSE,IPRSOR
      IF(MODINP.NE.0) READ(IUREAL(IN),*) ACCL,HCLOSE,IPRSOR
      ZERO=0.
      IF(ACCL.EQ.ZERO) ACCL=1.
      IF(IPRSOR.LT.1) IPRSOR=999
C
C2------PRINT ACCL, HCLOSE, IPRSOR
      WRITE(IOUT,100)
  100 FORMAT(1X,///10X,'SOLUTION BY SLICE-SUCCESSIVE OVERRELAXATION'
     1    /10X,43('-'))
      WRITE(IOUT,115) MXITER
  115 FORMAT(1X,'MAXIMUM ITERATIONS ALLOWED FOR CLOSURE =',I9)
      WRITE(IOUT,120) ACCL
  120 FORMAT(1X,16X,'ACCELERATION PARAMETER =',G15.5)
      WRITE(IOUT,125) HCLOSE
  125 FORMAT(1X,5X,'HEAD CHANGE CRITERION FOR CLOSURE =',E15.5)
      WRITE(IOUT,130) IPRSOR
  130 FORMAT(1X,5X,'SOR HEAD CHANGE PRINTOUT INTERVAL =',I9)
      CALL VALSAV('HCLSOR',0,0,HCLOSE)
      CALL VALSAV('ACLSOR',0,0,ACCL)
      CALL IVLSAV('IPRSOR',0,0,IPRSOR)
C
C3------RETURN
      RETURN
      END
      SUBROUTINE DE4AL
C     ******************************************************************
C     ALLOCATE STORAGE FOR D4 ARRAYS
C     ******************************************************************
C
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      CHARACTER*80 LINE
C     ------------------------------------------------------------------
      INDE4=IUNIT(10)
C
C1------PRINT A MESSAGE IDENTIFYING DE4 PACKAGE.
      WRITE(IOUT,1) INDE4
    1 FORMAT(1X,/1X,'DE45 -- D4 DIRECT SOLUTION PACKAGE',
     1    ', VERSION 5, 7/1/93  INPUT READ FROM UNIT',I3)
C
C3------READ AND PRINT ITMX, MXUP, MXLOW, MXBW.  FOR ANY
C3------INVALID VALUES, SUBSTITUE AN APPROPRIATE VALUE.
      CALL URDCOM(IUREAL(INDE4),LINE,10)
      LLOC=1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,ITMX,R,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,MXUP,R,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,MXLOW,R,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,MXBW,R,IOUT,IN)
      IF(ITMX.LT.1) ITMX=1
      WRITE(IOUT,3) ITMX
    3 FORMAT(1X,'MAXIMUM ITERATIONS (EXTERNAL OR INTERNAL) =',I3)
      IF(MXUP.LT.0) MXUP=0
      IF(MXLOW.LT.0) MXLOW=0
      IF(MXBW.LT.0) MXBW=0
      WRITE(IOUT,4) MXUP,MXLOW,MXBW
    4 FORMAT(1X,'MAXIMUM EQUATIONS IN UPPER PART:',I7,/
     1       1X,'MAXIMUM EQUATIONS IN LOWER PART:',I7,/
     2       1X,'MAXIMUM BAND WIDTH+1 OF [AL]:',I5)
C
      CALL IVLSAV('ITMX',0,0,ITMX)
      CALL IVLSAV('MXUP',0,0,MXUP)
      CALL IVLSAV('MXLOW',0,0,MXLOW)
      CALL IVLSAV('MXBW',0,0,MXBW)
C
      RETURN
      END
      SUBROUTINE DE4RP
C     ******************************************************************
C     READ DATA FOR DE4
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
C     ------------------------------------------------------------------
      INDE4=IUNIT(10)
C
C1------READ IFREQ, MUTD4, ACCL, HCLOSE, AND IPRD4
      ONE=1.
      ZERO=0.
      READ(IUREAL(INDE4),*) IFREQ,MUTD4,ACCL,HCLOSE,IPRD4
      IF(ACCL.LE.ZERO) ACCL=ONE
      IF(IPRD4.LE.0) IPRD4=999
      IF(MUTD4.LT.0 .OR. MUTD4.GT.2) MUTD4=0
      IF(IFREQ.LT.1 .OR. IFREQ.GT.3) THEN
         WRITE(IOUT,11) IFREQ
   11    FORMAT(1H0,'INVALID VALUE FOR IFREQ PARAMETER:',I8)
         CALL RDABRT
      END IF
C
      CALL IVLSAV('IFREQ',0,0,IFREQ)
      CALL IVLSAV('MUTD4',0,0,MUTD4)
      CALL VALSAV('ACLDE4',0,0,ACCL)
      CALL VALSAV('HCLDE4',0,0,HCLOSE)
      CALL IVLSAV('IPRD4',0,0,IPRD4)
C
      RETURN
      END
      SUBROUTINE SOLVSV(IUNDEF,IWRFLG)
C
C     ******************************************************************
C     SAVE DATA FOR SOLVER PACKAGE
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
C     ------------------------------------------------------------------
      IUNDEF=0
      IFIL=IUMISC
      IF(IWRFLG.LE.0) IFIL=0
C
10    IF(IUNIT(13).NE.0) THEN
C  PCG
         IULOC=13
         IF(IUREAL(IUNIT(IULOC)).EQ.0) CALL REALUN(IUNIT(IULOC))
         IF(IWRFLG.EQ.1) OPEN(FILE='MFI.PCG',UNIT=IFIL)
         IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUNIT(IULOC)),UNIT=IFIL)
C
C  Write comments
         IF(IWRFLG.GT.0) THEN
            DO 8 I=1,20
            IF(COMENT(I,IULOC)(1:1).EQ.'#') THEN
               DO 6 N=80,1,-1
               IF(COMENT(I,IULOC)(N:N) .NE. ' ') GO TO 7
6              CONTINUE
7              WRITE(IFIL,'(A)') COMENT(I,IULOC)(1:N)
            END IF
8           CONTINUE
         END IF
C
         CALL IVLGET('MXIPCG',0,0,ITYPE,MXIPCG)
         IF(ITYPE.NE.0) MXIPCG=15
         CALL IVLGET('ITER1',0,0,ITYPE,ITER1)
         IF(ITYPE.NE.0) ITER1=20
         CALL IVLGET('IPRPCG',0,0,ITYPE,IPRPCG)
         IF(ITYPE.NE.0) IPRPCG=1
         CALL IVLGET('MUTPCG',0,0,ITYPE,MUTPCG)
         IF(ITYPE.NE.0) MUTPCG=0
         CALL VALGET('HCLPCG',0,0,ITYPE,HCLPCG)
         IF(ITYPE.NE.0) HCLPCG=.001
         CALL VALGET('RCLOSE',0,0,ITYPE,RCLOSE)
         IF(ITYPE.NE.0) RCLOSE=1000.
         CALL VALGET('RELAX',0,0,ITYPE,RELAX)
         IF(ITYPE.NE.0) RELAX=1.0
         CALL VALGET('DAMP',0,0,ITYPE,DAMP)
         IF(ITYPE.NE.0) DAMP=1.0
         IF(IWRFLG.GT.0) WRITE(IFIL,'(2I10,A)') MXIPCG,ITER1,
     1          '         1   MXITER  ITER1  NPCOND'
         IF(IWRFLG.GT.0) WRITE(IFIL,'(1P,3E10.2,A,2I10,E10.3,A)')
     1         HCLPCG,RCLOSE,RELAX,'         2',IPRPCG,MUTPCG,DAMP,
     2     '  HCLOSE RCLOSE RELAX NPBOL IPRPCG MUTPCG DAMP'
      ELSE IF(IUNIT(9).NE.0) THEN
C  SIP
         IULOC=9
         IF(IUREAL(IUNIT(IULOC)).EQ.0) CALL REALUN(IUNIT(IULOC))
         IF(IWRFLG.EQ.1) OPEN(FILE='MFI.SIP',UNIT=IFIL)
         IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUNIT(IULOC)),UNIT=IFIL)
C
C  Write comments
         IF(IWRFLG.GT.0) THEN
            DO 18 I=1,20
            IF(COMENT(I,IULOC)(1:1).EQ.'#') THEN
               DO 16 N=80,1,-1
               IF(COMENT(I,IULOC)(N:N) .NE. ' ') GO TO 17
16             CONTINUE
17             WRITE(IFIL,'(A)') COMENT(I,IULOC)(1:N)
            END IF
18          CONTINUE
         END IF
C
         CALL IVLGET('MXISIP',0,0,ITYPE,MXISIP)
         IF(ITYPE.NE.0) MXISIP=50
         CALL IVLGET('NPARM',0,0,ITYPE,NPARM)
         IF(ITYPE.NE.0) NPARM=5
         CALL IVLGET('IPRSIP',0,0,ITYPE,IPRSIP)
         IF(ITYPE.NE.0) IPRSIP=1
         CALL VALGET('HCLSIP',0,0,ITYPE,HCLSIP)
         IF(ITYPE.NE.0) HCLSIP=.001
         CALL VALGET('ACLSIP',0,0,ITYPE,ACLSIP)
         IF(ITYPE.NE.0) ACLSIP=1.0
         CALL VALGET('WSEED',0,0,ITYPE,WSEED)
         IF(ITYPE.NE.0) WSEED=0.0
         IPCALC=0
         IF(WSEED.EQ. 0.0) IPCALC=1
         IF(IWRFLG.GT.0) WRITE(IFIL,'(2I10,A)') MXISIP,NPARM,
     1                             '  MXITER  NPARM'
         IF(IWRFLG.GT.0) WRITE(IFIL,'(1P,2E10.2,I10,E10.2,I10,A)')
     1         ACLSIP,HCLSIP,IPCALC,WSEED,IPRSIP,
     2         ' ACCL HCLOSE IPCALC WSEED IPRSIP'
      ELSE IF(IUNIT(11).NE.0) THEN
C  SOR
         IULOC=11
         IF(IUREAL(IUNIT(IULOC)).EQ.0) CALL REALUN(IUNIT(IULOC))
         IF(IWRFLG.EQ.1) OPEN(FILE='MFI.SOR',UNIT=IFIL)
         IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUNIT(IULOC)),UNIT=IFIL)
C
C  Write comments
         IF(IWRFLG.GT.0) THEN
            DO 28 I=1,20
            IF(COMENT(I,IULOC)(1:1).EQ.'#') THEN
               DO 26 N=80,1,-1
               IF(COMENT(I,IULOC)(N:N) .NE. ' ') GO TO 27
26             CONTINUE
27             WRITE(IFIL,'(A)') COMENT(I,IULOC)(1:N)
            END IF
28          CONTINUE
         END IF
C
         CALL IVLGET('MXISOR',0,0,ITYPE,MXISOR)
         IF(ITYPE.NE.0) MXISOR=50
         CALL IVLGET('IPRSOR',0,0,ITYPE,IPRSOR)
         IF(ITYPE.NE.0) IPRSOR=1
         CALL VALGET('HCLSOR',0,0,ITYPE,HCLSOR)
         IF(ITYPE.NE.0) HCLSOR=.001
         CALL VALGET('ACLSOR',0,0,ITYPE,ACLSOR)
         IF(ITYPE.NE.0) ACLSOR=1.5
         IF(IWRFLG.GT.0) WRITE(IFIL,'(I10,A)') MXISOR,'  MXITER'
         IF(IWRFLG.GT.0) WRITE(IFIL,'(1P,2E10.2,I10,A)')
     1         ACLSOR,HCLSOR,IPRSOR,'  ACCL HCLOSE IPRSOR'
      ELSE IF(IUNIT(10).NE.0) THEN
C  DE4
         IULOC=10
         IF(IUREAL(IUNIT(IULOC)).EQ.0) CALL REALUN(IUNIT(IULOC))
         IF(IWRFLG.EQ.1) OPEN(FILE='MFI.DE4',UNIT=IFIL)
         IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUNIT(IULOC)),UNIT=IFIL)
C
C  Write comments
         IF(IWRFLG.GT.0) THEN
            DO 38 I=1,20
            IF(COMENT(I,IULOC)(1:1).EQ.'#') THEN
               DO 36 N=80,1,-1
               IF(COMENT(I,IULOC)(N:N) .NE. ' ') GO TO 37
36             CONTINUE
37             WRITE(IFIL,'(A)') COMENT(I,IULOC)(1:N)
            END IF
38          CONTINUE
         END IF
C
         CALL IVLGET('IFREQ',0,0,ITYPE,IFREQ)
         IF(ITYPE.NE.0) IFREQ=3
         CALL IVLGET('ITMX',0,0,ITYPE,ITMX)
         IF(ITYPE.NE.0) THEN
            ITMX=1
            IF(IFREQ.EQ.3) ITMX=5
         END IF
         CALL IVLGET('MXUP',0,0,ITYPE,MXUP)
         IF(ITYPE.NE.0) MXUP=0
         CALL IVLGET('MXLOW',0,0,ITYPE,MXLOW)
         IF(ITYPE.NE.0) MXLOW=0
         CALL IVLGET('MXBW',0,0,ITYPE,MXBW)
         IF(ITYPE.NE.0) MXBW=0
         CALL IVLGET('IPRD4',0,0,ITYPE,IPRD4)
         IF(ITYPE.NE.0) IPRD4=1
         CALL IVLGET('MUTD4',0,0,ITYPE,MUTD4)
         IF(ITYPE.NE.0) MUTD4=0
         CALL VALGET('HCLDE4',0,0,ITYPE,HCLDE4)
         IF(ITYPE.NE.0) HCLDE4=.01
         CALL VALGET('ACLDE4',0,0,ITYPE,ACLDE4)
         IF(ITYPE.NE.0) ACLDE4=1.
         IF(IWRFLG.GT.0) WRITE(IFIL,'(4I10,A)') ITMX,MXUP,MXLOW,MXBW,
     1                                    '   ITMX  MXUP  MXLOW  MXBW'
         IF(IWRFLG.GT.0) WRITE(IFIL,'(1P,2I5,2E10.2,I10,A)')
     1         IFREQ,MUTD4,ACLDE4,HCLDE4,IPRD4,
     2     '   IFREQ MUTD4 ACCL HCLOSE IPRD4'
      ELSE IF(IUNIT(14).NE.0) THEN
C  LMG
         IULOC=14
         IF(IUREAL(IUNIT(IULOC)).EQ.0) CALL REALUN(IUNIT(IULOC))
         IF(IWRFLG.EQ.1) OPEN(FILE='MFI.LMG',UNIT=IFIL)
         IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUNIT(IULOC)),UNIT=IFIL)
C
C  Write comments
         IF(IWRFLG.GT.0) THEN
            DO 48 I=1,20
            IF(COMENT(I,IULOC)(1:1).EQ.'#') THEN
               DO 46 N=80,1,-1
               IF(COMENT(I,IULOC)(N:N) .NE. ' ') GO TO 47
46             CONTINUE
47             WRITE(IFIL,'(A)') COMENT(I,IULOC)(1:N)
            END IF
48          CONTINUE
         END IF
C
         CALL VALGET('STOR1',0,0,ITYPE,STOR1)
         IF(ITYPE.NE.0) STOR1=3.0
         CALL VALGET('STOR2',0,0,ITYPE,STOR2)
         IF(ITYPE.NE.0) STOR2=2.2
         CALL VALGET('STOR3',0,0,ITYPE,STOR3)
         IF(ITYPE.NE.0) STOR3=5.4
         CALL IVLGET('ICG',0,0,ITYPE,ICG)
         IF(ITYPE.NE.0) ICG=0
         CALL IVLGET('MXILMG',0,0,ITYPE,MXILMG)
         IF(ITYPE.NE.0) MXILMG=15
         CALL IVLGET('MXCYC',0,0,ITYPE,MXCYC)
         IF(ITYPE.NE.0) MXCYC=20
         CALL VALGET('BCLOSE',0,0,ITYPE,BCLOSE)
         IF(ITYPE.NE.0) BCLOSE=100.0
         CALL VALGET('DAMP_LMG',0,0,ITYPE,DAMP_LMG)
         IF(ITYPE.NE.0) DAMP_LMG=1.0
         CALL IVLGET('IOUTAMG',0,0,ITYPE,IOUTAMG)
         IF(ITYPE.NE.0) IOUTAMG=3
         CALL VALGET('DUP',0,0,ITYPE,DUP)
         IF(ITYPE.NE.0) DUP=1.0
         CALL VALGET('DLOW',0,0,ITYPE,DLOW)
         IF(ITYPE.NE.0) DLOW=0.2
         IF(IWRFLG.GT.0) WRITE(IFIL,'(1P,3E10.2,I10,A)')
     1         STOR1,STOR2,STOR3,ICG,'   STOR1  STOR2  STOR3  ICG'
         IF(IWRFLG.GT.0) WRITE(IFIL,'(1P,2I5,2E10.2,I10,A)')
     1         MXILMG,MXCYC,BCLOSE,DAMP_LMG,IOUTAMG,
     2     '   MXITER  MXCYC  BCLOSE  DAMP  IOUTAMG'
         IF(IWRFLG.GT.0 .AND. DAMP_LMG.EQ.3.0)
     1         WRITE(IFIL,'(1P,2E10.2,A)') DUP,DLOW,'   DUP  DLOW'
      ELSE
C  No solver selected yet -- force PCG with default values
         CALL FINDUN(23,IU,'PCG','PCG')
         IUNIT(13)=IU
         GO TO 10
      END IF
 
C
      IF(IFIL.GT.0) CLOSE(UNIT=IFIL)
      RETURN
      END
