      SUBROUTINE WEL6AL(IBDSAM,NPWEL)
C
C     ******************************************************************
C     ALLOCATE ARRAY STORAGE FOR WELL PACKAGE
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
C  Common block for WEL Package
      COMMON /WELCOM/WELAUX(3)
      CHARACTER*16 WELAUX
      CHARACTER*200 LINE
C     ------------------------------------------------------------------
      IULOC=2
      IN=IUNIT(IULOC)
C
C1------IDENTIFY PACKAGE AND INITIALIZE NWELLS.
      WRITE(IOUT,1)IN
    1 FORMAT(1X,/1X,'WEL -- WELL PACKAGE,  INPUT READ FROM UNIT',I3)
      NNPWEL=0
C
C2------READ MAXIMUM NUMBER OF WELLS AND UNIT OR FLAG FOR
C2------CELL-BY-CELL FLOW TERMS.
      CALL URDCOM(IUREAL(IN),LINE,IULOC)
      CALL UPARLSTAL(IUREAL(IN),IOUT,LINE,NPWEL,MXPW)
      IF(MODINP.EQ.0) THEN
         READ(LINE,'(2I10)') MXACTW,IWELCB
         LLOC=21
      ELSE
         LLOC=1
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,MXACTW,R,IOUT,IN)
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IWELCB,R,IOUT,IN)
      END IF
      WRITE(IOUT,3) MXACTW
    3 FORMAT(1X,'MAXIMUM OF',I5,' ACTIVE WELLS AT ONE TIME')
      IF(IWELCB.LT.0) WRITE(IOUT,7)
    7 FORMAT(1X,'CELL-BY-CELL FLOWS WILL BE PRINTED WHEN ICBCFL NOT 0')
      IF(IWELCB.GT.0) WRITE(IOUT,8) IWELCB
    8 FORMAT(1X,'CELL-BY-CELL FLOWS WILL BE SAVED ON UNIT',I3)
C
C  Process CBC flag
      IF(IWELCB.LT.0) IWELCB=-1
      IUNIT2(IULOC)=IWELCB
      IF(IWELCB.GT.0) THEN
         IF(FILTYP(IWELCB).EQ.'DATA(BINARY)') THEN
            IFNUSE(IWELCB)=IUNIT(12)
         ELSE IF(FILTYP(IWELCB).EQ.' ') THEN
            IUNIT2(IULOC)=0
         ELSE
            WRITE(IOUT,*)
     1 'Attempt to save CBC budget in a file that is not DATA(BINARY)'
            CALL RDABRT
         END IF
         IF((IHEDUN.GT.0 .AND. IUNIT2(IULOC).EQ.IHEDUN) .OR.
     1      (IDDNUN.GT.0 .AND. IUNIT2(IULOC).EQ.IDDNUN)) THEN
            WRITE(IOUT,*) 'CBC file is same as HEAD or DRAWDOWN file'
            CALL RDABRT
         END IF
      END IF
      IF(IBDSAM.EQ.-2) THEN
         IF(IWELCB.NE.0) IBDSAM=IWELCB
      ELSE
         IF(IBDSAM.NE.IWELCB) IBDSAM=0
      END IF
C
C3------READ AUXILIARY VARIABLES AND CBC ALLOCATION OPTION.
      IWELAL=0
      NAUX=0
   10 CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IN)
      IF(LINE(ISTART:ISTOP).EQ.'CBCALLOCATE' .OR.
     1   LINE(ISTART:ISTOP).EQ.'CBC') THEN
         IWELAL=1
         WRITE(IOUT,11)
   11    FORMAT(1X,'MEMORY IS ALLOCATED FOR CELL-BY-CELL BUDGET TERMS')
         GO TO 10
      ELSE IF(LINE(ISTART:ISTOP).EQ.'AUXILIARY' .OR.
     1        LINE(ISTART:ISTOP).EQ.'AUX') THEN
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IN)
         IF(NAUX.LT.3) THEN
            NAUX=NAUX+1
            WELAUX(NAUX)=LINE(ISTART:ISTOP)
            WRITE(IOUT,12) WELAUX(NAUX)
   12       FORMAT(1X,'AUXILIARY WELL VARIABLE: ',A)
         ELSE 
            WRITE(IOUT,*) ' Too many auxiliary variables for MFI2K'
            CALL RDABRT
         END IF
         GO TO 10
      END IF
C
C6------RETURN
      RETURN
      END
      SUBROUTINE WEL6RQ(NPWEL)
C
C     ******************************************************************
C     READ PARAMETERS
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      COMMON /WELCOM/WELAUX(3)
      CHARACTER*16 WELAUX
      CHARACTER*10 ARRNAM
C     ------------------------------------------------------------------
      IW=7
      IULOC=2
      IN=IUNIT(IULOC)
C
C-------READ NAMED PARAMETERS
      WRITE(IOUT,3) NPWEL
    3 FORMAT(1X,//1X,I5,' Well parameters')
      IF(NPWEL.GT.0) THEN
        DO 5 K=1,NPWEL
C---------READ AND STORE LIST PARAMETER DEFINITION INFORMATION
          CALL UPARLSTRP(IUREAL(IN),'WEL','Q',NLST,ARRNAM)
C  Make a data list for the parameter
          CALL LSTMAK2(ARRNAM,-3,-3,IW,NLST)
          NAR=NARRAY
C---------READ AND PRINT A LIST OF CELLS
          CALL LSTRD2(NLST,NAR,IX(IARRDA(2,NAR)),IN,
     1      'WELL NO.  LAYER   ROW   COL   STRESS FACTOR',
     2      WELAUX,3)
    5   CONTINUE
      END IF
C
C6------RETURN
      RETURN
      END
      SUBROUTINE WEL6RP(KPER,NPWEL)
C
C     ******************************************************************
C     READ NEW WELL LOCATIONS AND STRESS RATES
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      COMMON /WELCOM/WELAUX(3)
      CHARACTER*16 WELAUX
C     ------------------------------------------------------------------
      IW=7
      IULOC=2
      IN=IUNIT(IULOC)
C
C1----READ NUMBER OF WELLS (OR FLAG SAYING REUSE WELL DATA).
C1----AND NUMBER OF PARAMETERS
      IF(NPWEL.GT.0) THEN
        IF(MODINP.EQ.0) THEN
           READ(IUREAL(IN),'(2I10)') ITMP,NP
        ELSE
           READ(IUREAL(IN),*) ITMP,NP
        END IF
      ELSE
         NP=0
         IF(MODINP.EQ.0) THEN
            READ(IUREAL(IN),'(I10)') ITMP
         ELSE
            READ(IUREAL(IN),*) ITMP
         END IF
      END IF
C
C------Calculate some constants.
C
C1A-----IF ITMP LESS THAN ZERO REUSE NON-PARAMETER DATA. PRINT MESSAGE.
C1A-----IF ITMP=>0, SET NUMBER OF NON-PARAMETER WELLS EQUAL TO ITMP.
      IF(ITMP.EQ.IMISS) THEN
         WRITE(IOUT,*) 'Non-parameter wells are undefined'
         GO TO 100
      ELSE IF(ITMP.LT.0) THEN
         WRITE(IOUT,6)
    6    FORMAT(1X,/
     1    1X,'REUSING NON-PARAMETER WELLS FROM LAST STRESS PERIOD')
      END IF
C
C1B-----IF THERE ARE NEW NON-PARAMETER WELLS, READ THEM.
       CALL LSTMAK2('WELL',0,KPER,IW,ITMP)
       NAR=NARRAY
C---------READ AND PRINT A LIST OF CELLS
       CALL LSTRD2(ITMP,NAR,IX(IARRDA(2,NAR)),IN,
     1      'WELL NO.  LAYER   ROW   COL   STRESS FACTOR',
     2      WELAUX,3)
C
C1C-----IF THERE ARE ACTIVE WELL PARAMETERS, READ THEM
100   IPF=0
      CALL PERPARRD(IUREAL(IN),NP,'Q',KPER,IPF)
C
C6------RETURN
      RETURN
      END
      SUBROUTINE WELSV(IUNDEF,IWRFLG)
C     ******************************************************************
C     Save WELL data
C     ******************************************************************
      COMMON /WELCOM/WELAUX(3)
      CHARACTER*16 WELAUX
C     ------------------------------------------------------------------
C
      IULOC=2
      CALL LSTSAV3(IULOC,'WELL',WELAUX,3,IUNDEF,IWRFLG,
     1          'WEL',' MXACTW IWELCB','Q')
      RETURN
      END
