      SUBROUTINE MPED
C     ******************************************************************
C     Input MODPATH Package data
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
C
      INCLUDE 'mfi2k.inc'
C
      PARAMETER (NSPEC=12)
      COMMON /DISCOM/LBOTM(200),LAYCBD(200)
      COMMON /MPCCOM/MPNAME,MPTYPE,CLEGND(15),CLTITL
      CHARACTER*60 MPNAME(NSPEC)
      CHARACTER*16 MPTYPE(NSPEC)
      CHARACTER*30 CLEGND
      CHARACTER*50 CLTITL
      COMMON /MPCOM/IGUAUN,IGUAM,GUAMIN(15),GUAMAX(15)
      TYPE(WIN_MESSAGE)   :: MESSAGE
      DIMENSION IPER(MXPER)
      CHARACTER*4 CTMP
      CHARACTER*40 LABARR(400)
      CHARACTER*6 ARRNAM(400)
      DIMENSION LAYER(400)
      CHARACTER*80 CTXT(1)
C     ------------------------------------------------------------------
      CALL IVLGET('IXSEC',0,0,ITYPE,IXSEC)
      IF(ITYPE.NE.0) IXSEC=0
C  Switch to MODPATH's file units
      CALL MPIUMK
C
C  Activate MODPATH if not active already.
      IF(IUNIT(40).EQ.0) THEN
C  Ready to activate MODPATH
         CALL FINDUN(70,IU,'MP','MP')
         IUNIT(40)=IU
         IGUAM=1
         CALL IVLSAV('IRCHTP',0,0,1)
         CALL IVLSAV('IEVTTP',0,0,1)
C  Initialize MPNAME
         DO 6 I=1,NSPEC
         MPNAME(I)=' '
6        CONTINUE
C  Copy IBOUND to IBNDMB if possible
         CALL IBNDCP
      END IF
      MODSAV=MODOUT
      MODOUT=1
C
C  Ready to edit data
      CALL WDialogLoad(MODPATH_DIALOG)
      CALL WDialogShow(-1,50,0,SemiModeless)
C
5     CALL WMessage(ITYPE,MESSAGE)
C
C  Check for push buttons
      IF(ITYPE.EQ.PushButton) THEN
         IF(MESSAGE%VALUE1.EQ.MODPATH_CHECK_BUT) THEN
            CALL MPSV(IUNDEF,-1)
C  MISC BUTTON
         ELSE IF(MESSAGE%VALUE1.EQ.MODPATH_MISC_BUT) THEN
            CALL MPMISC
C
         ELSE IF(MESSAGE%VALUE1.EQ.MODPATH_IBOUND_BUT) THEN
C  IBOUND PUSHBUTTON
            IF(IXSEC.EQ.0) THEN
               CALL U3DIN('MODPATH IBOUND','IBNDMP',NCOL,NROW,
     1               IUNIT(40),NLAY)
            ELSE
               CALL U2DIN('MODPATH IBOUND for cross section','IBNDMP',
     1                NCOL,NLAY,IUNIT(40),0,0)
            END IF
C
         ELSE IF(MESSAGE%VALUE1.EQ.MODPATH_POROSITY_BUT) THEN
C  POROSITY PUSHBUTTON
            NUMARR=0
            DO 20 K=1,NLAY
            WRITE(CTMP,'(I4)') K
            NUMARR=NUMARR+1
            LABARR(NUMARR)='POROSITY FOR LAYER'//CTMP
            ARRNAM(NUMARR)='POR'
            LAYER(NUMARR)=K
            IF(LAYCBD(K).NE.0) THEN
               NUMARR=NUMARR+1
               LABARR(NUMARR)='CONFINING BED POROSITY FOR LAYER'//CTMP
               ARRNAM(NUMARR)='PORCB'
               LAYER(NUMARR)=K
            END IF
20          CONTINUE
            CALL UGARRIN(NUMARR,LABARR,ARRNAM,LAYER,IUNIT(40),
     1            'Porosity Dialog')
C
         ELSE IF(MESSAGE%VALUE1.EQ.MODPATH_GUA_METHOD_BUT) THEN
C  GUA METHOD PUSHBUTTON
            CALL GUAMETHED
C
         ELSE IF(MESSAGE%VALUE1.EQ.MODPATH_GUA_ARRAY_BUT) THEN
C  GUArray PUSHBUTTON
            IF(IGUAM.EQ.2) THEN
               CALL U3DIN('MODPATH Grid Unit Array','IGUA',NCOL,NROW,
     1               IUNIT(40),NLAY)
            ELSE IF(IGUAM.EQ.3 .OR. IGUAM.EQ.4) THEN
               CALL U3DIN('MODPATH Grid Unit Array','RGUA',NCOL,NROW,
     1               IUNIT(40),NLAY)
            ELSE
               CTXT(1)=
     1   'Grid Unit Array is not needed because GUA Method is "None"'
               CALL TXTLOG(CTXT,1)
            END IF
C
         ELSE IF(MESSAGE%VALUE1.EQ.IDCLOSE) THEN
C  CLOSE PUSHBUTTON -- done with BAS dialog
            CALL BASSV(IUNDEF,1)
            CALL WDialogUnload(MODPATH_DIALOG)
            RETURN
         END IF
         CALL WDialogSelect(MODPATH_DIALOG)
      END IF
      GO TO 5
C
      END
      SUBROUTINE IBNDCP()
C     ******************************************************************
C     Copy IBOUND to IBNDMP if INTERNAL or CONSTANT
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
C
      NL=NLAY
      K1=0
      CALL IVLGET('IXSEC',0,0,ITYPE,IXSEC)
      IF(ITYPE.NE.0) IXSEC=0
      IF(IXSEC.NE.0) THEN
         NL=1
         K1=-1
      END IF
      DO 100 K=1,NL
      K1=K1+1
C
      CALL VALGET('IBOUND',K1,0,NIBND,DUM)
      IF(NIBND.GT.0) THEN
C  IBOUND is a constant array.
         IF(IARRDA(1,NIBND).EQ.0) THEN
            CALL VALGET('IBNDMP',K1,0,NIBMP,DUM)
            IF(NIBMP.LT.0) THEN
               CALL ARRMAK('IBNDMP',K1,0,
     1              IARRDA(3,NIBND),IARRDA(4,NIBND))
               NIBMP=NARRAY
            END IF
            ARRCON(NIBMP)=ARRCON(NIBND)
            IARRDA(1,NIBMP)=0
         ELSE IF(IARRDA(1,NIBND).EQ.-1 .AND. IARRDA(2,NIBND).GT.0) THEN
C  IBOUND is a defined, INTERNAL array.
            CALL VALGET('IBNDMP',K1,0,NIBMP,DUM)
            IF(NIBMP.LT.0) THEN
               CALL ARRMAK('IBNDMP',K1,0,
     1              IARRDA(3,NIBND),IARRDA(4,NIBND))
               NIBMP=NARRAY
            END IF
            ARRCON(NIBMP)=ARRCON(NIBND)
            IF(IARRDA(2,NIBMP).EQ.0) CALL ARRALO(IARRDA(2,NIBMP),
     1              IARRDA(3,NIBND),IARRDA(4,NIBND))
            IARRDA(1,NIBMP)=-1
            CALL ARRCP(X(IARRDA(2,NIBND)),X(IARRDA(2,NIBMP)),
     1              IARRDA(3,NIBND),IARRDA(4,NIBND))
         END IF
      END IF
C
100   CONTINUE
C
      RETURN
      END
      SUBROUTINE ARRCP(A,B,JJ,II)
      DIMENSION A(JJ,II),B(JJ,II)
      DO 100 I=1,II
      DO 100 J=1,JJ
      B(J,I)=A(J,I)
100   CONTINUE
      RETURN
      END
      SUBROUTINE MPMISC
C     ******************************************************************
C     MODPATH MISCELLANEOUS edit
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
C
      INCLUDE 'mfi2k.inc'
      COMMON /PERCOM/PERLEN(MXPER),NSTP(MXPER),TSMULT(MXPER),
     1               ISSFLG(MXPER)
      CHARACTER*70 CTXT(5)
      DATA CTXT/
     1'The specified interval of time steps is invalid.',
     2'For example, BegPeriod may be greater than EndPeriod, or',
     3'BegStep may exceed the number of time steps in stres period',
     4'BegPeriod.  You must enter a valid range consisting of',
     5'1 or more time steps.'/
C     ------------------------------------------------------------------
      ISS=1
      DO 77 N=1,NPER
      IF(ISSFLG(N).EQ.0) ISS=0
77    CONTINUE
C
      CALL IVLGET('MAXSIZ',0,0,ITYPE,MAXSIZ)
      IF(ITYPE.NE.0) MAXSIZ=0
      CALL IVLGET('NPART',0,0,ITYPE,NPART)
      IF(ITYPE.NE.0) NPART=0
      CALL IVLGET('IRCHTP',0,0,ITYPE,IRCHTP)
      IF(ITYPE.NE.0) IRCHTP=1
      CALL IVLGET('IEVTTP',0,0,ITYPE,IEVTTP)
      IF(ITYPE.NE.0) IEVTTP=1
C
      CALL IVLGET('MPCOMP',0,0,ITYPE,MPCOMP)
      IF(ITYPE.NE.0) MPCOMP=0
      CALL IVLGET('MPBIN',0,0,ITYPE,MPBIN)
      IF(ITYPE.NE.0) MPBIN=0
      MPFTYP=1
      IF(MPCOMP.NE.0) MPFTYP=2
      IF(MPBIN.NE.0) MPFTYP=3
C
      CALL IVLGET('MPWTOF',0,0,ITYPE,MPWTOF)
      IF(ITYPE.NE.0) MPWTOF=0
      CALL IVLGET('MPWTDO',0,0,ITYPE,MPWTDO)
      IF(ITYPE.NE.0) MPWTDO=0
      CALL IVLGET('MPWTDA',0,0,ITYPE,MPWTDA)
      IF(ITYPE.NE.0) MPWTDA=0
      MPWT=1
      IF(MPWTOF.NE.0) MPWT=2
      IF(MPWTDO.NE.0) MPWT=3
      IF(MPWTDA.NE.0) MPWT=4
      CALL VALGET('TBEGIN',0,0,ITYPE,TBEGIN)
      IF(ITYPE.NE.0) TBEGIN=0.
      CALL IVLGET('ITFULL',0,0,ITYPE,ITFULL)
      IF(ITYPE.NE.0) ITFULL=1
      CALL IVLGET('IBEGP',0,0,ITYPE,IBEGP)
      IF(ITYPE.NE.0 .OR. ITFULL.EQ.1) IBEGP=1
      CALL IVLGET('IBEGS',0,0,ITYPE,IBEGS)
      IF(ITYPE.NE.0 .OR. ITFULL.EQ.1) IBEGS=1
      CALL IVLGET('IENDP',0,0,ITYPE,IENDP)
      IF(ITYPE.NE.0 .OR. ITFULL.EQ.1) IENDP=NPER
      CALL IVLGET('IENDS',0,0,ITYPE,IENDS)
      IF(ITYPE.NE.0 .OR. ITFULL.EQ.1) IENDS=NSTP(NPER)
      IF(IENDP.GT.NPER) IENDP=NPER
      IF(IENDS.GT.NSTP(IENDP)) IENDS=NSTP(IENDP)
      IF(IBEGS.GT.NSTP(IBEGP)) IBEGS=NSTP(IBEGP)
C
C  Activate screen -- works for steady state and transient
15    CALL WDialogLoad(MODPATH_MISC_DIALOG)
      IF(ISS.EQ.0) THEN
C  Set field state for transient values
         Call WDialogFieldState(MODPATH_MISC_RADIO_FULL,Enabled)
         Call WDialogFieldState(MODPATH_MISC_RADIO_PARTIAL,Enabled)
         Call WDialogFieldState(MODPATH_MISC_TBEGIN,Enabled)
         Call WDialogFieldState(MODPATH_MISC_BEGPER,Enabled)
         Call WDialogFieldState(MODPATH_MISC_BEGSTP,Enabled)
         Call WDialogFieldState(MODPATH_MISC_ENDPER,Enabled)
         Call WDialogFieldState(MODPATH_MISC_ENDSTP,Enabled)
      ELSE
C  Set field state for SS values
         Call WDialogFieldState(MODPATH_MISC_RADIO_FULL,Disabled)
         Call WDialogFieldState(MODPATH_MISC_RADIO_PARTIAL,Disabled)
         Call WDialogFieldState(MODPATH_MISC_TBEGIN,Disabled)
         Call WDialogFieldState(MODPATH_MISC_BEGPER,Disabled)
         Call WDialogFieldState(MODPATH_MISC_BEGSTP,Disabled)
         Call WDialogFieldState(MODPATH_MISC_ENDPER,Disabled)
         Call WDialogFieldState(MODPATH_MISC_ENDSTP,Disabled)
      END IF
C
C  Initialize screen values
      CALL WDialogPutInteger(MP_MISC_NPART,NPART)
      CALL WDialogPutInteger(MP_MISC_MAXSIZ,MAXSIZ)
      CALL WDialogPutOption(MP_MISC_FTYP,MPFTYP)
      CALL WDialogPutOption(MP_MISC_WT,MPWT)
      ITMP1=IRCHTP+1
      CALL WDialogPutOption(MP_MISC_IRCHTP,ITMP1)
      ITMP2=IEVTTP+1
      CALL WDialogPutOption(MP_MISC_IEVTTP,ITMP2)
      CALL WDialogPutReal(MODPATH_MISC_TBEGIN,TBEGIN,'(1PG13.6)')
      IF(ITFULL.EQ.1) THEN
         CALL WDialogPutRadioButton(MODPATH_MISC_RADIO_FULL)
      ELSE
         CALL WDialogPutRadioButton(MODPATH_MISC_RADIO_PARTIAL)
      END IF
      CALL WDialogPutInteger(MODPATH_MISC_BEGPER,IBEGP)
      CALL WDialogPutInteger(MODPATH_MISC_BEGSTP,IBEGS)
      CALL WDialogPutInteger(MODPATH_MISC_ENDPER,IENDP)
      CALL WDialogPutInteger(MODPATH_MISC_ENDSTP,IENDS)
C
C  Make Miscellaneous Dialog visible
      CALL WDialogShow(-1,50,0,MODAL)
C
      IF(WInfoDialog(ExitButton).EQ.IDOK) THEN
C  "OK" was pushed -- Retrieve edited values -- start with transient values
         IF(ISS.EQ.0) THEN
            CALL WDialogGetReal(MODPATH_MISC_TBEGIN,TBEGIN)
            CALL VALSAV('TBEGIN',0,0,TBEGIN)
            CALL WDialogGetRadioButton(MODPATH_MISC_RADIO_FULL,ITFULL)
            IF(ITFULL.EQ.1) THEN
               IBEGP=1
               IBEGS=1
               IENDP=NPER
               IENDS=NSTP(NPER)
            ELSE
               CALL WDialogGetInteger(MODPATH_MISC_BEGPER,IBEGP)
               CALL WDialogGetInteger(MODPATH_MISC_BEGSTP,IBEGS)
               CALL WDialogGetInteger(MODPATH_MISC_ENDPER,IENDP)
               CALL WDialogGetInteger(MODPATH_MISC_ENDSTP,IENDS)
               IF(IBEGP.GT.NPER .OR. IENDP.GT.NPER .OR. IBEGP.GT.IENDP)
     1                   THEN
                  CALL TXTLOG(CTXT,5)
                  GO TO 15
               END IF
               IF(IBEGP.EQ.IENDP .AND. IBEGS.GT.IENDS) THEN
                  CALL TXTLOG(CTXT,5)
                  GO TO 15
               END IF
               IF(IBEGS.GT.NSTP(IBEGP) .OR. IENDS.GT.NSTP(IENDP)) THEN
                  CALL TXTLOG(CTXT,5)
                  GO TO 15
               END IF
            END IF
            CALL IVLSAV('ITFULL',0,0,ITFULL)
            CALL IVLSAV('IBEGP',0,0,IBEGP)
            CALL IVLSAV('IBEGS',0,0,IBEGS)
            CALL IVLSAV('IENDP',0,0,IENDP)
            CALL IVLSAV('IENDS',0,0,IENDS)
         END IF
C
C  Now get values common to steady state and transient
         CALL WDialogGetInteger(MP_MISC_NPART,NPART)
         CALL WDialogGetInteger(MP_MISC_MAXSIZ,MAXSIZ)
         CALL IVLSAV('MAXSIZ',0,0,MAXSIZ)
         CALL IVLSAV('NPART',0,0,NPART)
         CALL WDialogGetMenu(MP_MISC_FTYP,MPFTYP)
         CALL WDialogGetMenu(MP_MISC_WT,MPWT)
         CALL WDialogGetMenu(MP_MISC_IRCHTP,ITMP)
         IRCHTP=ITMP-1
         CALL WDialogGetMenu(MP_MISC_IEVTTP,ITMP)
         IEVTTP=ITMP-1
         MPWTOF=0
         MPWTDO=0
         MPWTDA=0
         IF(MPWT.EQ.2) THEN
            MPWTOF=1
         ELSE IF(MPWT.EQ.3) THEN
            MPWTDO=1
         ELSE IF(MPWT.EQ.4) THEN
            MPWTDA=1
         END IF
         MPCOMP=0
         MPBIN=0
         IF(MPFTYP.EQ.2) THEN
            MPCOMP=1
         ELSE IF(MPFTYP.EQ.3) THEN
            MPBIN=1
         END IF
         CALL IVLSAV('MPCOMP',0,0,MPCOMP)
         CALL IVLSAV('MPBIN',0,0,MPBIN)
         CALL IVLSAV('MPWTOF',0,0,MPWTOF)
         CALL IVLSAV('MPWTDO',0,0,MPWTDO)
         CALL IVLSAV('MPWTDA',0,0,MPWTDA)
         CALL IVLSAV('IRCHTP',0,0,IRCHTP)
         CALL IVLSAV('IEVTTP',0,0,IEVTTP)
      END IF
C
      IF(ISS.NE.0) THEN
         CALL WDialogUnload(MODPATH_SSMISC_DIALOG)
      ELSE
         CALL WDialogUnload(MODPATH_TRMISC_DIALOG)
      END IF
C
      RETURN
      END
      SUBROUTINE GUAMETHED()
C     ******************************************************************
C     Edit GUA METHOD data
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
      INCLUDE 'mfi2k.inc'
      TYPE(WIN_MESSAGE)  :: MESSAGE
      COMMON /MPCCOM/MPNAME,MPTYPE,CLEGND(15),CLTITL
      PARAMETER (NSPEC=12)
      CHARACTER*60 MPNAME(NSPEC)
      CHARACTER*16 MPTYPE(NSPEC)
      CHARACTER*30 CLEGND
      CHARACTER*50 CLTITL
      COMMON /MPCOM/IGUAUN,IGUAM,GUAMIN(15),GUAMAX(15)
      DIMENSION IGNUM(15)
      DATA IGNUM/1,2,3,4,5,6,7,8,9,10,11,12,13,14,15/
      CHARACTER*60 CTXT(1)
C     ------------------------------------------------------------------
C
C  Load GUA Method_DIALOG
      CALL WDialogLoad(MODPATH_GUA_DIALOG)
C
C  Set current method
      IF(IGUAM.EQ.1) THEN
         CALL WDialogPutRadioButton(GUA_RADIO_NONE)
      ELSE IF(IGUAM.EQ.2) THEN
         CALL WDialogPutRadioButton(GUA_RADIO_INTEGER)
      ELSE IF(IGUAM.EQ.3) THEN
         CALL WDialogPutRadioButton(GUA_RADIO_NONUNIFORM)
      ELSE
         CALL WDialogPutRadioButton(GUA_RADIO_UNIFORM)
      END IF
C  Common data
      Call WDialogPutString(GUA_LEGENDTEXT,CLTITL)
C  Load current data for all methods
C  ZONES (Integer) Method
      CALL WGridPutInteger(GUA_GRID_INTEGER,1,IGNUM,15)
      CALL WGridPutString(GUA_GRID_INTEGER,2,CLEGND,15)
C  Nonuniform RANGES Method
      CALL WGridPutInteger(GUA_GRID_NONUNIFORM,1,IGNUM,15)
      CALL WGridPutReal(GUA_GRID_NONUNIFORM,2,GUAMIN,15,'(1PE15.6)')
      CALL WGridPutReal(GUA_GRID_NONUNIFORM,3,GUAMAX,15,'(1PE15.6)')
C  Uniform MRANGES ethod
      CALL IVLGET('IGUNMN',0,0,ITYPE,IGUNMN)
      IF(ITYPE.NE.0) IGUNMN=1
      CALL IVLGET('IGUNMX',0,0,ITYPE,IGUNMX)
      IF(ITYPE.NE.0) IGUNMX=15
      CALL VALGET('GUAVAL',0,0,ITYPE,GUAVAL)
      IF(ITYPE.NE.0) GUAVAL=1.
      CALL VALGET('GUASTR',0,0,ITYPE,GUASTR)
      IF(ITYPE.NE.0) GUASTR=0.
      Call WDialogPutInteger(UNIFORM_FIRST,IGUNMN)
      Call WDialogPutInteger(UNIFORM_LAST,IGUNMX)
      Call WDialogPutReal(UNIFORM_INTERVAL,GUAVAL,'(1PE15.6)')
      Call WDialogPutReal(UNIFORM_MINIMUM,GUASTR,'(1PE15.6)')
C
C  Show GUA DIALOG
      CALL WDialogShow(-1,50,0,SemiModeless)
      CALL WMessageEnable(FieldChanged,Enabled)
C
C  Enable/disable fields depending on method
20    IF(IGUAM.EQ.1) THEN
         CALL WDialogFieldState(GUA_GRID_INTEGER,Disabled)
         CALL WDialogFieldState(GUA_GRID_NONUNIFORM,Disabled)
         CALL WDialogFieldState(UNIFORM_FIRST,Disabled)
         CALL WDialogFieldState(UNIFORM_LAST,Disabled)
         CALL WDialogFieldState(UNIFORM_INTERVAL,Disabled)
         CALL WDialogFieldState(UNIFORM_MINIMUM,Disabled)
      ELSE IF(IGUAM.EQ.2) THEN
         CALL WDialogFieldState(GUA_GRID_INTEGER,Enabled)
         CALL WDialogFieldState(GUA_GRID_NONUNIFORM,Disabled)
         CALL WDialogFieldState(UNIFORM_FIRST,Disabled)
         CALL WDialogFieldState(UNIFORM_LAST,Disabled)
         CALL WDialogFieldState(UNIFORM_INTERVAL,Disabled)
         CALL WDialogFieldState(UNIFORM_MINIMUM,Disabled)
      ELSE IF(IGUAM.EQ.3) THEN
         CALL WDialogFieldState(GUA_GRID_INTEGER,Disabled)
         CALL WDialogFieldState(GUA_GRID_NONUNIFORM,Enabled)
         CALL WDialogFieldState(UNIFORM_FIRST,Disabled)
         CALL WDialogFieldState(UNIFORM_LAST,Disabled)
         CALL WDialogFieldState(UNIFORM_INTERVAL,Disabled)
         CALL WDialogFieldState(UNIFORM_MINIMUM,Disabled)
      ELSE
         CALL WDialogFieldState(GUA_GRID_INTEGER,Disabled)
         CALL WDialogFieldState(GUA_GRID_NONUNIFORM,Disabled)
         CALL WDialogFieldState(UNIFORM_FIRST,Enabled)
         CALL WDialogFieldState(UNIFORM_LAST,Enabled)
         CALL WDialogFieldState(UNIFORM_INTERVAL,Enabled)
         CALL WDialogFieldState(UNIFORM_MINIMUM,Enabled)
      END IF
C
C  Message loop
50    CALL WMessage(ITYPE,MESSAGE)
C
C  Check to see if the GUA method has changed.  If so, update the screen.
      IF(ITYPE.EQ.FieldChanged) THEN
         CALL WDialogGetRadioButton(GUA_RADIO_NONE,INEW)
         IF(INEW.NE.IGUAM) THEN
            IGUAM=INEW
            GO TO 20
         END IF
C
C  Get and store values if "OK" was pushed
      ELSE IF(ITYPE.EQ.PushButton) THEN
C
         IF(MESSAGE%VALUE1.EQ.IDOK) THEN
C  Activate or deactivate the GUA file as appropriate
            IF(IGUAM.GT.1 .AND. IGUAUN.EQ.0) THEN
               CALL FINDUN(40,IGUAUN,'GUA','GUA')
               IFNUSE(IGUAUN)=IUNIT(40)
            ELSE IF(IGUAM.EQ.1 .AND. IGUAUN.GT.0) THEN
               IFNUSE(IGUAUN)=0
               IGUAUN=0
            END IF
C
            Call WDialogGetString(GUA_LEGENDTEXT,CLTITL)
C  Get ZONES (Integer) Method data
            N=15
            CALL WGridGetString(GUA_GRID_INTEGER,2,CLEGND,N)
C  Get Nonuniform RANGES Method data
            N=15
            CALL WGridGetReal(GUA_GRID_NONUNIFORM,2,GUAMIN,N)
            CALL WGridGetReal(GUA_GRID_NONUNIFORM,3,GUAMAX,N)
C  Get Uniform RANGES Method data
            Call WDialogGetInteger(UNIFORM_FIRST,IGUNMN)
            Call WDialogGetInteger(UNIFORM_LAST,IGUNMX)
            Call WDialoggetReal(UNIFORM_INTERVAL,GUAVAL)
            Call WDialogGetReal(UNIFORM_MINIMUM,GUASTR)
            CALL VALSAV('GUAVAL',0,0,GUAVAL)
            CALL VALSAV('GUASTR',0,0,GUASTR)
C  Calculate uniform intervals
            IF(IGUNMN.GT.IGUNMX) THEN
               CTXT(1)=
     1   'The first GUA number must be less than the last GUA number'
               CALL TXTLOG(CTXT,1)
               CALL WDialogSelect(MODPATH_GUA_DIALOG)
               GO TO 50
            END IF
            CALL IVLSAV('IGUNMN',0,0,IGUNMN)
            CALL IVLSAV('IGUNMX',0,0,IGUNMX)
            GUAMIN(IGUNMN)=GUASTR
            NG=0
            DO 775 I=1,15
            IF(I.LT.IGUNMN .OR. I.GT.IGUNMX) THEN
               GUAMAX(I)=0.
               GUAMIN(I)=0.
            ELSE
               NG=NG+1
               IF(I.NE.IGUNMN) GUAMIN(I)=GUAMAX(I-1)
               GUAMAX(I)=REAL(NG)*GUAVAL+GUASTR
            END IF
775         CONTINUE
C  Exit
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL WDialogUnload
            RETURN
         ELSE
C  Assume IDCANCEL, which is the only other pushbutton
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL WDialogUnload
            RETURN
         END IF
      END IF
      GO TO 50
C
      END
