      SUBROUTINE UPARARRAL(IN,IOUT,LINE,NP)
C
C-----VERSION 15SEPT1998 UPARARRAL
C     ******************************************************************
C     Setup array parameter definition for a package.
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2kpar.inc'
      CHARACTER*(*) LINE
C     ------------------------------------------------------------------
C
C  If NP has not already been defined, decode PARAMETER definitions if
C  they exist
      IF(IN.GT.0) THEN
         NP=0
         LLOC=1
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IN)
         IF(LINE(ISTART:ISTOP).EQ.'PARAMETER') THEN
            CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NP,R,IOUT,IN)
            READ(IN,'(A)') LINE
         END IF
      END IF
C
C  Process the parameter information
      IF(NP.GT.0) THEN
         WRITE(IOUT,31) NP
   31    FORMAT(1X,I5,' Named Parameters     ')
      ELSE
         NP=0
         WRITE(IOUT,'(A)') ' No named parameters'
      END IF
C
      RETURN
      END
      SUBROUTINE UPARARRRP(IN,IOUT,NP,ILFLG,PTYP,ITERP)
C
C-----VERSION 19MARCH1998 UPARARRRP
C     ******************************************************************
C     Read and store array parameter definition information
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2kpar.inc'
      CHARACTER*(*) PTYP
      CHARACTER*80 LINE
      CHARACTER*10 PN,CTMP1,CTMP2
C     ------------------------------------------------------------------
C
C  Read a parameter definition line and decode the parameter name, type,
C  and value
      READ(IN,'(A)') LINE
      LLOC=1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,0,N,R,IOUT,IN)
      PN=LINE(ISTART:ISTOP)
      CTMP1=PN
      CALL UPCASE(CTMP1)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IN)
      PTYP=LINE(ISTART:ISTOP)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,N,PV,IOUT,IN)
C
C  Look for the parameter name in the parameter list
      DO 10 NP=1,MXPAR
      CTMP2=PARNAM(NP)
      CALL UPCASE(CTMP2)
      IF(CTMP1.EQ.CTMP2) THEN
C  Illegal duplicate
            WRITE(IOUT,*) ' Duplicate parameter name'
            CALL RDABRT
      ELSE IF(PARNAM(NP).EQ.' ') THEN
C  Parameter was not found in the list, so it is a new definition.
C  Put values in the list.
         PARNAM(NP)=PN
         B(NP)=PV
         B2(NP)=PV
         ISFILE(NP)=0
         ISENS(NP)=0
         LN(NP)=0
         BL(NP)=0.0
         BU(NP)=0.0
         BSCAL(NP)=0.0
         IPSUM=IPSUM+1
         GO TO 100
      END IF
10    CONTINUE
C
C  Too many parameters
      WRITE(IOUT,11)
   11 FORMAT(1X,'The number of parameters has exceeded the maximum')
      CALL RDABRT
C
C  Parse the rest of the parameter definition.
100   PARTYP(NP)=PTYP
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NCLU,R,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IN)
      IF(LINE(ISTART:ISTOP).EQ.'INSTANCES') THEN
         WRITE(IOUT,*) 'Data set contains INSTANCES for a parameter.'
         WRITE(IOUT,*) 'INSTANCES are not supported in MFI2K.'
         CALL RDABRT
      END IF
      IF(IPLOC(1,NP).EQ.0) THEN
         IPLOC(1,NP)=ICLSUM+1
         ICLSUM=ICLSUM+NCLU
         IPLOC(2,NP)=ICLSUM
      END IF
      IACTIVE(NP)=0
C
      IF(IPLOC(2,NP).GT.MXCLST) THEN
          WRITE(IOUT,117) IPLOC(2,NP),MXCLST
  117     FORMAT(1X,I5,
     1 ' CLUSTERS WERE SPECIFIED, BUT THERE IS SPACE FOR ONLY',I5)
           WRITE(IOUT,*) NP,NCLU
           WRITE(IOUT,'(A)') PARNAM(NP)
           WRITE(IOUT,'(2I10)') IPLOC
           CALL RDABRT
      END IF
      WRITE(IOUT,121) PARNAM(NP),PARTYP(NP),NCLU
  121 FORMAT(1X/,1X,'PARAMETER NAME:',A,'   TYPE:',A,'   CLUSTERS:',I4)
      WRITE(IOUT,122) PV
  122 FORMAT(1X,'The parameter value from the package file is:',1PG13.5)
C
C  Read clusters
      DO 200 I=IPLOC(1,NP),IPLOC(2,NP)
      READ(IN,'(A)') LINE
      LLOC=1
      IF(ILFLG.NE.0) THEN
C  Read layer number for cluster
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IPCLST(1,I),R,IOUT,IN)
      ELSE
         IPCLST(1,I)=0
      END IF
      CALL URWORD(LINE,LLOC,IM1,IM2,0,N,R,IOUT,IN)
      CALL URWORD(LINE,LLOC,IZ1,IZ2,0,N,R,IOUT,IN)
      DO 30 J=3,12
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IPCLST(J,I),R,-1,IN)
      IF(IPCLST(J,I).EQ.0) THEN
         IPCLST(2,I)=J-1
         GO TO 32
      END IF
   30 CONTINUE
      IPCLST(2,I)=12
   32 IF(ILFLG.NE.0) THEN
         WRITE(IOUT,36) IPCLST(1,I),LINE(IM1:IM2),LINE(IZ1:IZ2)
   36    FORMAT(1X,'               LAYER:',I3,'   MULTIPLIER:',A,
     2      '   ZONE:',A)
      ELSE
         WRITE(IOUT,37) LINE(IM1:IM2),LINE(IZ1:IZ2)
   37    FORMAT(1X,'               MULTIPLIER:',A,'   ZONE:',A)
      END IF
C
C  Save the multiplier array name
      CTMP1=LINE(IM1:IM2)
      CALL UPCASE(CTMP1)
      IF(CTMP1.EQ.'NONE') THEN
         CPCLST(1,I)='NONE'
      ELSE
         DO 40 J=1,MXMLT
         CTMP2=MLTNAM(J)
         CALL UPCASE(CTMP2)
         IF(CTMP1.EQ.CTMP2) GO TO 45
         CTMP2=MLTFNM(J)
         CALL UPCASE(CTMP2)
         IF(CTMP1.EQ.CTMP2) GO TO 45
   40    CONTINUE
         WRITE(IOUT,'(A)') ' Multiplier array has not been defined'
         CALL RDABRT
   45    CPCLST(1,I)=LINE(IM1:IM2)
      END IF
C
C  Save the zone array name
      CTMP1=LINE(IZ1:IZ2)
      CALL UPCASE(CTMP1)
      IF(CTMP1.EQ.'ALL') THEN
         CPCLST(2,I)='ALL'
      ELSE
         IF(IPCLST(2,I).EQ.2) THEN
            WRITE(IOUT,47)
   47       FORMAT(
     1      1X,'There were no zone values specified in the cluster',/
     2      1X,'At least one zone must be specified')
            CALL RDABRT
         END IF
         WRITE(IOUT,48) (IPCLST(J,I),J=3,IPCLST(2,I))
   48    FORMAT(1X,'               ZONE VALUES:',10I5)
         DO 50 J=1,MXZON
         CTMP2=ZONNAM(J)
         CALL UPCASE(CTMP2)
         IF(CTMP1.EQ.CTMP2) GO TO 55
   50    CONTINUE
         WRITE(IOUT,'(A)') ' Zone array has not been defined'
         CALL RDABRT
   55    CPCLST(2,I)=LINE(IZ1:IZ2)
      END IF
C
  200 CONTINUE
C
      RETURN
      END
      SUBROUTINE UPARLSTAL(IN,IOUT,LINE,NP,MXL)
C
C-----VERSION 26FEB1998 UPARLSTAL
C     ******************************************************************
C     Setup list parameter definition for a package
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2kpar.inc'
      CHARACTER*(*) LINE
C     ------------------------------------------------------------------
C
C  Decode PARAMETER definitions if they exist
      NP=0
      MXL=0
      LLOC=1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IN)
      IF(LINE(ISTART:ISTOP).EQ.'PARAMETER') THEN
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NP,R,IOUT,IN)
         IF(NP.LT.0) NP=0
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,MXL,R,IOUT,IN)
         IF(MXL.LT.0) MXL=0
C
C
         WRITE(IOUT,31) NP,MXL
   31    FORMAT(1X,I5,' Named Parameters     ',I5,' List entries')
         READ(IN,'(A)') LINE
      ELSE
         WRITE(IOUT,'(A)') ' No named parameters'
      END IF
C
      RETURN
      END
      SUBROUTINE UPARLSTRP(IN,PACK,PTYPX,NLST,ARRNAM)
C
C     ******************************************************************
C     Read and store parameter definition information for one list parameter
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      INCLUDE 'mfi2kpar.inc'
      CHARACTER*(*) PACK,PTYPX,ARRNAM
      CHARACTER*4 PTYP
      CHARACTER*10 PN,CTMP1,CTMP2
      CHARACTER*80 LINE
C     ------------------------------------------------------------------
C
C  Read the parameter name and definition
20    READ(IN,'(A)') LINE
      LLOC=1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,0,N,R,IOUT,IN)
      PN=LINE(ISTART:ISTOP)
      CTMP1=PN
      CALL UPCASE(CTMP1)
      ARRNAM=CTMP1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IN)
      PTYP=LINE(ISTART:ISTOP)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,N,PV,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NLST,R,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IN)
      IF(LINE(ISTART:ISTOP).EQ.'INSTANCES') THEN
         WRITE(IOUT,*) 'Data set contains INSTANCES for a parameter.'
         WRITE(IOUT,*) 'INSTANCES are not supported in MFI2K.'
         CALL RDABRT
      END IF
C
      DO 10 NP=1,MXPAR
        CTMP2=PARNAM(NP)
        CALL UPCASE(CTMP2)
        IF(CTMP1.EQ.CTMP2) THEN
C   Illegal duplicate
           WRITE(IOUT,*) ' Duplicate parameter name'
           CALL RDABRT
        ELSE IF(PARNAM(NP).EQ.' ') THEN
C         Parameter was not found in the list, so it is a new definition.
          PARNAM(NP)=PN
          B(NP)=PV
          B2(NP)=PV
          ISFILE(NP)=0
          ISENS(NP)=0
          LN(NP)=0
          BL(NP)=0.0
          BU(NP)=0.0
          BSCAL(NP)=0.0
          IPSUM=IPSUM+1
          GO TO 100
        ENDIF
10    CONTINUE
C  Too many parameters
      WRITE(IOUT,99)
  99  FORMAT(' Number of parameters exceeds MXPAR -- STOP EXECUTION')
      CALL RDABRT
 100  CONTINUE
C
C     PUT PARAMETER TYPE IN THE LIST
      PARTYP(NP)=PTYP
C
      IPLOC(1,NP)=1
      IPLOC(2,NP)=2
C
C-----WRITE PARAMETER INFORMATION
      WRITE(IOUT,121) PARNAM(NP),PARTYP(NP)
  121 FORMAT(1X/,1X,'PARAMETER NAME:',A,'   TYPE:',A)
      WRITE(IOUT,122) PV
  122 FORMAT(1X,'The parameter value from the package file is:',1PG13.5)
      WRITE(IOUT,130) NLST
  130 FORMAT(  '   NUMBER OF ENTRIES: ',I3)
C
C  Check for correct parameter type
      IF(PARTYP(NP).NE.PTYPX) THEN
         WRITE(IOUT,137) PTYPX,PACK
  137    FORMAT(1X,'Parameter type must be:',A,' in the ',A,' Package')
         CALL RDABRT
      END IF
      IACTIVE(NP)=0
C
      IF(NLST.GT.10*MXLIST) THEN
         WRITE(IOUT,*) ' List is longer than 10 times MXLIST'
         CALL RDABRT
      END IF
C
      RETURN
      END
      SUBROUTINE PRESET(PTYP)
C
C-----VERSION 30MARCH1998
C     ******************************************************************
C     Clear time step flag for all parameters of the specified type
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2kpar.inc'
      CHARACTER*(*) PTYP
C     ------------------------------------------------------------------
C
      DO 10 I=1,IPSUM
      IF(PARTYP(I).EQ.PTYP) IACTIVE(I)=0
   10 CONTINUE
C
      RETURN
      END
      SUBROUTINE PPRINT(IOUT)
C     ******************************************************************
C     Test routine for printing out defined parameters
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2kpar.inc'
C     ------------------------------------------------------------------
C
      WRITE(IOUT,11)
   11 FORMAT(1X,'PARNAM  PARTYP    1st loc   2nd loc  IACTIVE  VALUE')
      DO 10 I=1,IPSUM
      WRITE(IOUT,12) PARNAM(I),PARTYP(I),(IPLOC(J,I),J=1,2),IACTIVE(I),
     1       B(I)
   12 FORMAT(1X,A,A,3I10,G12.3)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE PERPARRD(IN,NP,PTYP,KPER,IPF)
C     ******************************************************************
C     Read parameters in effect for a stress period
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      INCLUDE 'mfi2kpar.inc'
      CHARACTER*(*) PTYP
      CHARACTER*200 LINE
      CHARACTER*10 CTMP1,CTMP2
C     ------------------------------------------------------------------
      IF(NP.LE.0) RETURN
      IPFCHK=IPF
C
      DO 10 I=1,MXPERPAR
      IF(PERPARNAM(I).EQ.' ') GO TO 100
10    CONTINUE
      I=MXPERPAR+1
100   NPERPAR=I-1
      IF(NPERPAR+NP.GT.MXPERPAR) THEN
         WRITE(IOUT,*) ' Not enough room in PERPARNAM'
         CALL RDABRT
      END IF
C
      DO 500 K=1,NP
      READ(IN,'(A)') LINE
      LLOC=1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,0,N,R,IOUT,IN)
      CTMP1=LINE(ISTART:ISTOP)
      CALL UPCASE(CTMP1)
      WRITE(IOUT,*) 'PARAMETER:',LINE(ISTART:ISTOP)
      NPERPAR=NPERPAR+1
C
      DO 110 I=1,MXPAR
      CTMP2=PARNAM(I)
      CALL UPCASE(CTMP2)
      IF(CTMP1.EQ.CTMP2) GO TO 200
110   CONTINUE
      WRITE(IOUT,*) 'PARAMETER HAS NOT BEEN DEFINED'
      CALL RDABRT
C
200   PERPARNAM(NPERPAR)=PARNAM(I)
      IPERPARPER(NPERPAR)=KPER
      PERPARTYP(NPERPAR)=PTYP
C
C  Get new value of print flag if it is there.
      IF(IPFCHK.EQ.-999) THEN
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IVAL,RDUM,-1,IN)
         IF(LINE(200:200) .NE. 'E' .AND.
     1      LINE(ISTART:ISTOP) .NE. ' ') IPF=IVAL
      END IF
C
500   CONTINUE
C
      RETURN
      END
