      SUBROUTINE SSLSTG(IXLOC,NNLIST,LABEL,NMFLOW,NAR,CAUX,NCAUX,IDDIAL)
C     ******************************************************************
C     Interface for editing a list using wintwracter
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
      TYPE(WIN_MESSAGE)   :: MESSAGE
      INCLUDE 'mfi2k.inc'
      DIMENSION IXLOC(10)
      CHARACTER*(*) LABEL(NMFLOW,2)
      CHARACTER*16 CAUX(NCAUX)
      CHARACTER*8 LABEL2(3,2)
      DIMENSION ISSCOL(20),MFICOL(20),JCOL(20)
      CHARACTER*10 CNLST
      DIMENSION KDATA(100),IDATA(100),JDATA(100),RDATA(100,8)
      CHARACTER*70 CTXT(2)
C     ------------------------------------------------------------------
      NLIST=NNLIST
      IRDONLY=0
      IF(NLIST.GT.100) THEN
         NLIST=100
         CTXT(1)='There are more than 100 cells in the list'
         CTXT(2)='The first 100 are displayed.  Editing is turned off'
         CALL TXTLOG(CTXT,2)
         IRDONLY=1
      END IF
C
C  Generate ISSCOL (spreadsheet column for each item in a row of data
C  as stored in MODFLOW) and MFICOL (MODFLOW column for each item in a
C  row as stored the spreadsheet).
      DO 2 I=1,NMFLOW
      ISSCOL(I)=I
      MFICOL(I)=I
      JCOL(I)=I
2     CONTINUE
      DO 3 I=1,3
      LABEL2(I,1)=' '
      LABEL2(I,2)=' '
      ISSCOL(NMFLOW+I)=0
3     CONTINUE
C
      NV=NMFLOW
      LSTDIM=IARRDA(3,NAR)
C
C  Activate IFACE as first AUX field if MODPATH is active
      IF(IUNIT(40).GT.0) THEN
         CAUX(1)='IFACE'
      END IF
C
C  Create spread sheet labels for AUX fields
      DO 5 I=1,NCAUX
      IF(CAUX(I).NE.' ') THEN
C  Note that only non-blank labels will be displayed as columns in the
C  spread sheet
         LABEL2(I,2)=CAUX(I)
         NV=NV+1
         JCOL(NV)=NV
         ISSCOL(NMFLOW+I)=NV
         MFICOL(NV)=NMFLOW+I
      END IF
5     CONTINUE
C
C  Create the spread sheet
      CALL WDialogLoad(LIST_GRID_DIALOG)
      CALL WGridColumns(LIST_GRID,NV,JCOL)
      CALL WGridRows(LIST_GRID,100)
      DO 8 I=1,NMFLOW
      CALL WGridLabelColumn(LIST_GRID,I,LABEL(I,2))
8     CONTINUE
      IF(NV.GT.NMFLOW) THEN
         DO 9 I=NMFLOW+1,NV
         CALL WGridLabelColumn(
     1      LIST_GRID,I,LABEL2(I-NMFLOW,2))
9        CONTINUE
      END IF
C
C  Write existing values into spreadsheet.
      IF(NLIST.GT.0) THEN
         DO 20 L=1,LSTDIM
         IF(ISSCOL(L).GT.0) THEN
            DO 15 N=1,NLIST
            IGROUP=(N-1)/MXLIST + 1
            IOFF=IXLOC(IGROUP)+ (N-1-(IGROUP-1)*MXLIST)*LSTDIM - 1
            IF(ISSCOL(L).GT.3) THEN
               RDATA(N,1)=X(IOFF+L)
            ELSE
               IDATA(N)=X(IOFF+L)
            END IF
15          CONTINUE
            IF(ISSCOL(L).GT.3) THEN
               CALL WGridPutReal(
     1             LIST_GRID,ISSCOL(L),RDATA(1,1),NLIST,'(1PG12.5)')
            ELSE
               CALL WGridPutInteger(LIST_GRID,ISSCOL(L),IDATA,NLIST)
            END IF
         END IF
20       CONTINUE
      END IF
      IF(IRDONLY.NE.0) CALL WDialogFieldState(LIST_GRID,DialogReadOnly)
C
      CALL WDialogShow(-1,50,0,MODAL)
C
C  Get and store values if "OK" was pushed
      IF(WInfoDialog(ExitButton).EQ.IDOK .AND. IRDONLY.EQ.0) THEN
         NN=100
         CALL WGridGetInteger(LIST_GRID,1,KDATA,NN)
         CALL WGridGetInteger(LIST_GRID,2,IDATA,NN)
         CALL WGridGetInteger(LIST_GRID,3,JDATA,NN)
         DO 22 N=4,NV
         CALL WGridGetReal(LIST_GRID,N,RDATA(1,N-3),NN)
22       CONTINUE
C
C  Entire spreadsheet has been read.  Move valid data into the list.
         NLIST=0
         DO 30 N=1,100
         IC=JDATA(N)
         IR=IDATA(N)
         IL=KDATA(N)
         IF(IC.LT.1    .OR. IR.LT.1    .OR. IL.LT.1 .OR.
     1       IC.GT.NCOL .OR. IR.GT.NROW .OR. IL.GT.NLAY) GO TO 30
         NLIST=NLIST+1
         IGROUP=(NLIST-1)/MXLIST + 1
         IF(IGROUP.GT.IARRDA(4,NAR)) CALL LSTALO(NAR,IGROUP)
         IOFF=(NLIST-1-(IGROUP-1)*MXLIST)*LSTDIM - 1
         X(IXLOC(IGROUP)+IOFF+1)=IL
         X(IXLOC(IGROUP)+IOFF+2)=IR
         X(IXLOC(IGROUP)+IOFF+3)=IC
         DO 25 I=4,NV
         X(IXLOC(IGROUP)+IOFF+MFICOL(I))=RDATA(N,I-3)
25       CONTINUE
30       CONTINUE
         NNLIST=NLIST
      END IF
C
      CALL WDialogUnload(LIST_GRID_DIALOG)
      CALL WDialogSelect(IDDIAL)
C
      RETURN
      END
      SUBROUTINE SS2DRG(XX,NCC,NRR,LABEL,IDDIAL)
C     ******************************************************************
C     Winteracter Interface for editing a 2-D real array
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
      TYPE(WIN_MESSAGE)   :: MESSAGE
      INCLUDE 'mfi2k.inc'
      DIMENSION XX(NCC,NRR)
      CHARACTER*(*) LABEL
      DIMENSION COL(100),JCOL(100)
      CHARACTER*70 CTXT(2)
C     ------------------------------------------------------------------
C
C  Maximum grid size is 100x100
      IF(NCC.GT.100 .OR. NRR.GT.100) THEN
         CTXT(1)='There are more than 100 rows or columns'
         CTXT(2)='The array cannot be edited'
         CALL TXTLOG(CTXT,2)
         CALL WDialogSelect(IDDIAL)
         RETURN
      END IF
C
      CALL WDialogLoad(REAL_ARRAY_DIALOG)
      CALL WDialogPutString(REAL_ARRAY_LABEL,LABEL)
C
C  Set the grid size
      NC=NCC
      NR=NRR
      DO 4 J=1,NC
      JCOL(J)=J
4     CONTINUE
      CALL WGridColumns(REAL_ARRAY_GRID,NC,JCOL)
      CALL WGridRows(REAL_ARRAY_GRID,NR)
C
C  Display the current values
      DO 10 J=1,NC
      DO 8  I=1,NR 
      COL(I)=XX(J,I)
8     CONTINUE
      CALL WGridPutReal(REAL_ARRAY_GRID,J,COL,NR,'(1PG12.5)')
10    CONTINUE
C
      CALL WDialogShow(-1,50,0,MODAL)
C
C  Get and store values if "OK" was pushed
      IF(WInfoDialog(ExitButton).EQ.IDOK) THEN
         DO 20 J=1,NC
         N=NR
         CALL WGridGetReal(REAL_ARRAY_GRID,J,COL,N)
         DO 18 I=1,NR
         XX(J,I)=COL(I)
18       CONTINUE
20       CONTINUE
      END IF
C
      CALL WDialogUnload(REAL_ARRAY_DIALOG)
      CALL WDialogSelect(IDDIAL)
C
      RETURN
      END
      SUBROUTINE SS2DIG(IXX,NCC,NRR,LABEL,IDDIAL)
C     ******************************************************************
C     Winteracter Interface for editing a 2-D integer array
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
      TYPE(WIN_MESSAGE)   :: MESSAGE
      INCLUDE 'mfi2k.inc'
      DIMENSION IXX(NCC,NRR)
      CHARACTER*(*) LABEL
      DIMENSION IC(100),JCOL(100)
      CHARACTER*70 CTXT(2)
C     ------------------------------------------------------------------
C
C  Maximum grid size is 100x100
      IF(NCC.GT.100 .OR. NRR.GT.100) THEN
         CTXT(1)='There are more than 100 rows or columns'
         CTXT(2)='The array cannot be edited'
         CALL TXTLOG(CTXT,2)
         CALL WDialogSelect(IDDIAL)
         RETURN
      END IF
C
      CALL WDialogLoad(INTEGER_ARRAY_DIALOG)
      CALL WDialogPutString(INTEGER_ARRAY_LABEL,LABEL)
C
C  Set the grid size
      NC=NCC
      NR=NRR
      DO 4 J=1,NC
      JCOL(J)=J
4     CONTINUE
      CALL WGridColumns(INTEGER_ARRAY_GRID,NC,JCOL)
      CALL WGridRows(INTEGER_ARRAY_GRID,NR)
C
C  Display the current values
      DO 10 J=1,NC
      DO 8  I=1,NR 
      IC(I)=IXX(J,I)
8     CONTINUE
      CALL WGridPutInteger(INTEGER_ARRAY_GRID,J,IC,NR)
10    CONTINUE
C
      CALL WDialogShow(-1,50,0,MODAL)
C
C  Get and store values if "OK" was pushed
      IF(WInfoDialog(ExitButton).EQ.IDOK) THEN
         DO 20 J=1,NC
         N=NR
         CALL WGridGetInteger(INTEGER_ARRAY_GRID,J,IC,N)
         DO 18 I=1,NR
         IXX(J,I)=IC(I)
18       CONTINUE
20       CONTINUE
      END IF
C
      CALL WDialogUnload(INTEGER_ARRAY_DIALOG)
      CALL WDialogSelect(IDDIAL)
C
      RETURN
      END
