      SUBROUTINE SSLST(IXLOC,NLIST,LABEL,NMFLOW,NAR,CAUX,NCAUX,IDDIAL)
      USE WINTERACTER
C     ******************************************************************
C     Interface for editing a list
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      DIMENSION IXLOC(10)
      CHARACTER*(*) LABEL(NMFLOW,2)
      CHARACTER*16 CAUX(NCAUX)
      CHARACTER*8 LABEL2(3,2)
      DIMENSION ISSCOL(20),MFICOL(20),RDATA(20)
      CHARACTER*10 CNLST
C     ------------------------------------------------------------------
C
C  Generate ISSCOL (spreadsheet column for each item in a row of data
C  as stored in MODFLOW) and MFICOL (MODFLOW column for each item in a
C  row as stored the spreadsheet).
      DO 2 I=1,NMFLOW
      ISSCOL(I)=I
      MFICOL(I)=I
2     CONTINUE
      DO 3 I=1,3
      LABEL2(I,1)=' '
      LABEL2(I,2)=' '
      ISSCOL(NMFLOW+I)=0
3     CONTINUE
C
      NV=NMFLOW
      LSTDIM=IARRDA(3,NAR)
C
C  Create spread sheet labels for AUX fields
      DO 5 I=1,NCAUX
      IF(CAUX(I).NE.' ') THEN
C  Note that only non-blank labels will be displayed as columns in the
C  spread sheet
         LABEL2(I,2)=CAUX(I)
         NV=NV+1
         ISSCOL(NMFLOW+I)=NV
         MFICOL(NV)=NMFLOW+I
      END IF
5     CONTINUE
C
C  Create the spread sheet file
      CALL SSOPWR(IUMISC,IERR)
      IF(IERR.NE.0) RETURN
      CALL SSLAWR(IUMISC,LABEL(1,1),NMFLOW,LABEL2(1,1),3,1)
      CALL SSLAWR(IUMISC,LABEL(1,2),NMFLOW,LABEL2(1,2),3,2)
C  Write existing values into spreadsheet file.
      IF(NLIST.GT.0) THEN
         DO 15 N=1,NLIST
         IGROUP=(N-1)/MXLIST + 1
         IOFF=IXLOC(IGROUP)+ (N-1-(IGROUP-1)*MXLIST)*LSTDIM - 1
         DO 10 L=1,LSTDIM
         IF(ISSCOL(L).GT.0) RDATA(ISSCOL(L))=X(IOFF+L)
10       CONTINUE
         CALL SSWR(IUMISC,NV,RDATA)
15       CONTINUE
      END IF
      CLOSE(UNIT=IUMISC)
C
C  Tell user to use their spreadsheet program to edit the data
C      CALL IOsCommand('notepad _mfiss.csv')
      CALL WMessageBox(OKOnly,ExclamationIcon,CommonOK,
     1  'The current data values have been written into file'
     2 //CHAR(13)//'''_mfiss.csv''.  Edit this file with an external'
     3      //' program and'
     4  //CHAR(13)//'save the modified values back into _mfiss.csv'
     5  //CHAR(13)//'Then close the modified file.  Click OK when done!'
     6     ,' ')
      CALL WDialogSelect(IDDIAL)
C
C  Read the edited values from the spreadsheet file.
      CALL SSOPRD(IUMISC,IERR)
      IF(IERR.NE.0) RETURN
C  Skip 2 lines of column headings
      READ(IUMISC,*,END=30)
      READ(IUMISC,*,END=30)
C  Set old values to 0 before reading new values so that the old values
C  cannot be inadvertantly reused if the user leaves some fields in the
C  spreadsheet blank.  Most spreadsheets do not write out blank fields;
C  therefore, if values were not set to, blank fields in the spreadsheet
C  would result in reusing the former values in that field.  This would
C  be misleading because the user would not see this unless the values
C  were reedited in the spreadsheet.  Thus, setting all values to 0 avoids
C  this problem.
      DO 17 N=1,NLIST
      IGROUP=(N-1)/MXLIST + 1
      IOFF=IXLOC(IGROUP)+ (N-1-(IGROUP-1)*MXLIST)*LSTDIM - 1
      DO 16 L=1,LSTDIM
      X(IOFF + L)=0.
16    CONTINUE
17    CONTINUE
C
      MXN=0
C  Read one line from the file
20    CALL SSRD(IUMISC,NV,RDATA,IERR)
      IF(IERR.NE.0) GO TO 30
      MXN=MXN+1
      IGROUP=(MXN-1)/MXLIST + 1
      IF(IGROUP.GT.IARRDA(4,NAR)) CALL LSTALO(NAR,IGROUP)
      IOFF=IXLOC(IGROUP) + (MXN-1-(IGROUP-1)*MXLIST)*LSTDIM - 1
      IF(MXN.LE.MXLIST*10) THEN
         DO 21 L=1,NV
         X(IOFF+MFICOL(L))=RDATA(L)
21       CONTINUE
      END IF
      GO TO 20
C
C  Entire spreadsheet file has been read.  Count the valid rows in
C  the list, and throw out invalid rows by moving the following rows
C  forward in the list.
30    NLIST=0
      DO 40 N=1,MXN
      IGROUP=(N-1)/MXLIST + 1
      IOFF=(N-1-(IGROUP-1)*MXLIST)*LSTDIM
      IL=X(IXLOC(IGROUP)+IOFF)
      IR=X(IXLOC(IGROUP)+IOFF+1)
      IC=X(IXLOC(IGROUP)+IOFF+2)
      IF(IC.LT.1    .OR. IR.LT.1    .OR. IL.LT.1 .OR.
     1   IC.GT.NCOL .OR. IR.GT.NROW .OR. IL.GT.NLAY) GO TO 40
      NLIST=NLIST+1
      IF(NLIST.NE.N) THEN
         IGRP2=(NLIST-1)/MXLIST + 1
         IOFF2=(NLIST-1-(IGRP2-1)*MXLIST)*LSTDIM
         DO 35 L=1,LSTDIM
         X(IXLOC(IGRP2)+IOFF2+L-1)=X(IXLOC(IGROUP)+IOFF+L-1)
         X(IXLOC(IGROUP)+IOFF+L-1)=0.
35       CONTINUE
      END IF
40    CONTINUE
C
C  Close the spreadsheet file
100   CLOSE(UNIT=IUMISC,ERR=150)
      CALL IOsDeleteFile('_mfiss.csv')
      IF(InfoError(1).EQ.13) GO TO 150
      RETURN
C
C
150   CALL WMessageBox(OKOnly,StopIcon,CommonOK,
     1      'The external editing file, _mfiss.csv, cannot be deleted'//
     2       CHAR(13)//
     3      'Close it in the external software BEFORE hitting OK',' ')
      IRESP=WInfoDialog(ExitButtonCommon)
      IF(IRESP.EQ.CommonOK) GO TO 100
      CALL MFISTP
C
      END
      SUBROUTINE SS2DR(XX,NCC,NR,LABEL,IDDIAL)
      USE WINTERACTER
C     ******************************************************************
C     Interface for editing a 2-D real array
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      DIMENSION XX(NCC,NR)
      CHARACTER*(*) LABEL
      CHARACTER*8 CROW
C     ------------------------------------------------------------------
C
      NC=NCC
      IF(NC.GT.256) NC=256
C
      CALL SSOPWR(IUMISC,IERR)
      IF(IERR.NE.0) RETURN
      DO 10 I=1,NR
      CALL SSWR(IUMISC,NC,XX(1,I))
10    CONTINUE
      CLOSE(UNIT=IUMISC)
C
C      CALL IOSCommand('notepad _mfiss.csv')
      CALL WMessageBox(OKOnly,ExclamationIcon,CommonOK,
     1  'The current data values have been written into file'
     2 //CHAR(13)//'''_mfiss.csv''.  Edit this file with an external'
     3      //' program and'
     4  //CHAR(13)//'save the modified values back into _mfiss.csv'
     5  //CHAR(13)//'Then close the modified file.  Click OK when done!'
     6     ,' ')
      CALL WDialogSelect(IDDIAL)
C
      CALL SSOPRD(IUMISC,IERR)
      IF(IERR.NE.0) RETURN
      N=0
      DO 20 I=1,NR
      CALL SSRD(IUMISC,NC,XX(1,I),IERR)
      IF(IERR.NE.0) THEN
         NBAD=NC*(NR-I+1)
C  Print number of rejected values if there are any
         IF(NBAD.NE.0) THEN
            WRITE(CROW,'(I8)') I
            CALL WMessageBox(OKOnly,ExclamationIcon,CommonOK,
     1         'Bad numeric data in row' //CROW//CHAR(13)//
     2     'The bad data and all following data have been ignored',' ')
         END IF
         GO TO 100
      END IF
      N=N+NC
20    CONTINUE
C
100   CLOSE(UNIT=IUMISC,ERR=150)
      CALL IOsDeleteFile('_mfiss.csv')
      IF(InfoError(1).EQ.13) GO TO 150
      RETURN
C
150   CALL WMessageBox(OKOnly,StopIcon,CommonOK,
     1      'The external editing file, _mfiss.csv, cannot be deleted'//
     2       CHAR(13)//
     3      'Close it in the external software BEFORE hitting OK',' ')
      IRESP=WInfoDialog(ExitButtonCommon)
      IF(IRESP.EQ.CommonOK) GO TO 100
      CALL MFISTP
C
      END
      SUBROUTINE SS2DI(IXD,NCC,NR,LABEL,IDDIAL)
      USE WINTERACTER
C     ******************************************************************
C     Interface for editing a 2-D integer array
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      DIMENSION IXD(NCC,NR)
      CHARACTER*(*) LABEL
      CHARACTER*8 CROW
      DIMENSION IR(256),R(256)
C
      NC=NCC
      IF(NC.GT.256) NC=256
C
      CALL SSOPWR(IUMISC,IERR)
      IF(IERR.NE.0) RETURN
      DO 11 I=1,NR
      DO 10 J=1,NC
      IR(J)=IXD(J,I)
10    CONTINUE
      CALL SSIWR(IUMISC,NC,IR)
11    CONTINUE
      CLOSE(UNIT=IUMISC)
C
C      CALL IOsCommand('notepad _mfiss.csv')
      CALL WMessageBox(OKOnly,ExclamationIcon,CommonOK,
     1  'The current data values have been written into file'
     2 //CHAR(13)//'''_mfiss.csv''.  Edit this file with an external'
     3      //' program and'
     4  //CHAR(13)//'save the modified values back into _mfiss.csv'
     5  //CHAR(13)//'Then close the modified file.  Click OK when done!'
     6     ,' ')
      CALL WDialogSelect(IDDIAL)
C
      CALL SSOPRD(IUMISC,IERR)
      IF(IERR.NE.0) RETURN
      N=0
      DO 20 I=1,NR
      CALL SSRD(IUMISC,NC,R,IERR)
      IF(IERR.NE.0) THEN
         NBAD=NC*(NR-N+1)
         IF(NBAD.NE.0) THEN
            WRITE(CROW,'(I8)') I
            CALL WMessageBox(OKOnly,ExclamationIcon,CommonOK,
     1         'Bad numeric data in row' //CROW//CHAR(13)//
     2     'The bad data and all following data have been ignored',' ')
         END IF
         GO TO 100
      END IF
      N=N+NC
      DO 15 J=1,NC
         IXD(J,I)=R(J)
15    CONTINUE
20    CONTINUE
C
100   CLOSE(UNIT=IUMISC,ERR=150)
      CALL IOsDeleteFile('_mfiss.csv')
      IF(InfoError(1).EQ.13) GO TO 150
      RETURN
C
150   CALL WMessageBox(OKOnly,StopIcon,CommonOK,
     1      'The external editing file, _mfiss.csv, cannot be deleted'//
     2       CHAR(13)//
     3      'Close it in the external software BEFORE hitting OK',' ')
      IRESP=WInfoDialog(ExitButtonCommon)
      IF(IRESP.EQ.CommonOK) GO TO 100
      CALL MFISTP
C
      END
      SUBROUTINE SSOPWR(IU,IERR)
C     ******************************************************************
C     Open spreadsheet file for writing
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2k.inc'
      CHARACTER*128 FNAME(2)
C     ------------------------------------------------------------------
C
      NFILE=1
      CALL IOsDirList(' ','_mfiss.csv',FNAME,NFILE)
      IF(NFILE.GE.1) THEN
         CALL WMessageBox(OKOnly,StopIcon,CommonOK,
     1      'The external editing file, _mfiss.csv, already exists'//
     1       CHAR(13)//
     2    'You must delete this file before MFI can use it',' ')
         IERR=1
         RETURN
      END IF
      OPEN(UNIT=IU,FILE='_mfiss.csv',ERR=100)
C
C  Beginning of file
      IERR=0
      RETURN
C
100   CALL WMessageBox(OKOnly,ExclamationIcon,CommonOK,
     1      'The external editing file, _mfiss.csv, could not'//
     2      CHAR(13)//'be opened.',' ')
      IERR=1
      RETURN
      END
      SUBROUTINE SSLAWR(IU,LABEL,NMFLOW,LABEL2,NCAUX,IR)
C     ******************************************************************
C     Write labels into a spreadsheet file
C     ******************************************************************
      USE WINTERACTER
      CHARACTER*(*) LABEL(NMFLOW),LABEL2(NCAUX)
C
C  Write labels
      WRITE(IU,5,ERR=100) (LABEL(J),J=1,NMFLOW),(LABEL2(K),K=1,NCAUX)
5     FORMAT(20(A15,:,','))
C
      RETURN
C
100   CALL WMessageBox(OKOnly,ExclamationIcon,CommonOK,
     1  'Error writing spreadsheet file',' ')
      CALL SAVALL(1,IERR)
      STOP
      END
      SUBROUTINE SSWR(IU,NC,X)
C     ******************************************************************
C     Write  1 row of spreadsheet
C     ******************************************************************
      USE WINTERACTER
      DIMENSION X(NC)
C
      WRITE(IU,5,ERR=100) (X(J),J=1,NC)
5     FORMAT(1P,256(G15.7,:,','))
      RETURN
C
100   CALL WMessageBox(OKOnly,ExclamationIcon,CommonOK,
     1  'Error writing spreadsheet file',' ')
      CALL SAVALL(1,IERR)
      STOP
      END
      SUBROUTINE SSIWR(IU,NC,IX)
C     ******************************************************************
C     Write  1 row of spreadsheet
C     ******************************************************************
      USE WINTERACTER
      DIMENSION IX(NC)
C
      WRITE(IU,5,ERR=100) (IX(J),J=1,NC)
5     FORMAT(256(I10,:,','))
      RETURN
C
100   CALL WMessageBox(OKOnly,ExclamationIcon,CommonOK,
     1  'Error writing spreadsheet file',' ')
      CALL SAVALL(1,IERR)
      STOP
      END
      SUBROUTINE SSOPRD(IU,IERR)
C     ******************************************************************
C     Open the spreadsheet file for reading
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2k.inc'
C
10    OPEN(UNIT=IU,FILE='_mfiss.csv',ERR=100)
      IERR=0
      RETURN
C
100   CALL WMessageBox(RetryCancel,QuestionIcon,CommonRetry,
     1      'The external editing file, _mfiss.csv, could not'//
     2      CHAR(13)//'be opened for reading.',' ')
      IRESP=WInfoDialog(ExitButtonCommon)
      IF(IRESP.NE.CommonRetry) GO TO 10
      IERR=1
      RETURN
      END
      SUBROUTINE SSRD(IU,NC,R,IERR)
C     ******************************************************************
C     Read a row from spreadsheet file
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      DIMENSION R(NC)
      CHARACTER*5000 CLINE
C     ------------------------------------------------------------------
C
      IERR=0
C  Read one row of data from a single line in the file
      READ(IU,'(A)',ERR=100,END=100) CLINE
      READ(CLINE,*,ERR=100,END=100) (R(J),J=1,NC)
      RETURN
C
100   IERR=1
      RETURN
C
      END
