      SUBROUTINE VALSAV(VNAM,LAYER,IPER,VALUE)
C     ******************************************************************
C  Save a scalar variable's REAL value -- create a new variable if the
C  variable doesn't yet exist.
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      CHARACTER*(*) VNAM
C
      IF(NVAR.GT.0) THEN
         DO 10 I=1,NVAR
         IF(VARNAM(I).EQ.VNAM .AND. IVARDA(1,I).EQ.LAYER .AND.
     1    IVARDA(2,I).EQ.IPER) GO TO 100
10       CONTINUE
      END IF
C
C  Create new entry
      NVAR=NVAR+1
      IF(NVAR.GT.MXVAR) THEN
         WRITE(IOUT,*) ' Variable overflow'
         CALL MFISTP
      END IF
      VARNAM(NVAR)=VNAM
      IVARDA(1,NVAR)=LAYER
      IVARDA(2,NVAR)=IPER
      IVARDA(3,NVAR)=0
      VARVAL(NVAR)=VALUE
      RETURN
C
C  Replace old value
100   VARVAL(I)=VALUE
C
      RETURN
      END
      SUBROUTINE IVLSAV(VNAM,LAYER,IPER,IVALUE)
C     ******************************************************************
C  Save a scalar variable's INTEGER value -- create a new variable if the
C  variable doesn't yet exist.
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      CHARACTER*(*) VNAM
C
      IF(NVAR.GT.0) THEN
         DO 10 I=1,NVAR
         IF(VARNAM(I).EQ.VNAM .AND. IVARDA(1,I).EQ.LAYER .AND.
     1    IVARDA(2,I).EQ.IPER) GO TO 100
10       CONTINUE
      END IF
C
C  Create new entry
      NVAR=NVAR+1
      IF(NVAR.GT.MXVAR) THEN
         WRITE(IOUT,*) ' Variable overflow'
         CALL MFISTP
      END IF
      VARNAM(NVAR)=VNAM
      IVARDA(1,NVAR)=LAYER
      IVARDA(2,NVAR)=IPER
      IVARDA(3,NVAR)=0
      VARVAL(NVAR)=IVALUE
      RETURN
C
C  Replace old value
100   VARVAL(I)=IVALUE
C
      RETURN
      END
      SUBROUTINE ARRMAK(VNAM,LAYER,IPER,IDIM1,IDIM2)
C     ******************************************************************
C     Create an array.  First a variable is created, then an extra
C     structure is created to define the array
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      CHARACTER*(*) VNAM
C
      IF(NVAR.GT.0) THEN
         DO 10 I=1,NVAR
         IF(VARNAM(I).EQ.VNAM .AND. IVARDA(1,I).EQ.LAYER .AND.
     1    IVARDA(2,I).EQ.IPER) GO TO 100
10       CONTINUE
      END IF
C
C  Create new entry
      NVAR=NVAR+1
      IF(NVAR.GT.MXVAR) THEN
         WRITE(IOUT,*) ' Variable overflow'
         CALL MFISTP
      END IF
      NARRAY=NARRAY+1
      IF(NARRAY.GT.MXARR) THEN
         WRITE(IOUT,*) ' Array overflow'
         CALL MFISTP
      END IF
      VARNAM(NVAR)=VNAM
      IVARDA(1,NVAR)=LAYER
      IVARDA(2,NVAR)=IPER
      IVARDA(3,NVAR)=NARRAY
      VARVAL(NVAR)=-999.99
      IARRDA(1,NARRAY)=0
      IARRDA(2,NARRAY)=0
      IARRDA(3,NARRAY)=IDIM1
      IARRDA(4,NARRAY)=IDIM2
      IARRDA(5,NARRAY)=0
      ARRCON(NARRAY)=0.
      RETURN
C
C  Variable already exists
100   WRITE(IOUT,*) ' Duplicate variable:',VNAM
      CALL MFISTP
      END
      SUBROUTINE ARRMAK2(VNAM,LAYER,IPER,IDIM1,IDIM2)
C     ******************************************************************
C     Create an array. -- same as ARRMAK, except call rdabrt upon
C     error rather than MFISTP.
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      CHARACTER*(*) VNAM
C
      IF(NVAR.GT.0) THEN
         DO 10 I=1,NVAR
         IF(VARNAM(I).EQ.VNAM .AND. IVARDA(1,I).EQ.LAYER .AND.
     1    IVARDA(2,I).EQ.IPER) GO TO 100
10       CONTINUE
      END IF
C
C  Create new entry
      NVAR=NVAR+1
      IF(NVAR.GT.MXVAR) THEN
         WRITE(IOUT,*) ' Variable overflow'
         CALL RDABRT
      END IF
      NARRAY=NARRAY+1
      IF(NARRAY.GT.MXARR) THEN
         WRITE(IOUT,*) ' Array overflow'
         CALL RDABRT
      END IF
      VARNAM(NVAR)=VNAM
      IVARDA(1,NVAR)=LAYER
      IVARDA(2,NVAR)=IPER
      IVARDA(3,NVAR)=NARRAY
      VARVAL(NVAR)=-999.99
      IARRDA(1,NARRAY)=0
      IARRDA(2,NARRAY)=0
      IARRDA(3,NARRAY)=IDIM1
      IARRDA(4,NARRAY)=IDIM2
      IARRDA(5,NARRAY)=0
      ARRCON(NARRAY)=0.
      RETURN
C
C  Variable already exists
100   WRITE(IOUT,*) ' Duplicate variable:',VNAM
      CALL RDABRT
      END
      SUBROUTINE LSTMAK(VNAM,LAYER,IPER,IWIDTH)
C     ******************************************************************
C     Create a list.  First an array is created, then space for 10
C     locator values is allocated in X to provide for lists to expand
C     a group at a time.  Each group should be allocated as needed.
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      CHARACTER*(*) VNAM
C
      CALL ARRMAK(VNAM,LAYER,IPER,IWIDTH,0)
      CALL ARRALO(IARRDA(2,NARRAY),10,1)
      ARRCON(NARRAY)=1.0
      CALL IVLSAV(VNAM,LAYER,IPER,IMISS)
      RETURN
      END
      SUBROUTINE LSTMAK2(VNAM,LAYER,IPER,IWIDTH,NLST)
C     ******************************************************************
C     Create a list.  First an array is created, then space for 10
C     locator values is allocated in X to provide for lists to expand
C     a group at a time.  Each group should be allocated as needed.
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      CHARACTER*(*) VNAM
C
      CALL ARRMAK(VNAM,LAYER,IPER,IWIDTH,0)
      CALL ARRALO(IARRDA(2,NARRAY),10,1)
      ARRCON(NARRAY)=1.0
      CALL IVLSAV(VNAM,LAYER,IPER,NLST)
      RETURN
      END
      SUBROUTINE ARRALO(IXLOC,IDIM1,IDIM2)
C     ******************************************************************
C     Allocate memory in the X array -- for use when creating new data
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
C
      IXLOC=ISUM
      ISUM=ISUM+IDIM1*IDIM2
      IF(ISUM-1 .GT.LENX) THEN
         WRITE(IOUT,*) ' ***ERROR -- X array overflow'
         CALL MFISTP
      END IF
      RETURN
      END
      SUBROUTINE ARRAL2(IXLOC,IDIM1,IDIM2)
C     ******************************************************************
C     Allocate memory in the X array -- for use while reading old data
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
C
      IXLOC=ISUM
      ISUM=ISUM+IDIM1*IDIM2
      IF(ISUM-1 .GT.LENX) THEN
         WRITE(IOUT,*) ' ***ERROR -- X array overflow'
         CALL RDABRT
      END IF
      RETURN
      END
      SUBROUTINE LSTALO(NAR,IGROUP)
C     ******************************************************************
C     Allocate memory in the X array for list groups
C        For use when defining new data
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
C
      IF(IARRDA(4,NAR).GE.IGROUP) RETURN
      IF(IGROUP.GT.10) THEN
         WRITE(IOUT,*) ' List overflow -- maximum list length is',
     1              MXLIST*10
         CALL MFISTP
      END IF
      DO 10 I=IARRDA(4,NAR)+1,IGROUP
         LOC=IARRDA(2,NAR)+I-1
         CALL ARRALO(IX(LOC),IARRDA(3,NAR),MXLIST)
         LLOC=IX(LOC)
         DO 5 J=LLOC,LLOC+MXLIST*IARRDA(3,NAR)-1
         X(J)=0.
5        CONTINUE
10    CONTINUE
      IARRDA(4,NAR)=IGROUP
      RETURN
      END
      SUBROUTINE LSTAL2(NAR,IGROUP)
C     ******************************************************************
C     Allocate memory in the X array for list groups
C        For use when reading old data
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
C
      IF(IARRDA(4,NAR).GE.IGROUP) RETURN
      IF(IGROUP.GT.10) THEN
         WRITE(IOUT,*) ' List overflow -- maximum list length is',
     1              MXLIST*10
         CALL RDABRT
      END IF
      DO 10 I=IARRDA(4,NAR)+1,IGROUP
         LOC=IARRDA(2,NAR)+I-1
         CALL ARRAL2(IX(LOC),IARRDA(3,NAR),MXLIST)
         LLOC=IX(LOC)
         DO 5 J=LLOC,LLOC+MXLIST*IARRDA(3,NAR)-1
         X(J)=0.
5        CONTINUE
10    CONTINUE
      IARRDA(4,NAR)=IGROUP
      RETURN
      END
      SUBROUTINE VALGET(VNAM,LAYER,IPER,ITYPE,VALUE)
C     ******************************************************************
C     Get the REAL value of a stored variable.
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      CHARACTER*(*) VNAM
C
      IF(NVAR.GT.0) THEN
         DO 10 I=1,NVAR
         IF(VARNAM(I).EQ.VNAM .AND. IVARDA(1,I).EQ.LAYER .AND.
     1    IVARDA(2,I).EQ.IPER) GO TO 100
10       CONTINUE
      END IF
      ITYPE=-1
      RETURN
C
C  Found entry
100   ITYPE=IVARDA(3,I)
      VALUE=VARVAL(I)
      RETURN
C
      END
      SUBROUTINE IVLGET(VNAM,LAYER,IPER,ITYPE,IVALUE)
C     ******************************************************************
C     Get the INTEGER value of a stored variable.
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      CHARACTER*(*) VNAM
C
      IF(NVAR.GT.0) THEN
         DO 10 I=1,NVAR
         IF(VARNAM(I).EQ.VNAM .AND. IVARDA(1,I).EQ.LAYER .AND.
     1    IVARDA(2,I).EQ.IPER) GO TO 100
10       CONTINUE
      END IF
      ITYPE=-1
      RETURN
C
C  Found entry
100   ITYPE=IVARDA(3,I)
      IVALUE=VARVAL(I)
      RETURN
C
      END
      SUBROUTINE REALUN(IU)
C     ******************************************************************
C     Find an unused real file unit for a virtual file unit.
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
C
      IF(IUREAL(IU).GT.0) RETURN
C
C  If OPEN/CLOSE, then use the miscellaneous unit
      IF(FILTYP(IU)(1:10).EQ.'OPEN/CLOSE') THEN
         IUREAL(IU)=IUMISC
         RETURN
      END IF
C
C  Try using the virtual unit as the index to the real unit.
C  Then try going up from the virtual unit.
      I=MOD(IU,100)
      IUSTRT=MXUNIT+1
      IF(I.GT.0 .AND. I.LE.MXUNIT) THEN
         IF(IUAVAI(I).GT.0) GO TO 100
         IUSTRT=I
         DO 5 I=IUSTRT,MXUNIT
         IF(IUAVAI(I).GT.0) GO TO 100
5        CONTINUE
      END IF
C
C  Scan for any other available unit
      IF(IUSTRT.GT.1) THEN
         DO 10 I=1,IUSTRT-1
         IF(IUAVAI(I).GT.0) GO TO 100
10       CONTINUE
      END IF
C
C  No unit is available
      WRITE(IOUT,*) 'All file units are used up'
      CALL MFISTP
C
C  Found a unit
100   IUREAL(IU)=IUAVAI(I)
      IUAVAI(I)=0
      RETURN
      END
      SUBROUTINE RTRNUN(J)
C     ******************************************************************
C     Return the real file unit corresponding to virtual file J to the
C     list of available units.
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
C
      IF(IUREAL(J).NE.IUMISC .AND. IUREAL(J).GT.0) THEN
C  The real unit is from the list of available units -- put the unit
C  back into the list
         IF(IUREAL(J).LE.MXUNIT .AND. IUAVAI(IUREAL(J)).EQ.0) THEN
C  Use the element in the list of available units that is equal to
C  the real unit if possible
            IUAVAI(IUREAL(J))=IUREAL(J)
         ELSE
C  Find an empty slot in the list of available units and put the unit
C  there.
            DO 25 N=1,MXUNIT
            IF(IUAVAI(N).EQ.0) THEN
               IUAVAI(N)=IUREAL(J)
               GO TO 26
            END IF
25          CONTINUE
         END IF
26       IUREAL(J)=0
      ELSE
C  The real unit is equal to IUMISC or is an illegal value -- no need
C  to restore the unit to the list of available units -- zero the value.
         IUREAL(J)=0
      END IF
      RETURN
      END
      SUBROUTINE FINDUN(IBEG,IU,PACK,CEXT)
C     ******************************************************************
C     Find an unused virtual file unit for a package.  Create an entry
C     in the list of file names for the file and lookup a real unit.
C     Although this code functions with CEXT being any length, for PC's
C     CEXT should be 3 characters or less because CEXT is used as a
C     file name extension.
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      CHARACTER*(*) PACK
      CHARACTER*80 NEWNAM
      CHARACTER*(*) CEXT
      CHARACTER*3 CEXTN
C
      CEXTN=CEXT
      IF(IUCASE.EQ.0) CALL USTRLC(CEXTN,3)
      NEWNAM=DSNAME(1:NDSNAM)//'.'//CEXTN
      DO 5 I=1,MXFNAM
      IF(FILNAM(I).EQ.NEWNAM) THEN
         WRITE(IOUT,*) 'File name for package is a duplicate name'
         WRITE(IOUT,*) NEWNAM(1:40),' ',PACK
         CALL MFISTP
      END IF
5     CONTINUE
C
C  Find an available virtual unit
      DO 10 I=IBEG,MXFNAM
      IF(FILTYP(I).EQ.' ') GO TO 100
10    CONTINUE
      WRITE(IOUT,*) 'All file-name slots are used up'
      CALL MFISTP
C
C  Found an available virtual unit -- assign its name and type, and set the
C  IFNUSE flag.
100   FILTYP(I)=PACK
      FILNAM(I)=NEWNAM
      IFNUSE(I)=I
      IU=I
      RETURN
      END
      SUBROUTINE FNDUN2(NEWNAM,IU,TYPE,IUSE)
C     ******************************************************************
C     Find an unused virtual file unit for a file.  Create an entry
C     in the list of file names for the file and lookup a real unit.
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      CHARACTER*(*) TYPE
      CHARACTER*(*) NEWNAM
C
      DO 5 I=1,MXFNAM
      IF(FILNAM(I).EQ.NEWNAM) THEN
         IF(TYPE.NE.FILTYP(I) .OR.
     1        (IFNUSE(I).GT.0 .AND. IFNUSE(I).NE.IUSE)) THEN
            IU=-1
            RETURN
         ELSE
            IU=I
            IFNUSE(I)=IUSE
            RETURN
         END IF
      END IF
5     CONTINUE
C
C  Find an available virtual unit
      DO 10 I=50,MXFNAM
      IF(FILTYP(I).EQ.' ') GO TO 100
10    CONTINUE
      WRITE(IOUT,*) 'All file-name slots are used up'
      CALL MFISTP
C
C  Found an available virtual unit -- assign its name and type, and set the
C  IFNUSE flag.
100   FILTYP(I)=TYPE
      FILNAM(I)=NEWNAM
      IFNUSE(I)=IUSE
      IU=I
      RETURN
      END
      SUBROUTINE FNDUN3(IBEG,NEWNAM,IU,TYPE)
C     ******************************************************************
C     Find an unused virtual file unit for a file.  Create an entry
C     in the list of file names for the file and lookup a real unit.
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      CHARACTER*(*) TYPE
      CHARACTER*(*) NEWNAM
C
      DO 5 I=1,MXFNAM
      IF(FILNAM(I).EQ.NEWNAM) THEN
         IU=-1
         RETURN
      END IF
5     CONTINUE
C
C  Find an available virtual unit
      DO 10 I=IBEG,MXFNAM
      IF(FILTYP(I).EQ.' ') GO TO 100
10    CONTINUE
      WRITE(IOUT,*) 'All file-name slots are used up'
      CALL MFISTP
C
C  Found an available virtual unit -- assign its name and type, and set the
C  IFNUSE flag.
100   FILTYP(I)=TYPE
      FILNAM(I)=NEWNAM
      IFNUSE(I)=I
      IU=I
      RETURN
      END
      SUBROUTINE FNAMCK(I,TYPE,IUPACK)
C     ******************************************************************
C     Check a name in the list of file names to make sure it is being
C     used consistently.  This is for use when reading an existing
C     dataset.
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      CHARACTER*(*) TYPE
C
      IF(FILNAM(I).NE.' ') THEN
         IF(FILTYP(I).EQ.TYPE) THEN
            IF(IFNUSE(I).EQ.IUPACK .OR.IFNUSE(I).LT.0) THEN
               IFNUSE(I)=IUPACK
            ELSE
               WRITE(IOUT,*) ' FILE IS BEING USED BY ANOTHER PACKAGE'
               CALL RDABRT
            END IF
         ELSE
            WRITE(IOUT,*) ' CONFLICT BETWEEN FILE TYPES'
            WRITE(IOUT,*) ' OR FILE FORMATTING'
            CALL RDABRT
         END IF
         RETURN
      ELSE
         WRITE(IOUT,*) ' THE CORRESPONDING FILE IS NOT IN THE NAME FILE'
         CALL RDABRT
      END IF
C
      END
      SUBROUTINE FNAMSV(NAME,IU,TYPE,IUPACK)
C     ******************************************************************
C     Put a name into the list of file names and return its unit.  If
C     the name already exists, return its unit.  Abort if there are
C     conflicts.  This is for use while reading an existing dataset.
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      CHARACTER*(*) NAME,TYPE
C
      DO 10 I=1,MXFNAM
      IF(FILNAM(I).EQ.NAME) THEN
         IF(FILTYP(I).EQ.TYPE) THEN
            IF(IFNUSE(I).EQ.IUPACK .OR.IFNUSE(I).LT.0) THEN
               IU=I
               IFNUSE(I)=IUPACK
            ELSE
               WRITE(IOUT,*) ' FILE IS BEING USED BY ANOTHER PACKAGE'
               WRITE(IOUT,*) NAME
               CALL RDABRT
            END IF
         ELSE
            WRITE(IOUT,*) ' CONFLICT BETWEEN FILE TYPES'
            WRITE(IOUT,*) ' OR FILE FORMATTING'
            WRITE(IOUT,*) TYPE,NAME
            CALL RDABRT
         END IF
         RETURN
      END IF
10    CONTINUE
C
      DO 20 I=50,MXFNAM
      IF(FILTYP(I).EQ.' ') GO TO 100
20    CONTINUE
      WRITE(IOUT,*) 'All file-name slots are used up'
      CALL RDABRT
C
100   FILTYP(I)=TYPE
      FILNAM(I)=NAME
      IFNUSE(I)=IUPACK
      IU=I
      RETURN
      END
      SUBROUTINE FNMSV2(NAME,IU,IFM,IUPACK,NAR,IFTYP)
      USE WINTERACTER
C     ******************************************************************
C     Put a name into the list of file names and return its unit.  If
C     the name already exists, return its unit. This is for interactive
C     use when specifying separate arrays.
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      CHARACTER*(*) NAME
      CHARACTER*100 CTXT(2)
C
      IF(NAME.EQ.' ') THEN
         CALL WMessageBox(OKOnly,ExclamationIcon,OKOnly,
     1   'A blank file name was entered',' ')
         IU=-1
         RETURN
      END IF
C
      DO 10 I=1,MXFNAM
C  Check for existing file name
      IF(FILNAM(I).EQ.NAME) THEN
C  File exists -- check for use by the current package
         IF(IFNUSE(I).NE.IUPACK) THEN
C  Not used by the same package -- prior use wins out
            CTXT(1)='File '//NAME
            IF(IFNUSE(I).LE.0) THEN
               CTXT(2)='is reserved for use by an unspecified package'
            ELSE
               CTXT(2)= 'is already being used by the '//
     1               FILTYP(IFNUSE(I))//' Package'
            END IF
            CALL TXTLOG(CTXT,2)
            IU=-1
         ELSE
C  Used by the same package -- check if formatting matches and that the
C  file is a data file
            IF(IFM.NE.0) THEN
C  User wants a formatted file
               IF(FILTYP(I).EQ.'OPEN/CLOSE' .OR.
     1            FILTYP(I).EQ.'DATA') THEN
C  Format and type match, so OK to reuse this file
                  IU=I
               ELSE IF(FILTYP(I).EQ.'OPEN/CLOSE(BINARY)' .OR.
     1                 FILTYP(I).EQ.'DATA(BINARY)') THEN
C  Format conflict, but the file is a data file -- ask whether or not
C  the formatting should be changed.
                     CALL WMessageBox(3,2,CommonYes,
     1   FILNAM(I)//' format conflict -- change file to formatted?',' ')
                     IRESP=WInfoDialog(ExitButtonCommon)
                     IF(IRESP.NE.CommonYes) THEN
                        IU=-1
                     ELSE
                        IF(FILTYP(I).EQ.'OPEN/CLOSE(BINARY)')
     1                         FILTYP(I)='OPEN/CLOSE'
                        IF(FILTYP(I).EQ.'DATA(BINARY)') FILTYP(I)='DATA'
                        DO 4 J=1,NARRAY
                        IF(IARRDA(1,J).EQ.I) THEN
                           ARRFMT(J)=ARRFMT(NAR)
                        END IF
4                       CONTINUE
                        IU=I
                     END IF
               ELSE
C  The file is not a data file -- it therefore must be the package file,
C  and this prior use wins out
                  CTXT(1)='File '//NAME
         CTXT(2)='is already being used by the '//FILTYP(I)//' Package'
                  CALL TXTLOG(CTXT,2)
                  IU=-1
               END IF
            ELSE
C  User wants a binary file
               IF(FILTYP(I).EQ.'OPEN/CLOSE(BINARY)' .OR.
     1              FILTYP(I).EQ.'DATA(BINARY)') THEN
C  Format and type match, so OK to reuse this file
                  IU=I
               ELSE IF(FILTYP(I).EQ.'OPEN/CLOSE' .OR.
     1                 FILTYP(I).EQ.'DATA') THEN
C  Format conflict, but the file is a data file -- ask whether or not
C  the formatting should be changed.
                     CALL WMessageBox(YesNo,QuestionIcon,CommonYes,
     1   FILNAM(I)//' format conflict -- change file to binary?',' ')
                     IRESP=WInfoDialog(ExitButtonCommon)
                     IF(IRESP.NE.CommonYes) THEN
                        IU=-1
                     ELSE
                        IF(FILTYP(I).EQ.'OPEN/CLOSE')
     1                         FILTYP(I)='OPEN/CLOSE(BINARY)'
                        IF(FILTYP(I).EQ.'DATA') FILTYP(I)='DATA(BINARY)'
                        DO 6 J=1,NARRAY
                        IF(IARRDA(1,J).EQ.I) THEN
                           ARRFMT(J)=ARRFMT(NAR)
                        END IF
6                       CONTINUE
                        IU=I
                     END IF
               ELSE
C  The file is not a data file -- it therefore must be the package file,
C  and this prior use wins out
                  CTXT(1)='File '//NAME
        CTXT(2)='is already being used by the '//FILTYP(I)//' Package'
                  CALL TXTLOG(CTXT,2)
                  IU=-1
               END IF
            END IF
         END IF
C  Switch between DATA and OPEN/CLOSE as appropriate
         IF(IU.GT.0) THEN
            IF(IFTYP.EQ.1 .AND. IFM.EQ.0) THEN
               FILTYP(I)='DATA(BINARY)'
            ELSE IF(IFTYP.EQ.1 .AND. IFM.NE.0) THEN
               FILTYP(I)='DATA'
            ELSE IF(IFM.EQ.0) THEN
               FILTYP(I)='OPEN/CLOSE(BINARY)'
            ELSE
               FILTYP(I)='OPEN/CLOSE'
            END IF
         END IF
         RETURN
      END IF
10    CONTINUE
C
      DO 20 I=50,MXFNAM
      IF(FILTYP(I).EQ.' ') GO TO 100
20    CONTINUE
      WRITE(IOUT,*) 'All file-name slots are used up'
      CALL MFISTP
C
100   IF(IFTYP.EQ.1 .AND. IFM.EQ.0) THEN
         FILTYP(I)='DATA(BINARY)'
      ELSE IF(IFTYP.EQ.1 .AND. IFM.NE.0) THEN
         FILTYP(I)='DATA'
      ELSE IF(IFM.EQ.0) THEN
         FILTYP(I)='OPEN/CLOSE(BINARY)'
      ELSE
         FILTYP(I)='OPEN/CLOSE'
      END IF
      FILNAM(I)=NAME
      IFNUSE(I)=IUPACK
      IU=I
      RETURN
      END
      SUBROUTINE FNMSV3(NAME,IU,FTYP,IUPACK,ICBC)
      USE WINTERACTER
C     ******************************************************************
C     Put a name into the list of file names and return its unit.  If
C     the name already exists, return its unit.  If a new name, file
C     type is an argument.  This is for interactive use when specifying
C     Output Control data.  The file type must be 'DATA' or 'DATA(BINARY)'
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      CHARACTER*(*) NAME,FTYP
      CHARACTER*100 CTXT(2)
C
      IF(NAME.EQ.' ') THEN
         CALL WMESSAGEBOX(OKOnly,InformationIcon,CommonOK,
     1   'A file name has been left blank.  A name must be specified',
     2   ' ')
         IU=-1
         RETURN
      END IF
C
      DO 10 I=1,MXFNAM
C  Check for existing file name
      IF(FILNAM(I).EQ.NAME) THEN
C  File exists -- check for use by current package
         IF(IFNUSE(I).NE.IUPACK) THEN
C  Not used by current package -- prior use wins
               CTXT(1)='File '//NAME
            IF(IFNUSE(I).LE.0) THEN
               CTXT(2)='is reserved for use by an unspecified package'
            ELSE
               CTXT(2)='is already being used by the '//
     1         FILTYP(IFNUSE(I))//' Package'
            END IF
            CALL TXTLOG(CTXT,2)
            IU=-1
         ELSE
C  Used by the current package -- the remaining checks depend on whether
C  the file is a budget file or a head/drawdown file.
            IF(ICBC.EQ.0) THEN
C  Head/drawdown file -- Check if the file is already used for budget
               IF(IBUDUN.LE.0) THEN
                  DO 5 J=1,40
                  IF(IUNIT2(J).EQ.I) THEN
                 CTXT(1)='File '//NAME
                 CTXT(2)='is already being used for a budget file'
                     CALL TXTLOG(CTXT,2)
                     IU=-1
                     RETURN
                  END IF
5                 CONTINUE
               ELSE
                  IF(IBUDUN.EQ.I) THEN
               CTXT(1)='File '//NAME
               CTXT(2)='is already being used for another purpose'
                     CALL TXTLOG(CTXT,2)
                     IU=-1
                     RETURN
                   END IF
               END IF
C  Check if formatting and type match
               IF(FILTYP(I).EQ.FTYP) THEN
C  Formatting and type match, so OK to reuse the file
                  IU=I
               ELSE IF(FILTYP(I).EQ.'DATA' .AND.
     1                 FTYP.EQ.'DATA(BINARY)') THEN
C  A binary file is desired, but the file is already a formatted file.
                  CALL WMessageBox(3,2,CommonYes,
     1   FILNAM(I)//' format conflict -- change file to binary?',' ')
                  IRESP=WInfoDialog(ExitButtonCommon)
                  IF(IRESP.NE.CommonYes) THEN
                     IU=-1
                  ELSE
                     FILTYP(I)='DATA(BINARY)'
                     IF(IHEDUN.EQ.I) CHEDFM='(BINARY)'
                     IF(IDDNUN.EQ.I) CDDNFM='(BINARY)'
                     IU=I
                  END IF
               ELSE IF(FILTYP(I).EQ.'DATA(BINARY)' .AND.
     1                   FTYP.EQ.'DATA') THEN
C  A formatted file is desired, but the file is already a binary file.
                  CALL WMessageBox(3,2,CommonYes,
     1   FILNAM(I)//' format conflict -- change file to formatted?',' ')
                  IRESP=WInfoDialog(ExitButtonCommon)
                  IF(IRESP.NE.CommonYes) THEN
                     IU=-1
                  ELSE
                     FILTYP(I)='DATA'
                     IF(IHEDUN.EQ.I .AND. CHEDFM.EQ.'(BINARY)')
     1                                CHEDFM=CDDNFM
                     IF(IDDNUN.EQ.I .AND. CDDNFM.EQ.'(BINARY)')
     1                                CDDNFM=CHEDFM
                     IU=I
                  END IF
               ELSE
C  The file is not a data file -- it therefore must be the OC file,
C  and this prior use wins out.
             CTXT(1)='File '//NAME
        CTXT(2)='is the already being used as the Output Control file'
                  CALL TXTLOG(CTXT,2)
                  IU=-1
               END IF
            ELSE IF(ICBC.GT.0) THEN
C  File is a Budget file -- Check if the file is already used for head
C  or drawdown
               IF(IHEDUN.EQ.I) THEN
              CTXT(1)='File '//NAME
        CTXT(2)='is already being used for a budget file'
                  CALL TXTLOG(CTXT,2)
                  IU=-1
                  RETURN
               END IF
               IF(IDDNUN.EQ.I) THEN
              CTXT(1)='File '//NAME
          CTXT(2)='is already being used for anothr purpose'
                  CALL TXTLOG(CTXT,2)
                  IU=-1
                  RETURN
               END IF
C  Check if formatting and type match
               IF(FILTYP(I).EQ.FTYP) THEN
C  Formatting and type match, so OK to reuse the file
                  IU=I
               ELSE
C  The file is not a binary data file -- it therefore must be the OC
C  file, and this prior use wins out.
             CTXT(1)='File '//NAME
        CTXT(2)='is the already being used as the Output Control file'
                  CALL TXTLOG(CTXT,2)
                  IU=-1
               END IF
            ELSE
C  File is not part of the OC Package, so let the calling program decide
C  if it is OK to use the name of a file that is already in use by
C  the same package to be used again.
               IU=I
            END IF
         END IF
         RETURN
      END IF
10    CONTINUE
C
      DO 20 I=50,MXFNAM
      IF(FILTYP(I).EQ.' ') GO TO 100
20    CONTINUE
      WRITE(IOUT,*) 'All file-name slots are used up'
      CALL MFISTP
C
C  Create a new file entry
100   FILTYP(I)=FTYP
      FILNAM(I)=NAME
      IFNUSE(I)=IUPACK
      IU=I
      RETURN
      END
      SUBROUTINE FNMSV4(NAME,IU,TYPE,IUPACK)
C     ******************************************************************
C     Put a name into the list of file names and return its unit.  If
C     the name already exists, return its unit.  Tell user and return an
C     error code if there are conflicts.  This is for interactive use.
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      CHARACTER*(*) NAME,TYPE
      DIMENSION LENS(3)
C
      DO 10 I=1,MXFNAM
      IF(FILNAM(I).EQ.NAME) THEN
         IF(FILTYP(I).EQ.TYPE) THEN
            IF(IFNUSE(I).EQ.IUPACK .OR.IFNUSE(I).LT.0) THEN
               IU=I
               IFNUSE(I)=IUPACK
            ELSE
C  File is being used by another package
C               LENS(1)=LEN(NAME)
C               LENS(2)=LEN(FILTYP(IFNUSE(I)))
C               LENS(3)=LEN(FILTYP(IFNUSE(IUPACK)))
         CALL WMESSAGEBOX(OKOnly,InformationIcon,CommonOK,
     1   'The file is being used by another package',' ')
               IU=-1
            END IF
         ELSE
C  Mismatch between desired file type and current use
C            LENS(1)=LEN(NAME)
C            LENS(2)=LEN(FILTYP(I))
C            LENS(3)=LEN(TYPE)
         CALL WMESSAGEBOX(OKOnly,InformationIcon,CommonOK,
     1   'Mismatch between file type and current use',' ')
            IU=-1
         END IF
         RETURN
      END IF
10    CONTINUE
C
      DO 20 I=50,MXFNAM
      IF(FILTYP(I).EQ.' ') GO TO 100
20    CONTINUE
C  No more room in list of files -- not likely to happen

      CALL WMESSAGEBOX(OKOnly,InformationIcon,CommonOK,
     1   'No more room in list of files',' ')
      IU=-1
      RETURN
C
100   FILTYP(I)=TYPE
      FILNAM(I)=NAME
      IFNUSE(I)=IUPACK
      IU=I
      RETURN
      END
      SUBROUTINE FNMRMV()
C     ******************************************************************
C     Remove unused file names from the list of file names.
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
C
      DO 50 I=1,MXFNAM
C  Find unused files.  Remove them and restore their file unit.
      IF(IFNUSE(I).EQ.0 .AND. FILNAM(I).NE.' ') THEN
         FILTYP(I)=' '
         FILNAM(I)=' '
         IFILSTAT(I)=1
         IFILREW(I)=1
         CALL RTRNUN(I)
C  For any arrays that are read from this file, make them constant
         DO 30 N=1,NARRAY
         IF(IARRDA(1,N).EQ.I) THEN
            IARRDA(1,N)=0
C  Also, undefine the array by setting its variable name to blank
            DO 25 J=1,NVAR
            IF(IVARDA(3,J).EQ.N) THEN
               VARNAM(J)=' '
               IVARDA(1,J)=0
               IVARDA(2,J)=0
               IVARDA(3,J)=0
               GO TO 30
            END IF
25          CONTINUE
         END IF
30       CONTINUE
      END IF
50    CONTINUE
      RETURN
      END
      SUBROUTINE MFISTP
C     ******************************************************************
C     ROUTINE TO HANDLE FATAL ERRORS.  SAVE DATA IN TEMPORARY FILE;
C     PRINT A MESSAGE TELLING USER TO LOOK AT LOG FILE AND STOP.
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2k.inc'
      CHARACTER*60 CTXT(3)
C
      CTXT(1)=
     1 'Fatal error that prevents program from continuing.  Look in'
      CTXT(2)=DSNAME(1:NDSNAM)//'.log to find the cause of the error.'
      CTXT(3)='Attempting to save data in backup files.'
      CALL TXTLOG(CTXT,3)
      CALL SAVALL(1,IERR)
      CALL WMessageBox(OKOnly,ExclamationIcon,CommonOK,
     1  'Data have been saved in the MFI backup files.',' ')
      STOP
      END
      SUBROUTINE MFIUMK
C     ****************************************************************
C     Initialize the list of real units and the list of available
C     units for MODFLOW
C     ****************************************************************
      INCLUDE 'mfi2k.inc'
C
C  Initialize real units
      DO 7 I=1,MXFNAM
      IUREAL(I)=0
7     CONTINUE
C
      MXUNIT=90
      DO 8 I=1,MXUNIT
      IUAVAI(I)=I
8     CONTINUE
C  Reserve real units as needed --
C  In this case, reserve units 5 and 6, which will be used for INBAS and ILOUT.
      IUAVAI(5)=MXUNIT+1
      IUAVAI(6)=MXUNIT+2
C
      RETURN
      END
      SUBROUTINE MPIUMK
C     ****************************************************************
C     Initialize the list of real units and the list of available
C     units for MODPATH
C     ****************************************************************
      INCLUDE 'mfi2k.inc'
C
C  Initialize real units
      DO 7 I=1,MXFNAM
      IUREAL(I)=0
7     CONTINUE
C
      MXUNIT=77
      DO 8 I=1,MXUNIT
      IUAVAI(I)=I
8     CONTINUE
C  Reserve real units as needed --
C  In this case, reserve units 5 and 6, which cannot be used.
      IUAVAI(5)=MXUNIT+1
      IUAVAI(6)=MXUNIT+2
C
      RETURN
      END
